#Spell system and FfH specific callout python functions
#All code by Kael, all bugs by woodelf

from CvPythonExtensions import *
from BasicFunctions import *
import CvUtil
import Popup as PyPopup
import CvScreensInterface
import sys
import PyHelpers
import CustomFunctions
import ScenarioFunctions
import CvEventInterface

import Blizzards		#Added in Frozen: Blizzards: TC01

PyInfo = PyHelpers.PyInfo
PyPlayer = PyHelpers.PyPlayer
gc = CyGlobalContext()
localText = CyTranslator()
cf = CustomFunctions.CustomFunctions()
sf = ScenarioFunctions.ScenarioFunctions()

Blizzards = Blizzards.Blizzards()		#Added in Frozen: Blizzards: TC01

# *******************
# Modular Python: ANW 16-feb-2010
#                     29-may-2010

import glob   # Unix style pathname pattern expansion
import CvPath # path to current assets
import imp    # importing module

# Load spells from internal directory
for moduleSource in glob.glob ( CvPath.assetsPath[2] + "\\python\\plugins\\spell*.py" ):
	exec("from "+moduleSource.replace ( '.py', '' ).replace ( '\\', '/' ).split ( '/' ) [ -1 ]+" import *")
	
# Load spells from modules
for modules in glob.glob(CvPath.assetsPath[2] + "\\Modules\\NormalModules\\*"):
	# Ignore all xml files in this folder, since they are MLF control files
	if modules[-4:] != ".xml":
		if modules+"\\python" in glob.glob(modules+"\\*"):
			for pythonFileSource in glob.glob(modules+"\\python\\spell*.py"):
				#print(pythonFileSource)
				tempFileName = file(pythonFileSource)
				tempModuleName = pythonFileSource.replace ( '.py', '' ).replace ( '\\', '/' ).split ( '/' ) [ -1 ]
				imp.load_module( tempModuleName, tempFileName, tempModuleName+".py", ("","",1))
				#print(pythonFileSource.replace ( '.py', '' ).replace ( '\\', '/' ).split ( '/' ) [ -1 ])
				exec("from "+tempModuleName+" import *")
				tempFileName.close()

# Modular Python End
# *******************

def cast(argsList):
	pCaster, eSpell = argsList
	spell = gc.getSpellInfo(eSpell)
	eval(spell.getPyResult())

def canCast(argsList):
	pCaster, eSpell = argsList
	spell = gc.getSpellInfo(eSpell)
	return eval(spell.getPyRequirement())

def effect(argsList):
	pCaster, eProm = argsList
	prom = gc.getPromotionInfo(eProm)
	eval(prom.getPyPerTurn())

# Broader Alignments: Added by Grey Fox 04/10/2008
def effectUnits(argsList):
	pCaster, eUnit = argsList
	unit = gc.getUnitInfo(eUnit)
	eval(unit.getPyPerTurn())
	
def postPromotionCombatLost(argsList):
	pCaster, pOpponent, eProm = argsList
	prom = gc.getPromotionInfo(eProm)
	eval(prom.getPyPostCombatLost())

def postPromotionCombatWon(argsList):
	pCaster, pOpponent, eProm = argsList
	prom = gc.getPromotionInfo(eProm)
	eval(prom.getPyPostCombatWon())
# Broader Alignments: End Add

def postDeath(argsList):
	pCaster, eKiller, eUnit = argsList
	if eKiller >= 0:
		pKiller = gc.getPlayer(eKiller)
	unit = gc.getUnitInfo(eUnit)
	eval(unit.getPyDeath())

def promotionRemove(argsList):
	pCaster, ePromotion = argsList
	promotion = gc.getPromotionInfo(ePromotion)
	return eval(promotion.getPyOnRemove())


def atRange(argsList):
	pCaster, pPlot, eImp = argsList
	imp = gc.getImprovementInfo(eImp)
	eval(imp.getPythonAtRange())

def onMove(argsList):
	pCaster, pPlot, eImp = argsList
	imp = gc.getImprovementInfo(eImp)
	eval(imp.getPythonOnMove())

def onMoveFeature(argsList):
	pCaster, pPlot, eFeature = argsList
	feature = gc.getFeatureInfo(eFeature)
	eval(feature.getPythonOnMove())

def vote(argsList):
	eVote, int = argsList
	vote = gc.getVoteInfo(eVote)
	eval(vote.getPyResult())

def miscast(argsList):
	pCaster, eSpell = argsList
	spell = gc.getSpellInfo(eSpell)
	eval(spell.getPyMiscast())

def globalAnnounce(argsList):
	unit, eSpell = argsList
	spell = gc.getSpellInfo(eSpell)
	player = PyPlayer(unit.getOwner())
	if gc.getGame().getAIAutoPlay() == 0:
		activePlayer = gc.getPlayer(gc.getGame().getActivePlayer())
		sPlayerName = player.getName()
		sSpellName = spell.getDescription()
		sQuote = spell.getQuote()
		sPopupText = CyTranslator().getText('TXT_KEY_MISC_SPELL_POPUP',(sPlayerName, sSpellName, sQuote))
		addPopup(sPopupText, str(gc.getLeaderHeadInfo(player.getLeaderType()).getImage()))

def postCombatLost(argsList):
	pCaster, pOpponent = argsList
	unit = gc.getUnitInfo(pCaster.getUnitType())
	eval(unit.getPyPostCombatLost())

def postCombatWon(argsList):
	pCaster, pOpponent = argsList
	unit = gc.getUnitInfo(pCaster.getUnitType())
	eval(unit.getPyPostCombatWon())

def findClearPlot(pUnit, plot):
	BestPlot = -1
	iBestPlot = 0
	getPlot	= CyMap().plot
	if pUnit == -1:
		iX = plot.getX()
		iY = plot.getY()
		for iiX,iiY in RANGE1:
			pPlot = getPlot(iX+iiX,iY+iiY)
			iCurrentPlot = 0
			if pPlot.getNumUnits() == 0:
				if (pPlot.isWater() == plot.isWater() and pPlot.isPeak() == False and pPlot.isCity() == False):
					iCurrentPlot = iCurrentPlot + 5
			if iCurrentPlot >= 1:
				iCurrentPlot = iCurrentPlot + CyGame().getSorenRandNum(5, "findClearPlot")
				if iCurrentPlot >= iBestPlot:
					BestPlot = pPlot
					iBestPlot = iCurrentPlot
		return BestPlot
	iX = pUnit.getX()
	iY = pUnit.getY()
	for iiX,iiY in RANGE1:
		pPlot = getPlot(iX+iiX,iY+iiY)
		iCurrentPlot = 0
		if pPlot.getNumUnits() == 0:
			if pUnit.canMoveOrAttackInto(pPlot, False):
				iCurrentPlot = iCurrentPlot + 5
		for i in range(pPlot.getNumUnits()):
			if pPlot.getUnit(i).getOwner() == pUnit.getOwner():
				if pUnit.canMoveOrAttackInto(pPlot, False):
					iCurrentPlot = iCurrentPlot + 15
		if pPlot.isCity():
			if pPlot.getPlotCity().getOwner() == pUnit.getOwner():
				iCurrentPlot = iCurrentPlot + 50
		if (iX == iiX and iY == iiY):
			iCurrentPlot = 0
		if iCurrentPlot >= 1:
			iCurrentPlot = iCurrentPlot + CyGame().getSorenRandNum(5, "findClearPlot")
			if iCurrentPlot >= iBestPlot:
				BestPlot = pPlot
				iBestPlot = iCurrentPlot
	return BestPlot

def postCombatConsumePaladin(pCaster, pOpponent):
	gc 			= CyGlobalContext()
	if (pOpponent.getUnitClassType() == gc.getInfoTypeForString('UNITCLASS_PALADIN')):
		pCaster.setDamage(0, pCaster.getOwner())
		CyInterface().addMessage(pCaster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_CONSUME_PALADIN", ()),'',1,'Art/Interface/Buttons/Units/Beast of Agares.dds',ColorTypes(8),pCaster.getX(),pCaster.getY(),True,True)
		
def postCombatScionPriest(pCaster, pOpponent):
	gc 			= CyGlobalContext()
	getInfoType	= gc.getInfoTypeForString
	pPlayer 	= gc.getPlayer(pCaster.getOwner())
	randNum		= CyGame().getSorenRandNum
	
	if (pCaster.getUnitClassType() == getInfoType('UNITCLASS_DOOMGIVER')):
		pPlot = pOpponent.plot()
		if pPlot.isCity():
			pCity = pPlot.getPlotCity()
			CyInterface().addMessage(pCity.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_POPULATION_REDUCED", ()),'',1,'Art/Interface/Buttons/Units/Angel of Death.dds',ColorTypes(7),pCity.getX(),pCity.getY(),True,True)
			CyInterface().addMessage(pCaster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_DOOMGIVER_CITY_ATTACK", ()),'',1,'Art/Interface/Buttons/Units/Angel of Death.dds',ColorTypes(7),pCity.getX(),pCity.getY(),True,True)
			iDoomgiverHurryAnger = (5 + randNum(10, "Doomgiver attack anger amount"))
			pCity.changeHurryAngerTimer(iDoomgiverHurryAnger)
			if pCity.getPopulation() > 1:
				if randNum(5, "Doomgiver chance to reduce pop") == 1:
					pCity.changePopulation(-1)
	
	pPlot = pCaster.plot()		
	if pOpponent.isAnimal(): 	return
	if not pOpponent.isAlive(): return
	iCasterLevel = pCaster.getLevel()
	iBarbMod = 0
	if pOpponent.isBarbarian():
		iBarbMod = 5
	iPriestMod = 0
	iDivine = getInfoType('PROMOTION_DIVINE')
	hasPromo	= pCaster.isHasPromotion
	if hasPromo(iDivine):	iPriestMod = 3
	iCommand1 = getInfoType('PROMOTION_COMMAND1')
	iCommand2 = getInfoType('PROMOTION_COMMAND2')
	iCommand3 = getInfoType('PROMOTION_COMMAND3')
	iCommandMod = 0
	if hasPromo(iCommand1): iCommandMod = 3
	if hasPromo(iCommand2):	iCommandMod = 6
	if hasPromo(iCommand3):	iCommandMod = 9
	iTurnRoll = randNum(100, "Scion priest Turn roll")
	if iTurnRoll < (7 + iPriestMod + iCommandMod - iBarbMod + (iCasterLevel * 2)):	
		iUnitRoll = randNum(100, "Scion priest Unit roll")
		if iUnitRoll < (30 + (8 * iBarbMod) - (100 * iCommandMod)):
			iArcher = getInfoType('UNITCOMBAT_ARCHER')
			iRecon 	= getInfoType('UNITCOMBAT_RECON')
			if pOpponent.getUnitCombatType() == iArcher:
				newUnit = pPlayer.initUnit(getInfoType('UNIT_ARCHER'), pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
				newUnit.setExperienceTimes100((pOpponent.getExperienceTimes100() / 3), -1)
				newUnit.setDamage(50, -1)
				newUnit.finishMoves()
				CyInterface().addMessage(pCaster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_UNIT_SPAWNED_PRIEST", ()),'',1,'Art/Interface/Buttons/Units/Scions/reborn.dds',ColorTypes(8),pPlot.getX(),pPlot.getY(),True,True)
				return
			if pOpponent.getUnitCombatType() == iRecon:
				newUnit = pPlayer.initUnit(getInfoType('UNIT_VELITES'), pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
				newUnit.setExperienceTimes100((pOpponent.getExperienceTimes100() / 3), -1)
				newUnit.setDamage(50, -1)
				newUnit.finishMoves()
				CyInterface().addMessage(pCaster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_UNIT_SPAWNED_PRIEST", ()),'',1,'Art/Interface/Buttons/Units/Scions/reborn.dds',ColorTypes(8),pPlot.getX(),pPlot.getY(),True,True)
				return
			iUnreliable 		= getInfoType('PROMOTION_UNRELIABLE')
			iTurnedUndeadArt 	= getInfoType('PROMOTION_TURNED_UNDEAD_ART')
			iUndead = getInfoType('PROMOTION_UNDEAD')
			newUnit = pPlayer.initUnit(getInfoType('UNIT_CENTENI'), pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
			newUnit.setHasPromotion(iUnreliable, False)
			newUnit.setHasPromotion(iTurnedUndeadArt, True)
			newUnit.setHasPromotion(iUndead, True)
			newUnit.setExperienceTimes100((pOpponent.getExperienceTimes100() / 3), -1)
			newUnit.setDamage(50, -1)
			newUnit.finishMoves()
			CyInterface().addMessage(pCaster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_UNIT_SPAWNED_PRIEST", ()),'',1,'Art/Interface/Buttons/Units/Scions/reborn.dds',ColorTypes(8),pPlot.getX(),pPlot.getY(),True,True)
			return
		else:
			newUnit = pPlayer.initUnit(getInfoType('UNIT_REBORN'), pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
			newUnit.finishMoves()
			CyInterface().addMessage(pCaster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_REBORN_SPAWNED_PRIEST", ()),'',1,'Art/Interface/Buttons/Units/Scions/reborn.dds',ColorTypes(8),pPlot.getX(),pPlot.getY(),True,True)
			return

def postCombatDonal(pCaster, pOpponent):
	gc 			= CyGlobalContext()
	getInfoType	= gc.getInfoTypeForString
	hasPromo	= pOpponent.isHasPromotion
	if (hasPromo(getInfoType('PROMOTION_DEMON')) or hasPromo(getInfoType('PROMOTION_UNDEAD'))):
		pCaster.setHasPromotion(getInfoType('PROMOTION_RECRUITER'), True)

def postCombatExplode(pCaster, pOpponent):

	fireSpreadToTile(pCaster.getX(), pCaster.getY())
	fireSpreadToTile(pOpponent.getX(), pOpponent.getY())
	
	pOpponent.doDamage(20, 100, pCaster, gc.getInfoTypeForString('DAMAGE_FIRE'), False)
	if pCaster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_SHEUT_STONE')):
		pOpponent.doDamage(20, 100, pCaster, gc.getInfoTypeForString('DAMAGE_DEATH'), False)
		
def postCombatBigExplode(pCaster, pOpponent):
	
	pPlot = CyMap().plot(pCaster.getX(), pCaster.getY())
	
	fireSpreadToTile(pCaster.getX(), pCaster.getY())
	fireSpreadToTile(pOpponent.getX(), pOpponent.getY())
	
	pPlot.setImprovementType(-1)
	
	pOpponent.doDamage(35, 100, pCaster, gc.getInfoTypeForString('DAMAGE_FIRE'), False)
	if pCaster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_SHEUT_STONE')):
		pOpponent.doDamage(20, 100, pCaster, gc.getInfoTypeForString('DAMAGE_DEATH'), False)
	
def fireSpreadToTile(iX, iY):
	pPlot = CyMap().plot(iX,iY)

	iFeature = pPlot.getFeatureType()
	
	if iFeature == -1:
		return

	if (iFeature == gc.getInfoTypeForString('FEATURE_FOREST') or iFeature == gc.getInfoTypeForString('FEATURE_JUNGLE') or iFeature == gc.getInfoTypeForString('FEATURE_FOREST_NEW')):
		if CyGame().getSorenRandNum(100, "Flames Spread") <= gc.getDefineINT('FLAMES_SPREAD_CHANCE'):
			bValid = True
			iImprovement = pPlot.getImprovementType()
			if iImprovement != -1 :
				if gc.getImprovementInfo(iImprovement).isPermanent() :
					bValid = False
			if bValid:
				pPlot.setImprovementType(gc.getInfoTypeForString('IMPROVEMENT_SMOKE'))
	

def postCombatHeal50(pCaster, pOpponent):
	if pCaster.getDamage() > 0:
		pCaster.setDamage(pCaster.getDamage() / 2, pCaster.getOwner())

def postCombatIra(pCaster, pOpponent):
	if pOpponent.isAlive():
		if pCaster.baseCombatStr() < 32:
			pCaster.changeStrBoost(1)

def pyPerTurnIra(pCaster):
	iStrength = pCaster.getStrBoost()
	if iStrength >= -4:
		iRnd = CyGame().getSorenRandNum(100, "Ira Strength Decrease")
		if iRnd < 33:
			pCaster.changeStrBoost(-1)
			
def postCombatMimic(pCaster, pOpponent):
	gc 				= CyGlobalContext()
	getInfoType		= gc.getInfoTypeForString
	iBronze 		= getInfoType('PROMOTION_BRONZE_WEAPONS')
	iChanneling3 	= getInfoType('PROMOTION_CHANNELING3')
	iDivine 		= getInfoType('PROMOTION_DIVINE')
	iGreatCommander = getInfoType('PROMOTION_GREAT_COMMANDER')
	iIron 			= getInfoType('PROMOTION_IRON_WEAPONS')
	iMithril	 	= getInfoType('PROMOTION_MITHRIL_WEAPONS')
	iUndead 		= getInfoType('PROMOTION_UNDEAD')
	listProms = []
	iCount = 0
	for iProm in range(gc.getNumPromotionInfos()):
		if pCaster.isHasPromotion(iProm):
			iCount += 1
		else:
			if (pOpponent.isHasPromotion(iProm)):
				if gc.getPromotionInfo(iProm).isEquipment() == False:
					if (iProm != iChanneling3 and iProm != iUndead and iProm != iDivine and iProm != iBronze and iProm != iIron and iProm != iMithril and iProm != iGreatCommander):
						if gc.getPromotionInfo(iProm).isRace() == False:
							listProms.append(iProm)
	if len(listProms) > 0:
		iCount += 1
		iRnd = CyGame().getSorenRandNum(len(listProms), "Mimic")
		pCaster.setHasPromotion(listProms[iRnd], True)
		CyInterface().addMessage(pCaster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_PROMOTION_STOLEN", ()),'',1,gc.getPromotionInfo(listProms[iRnd]).getButton(),ColorTypes(8),pCaster.getX(),pCaster.getY(),True,True)
	if iCount >= 20:
		pPlayer = gc.getPlayer(pCaster.getOwner())
		if pPlayer.isHuman():
			t = "TROPHY_FEAT_MIMIC_20"
			if not CyGame().isHasTrophy(t):
				CyGame().changeTrophyValue(t, 1)

def postCombatAcheron(pCaster, pOpponent):
	pPlayer = gc.getPlayer(pOpponent.getOwner())
	if pPlayer.isHuman():
		t = "TROPHY_DEFEATED_ACHERON"
		if not CyGame().isHasTrophy(t):
			CyGame().changeTrophyValue(t, 1)

def postCombatArs(pCaster, pOpponent):
	pPlayer = gc.getPlayer(pOpponent.getOwner())
	if pPlayer.isHuman():
		t = "TROPHY_DEFEATED_ARS"
		if not CyGame().isHasTrophy(t):
			CyGame().changeTrophyValue(t, 1)

def postCombatAuricAscendedLost(pCaster, pOpponent):
	iPlayer = pCaster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	for iTrait in range(gc.getNumTraitInfos()):
		if pPlayer.hasTrait(iTrait):
			pPlayer.setHasTrait(iTrait,False)
	if pOpponent.isHasPromotion(gc.getInfoTypeForString('PROMOTION_GODSLAYER')):
		pOppPlayer = gc.getPlayer(pOpponent.getOwner())
		if pOppPlayer.isHuman():
			t = "TROPHY_FEAT_GODSLAYER"
			if not CyGame().isHasTrophy(t):
				CyGame().changeTrophyValue(t, 1)

def postCombatAuricAscendedWon(pCaster, pOpponent):
	if pOpponent.isHasPromotion(gc.getInfoTypeForString('PROMOTION_GODSLAYER')):
		iPlayer = pCaster.getOwner()
		pPlayer = gc.getPlayer(iPlayer)
		for iTrait in range(gc.getNumTraitInfos()):
			if pPlayer.hasTrait(iTrait):
				pPlayer.setHasTrait(iTrait,False)
		pCaster.kill(True, pOpponent.getOwner())
		pOppPlayer = gc.getPlayer(pOpponent.getOwner())
		if pOppPlayer.isHuman():
			t = "TROPHY_FEAT_GODSLAYER"
			if not CyGame().isHasTrophy(t):
				CyGame().changeTrophyValue(t, 1)

def onDeathAuric(pCaster):
	iPlayer = pCaster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	for iTrait in range(gc.getNumTraitInfos()):
		if pPlayer.hasTrait(iTrait):
			pPlayer.setHasTrait(iTrait,False)
				
def postCombatBasium(pCaster, pOpponent):
	if not pCaster.isImmortal():
		iPlayer = pCaster.getOwner()
		pPlayer = gc.getPlayer(iPlayer)
		for iTrait in range(gc.getNumTraitInfos()):
			if pPlayer.hasTrait(iTrait):
				pPlayer.setHasTrait(iTrait,False)
		pOppPlayer = gc.getPlayer(pOpponent.getOwner())
		if pOppPlayer.isHuman():
			t = "TROPHY_DEFEATED_BASIUM"
			if not CyGame().isHasTrophy(t):
				CyGame().changeTrophyValue(t, 1)

def postCombatBuboes(pCaster, pOpponent):
	pPlayer = gc.getPlayer(pOpponent.getOwner())
	if pPlayer.isHuman():
		t = "TROPHY_DEFEATED_BUBOES"
		if not CyGame().isHasTrophy(t):
			CyGame().changeTrophyValue(t, 1)

def postCombatHyborem(pCaster, pOpponent):
	if not pCaster.isImmortal():
		iPlayer = pCaster.getOwner()
		pPlayer = gc.getPlayer(iPlayer)
		for iTrait in range(gc.getNumTraitInfos()):
			if iTrait != gc.getInfoTypeForString('TRAIT_FALLOW'):
				if pPlayer.hasTrait(iTrait):
					pPlayer.setHasTrait(iTrait,False)
		pOppPlayer = gc.getPlayer(pOpponent.getOwner())
		if pOppPlayer.isHuman():
			t = "TROPHY_DEFEATED_HYBOREM"
			if not CyGame().isHasTrophy(t):
				CyGame().changeTrophyValue(t, 1)

def postCombatLeviathan(pCaster, pOpponent):
	pPlayer = gc.getPlayer(pOpponent.getOwner())
	if pPlayer.isHuman():
		t = "TROPHY_DEFEATED_LEVIATHAN"
		if not CyGame().isHasTrophy(t):
			CyGame().changeTrophyValue(t, 1)

def postCombatOrthus(pCaster, pOpponent):
	pPlayer = gc.getPlayer(pOpponent.getOwner())
	if pPlayer.isHuman():
		t = "TROPHY_DEFEATED_ORTHUS"
		if not CyGame().isHasTrophy(t):
			CyGame().changeTrophyValue(t, 1)

def postCombatZarcaz(pCaster, pOpponent):
	pPlayer = gc.getPlayer(pOpponent.getOwner())
	if pPlayer.isHuman():
		t = "TROPHY_DEFEATED_ZARCAZ"
		if not CyGame().isHasTrophy(t):
			CyGame().changeTrophyValue(t, 1)			
			
def postCombatStephanos(pCaster, pOpponent):
	pPlayer = gc.getPlayer(pOpponent.getOwner())
	if pPlayer.isHuman():
		t = "TROPHY_DEFEATED_STEPHANOS"
		if not CyGame().isHasTrophy(t):
			CyGame().changeTrophyValue(t, 1)

def postCombatTreant(pCaster):
	pPlot = pCaster.plot()
	if pPlot.getFeatureType() == -1:
		if pPlot.canHaveFeature(gc.getInfoTypeForString('FEATURE_FOREST_NEW')):
			pPlot.setFeatureType(gc.getInfoTypeForString('FEATURE_FOREST_NEW'), 1)

def postCombatYersinia(pCaster, pOpponent):
	pPlayer = gc.getPlayer(pOpponent.getOwner())
	if pPlayer.isHuman():
		t = "TROPHY_DEFEATED_YERSINIA"
		if not CyGame().isHasTrophy(t):
			CyGame().changeTrophyValue(t, 1)

def postCombatReduceCombat1(pCaster, pOpponent):
	if pOpponent.isAlive():
		if pCaster.baseCombatStr() > 5:
			pCaster.changeStrBoost(-1)
			CyInterface().addMessage(pCaster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_STRENGTH_REDUCED", ()),'',1,'Art/Interface/Buttons/Units/Repentant Angel.dds',ColorTypes(7),pCaster.getX(),pCaster.getY(),True,True)

def postCombatReducePopulation(pCaster, pOpponent):
	pPlot = pOpponent.plot()
	if pPlot.isCity():
		pCity = pPlot.getPlotCity()
		if pCity.getPopulation() > 1:
			pCity.changePopulation(-1)
			CyInterface().addMessage(pCity.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_POPULATION_REDUCED", ()),'',1,'Art/Interface/Buttons/Units/Angel of Death.dds',ColorTypes(7),pCity.getX(),pCity.getY(),True,True)

def postCombatLostSailorsDirge(pCaster, pOpponent):
	iPlayer = pOpponent.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	iEvent = CvUtil.findInfoTypeNum(gc.getEventTriggerInfo, gc.getNumEventTriggerInfos(),'EVENTTRIGGER_SAILORS_DIRGE_DEFEATED')
	triggerData = pPlayer.initTriggeredData(iEvent, True, -1, pCaster.getX(), pCaster.getY(), iPlayer, -1, -1, -1, -1, -1)

def postCombatSplit(pCaster, pOpponent):
	gc 				= CyGlobalContext()
	getInfoType		= gc.getInfoTypeForString
	if pCaster.isHasPromotion(getInfoType('PROMOTION_WEAK')) == False:
		pPlayer = gc.getPlayer(pCaster.getOwner())
		iUnit = pCaster.getUnitType()
		newUnit = pPlayer.initUnit(iUnit, pCaster.getX(), pCaster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		newUnit2 = pPlayer.initUnit(iUnit, pCaster.getX(), pCaster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		newUnit.setHasPromotion(getInfoType('PROMOTION_STRONG'), False)
		newUnit2.setHasPromotion(getInfoType('PROMOTION_STRONG'), False)
		newUnit.setDamage(25, -1)
		newUnit2.setDamage(25, -1)
		if pCaster.isHasPromotion(getInfoType('PROMOTION_STRONG')) == False:
			newUnit.setHasPromotion(getInfoType('PROMOTION_WEAK'), True)
			newUnit2.setHasPromotion(getInfoType('PROMOTION_WEAK'), True)
		#Should we make this assign the units to the same Master as the original unit had?
		newUnit.setDuration(pCaster.getDuration())
		newUnit2.setDuration(pCaster.getDuration())
		CyInterface().addMessage(pCaster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_SPLIT", ()),'',1,gc.getUnitInfo(iUnit).getButton(),ColorTypes(7),pCaster.getX(),pCaster.getY(),True,True)

def postCombatWolfRider(pCaster, pOpponent):
	if (pOpponent.getUnitType() == gc.getInfoTypeForString('UNIT_WOLF') or pOpponent.getUnitType() == gc.getInfoTypeForString('UNIT_WOLF_PACK')):
		CyInterface().addMessage(pCaster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_WOLF_RIDER", ()),'',1,'Art/Interface/Buttons/Units/Wolf Rider.dds',ColorTypes(8),pCaster.getX(),pCaster.getY(),True,True)
		pPlayer = gc.getPlayer(pCaster.getOwner())
		newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_WOLF_RIDER'), pCaster.getX(), pCaster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		newUnit.convert(pCaster)
		
def babySpiderGrowth(pCaster, ePromotion):
	gc 			= CyGlobalContext()
	getInfoType	= gc.getInfoTypeForString
	CyInterface().addMessage(pCaster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_SPIDER_GROWTH", (pCaster.getName(), )),'',1,'Art/Interface/Buttons/Units/Spider.dds',ColorTypes(8),pCaster.getX(),pCaster.getY(),True,True)
	pPlayer 	= gc.getPlayer(pCaster.getOwner())
	
	iUnit 		= getInfoType('UNITCLASS_GIANT_SPIDER')
	infoCiv 	= gc.getCivilizationInfo(pPlayer.getCivilizationType())
	iUnit 		= infoCiv.getCivilizationUnits(iUnit)
	if iUnit == -1:
		iUnit = getInfoType('UNIT_GIANT_SPIDER')
	
	pCaster.safeRemovePromotion(ePromotion)
	newUnit = pPlayer.initUnit(iUnit, pCaster.getX(), pCaster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
	newUnit.convert(pCaster)
	return False
	
def HauntedLandsEffects(pCaster):
	gc 				= CyGlobalContext()
	getInfoType		= gc.getInfoTypeForString
	iHaunted 		= getInfoType('PROMOTION_HAUNTED')
	iSpooked 		= getInfoType('PROMOTION_SPOOKED')
	iShatteredNerve = getInfoType('PROMOTION_SHATTERED_NERVE')
	iUnwholesomeAddiction = getInfoType('PROMOTION_UNWHOLESOME_ADDICTION')
	iHauntedLands 	= getInfoType('FEATURE_HAUNTED_LANDS')
	setHasPromo		= pCaster.setHasPromotion
	
	pPlot = pCaster.plot()
	if pPlot.getFeatureType() != iHauntedLands:
		setHasPromo(iHaunted, False)
		setHasPromo(iUnwholesomeAddiction, False)
		setHasPromo(iSpooked, False)
		
	iSiege 		= getInfoType('UNITCOMBAT_SIEGE')
	iGolem 		= getInfoType('PROMOTION_GOLEM')
	iGhostwalker= getInfoType('UNIT_GHOSTWALKER')
	iCreeper 	= getInfoType('UNIT_CREEPER')
	
	randNum = CyGame().getSorenRandNum
	if randNum(9, "Haunted Lands Effects 1") == 1:
		if (pCaster.isAlive() or pCaster.getUnitType == iGhostwalker or pCaster.getUnitCombatType() == iSiege or pCaster.getRace() == iGolem):
			
			if pCaster.getUnitType == iGhostwalker:
				if pCaster.getDamage() > 50:
					if randNum(2, "HL wounded Ghostwalker creeper check") == 0:
						spawnUnit = pPlayer.initUnit(iCreeper, pCaster.getX(), pCaster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
						CyInterface().addMessage(pCaster.getOwner(),True,25,CyTranslator().getText("A Reaching Creeper is born of a Ghostwalker's blood.", ()),'',1,'Art/Interface/Buttons/Spells/creeper.dds',ColorTypes(8),pCaster.getX(),pCaster.getY(),True,True)
						return
		
			iUndead = getInfoType('PROMOTION_UNDEAD')
			iEstranged = getInfoType('PROMOTION_ESTRANGED')
			if pCaster.getDamage() >= 20:
				setHasPromo(iUndead, True)
				setHasPromo(iEstranged, True)
				CyInterface().addMessage(pCaster.getOwner(),True,25,CyTranslator().getText("A unit has succumbed to the Haunted Lands.", ()),'',1,'Art/Interface/Buttons/Promotions/Undead.dds',ColorTypes(8),pCaster.getX(),pCaster.getY(),True,True)
				return	
			
			iRnd = randNum(100, "Haunted Lands Effects 2")
			if iRnd < 30:
				CyInterface().addMessage(pCaster.getOwner(),True,25,CyTranslator().getText("The Haunted Lands have taken their toll.", ()),'',1,'Art/Interface/Buttons/Promotions/haunted.dds',ColorTypes(8),pCaster.getX(),pCaster.getY(),True,True)
				iRnd2 = randNum(17, "Haunted Lands Effects 3")
				if iRnd2 <= 2: 
					setHasPromo(iUnwholesomeAddiction, True)
				if (iRnd2 >=3 and iRnd2 <= 6):	
					setHasPromo(iShatteredNerve, True)
				if (iRnd2 >= 7 and iRnd2 <= 11):		
					setHasPromo(iHaunted, True)
				if (iRnd2 >= 12 and iRnd2 <= 17):
					setHasPromo(iSpooked, True)
			if iRnd < 10:
				iRnd3 = randNum(17, "Haunted Lands Effects 4")
				if iRnd3 <= 2: 
					setHasPromo(iUnwholesomeAddiction, True)
				if (iRnd3 >=3 and iRnd3 <= 6):	
					setHasPromo(iShatteredNerve, True)
				if (iRnd3 >= 7 and iRnd3 <= 11):		
					setHasPromo(iHaunted, True)
				if (iRnd3 >= 12 and iRnd3 <= 17):
					setHasPromo(iSpooked, True)	
		
def postCombatGainKnowledge(pCaster, pOpponent):
		iOpponentLevel = pOpponent.getLevel()
		if iOpponentLevel > 0:
				CyInterface().addMessage(pCaster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_GAIN_KNOWLEDGE", ()),'',1,'Art/Interface/Buttons/Units/Wolf Rider.dds',ColorTypes(8),pCaster.getX(),pCaster.getY(),True,True)
				pCaster.changeExperience(iOpponentLevel*2, 100, True, False, True)

def reqAddToFleshGolem(caster):
	if caster.isImmortal():
		return False
	if caster.isImmuneToMagic():
		return False
	if not caster.getMasterUnit().isNone():
		return False
	return True

def spellAddToFleshGolem(caster):
	gc 				= CyGlobalContext()
	getInfoType		= gc.getInfoTypeForString
	pPlayer 		= gc.getPlayer(caster.getOwner())
	pPlot 			= caster.plot()
#Can either use Tarq's fix (block all immortals) or this one (cancel any immortality).  Personally I don't care
#	caster.changeImmortal(-20)
	iChanneling 	= getInfoType('PROMOTION_CHANNELING')
	iChanneling2 	= getInfoType('PROMOTION_CHANNELING2')
	iChanneling3 	= getInfoType('PROMOTION_CHANNELING3')
	iDivine 		= getInfoType('PROMOTION_DIVINE')
	iUndead 		= getInfoType('PROMOTION_UNDEAD')
	iFleshGolem 	= getInfoType('UNITCLASS_FLESH_GOLEM')
	pFleshGolem = -1
	for i in xrange(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (caster.getOwner() == pUnit.getOwner() and pUnit.getUnitClassType() == iFleshGolem):
			pFleshGolem = pUnit
	if pFleshGolem != -1:
		if caster.baseCombatStr() > pFleshGolem.baseCombatStr():
			pFleshGolem.changeStrBoost(1)
		getPromInfo = gc.getPromotionInfo
		setHasPromo	= pFleshGolem.setHasPromotion
		for iCount in xrange(gc.getNumPromotionInfos()):
			if (caster.isHasPromotion(iCount)):
				if (iCount != iChanneling and iCount != iUndead and iCount != iChanneling2 and iCount != iChanneling3 and iCount != iDivine):
					if not getPromInfo(iCount).isRace():
						if getPromInfo(iCount).getBonusPrereq() == -1:
							if getPromInfo(iCount).getPromotionPrereqAnd() != iChanneling2:
								if getPromInfo(iCount).getPromotionPrereqAnd() != iChanneling3:
									if getPromInfo(iCount).isEquipment() == False:
										setHasPromo(iCount, True)
		if pFleshGolem.baseCombatStr() >= 15:
			if pPlayer.isHuman():
				t = "TROPHY_FEAT_FLESH_GOLEM_15"
				if not CyGame().isHasTrophy(t):
					CyGame().changeTrophyValue(t, 1)

def reqAddToFreakShowHuman(caster):
	if caster.getRace() != -1:
		return False
	return True

def reqArcaneLacuna(caster):
	gc 			= CyGlobalContext()
	pPlayer 	= gc.getPlayer(caster.getOwner())
	getInfoType	= gc.getInfoTypeForString
	manaTypes = [ 'BONUS_MANA_AIR','BONUS_MANA_BODY','BONUS_MANA_CHAOS','BONUS_MANA_DEATH','BONUS_MANA_EARTH','BONUS_MANA_ENCHANTMENT','BONUS_MANA_ENTROPY','BONUS_MANA_FIRE','BONUS_MANA_LAW','BONUS_MANA_LIFE','BONUS_MANA_METAMAGIC','BONUS_MANA_MIND','BONUS_MANA_NATURE','BONUS_MANA_SHADOW','BONUS_MANA_SPIRIT','BONUS_MANA_SUN','BONUS_MANA_WATER' ]
	iCount = 0
	getNumBoni 	= CyMap().getNumBonuses
	for szBonus in manaTypes:
		iBonus = getInfoType(szBonus)
		iCount += getNumBoni(iBonus)
	if iCount == 0:
		return False
	if not pPlayer.isHuman():
		if iCount < 7:
			return False
	return True

def spellArcaneLacuna(caster):
	gc 				= CyGlobalContext()
	getInfoType		= gc.getInfoTypeForString
	manaTypes 	= [ 'BONUS_MANA_AIR','BONUS_MANA_BODY','BONUS_MANA_CHAOS','BONUS_MANA_DEATH','BONUS_MANA_EARTH','BONUS_MANA_ENCHANTMENT','BONUS_MANA_ENTROPY','BONUS_MANA_FIRE','BONUS_MANA_LAW','BONUS_MANA_LIFE','BONUS_MANA_METAMAGIC','BONUS_MANA_MIND','BONUS_MANA_NATURE','BONUS_MANA_SHADOW','BONUS_MANA_SPIRIT','BONUS_MANA_SUN','BONUS_MANA_WATER' ]
	iAdept 		= getInfoType('UNITCOMBAT_ADEPT')
	iCount 		= 0
	getPlayer	= gc.getPlayer
	pPlayer 	= getPlayer(caster.getOwner())
	getNumBoni	= CyMap().getNumBonuses
	for szBonus in manaTypes:
		iBonus = getInfoType(szBonus)
		iCount += getNumBoni(iBonus)
	py = PyPlayer(caster.getOwner())
	for pUnit in py.getUnitList():
		if pUnit.getUnitCombatType() == iAdept:
			pUnit.changeExperience(iCount, -1, False, False, False)
	iDelay = 20
	eGameSpeed	= CyGame().getGameSpeedType()
	if eGameSpeed == getInfoType('GAMESPEED_QUICK'): 	iDelay = 14
	if eGameSpeed == getInfoType('GAMESPEED_EPIC'): 	iDelay = 30
	if eGameSpeed == getInfoType('GAMESPEED_MARATHON'):	iDelay = 60
	for iPlayer2 in xrange(gc.getMAX_PLAYERS()):
		pPlayer2 = getPlayer(iPlayer2)
		if pPlayer2.isAlive():
			if pPlayer2.getTeam() != pPlayer.getTeam():
				pPlayer2.changeDisableSpellcasting(iDelay)

def reqArdor(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.getGreatPeopleCreated() == 0:
		return False
	if pPlayer.isHuman() == False:
		if pPlayer.getGreatPeopleCreated() < 5:
			return False
	return True

def spellArdor(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	pPlayer.setGreatPeopleCreated(0)
	pPlayer.setGreatPeopleThresholdModifier(0)

def reqArenaBattle(caster):
	if caster.getUnitCombatType() == gc.getInfoTypeForString('UNITCOMBAT_MELEE'):
		return True
	if caster.getUnitCombatType() == gc.getInfoTypeForString('UNITCOMBAT_RECON'):
		return True
	if caster.getUnitClassType() == gc.getInfoTypeForString('UNITCLASS_SLAVE'):
		return True
	return False

def spellArenaBattle(caster):
	pCity = caster.plot().getPlotCity()
	pCity.changeHappinessTimer(3)
	if CyGame().getSorenRandNum(100, "Arena Battle") < 50:
		caster.changeExperience(CyGame().getSorenRandNum(6, "Arena Battle") + 1, -1, False, False, False)
		caster.setDamage(25, caster.getOwner())
		CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_ARENA_WIN", ()),'',1,'Art/Interface/Buttons/Buildings/Arena.dds',ColorTypes(8),caster.getX(),caster.getY(),True,True)
		if caster.getUnitClassType() == gc.getInfoTypeForString('UNITCLASS_SLAVE'):
			pPlayer = gc.getPlayer(caster.getOwner())
			newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_WARRIOR'), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
			newUnit.convert(caster)
	else:
		CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_ARENA_LOSE", ()),'',1,'Art/Interface/Buttons/Buildings/Arena.dds',ColorTypes(7),caster.getX(),caster.getY(),True,True)
		caster.kill(True, PlayerTypes.NO_PLAYER)

def reqCallBlizzard(caster):
	iBlizzard = gc.getInfoTypeForString('FEATURE_BLIZZARD')
	pPlot = caster.plot()
	if pPlot.getFeatureType() == iBlizzard:
		return False
	if pPlot.getFeatureType() == gc.getInfoTypeForString('FEATURE_FOREST_ANCIENT'):
		return False
	iX = caster.getX()
	iY = caster.getY()
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE1:
		pPlot = getPlot(iX+iiX,iY+iiY)
		if pPlot.getFeatureType() == iBlizzard:
			return True
	return False

def spellCallBlizzard(caster):
	iBlizzard = gc.getInfoTypeForString('FEATURE_BLIZZARD')
	iTundra = gc.getInfoTypeForString('TERRAIN_TUNDRA')
	iX = caster.getX()
	iY = caster.getY()
	pBlizPlot = -1
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE1:
		pPlot = getPlot(iX+iiX,iY+iiY)
		if pPlot.getFeatureType() == iBlizzard:
			pBlizPlot = pPlot
	if pBlizPlot != -1:
		pBlizPlot.setFeatureType(-1, -1)
	pPlot = caster.plot()
	pPlot.setFeatureType(iBlizzard, 0)
	Blizzards.doBlizzard(pPlot)		#Added in Frozen: TC01
	
#Old Code:
#	if pPlot.getTerrainType() == gc.getInfoTypeForString('TERRAIN_GRASS'):
#		pPlot.setTerrainType(iTundra,True,True)
#	if pPlot.getTerrainType() == gc.getInfoTypeForString('TERRAIN_PLAINS'):
#		pPlot.setTerrainType(iTundra,True,True)
#	if pPlot.getTerrainType() == gc.getInfoTypeForString('TERRAIN_DESERT'):
#		pPlot.setTerrainType(iTundra,True,True)

def reqCallForm(caster):
	if caster.getSummoner() == -1:
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	pUnit = pPlayer.getUnit(caster.getSummoner())
	pPlot = caster.plot()
	if not pUnit.canMoveInto(pPlot, False, False, False):
		return False
	return True

def spellCallForm(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	pUnit = pPlayer.getUnit(caster.getSummoner())
	pPlot = caster.plot()
	pUnit.setXY(pPlot.getX(), pPlot.getY(), False, True, True)

def reqCallOfTheGrave(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	iX = caster.getX()
	iY = caster.getY()
	eTeam = gc.getTeam(pPlayer.getTeam())
	iGraveyard = gc.getInfoTypeForString('IMPROVEMENT_GRAVEYARD')
	iUndead = gc.getInfoTypeForString('PROMOTION_UNDEAD')
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE2:
		pPlot = getPlot(iX+iiX,iY+iiY)
		for i in xrange(pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(i)
			p2Player = gc.getPlayer(pUnit.getOwner())
			e2Team = p2Player.getTeam()
			if eTeam.isAtWar(e2Team) == True:
				return True
			if pUnit.isHasPromotion(iUndead) == True:
				if pUnit.getDamage() != 0:
					return True
			if pPlot.getImprovementType() == iGraveyard:
				return True
	return False

def spellCallOfTheGrave(caster):
	gc 				= CyGlobalContext()
	getInfoType		= gc.getInfoTypeForString
	getPlayer		= gc.getPlayer
	pPlayer 		= getPlayer(caster.getOwner())
	iX = caster.getX()
	iY = caster.getY()
	eTeam 		= gc.getTeam(pPlayer.getTeam())
	iGraveyard 	= getInfoType('IMPROVEMENT_GRAVEYARD')
	iUndead 	= getInfoType('PROMOTION_UNDEAD')
	iWraith		= getInfoType('UNIT_WRAITH')
	iDeath		= getInfoType('DAMAGE_DEATH')
	initUnit	= pPlayer.initUnit
	getPlot		= CyMap().plot
	iNoAI		= UnitAITypes.NO_UNITAI
	iSouth		= DirectionTypes.DIRECTION_SOUTH
	trigger		= CyEngine().triggerEffect
	iSacrifice	= getInfoType('EFFECT_SACRIFICE')
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE2:
		pPlot = getPlot(iX+iiX,iY+iiY)
		bValid = False
		for i in xrange(pPlot.getNumUnits()):
			pUnit 		= pPlot.getUnit(i)
			p2Player 	= gc.getPlayer(pUnit.getOwner())
			e2Team 		= p2Player.getTeam()
			if eTeam.isAtWar(e2Team) == True:
				pUnit.doDamage(40, 100, caster, iDeath, True)
				bValid = True
			else:
				if pUnit.isHasPromotion(iUndead) == True:
					if pUnit.getDamage() != 0:
						pUnit.setDamage(0, caster.getOwner())
			if pPlot.getImprovementType() == iGraveyard:
				pPlot.setImprovementType(-1)
				initUnit(iWraith, iiX, iiY, iNoAI, iSouth)
				initUnit(iWraith, iiX, iiY, iNoAI, iSouth)
				initUnit(iWraith, iiX, iiY, iNoAI, iSouth)
				bValid = True
		if bValid:
			trigger(iSacrifice,pPlot.getPoint())

def reqCommanderJoin(caster):
	gc 				= CyGlobalContext()
	getInfoType		= gc.getInfoTypeForString
	pPlayer = gc.getPlayer(caster.getOwner())
	pPlot = caster.plot()
	if caster.isHasPromotion(getInfoType('PROMOTION_GREAT_COMMANDER')):
		return False
	iCommander = getInfoType('UNITCLASS_COMMANDER')
	pCommander = -1
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (caster.getOwner() == pUnit.getOwner() and pUnit.getUnitClassType() == iCommander):
			pCommander = pUnit
	if pCommander == -1:
		return False
	if pCommander.isHasCasted():
		return False
	if pPlayer.isHuman() == False:
		if caster.baseCombatStr() <= 5:
			return False
	return True

def spellCommanderJoin(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	pPlot = caster.plot()
	iCommander = gc.getInfoTypeForString('UNITCLASS_COMMANDER')
	pCommander = -1
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (caster.getOwner() == pUnit.getOwner() and pUnit.getUnitClassType() == iCommander):
			pCommander = pUnit
	if pCommander != -1:
		pCommander.setHasPromotion(gc.getInfoTypeForString('PROMOTION_GOLEM'), True)
		pCommander.kill(False, PlayerTypes.NO_PLAYER)

def spellCommanderJoinDecius(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	pPlot = caster.plot()
	iDecius = gc.getInfoTypeForString('UNIT_DECIUS')
	pCommander = -1
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (caster.getOwner() == pUnit.getOwner() and pUnit.getUnitType() == iDecius):
			pCommander = pUnit
	if pCommander != -1:
		caster.setScenarioCounter(iDecius)
		pCommander.setHasPromotion(gc.getInfoTypeForString('PROMOTION_GOLEM'), True)
		pCommander.kill(False, PlayerTypes.NO_PLAYER)

def spellCommanderSplit(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	iCommander = gc.getInfoTypeForString('UNIT_COMMANDER')
	if caster.getScenarioCounter() == gc.getInfoTypeForString('UNIT_DECIUS'):
		iCommander = gc.getInfoTypeForString('UNIT_DECIUS')
		caster.setScenarioCounter(-1)
	newUnit = pPlayer.initUnit(iCommander, caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)

def reqConvertCityBasium(caster):
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	if pCity.getOwner() == caster.getOwner():
		return False
	return True

def spellConvertCityBasium(caster):
	pCity = caster.plot().getPlotCity()
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	pPlayer.acquireCity(pCity,False,False)
	pCity = caster.plot().getPlotCity()
	pCity.changeCulture(iPlayer, 300, True)

def reqConvertCityRantine(caster):
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	if pCity.getOwner() == caster.getOwner():
		return False
	if pCity.getOwner() != gc.getORC_PLAYER():
		return False
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.getOwner() == gc.getORC_PLAYER():
			if pUnit.baseCombatStr() > caster.baseCombatStr():
				return False
	return True

def spellConvertCityRantine(caster):
	pCity = caster.plot().getPlotCity()
	pPlayer = gc.getPlayer(caster.getOwner())
	pPlayer.acquireCity(pCity,False,False)


def spellPaxDiabolis(caster):
	pCity = caster.plot().getPlotCity()
	iPop = pCity.getPopulation()
	gc	= CyGlobalContext()
	getInfoType = gc.getInfoTypeForString
	giftUnit = CvEventInterface.getEventManager().cf.giftUnit
	if CyGame().countKnownTechNumTeams(getInfoType('TECH_INFERNAL_PACT')) > 0 and CyGame().getNumCivActive(getInfoType('CIVILIZATION_INFERNAL')) > 0:
		for iX in xrange(iPop):
			giftUnit(getInfoType('UNIT_MANES'), getInfoType('CIVILIZATION_INFERNAL'), 0, caster.plot(), caster.getOwner())
	pCity.kill()
	
	pPlayer = gc.getPlayer(caster.getOwner())
	iDemonTeam = gc.getPlayer(gc.getDEMON_PLAYER()).getTeam()
	eTeam = gc.getTeam(pPlayer.getTeam())
	eTeam.makePeace(iDemonTeam)


def spellCreateBatteringRam(caster):
	pPlot = caster.plot()
	pPlot.setFeatureType(-1, -1)

def reqCreateDenBear(caster):
	if gc.getGame().isOption(GameOptionTypes.GAMEOPTION_NO_LAIRS):
		return False
	iImprovement = gc.getInfoTypeForString('IMPROVEMENT_BEAR_DEN')
	if caster.getDamage() > 0:
		return False
	pPlot = caster.plot()
	if pPlot.isOwned():
		return False
	if pPlot.getNumUnits() != 1:
		return False
	if pPlot.getImprovementType() != -1:
		return False
	iX = pPlot.getX()
	iY = pPlot.getY()
	for iiX in xrange(iX-4, iX+5, 1):
		for iiY in xrange(iY-4, iY+5, 1):
			pPlot2 = CyMap().plot(iiX,iiY)
			if pPlot2.getImprovementType() == iImprovement:
				return False
	return True

def spellCreateDenBear(caster):
	pPlot = caster.plot()
	iImprovement = gc.getInfoTypeForString('IMPROVEMENT_BEAR_DEN')
	iUnit = gc.getInfoTypeForString('UNIT_BEAR_PACK')
	pPlot.setImprovementType(iImprovement)
	pPlot2 = findClearPlot(-1, caster.plot())
	if pPlot2 != -1:
		caster.setXY(pPlot2.getX(), pPlot2.getY(), False, True, True)
		pPlayer = gc.getPlayer(gc.getANIMAL_PLAYER())
		newUnit = pPlayer.initUnit(iUnit, pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		newUnit.convert(caster)
		
def reqCreateDenCaveBear(caster):
	if gc.getGame().isOption(GameOptionTypes.GAMEOPTION_NO_LAIRS):
		return False
	iImprovement = gc.getInfoTypeForString('IMPROVEMENT_CAVE_BEAR_DEN')
	if caster.getDamage() > 0:
		return False
	pPlot = caster.plot()
	if pPlot.isOwned():
		return False
	if pPlot.getNumUnits() != 1:
		return False
	if pPlot.getImprovementType() != -1:
		return False
	iX = pPlot.getX()
	iY = pPlot.getY()
	for iiX in range(iX-4, iX+5, 1):
		for iiY in range(iY-4, iY+5, 1):
			pPlot2 = CyMap().plot(iiX,iiY)
			if pPlot2.getImprovementType() == iImprovement:
				return False
	return True

def spellCreateDenCaveBear(caster):
	pPlot = caster.plot()
	iImprovement = gc.getInfoTypeForString('IMPROVEMENT_CAVE_BEAR_DEN')
	iUnit = gc.getInfoTypeForString('UNIT_CAVE_BEAR_PACK')
	pPlot.setImprovementType(iImprovement)
	pPlot2 = findClearPlot(-1, caster.plot())
	if pPlot2 != -1:
		caster.setXY(pPlot2.getX(), pPlot2.getY(), False, True, True)
		pPlayer = gc.getPlayer(gc.getANIMAL_PLAYER())
		newUnit = pPlayer.initUnit(iUnit, pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		newUnit.convert(caster)

def reqCreateDenLion(caster):
	if gc.getGame().isOption(GameOptionTypes.GAMEOPTION_NO_LAIRS):
		return False
	iImprovement = gc.getInfoTypeForString('IMPROVEMENT_LION_DEN')
	if caster.getDamage() > 0:
		return False
	pPlot = caster.plot()
	if pPlot.isOwned():
		return False
	if pPlot.getNumUnits() != 1:
		return False
	if pPlot.getImprovementType() != -1:
		return False
	iX = pPlot.getX()
	iY = pPlot.getY()
	for iiX in range(iX-4, iX+5, 1):
		for iiY in range(iY-4, iY+5, 1):
			pPlot2 = CyMap().plot(iiX,iiY)
			if pPlot2.getImprovementType() == iImprovement:
				return False
	return True

def spellCreateDenLion(caster):
	pPlot = caster.plot()
	iImprovement = gc.getInfoTypeForString('IMPROVEMENT_LION_DEN')
	iUnit = gc.getInfoTypeForString('UNIT_LION_PRIDE')
	pPlot.setImprovementType(iImprovement)
	pPlot2 = findClearPlot(-1, caster.plot())
	if pPlot2 != -1:
		caster.setXY(pPlot2.getX(), pPlot2.getY(), False, True, True)
		pPlayer = gc.getPlayer(gc.getANIMAL_PLAYER())
		newUnit = pPlayer.initUnit(iUnit, pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		newUnit.convert(caster)

def reqCreateDenSabretooth(caster):
	if gc.getGame().isOption(GameOptionTypes.GAMEOPTION_NO_LAIRS):
		return False
	iImprovement = gc.getInfoTypeForString('IMPROVEMENT_SABRETOOTH_DEN')
	if caster.getDamage() > 0:
		return False
	pPlot = caster.plot()
	if pPlot.isOwned():
		return False
	if pPlot.getNumUnits() != 1:
		return False
	if pPlot.getImprovementType() != -1:
		return False
	iX = pPlot.getX()
	iY = pPlot.getY()
	for iiX in range(iX-4, iX+5, 1):
		for iiY in range(iY-4, iY+5, 1):
			pPlot2 = CyMap().plot(iiX,iiY)
			if pPlot2.getImprovementType() == iImprovement:
				return False
	return True

def spellCreateDenSabretooth(caster):
	pPlot = caster.plot()
	iImprovement = gc.getInfoTypeForString('IMPROVEMENT_SABRETOOTH_DEN')
	iUnit = gc.getInfoTypeForString('UNIT_SABRETOOTH_PRIDE')
	pPlot.setImprovementType(iImprovement)
	pPlot2 = findClearPlot(-1, caster.plot())
	if pPlot2 != -1:
		caster.setXY(pPlot2.getX(), pPlot2.getY(), False, True, True)
		pPlayer = gc.getPlayer(gc.getANIMAL_PLAYER())
		newUnit = pPlayer.initUnit(iUnit, pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		newUnit.convert(caster)
		
def reqCreateDenGriffon(caster):
	if gc.getGame().isOption(GameOptionTypes.GAMEOPTION_NO_LAIRS):
		return False
	iImprovement = gc.getInfoTypeForString('IMPROVEMENT_GRIFFON_WEYR')
	if caster.getDamage() > 0:
		return False
	pPlot = caster.plot()
	if pPlot.isOwned():
		return False
	if pPlot.getNumUnits() != 1:
		return False
	if pPlot.getImprovementType() != -1:
		return False
	iX = pPlot.getX()
	iY = pPlot.getY()
	for iiX in range(iX-4, iX+5, 1):
		for iiY in range(iY-4, iY+5, 1):
			pPlot2 = CyMap().plot(iiX,iiY)
			if pPlot2.getImprovementType() == iImprovement:
				return False
	return True

def spellCreateDenGriffon(caster):
	pPlot = caster.plot()
	iImprovement = gc.getInfoTypeForString('IMPROVEMENT_GRIFFON_WEYR')
	iUnit = gc.getInfoTypeForString('UNIT_GRIFFON_PACK')
	pPlot.setImprovementType(iImprovement)
	pPlot2 = findClearPlot(-1, caster.plot())
	if pPlot2 != -1:
		caster.setXY(pPlot2.getX(), pPlot2.getY(), False, True, True)
		pPlayer = gc.getPlayer(gc.getANIMAL_PLAYER())
		newUnit = pPlayer.initUnit(iUnit, pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		newUnit.convert(caster)
		
def reqCreateDenHippogriff(caster):
	if gc.getGame().isOption(GameOptionTypes.GAMEOPTION_NO_LAIRS):
		return False
	iImprovement = gc.getInfoTypeForString('IMPROVEMENT_HIPPOGRIFF_WEYR')
	if caster.getDamage() > 0:
		return False
	pPlot = caster.plot()
	if pPlot.isOwned():
		return False
	if pPlot.getNumUnits() != 1:
		return False
	if pPlot.getImprovementType() != -1:
		return False
	iX = pPlot.getX()
	iY = pPlot.getY()
	for iiX in range(iX-4, iX+5, 1):
		for iiY in range(iY-4, iY+5, 1):
			pPlot2 = CyMap().plot(iiX,iiY)
			if pPlot2.getImprovementType() == iImprovement:
				return False
	return True

def spellCreateDenHippogriff(caster):
	pPlot = caster.plot()
	iImprovement = gc.getInfoTypeForString('IMPROVEMENT_HIPPOGRIFF_WEYR')
	iUnit = gc.getInfoTypeForString('UNIT_HIPPOGRIFF_FLIGHT')
	pPlot.setImprovementType(iImprovement)
	pPlot2 = findClearPlot(-1, caster.plot())
	if pPlot2 != -1:
		caster.setXY(pPlot2.getX(), pPlot2.getY(), False, True, True)
		pPlayer = gc.getPlayer(gc.getANIMAL_PLAYER())
		newUnit = pPlayer.initUnit(iUnit, pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		newUnit.convert(caster)
		
def reqCreateDenWolf(caster):
	if gc.getGame().isOption(GameOptionTypes.GAMEOPTION_NO_LAIRS):
		return False
	iImprovement = gc.getInfoTypeForString('IMPROVEMENT_DEN_WOLF')
	if caster.getDamage() > 0:
		return False
	pPlot = caster.plot()
	if pPlot.isOwned():
		return False
	if pPlot.getNumUnits() != 1:
		return False
	if pPlot.getImprovementType() != -1:
		return False
	iX = pPlot.getX()
	iY = pPlot.getY()
	for iiX in range(iX-4, iX+5, 1):
		for iiY in range(iY-4, iY+5, 1):
			pPlot2 = CyMap().plot(iiX,iiY)
			if pPlot2.getImprovementType() == iImprovement:
				return False
	return True

def spellCreateDenWolf(caster):
	pPlot = caster.plot()
	iImprovement = gc.getInfoTypeForString('IMPROVEMENT_DEN_WOLF')
	iUnit = gc.getInfoTypeForString('UNIT_WOLF_PACK')
	pPlot.setImprovementType(iImprovement)
	pPlot2 = findClearPlot(-1, caster.plot())
	if pPlot2 != -1:
		caster.setXY(pPlot2.getX(), pPlot2.getY(), False, True, True)
		pPlayer = gc.getPlayer(gc.getANIMAL_PLAYER())
		newUnit = pPlayer.initUnit(iUnit, pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		newUnit.convert(caster)

def reqCreateDenSpider(caster):
	if gc.getGame().isOption(GameOptionTypes.GAMEOPTION_NO_LAIRS):
		return False
	iImprovement = gc.getInfoTypeForString('IMPROVEMENT_DEN_SPIDER')
	if caster.getDamage() > 0:
		return False
	pPlot = caster.plot()
	if pPlot.isOwned():
		return False
	if pPlot.getNumUnits() != 1:
		return False
	if pPlot.getImprovementType() != -1:
		return False
	iX = pPlot.getX()
	iY = pPlot.getY()
	for iiX in range(iX-4, iX+5, 1):
		for iiY in range(iY-4, iY+5, 1):
			pPlot2 = CyMap().plot(iiX,iiY)
			if pPlot2.getImprovementType() == iImprovement:
				return False
	return True

def spellCreateDenSpider(caster):
	pPlot = caster.plot()
	iImprovement = gc.getInfoTypeForString('IMPROVEMENT_DEN_SPIDER')
	iUnit = gc.getInfoTypeForString('UNIT_GIANT_SPIDER')
	pPlot.setImprovementType(iImprovement)
	pPlot2 = findClearPlot(-1, caster.plot())
	if pPlot2 != -1:
		caster.setXY(pPlot2.getX(), pPlot2.getY(), False, True, True)
		pPlayer = gc.getPlayer(gc.getANIMAL_PLAYER())
		newUnit = pPlayer.initUnit(iUnit, pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		newUnit.convert(caster)

def effectCrownOfBrillance(caster):
	caster.cast(gc.getInfoTypeForString('SPELL_CROWN_OF_BRILLANCE'))

def reqCrownOfBrillance(caster):
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_CROWN_OF_BRILLANCE')):
		return False
	return True

def HyboremAI(caster):
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_IMMORTAL')):
		return
	else:
		caster.setUnitAIType(gc.getInfoTypeForString('UNITAI_CITY_DEFENSE'))

def reqCrush(caster):
	iX = caster.getX()
	iY = caster.getY()
	pPlayer = gc.getPlayer(caster.getOwner())
	iTeam = pPlayer.getTeam()
	eTeam = gc.getTeam(iTeam)
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE2:
		pPlot = getPlot(iX+iiX,iY+iiY)
		bEnemy = False
		bNeutral = False
		for i in xrange(pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(i)
			if eTeam.isAtWar(pUnit.getTeam()):
				bEnemy = True
			else:
				bNeutral = True
		if (bEnemy and bNeutral == False):
			return True
	return False

def spellCrush(caster):
	iX = caster.getX()
	iY = caster.getY()
	pPlayer = gc.getPlayer(caster.getOwner())
	iTeam = pPlayer.getTeam()
	eTeam = gc.getTeam(iTeam)
	iBestValue = 0
	pBestPlot = -1
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE2:
		pPlot = getPlot(iX+iiX,iY+iiY)
		bNeutral = False
		iValue = 0
		for i in range(pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(i)
			if eTeam.isAtWar(pUnit.getTeam()):
				iValue = iValue + 10
			else:
				bNeutral = True
		if (iValue > iBestValue and bNeutral == False):
			iBestValue = iValue
			pBestPlot = pPlot
	if pBestPlot != -1:
		for i in range(pBestPlot.getNumUnits()):
			pUnit = pBestPlot.getUnit(i)
			pUnit.doDamage(50, 75, caster, gc.getInfoTypeForString('DAMAGE_PHYSICAL'), True)
		CyEngine().triggerEffect(gc.getInfoTypeForString('EFFECT_CRUSH'),pBestPlot.getPoint())

def reqBanishment(caster):
	iUndead = gc.getInfoTypeForString('PROMOTION_UNDEAD')
	iDemon = gc.getInfoTypeForString('PROMOTION_DEMON')
	iX = caster.getX()
	iY = caster.getY()
	pPlayer = gc.getPlayer(caster.getOwner())
	eTeam = pPlayer.getTeam()
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE1:
		pPlot = getPlot(iX+iiX,iY+iiY)
		for i in xrange(pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(i)
			if pUnit.isHasPromotion(iUndead) or pUnit.isHasPromotion(iDemon):
				if pPlayer.isHuman():
					return True
				p2Player = gc.getPlayer(pUnit.getOwner())
				e2Team = gc.getTeam(p2Player.getTeam())
				if e2Team.isAtWar(eTeam):
					return True
	return False

def spellBanishment(caster):
	iUndead = gc.getInfoTypeForString('PROMOTION_UNDEAD')
	iDemon = gc.getInfoTypeForString('PROMOTION_DEMON')
	iX = caster.getX()
	iY = caster.getY()
	iIra = gc.getInfoTypeForString('UNIT_IRA')
	pPlayer = gc.getPlayer(caster.getOwner())
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE1:
		pPlot = getPlot(iX+iiX,iY+iiY)
		for i in xrange(pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(i)
			if pUnit.isHasPromotion(iUndead) or pUnit.isHasPromotion(iDemon):
				pUnit.doDamage(20, 50, caster, gc.getInfoTypeForString('DAMAGE_HOLY'), True)
			if pUnit.getUnitType() == iIra:
				iStrength = pUnit.getStrBoost()
				if iStrength >= 0:
					pUnit.changeStrBoost(-4)

def reqDispelMagic(caster):
	iScions = gc.getInfoTypeForString('CIVILIZATION_SCIONS')
	if caster.canDispel(gc.getInfoTypeForString('SPELL_DISPEL_MAGIC')):
		return True
	pPlot = caster.plot()
	if pPlot.getBonusType(-1) != -1:
		if gc.getBonusInfo(pPlot.getBonusType(-1)).getBonusClassType() == gc.getInfoTypeForString('BONUSCLASS_MANA'):
			if pPlot.getImprovementType() == -1:
				return True
			if gc.getImprovementInfo(pPlot.getImprovementType()).isPermanent() == False:
				return True
	iHauntedLands = gc.getInfoTypeForString('FEATURE_HAUNTED_LANDS')
	iX = pPlot.getX()
	iY = pPlot.getY()
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE1:
		pPlot = getPlot(iX+iiX,iY+iiY)	
		if pPlot.isOwned():
			if gc.getPlayer(pPlot.getOwner()).getCivilizationType() != iScions:	
				if pPlot.getFeatureType() == iHauntedLands:
					return True
		if not pPlot.isOwned():
			if pPlot.getFeatureType() == iHauntedLands:
				return True	
	return False

def spellDispelMagic(caster):
	iScions = gc.getInfoTypeForString('CIVILIZATION_SCIONS')
	pPlot = caster.plot()
	if pPlot.getBonusType(-1) != -1:
		if gc.getBonusInfo(pPlot.getBonusType(-1)).getBonusClassType() == gc.getInfoTypeForString('BONUSCLASS_MANA'):
			if pPlot.getImprovementType() == -1:
				pPlot.setBonusType(gc.getInfoTypeForString('BONUS_MANA'))
			else:
				if gc.getImprovementInfo(pPlot.getImprovementType()).isPermanent() == False:
					pPlot.setBonusType(gc.getInfoTypeForString('BONUS_MANA'))
					pPlot.setImprovementType(-1)
	iX = pPlot.getX()
	iY = pPlot.getY()
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE1:
		pPlot = getPlot(iX+iiX,iY+iiY)
		if pPlot.getFeatureType() == gc.getInfoTypeForString('FEATURE_HAUNTED_LANDS'):	
			if pPlot.isOwned():
				if gc.getPlayer(pPlot.getOwner()).getCivilizationType() != iScions:	
					pPlot.setFeatureType(-1, -1)
			else:
				pPlot.setFeatureType(-1, -1)

def reqDisrupt(caster):
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	if caster.getTeam() == pCity.getTeam():
		return False
	if pCity.getTeam() == gc.getORC_TEAM():
		return False
	return True

def spellDisrupt(caster):
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	iPlayer2 = pCity.getOwner()
	pPlayer2 = gc.getPlayer(iPlayer2)
	pCity.changeHurryAngerTimer(2)
	iRnd = CyGame().getSorenRandNum(3, "Disrupt")
	if iRnd != 0:
		pCity.changeCulture(iPlayer2,-1 * iRnd,True)
	CyInterface().addMessage(iPlayer,True,25,CyTranslator().getText("TXT_KEY_MESSAGE_DISRUPT_ENEMY",()),'',1,'Art/Interface/Buttons/Spells/Disrupt.dds',ColorTypes(8),pCity.getX(),pCity.getY(),True,True)
	CyInterface().addMessage(iPlayer2,True,25,CyTranslator().getText("TXT_KEY_MESSAGE_DISRUPT",()),'',1,'Art/Interface/Buttons/Spells/Disrupt.dds',ColorTypes(7),pCity.getX(),pCity.getY(),True,True)
	if pCity.getCulture(iPlayer2) < 1:
		pPlayer.acquireCity(pCity,False,False)
		pPlayer2.AI_changeAttitudeExtra(iPlayer,-4)

def reqDivineRetribution(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		iTeam = gc.getPlayer(caster.getOwner()).getTeam()
		eTeam = gc.getTeam(iTeam)
		if eTeam.getAtWarCount(True) < 2:
			return False
	return True

def spellDivineRetribution(caster):
	gc 				= CyGlobalContext()
	getInfoType		= gc.getInfoTypeForString
	iDemon 			= getInfoType('PROMOTION_DEMON')
	iUndead 		= getInfoType('PROMOTION_UNDEAD')
	iScions 		= getInfoType('CIVILIZATION_SCIONS')
	iBlackLady 		= getInfoType('UNIT_KORRINA_BLACK_LADY')
	iBlackLadyHaunt = getInfoType('UNIT_HAUNT_KORRINA')
	iHoly			= getInfoType('DAMAGE_HOLY')
	getPlayer		= gc.getPlayer
	for iPlayer in xrange(gc.getMAX_PLAYERS()):
		if getPlayer(iPlayer).isAlive():
			py = PyPlayer(iPlayer)
			for pUnit in py.getUnitList():
				if (pUnit.getRace() == iDemon or pUnit.isHasPromotion(iUndead) == True) and pUnit.getCivilizationType() != iScions:
					pUnit.doDamage(50, 100, caster, iHoly, False)
				if pUnit.getCivilizationType() == iScions and pUnit.getUnitType() != iBlackLady:
					if pUnit.getUnitType() != iBlackLadyHaunt:
						pUnit.doDamage(25, 100, caster, iHoly, False)

def reqDomination(caster):
	iX = caster.getX()
	iY = caster.getY()
	pPlayer = gc.getPlayer(caster.getOwner())
	if caster.getNumForcedMinions() >= 3:
		return False
	iResistMax = 95
	if pPlayer.isHuman() == False:
		iResistMax = 20
	iTeam 	= pPlayer.getTeam()
	eTeam 	= gc.getTeam(iTeam)
	isAtWar	= eTeam.isAtWar
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE1:
		pPlot = getPlot(iX+iiX,iY+iiY)
		for i in xrange(pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(i)
			if pUnit.isAlive():
				if not pUnit.isDelayedDeath():
					if isAtWar(pUnit.getTeam()):
						iResist = pUnit.getResistChance(caster, gc.getInfoTypeForString('SPELL_DOMINATION'))
						if iResist <= iResistMax:
							return True
	return False

def spellDomination(caster):
	gc 				= CyGlobalContext()
	getInfoType		= gc.getInfoTypeForString
	iSpell 			= getInfoType('SPELL_DOMINATION')
	iX = caster.getX()
	iY = caster.getY()
	pPlayer = gc.getPlayer(caster.getOwner())
	iResistMax = 95
	iBestValue = 0
	pBestUnit = -1
	if not pPlayer.isHuman():
		iResistMax = 20
	iTeam 	= pPlayer.getTeam()
	eTeam 	= gc.getTeam(iTeam)
	isAtWar	= eTeam.isAtWar
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE1:
		pPlot = getPlot(iX+iiX,iY+iiY)
		for i in xrange(pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(i)
			iValue = 0
			if pUnit.isAlive():
				if pUnit.isDelayedDeath() == False:
					if isAtWar(pUnit.getTeam()):
						iResist = pUnit.getResistChance(caster, iSpell)
						if iResist <= iResistMax:
							iValue = pUnit.baseCombatStr() * 10
							iValue = iValue + (100 - iResist)
							if iValue > iBestValue:
								iBestValue = iValue
								pBestUnit = pUnit
	if pBestUnit != -1:
		pPlot = caster.plot()
		iPreviousOwner = pBestUnit.getOwner()
		if pBestUnit.isResisted(caster, iSpell) == False:
			CyInterface().addMessage(pBestUnit.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_DOMINATION", ()),'',1,'Art/Interface/Buttons/Spells/Domination.dds',ColorTypes(7),pBestUnit.getX(),pBestUnit.getY(),True,True)
			CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_DOMINATION_ENEMY", ()),'',1,'Art/Interface/Buttons/Spells/Domination.dds',ColorTypes(8),pPlot.getX(),pPlot.getY(),True,True)
			newUnit = pPlayer.initUnit(pBestUnit.getUnitType(), pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
			newUnit.convert(pBestUnit)
			newUnit.changeImmobileTimer(1)
			newUnit.setPreviousOwner(iPreviousOwner)
			caster.addMinion(newUnit)
		else:
			CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_DOMINATION_FAILED", ()),'',1,'Art/Interface/Buttons/Spells/Domination.dds',ColorTypes(7),pPlot.getX(),pPlot.getY(),True,True)

def reqEarthquake(caster):
	iX = caster.getX()
	iY = caster.getY()
	pPlayer = gc.getPlayer(caster.getOwner())
	if not pPlayer.isHuman():
		eTeam = pPlayer.getTeam()
		getPlot	= CyMap().plot
		for iiX,iiY in RANGE1:
			pPlot = getPlot(iX+iiX,iY+iiY)
			p2Player = gc.getPlayer(pPlot.getOwner())
			if pPlot.isOwned():
				e2Team = gc.getTeam(p2Player.getTeam())
				if e2Team.isAtWar(eTeam) == False:
					return False
	return True

def spellEarthquake(caster):
	iX = caster.getX()
	iY = caster.getY()
	pPlayer = gc.getPlayer(caster.getOwner())
	eTeam = pPlayer.getTeam()
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE1:
		pPlot = getPlot(iX+iiX,iY+iiY)
		if not pPlot.isNone():
			if (pPlot.isCity() or pPlot.getImprovementType() != -1):
				if pPlot.isOwned():
					startWar(caster.getOwner(), pPlot.getOwner(), WarPlanTypes.WARPLAN_TOTAL)
			if pPlot.isCity():
				pCity = pPlot.getPlotCity()
				for i in xrange(gc.getNumBuildingInfos()):
					iRnd = CyGame().getSorenRandNum(100, "Bob")
					if (gc.getBuildingInfo(i).getConquestProbability() != 100 and iRnd <= 25):
						pCity.setNumRealBuilding(i, 0)
			for iUnit in xrange(pPlot.getNumUnits()):
				pUnit = pPlot.getUnit(iUnit)
				if pUnit.isFlying() == False:
					pUnit.setFortifyTurns(0)
			iRnd = CyGame().getSorenRandNum(100, "Bob")
			if iRnd <= 25:
				iImprovement = pPlot.getImprovementType()
				if iImprovement != -1:
					if gc.getImprovementInfo(iImprovement).isPermanent() == False:
						pPlot.setImprovementType(-1)

def spellEnterPortal(caster):
	pPlot = caster.plot()
	iX = pPlot.getPortalExitX()
	iY = pPlot.getPortalExitY()
	pExitPlot = CyMap().plot(iX,iY)
	if not pPlot.isNone():
		caster.setXY(iX, iY, False, True, True)

def reqEntertain(caster):
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	if pCity.getTeam() == gc.getORC_TEAM():
		return False
	return True

def spellEntertain(caster):
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	iPlayer = caster.getOwner()
	iPlayer2 = pCity.getOwner()
	if iPlayer != iPlayer2:
		pPlayer = gc.getPlayer(iPlayer)
		pPlayer2 = gc.getPlayer(iPlayer2)
		iGold = (pCity.getPopulation() / 2) + 1
		pPlayer.changeGold(iGold)
		szBuffer = CyTranslator().getText("TXT_KEY_MESSAGE_ENTERTAIN_GOOD", (iGold, ))
		CyInterface().addMessage(iPlayer,True,25,szBuffer,'',1,'Art/Interface/Buttons/Spells/Entertain.dds',ColorTypes(8),pCity.getX(),pCity.getY(),True,True)
		iGold = iGold * -1
		pPlayer2.changeGold(iGold)
		szBuffer = CyTranslator().getText("TXT_KEY_MESSAGE_ENTERTAIN_BAD", (iGold, ))
		CyInterface().addMessage(iPlayer2,True,25,szBuffer,'',1,'Art/Interface/Buttons/Spells/Entertain.dds',ColorTypes(7),pCity.getX(),pCity.getY(),True,True)
	pCity.changeHappinessTimer(2)

def reqEscape(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		if caster.getDamage() >= 50:
			return False
	return True

def reqFeast(caster):
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	if pCity.getPopulation() < 3:
		return False
	return True

def spellFeast(caster):
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	caster.changeExperience(pCity.getPopulation()-2, -1, False, False, False)
	pCity.changeHurryAngerTimer(3)

def reqFeed(caster):
	if caster.getDamage() == 0: return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if not pPlayer.isHuman():
		if caster.getDamage() < 20:
			return False
	return True

def spellFeed(caster):
	caster.setDamage(caster.getDamage() - 20, caster.getOwner())
	pVictim = -1
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.getOwner() == caster.getOwner():
			if pUnit.getUnitType() == gc.getInfoTypeForString('UNIT_BLOODPET'):
				if (pVictim == -1 or pVictim.getLevel() > pUnit.getLevel()):
					pVictim = pUnit
	if pVictim != -1:
		pVictim.kill(True, 0)

def reqForTheHorde(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	bPlayer = gc.getPlayer(gc.getORC_PLAYER())
	if gc.getTeam(pPlayer.getTeam()).isAtWar(bPlayer.getTeam()):
		return False
	if bPlayer.getNumUnits() == 0:
		return False
	if pPlayer.isHuman() == False:
		if bPlayer.getNumUnits() < 60:
			return False
	return True

def spellForTheHorde(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	iHero = gc.getInfoTypeForString('PROMOTION_HERO')
	iPromotionHorde = gc.getInfoTypeForString('PROMOTION_FOR_THE_HORDE')
	iFrostling = gc.getInfoTypeForString('PROMOTION_FROSTLING')
	
	py = PyPlayer(gc.getORC_PLAYER())
	for pUnit in py.getUnitList():
		if pUnit.isHasPromotion(iHero) == False and pUnit.isHasPromotion(iFrostling) == False:
			newUnit = pPlayer.initUnit(pUnit.getUnitType(), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
			newUnit.convert(pUnit)
			newUnit.setHasPromotion(iPromotionHorde, True)

def reqGiftsOfNantosuelta(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.getNumCities() == 0:
		return False
	if pPlayer.isHuman() == False:
		if pPlayer.getNumCities() < 5:
			return False
	return True

def spellGiftsOfNantosuelta(caster):
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	iGoldenHammer = gc.getInfoTypeForString('EQUIPMENT_GOLDEN_HAMMER')
	for pyCity in PyPlayer(iPlayer).getCityList() :
		pCity = pyCity.GetCy()
		newUnit = pPlayer.initUnit(iGoldenHammer, pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)

def reqGiftVampirism(caster):
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isAlive() and pUnit.getOwner() == caster.getOwner()):
			if not pUnit.isHasPromotion(gc.getInfoTypeForString('PROMOTION_VAMPIRE')):
				if pUnit.getLevel() >= 6:
					return True
				if (pUnit.getLevel() >= 4 and pUnit.getUnitType() == gc.getInfoTypeForString('UNIT_MOROI')):
					return True
	return False

def spellGiftVampirism(caster):
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isAlive() and pUnit.getOwner() == caster.getOwner()):
			if not pUnit.isHasPromotion(gc.getInfoTypeForString('PROMOTION_VAMPIRE')):
				if pUnit.getLevel() >= 6:
					pUnit.setHasPromotion(gc.getInfoTypeForString('PROMOTION_VAMPIRE'),True)
				if (pUnit.getLevel() >= 4 and pUnit.getUnitType() == gc.getInfoTypeForString('UNIT_MOROI')):
					pUnit.setHasPromotion(gc.getInfoTypeForString('PROMOTION_VAMPIRE'),True)

def spellGiveHammerToCraftsman(caster, promotion):
	pCity = caster.plot().getPlotCity()
	pCity.changeFreeSpecialistCount(gc.getInfoTypeForString('SPECIALIST_ENGINEER'), 1)
	caster.setHasPromotion(gc.getInfoTypeForString(promotion), False)

def reqHastursRazor(caster):
	iX = caster.getX()
	iY = caster.getY()
	pPlayer = gc.getPlayer(caster.getOwner())
	eTeam = pPlayer.getTeam()
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE1:
		pPlot = getPlot(iX+iiX,iY+iiY)
		for i in range(pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(i)
			if pUnit.getDamage() > 0:
				if pPlayer.isHuman():
					return True
				if pUnit.getOwner() == caster.getOwner():
					return True
	return False

def spellHastursRazor(caster):
	iX = caster.getX()
	iY = caster.getY()
	pPlayer = gc.getPlayer(caster.getOwner())
	listDamage = []
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE1:
		pPlot = getPlot(iX+iiX,iY+iiY)
		for i in xrange(pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(i)
			listDamage.append(pUnit.getDamage())
	for iiX,iiY in RANGE1:
		pPlot = getPlot(iX+iiX,iY+iiY)
		for i in xrange(pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(i)
			iRnd = listDamage[CyGame().getSorenRandNum(len(listDamage), "Hasturs Razor")]
			if iRnd != pUnit.getDamage():
				CyInterface().addMessage(pUnit.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_HASTURS_RAZOR",()),'AS2D_CHARM_PERSON',1,'Art/Interface/Buttons/Spells/Hasturs Razor.dds',ColorTypes(7),pUnit.getX(),pUnit.getY(),True,True)
				if pUnit.getOwner() != caster.getOwner():
					CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_HASTURS_RAZOR",()),'AS2D_CHARM_PERSON',1,'Art/Interface/Buttons/Spells/Hasturs Razor.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
				pUnit.setDamage(iRnd, caster.getOwner())

def reqHeal(caster):
	pPlot = caster.plot()
	iPoisoned = gc.getInfoTypeForString('PROMOTION_POISONED')
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isAlive() and pUnit.getDamage() > 0):
			return True
		if pUnit.isHasPromotion(iPoisoned):
			return True
	return False

def spellHeal(caster,amount):
	pPlot = caster.plot()
	iPoisoned = gc.getInfoTypeForString('PROMOTION_POISONED')
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		pUnit.setHasPromotion(iPoisoned,False)
		if pUnit.isAlive():
			pUnit.changeDamage(-amount,0) #player doesn't matter - it won't kill

def reqHealingSalve(caster):
	if caster.getDamage() == 0:
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		if caster.getDamage() < 25:
			return False
	return True

def spellHealingSalve(caster):
	caster.setDamage(0, caster.getOwner())
	caster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_DISEASED'), False)
	caster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_PLAGUED'), False)
	caster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_POISONED'), False)
	caster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_WITHERED'), False)
	
def spellHealingPotion(caster):
	caster.setDamage(0, False)	
	caster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_DISEASED'), False)
	caster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_PLAGUED'), False)
	caster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_POISONED'), False)
	caster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_WITHERED'), False)

	if (CyGame().getSorenRandNum(10, "Potion run out chance") < 3):
		caster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_HEALING_POTION'), False)
		
def reqNewtsDraught(caster):
	if caster.isHasCasted():
		return True
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		if caster.getDamage() < 25:
			return False
	return True

def spellNewtsDraught(caster):
	caster.setHasCasted(False)		
	
def reqHellfire(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.getCivilizationType() != gc.getInfoTypeForString('CIVILIZATION_INFERNAL'):
		return False
	pPlot = caster.plot()
	if pPlot.isCity():
		return False
	if pPlot.isWater():
		return False
	if pPlot.getImprovementType() != -1:
		return False
	iHellFire = gc.getInfoTypeForString('IMPROVEMENT_HELLFIRE')
	iX = pPlot.getX()
	iY = pPlot.getY()
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE2:
		pPlot2 = getPlot(iX+iiX,iY+iiY)
		if pPlot2.getImprovementType() == iHellFire:
			return False
	if pPlayer.isHuman() == False:
		if pPlot.isOwned():
			if pPlot.getOwner() == caster.getOwner():
				return False
	return True

def reqHeraldsCall(caster):
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isAlive() and pUnit.getOwner() == caster.getOwner()):
			return True
	return False

def spellHeraldsCall(caster):
	iValor = gc.getInfoTypeForString('PROMOTION_VALOR')
	iBlessed = gc.getInfoTypeForString('PROMOTION_BLESSED')
	iCourage = gc.getInfoTypeForString('PROMOTION_COURAGE')
	iLoyalty = gc.getInfoTypeForString('PROMOTION_LOYALTY')
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isAlive() and pUnit.getOwner() == caster.getOwner()):
			pUnit.setHasPromotion(iValor,True)
			pUnit.setHasPromotion(iBlessed, True)
			pUnit.setHasPromotion(iCourage, True)
			pUnit.setHasPromotion(iLoyalty, True)
			pUnit.setDuration(1)

def reqHide(caster):
	if caster.isMadeAttack():
		return False
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_HIDDEN')):
		return False
	return True

def reqHireScorpionClan(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	bPlayer = gc.getPlayer(gc.getORC_PLAYER())
	eTeam = gc.getTeam(pPlayer.getTeam())
	if eTeam.isAtWar(bPlayer.getTeam()):
		return False
	return True

def spellHireArcher(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_ARCHER'), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)

def spellHireGiant(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	iHorde = gc.getInfoTypeForString('PROMOTION_FOR_THE_HORDE')
	newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_HILL_GIANT'), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
	newUnit.setHasPromotion(iHorde, True)

def spellHireWarrior(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_WARRIOR'), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
	
def spellHireCyklop(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	iHorde = gc.getInfoTypeForString('PROMOTION_FOR_THE_HORDE')
	newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_CYKLOP'), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
	newUnit.setHasPromotion(iHorde, True)

def spellHireMinotaur(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	iHorde = gc.getInfoTypeForString('PROMOTION_FOR_THE_HORDE')
	newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_MINOTAUR_LESSER'), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
	newUnit.setHasPromotion(iHorde, True)

def spellHireTroll(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	iHorde = gc.getInfoTypeForString('PROMOTION_FOR_THE_HORDE')
	newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_JOT_TROLL'), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
	newUnit.setHasPromotion(iHorde, True)

def spellHireLizardman(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	iHorde = gc.getInfoTypeForString('PROMOTION_FOR_THE_HORDE')
	newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_LIZARDMAN'), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
	newUnit.setHasPromotion(iHorde, True)

def spellHireWolfRider(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_HORSEMAN'), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)

def spellHireUnits(caster):
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	pCity = caster.plot().getPlotCity()
	iEvent = CvUtil.findInfoTypeNum(gc.getEventTriggerInfo, gc.getNumEventTriggerInfos(),'EVENTTRIGGER_MAGNADINE_HIRE_UNITS')
	triggerData = pPlayer.initTriggeredData(iEvent, True, -1, pCity.getX(), pCity.getY(), iPlayer, pCity.getID(), -1, -1, -1, -1)

def reqHyboremsWhisper(caster):
	if gc.getGame().isNetworkMultiPlayer():
		return False
	pCity = cf.getAshenVeilCity(3)
	if pCity == -1:
		return False
	return True

def spellHyboremsWhisper(caster):
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	iEvent = CvUtil.findInfoTypeNum(gc.getEventTriggerInfo, gc.getNumEventTriggerInfos(),'EVENTTRIGGER_HYBOREMS_WHISPER')
	triggerData = pPlayer.initTriggeredData(iEvent, True, -1, caster.getX(), caster.getY(), iPlayer, -1, -1, -1, -1, -1)

def reqImpersonateLeader(caster):
	pCity = caster.plot().getPlotCity()
	if pCity.getOwner() == caster.getOwner():
		return False
	if gc.getPlayer(pCity.getOwner()).isHuman():
		return False
	return True

def spellImpersonateLeader(caster):
	pCity = caster.plot().getPlotCity()
	iNewPlayer = pCity.getOwner()
	iOldPlayer = caster.getOwner()
	iTimer = 5 + CyGame().getSorenRandNum(10, "Impersonate Leader")
	CyGame().reassignPlayerAdvanced(iOldPlayer, iNewPlayer, iTimer)

def reqInquisition(caster):
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	pPlayer = gc.getPlayer(caster.getOwner())
	StateBelief = pPlayer.getStateReligion()
	if StateBelief == -1:
		if caster.getOwner() != pCity.getOwner():
			return False
	if (StateBelief != gc.getPlayer(pCity.getOwner()).getStateReligion()):
		return False
	for iTarget in range(gc.getNumReligionInfos()):
		if (StateBelief != iTarget and pCity.isHasReligion(iTarget) and pCity.isHolyCityByType(iTarget) == False):
			return True
	return False

def spellInquisition(caster):
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	pPlayer = gc.getPlayer(caster.getOwner())
	StateBelief = gc.getPlayer(pCity.getOwner()).getStateReligion()
	iRnd = CyGame().getSorenRandNum(4, "Bob")
	if StateBelief == gc.getInfoTypeForString('RELIGION_THE_ORDER'):
		iRnd = iRnd - 1
	for iTarget in range(gc.getNumReligionInfos()):
		if (not StateBelief == iTarget and pCity.isHasReligion(iTarget) and not pCity.isHolyCityByType(iTarget)):
			pCity.setHasReligion(iTarget, False, True, True)
			iRnd = iRnd + 1
			for i in range(gc.getNumBuildingInfos()):
				if gc.getBuildingInfo(i).getPrereqReligion() == iTarget:
					pCity.setNumRealBuilding(i, 0)
	if iRnd >= 1:
		pCity.changeHurryAngerTimer(iRnd)

# Scions start - Allows Inqusition to remove  Poisioned Words, Corrupt Guild.					
	if pCity.getNumRealBuilding(gc.getInfoTypeForString('BUILDING_POISON_WORDS')) > 0:		
		pCity.setNumRealBuilding(gc.getInfoTypeForString('BUILDING_POISON_WORDS'), 0)

	if pCity.getNumRealBuilding(gc.getInfoTypeForString('BUILDING_CORRUPT_GUILD')) > 0:		
		pCity.setNumRealBuilding(gc.getInfoTypeForString('BUILDING_CORRUPT_GUILD'), 0)
# Scions end

def reqIntoTheMist(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		if pPlayer.getNumUnits() < 40:
			return False
	return True

def spellIntoTheMist(caster):
	iInvisible = gc.getInfoTypeForString('PROMOTION_HIDDEN')
	py = PyPlayer(caster.getOwner())
	for pUnit in py.getUnitList():
		pUnit.setHasPromotion(iInvisible, True)

def reqIraUnleashed(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.getUnitClassCount(gc.getInfoTypeForString('UNITCLASS_IRA')) >= 4:
		return False
	return True

def spellIraUnleashed(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	iCount = 4 - pPlayer.getUnitClassCount(gc.getInfoTypeForString('UNITCLASS_IRA'))
	for i in range(iCount):
		pPlayer.initUnit(gc.getInfoTypeForString('UNIT_IRA'), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)

def reqKidnap(caster):
	pCity = caster.plot().getPlotCity()
	if pCity.getTeam() == caster.getTeam():
		return False
	i = 0
	i = i + pCity.getFreeSpecialistCount(gc.getInfoTypeForString('SPECIALIST_GREAT_PRIEST'))
	i = i + pCity.getFreeSpecialistCount(gc.getInfoTypeForString('SPECIALIST_GREAT_ARTIST'))
	i = i + pCity.getFreeSpecialistCount(gc.getInfoTypeForString('SPECIALIST_GREAT_MERCHANT'))
	i = i + pCity.getFreeSpecialistCount(gc.getInfoTypeForString('SPECIALIST_GREAT_ENGINEER'))
	i = i + pCity.getFreeSpecialistCount(gc.getInfoTypeForString('SPECIALIST_GREAT_SCIENTIST'))
	if i == 0:
		return False
	return True

def spellKidnap(caster):
	pCity = caster.plot().getPlotCity()
	if pCity.getFreeSpecialistCount(gc.getInfoTypeForString('SPECIALIST_GREAT_PRIEST')) > 0:
		iUnit = gc.getInfoTypeForString('UNIT_PROPHET')
		iSpec = gc.getInfoTypeForString('SPECIALIST_GREAT_PRIEST')
	if pCity.getFreeSpecialistCount(gc.getInfoTypeForString('SPECIALIST_GREAT_ARTIST')) > 0:
		iUnit = gc.getInfoTypeForString('UNIT_ARTIST')
		iSpec = gc.getInfoTypeForString('SPECIALIST_GREAT_ARTIST')
	if pCity.getFreeSpecialistCount(gc.getInfoTypeForString('SPECIALIST_GREAT_MERCHANT')) > 0:
		iUnit = gc.getInfoTypeForString('UNIT_MERCHANT')
		iSpec = gc.getInfoTypeForString('SPECIALIST_GREAT_MERCHANT')
	if pCity.getFreeSpecialistCount(gc.getInfoTypeForString('SPECIALIST_GREAT_ENGINEER')) > 0:
		iUnit = gc.getInfoTypeForString('UNIT_ENGINEER')
		iSpec = gc.getInfoTypeForString('SPECIALIST_GREAT_ENGINEER')
	if pCity.getFreeSpecialistCount(gc.getInfoTypeForString('SPECIALIST_GREAT_SCIENTIST')) > 0:
		iUnit = gc.getInfoTypeForString('UNIT_SCIENTIST')
		iSpec = gc.getInfoTypeForString('SPECIALIST_GREAT_SCIENTIST')
	iChance = caster.baseCombatStr() * 8
	if iChance > 95:
		iChance = 95
	pPlayer = gc.getPlayer(caster.getOwner())
	if CyGame().getSorenRandNum(100, "Kidnap") <= iChance:
		newUnit = pPlayer.initUnit(iUnit, caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		pCity.changeFreeSpecialistCount(iSpec, -1)
	else:
		if CyGame().getSorenRandNum(100, "Kidnap") <= 50:
			caster.setXY(pPlayer.getCapitalCity().getX(), pPlayer.getCapitalCity().getY(), False, True, True)
		else:
			caster.kill(True, 0)
		startWar(caster.getOwner(), pCity.getOwner(), WarPlanTypes.WARPLAN_TOTAL)

def reqLegends(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.getNumCities() == 0:
		return False
	if pPlayer.isHuman() == False:
		if pPlayer.getNumCities() < 5:
			return False
	return True

def spellLegends(caster):
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	for pyCity in PyPlayer(iPlayer).getCityList() :
		pCity = pyCity.GetCy()
		pCity.changeCulture(iPlayer, 300, True)

def reqLichdom(caster):
	if caster.getUnitClassType() == gc.getInfoTypeForString('UNITCLASS_FLESH_GOLEM'):
		return False
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_PUPPET')):
		return False
	if isWorldUnitClass(caster.getUnitClassType()):
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.getUnitClassCount(gc.getInfoTypeForString('UNITCLASS_LICH')) >= 4:
		return False
	return True

def reqMask(caster):
	if caster.isHiddenNationality():
		return False
	if caster.hasCargo():
		return False
	if caster.isCargo():
		return False
	pGroup = caster.getGroup()
	if pGroup.isNone() == False:
		if pGroup.getNumUnits() > 1:
			return False
	return True

def reqMezmerizeAnimal(caster):
	iX = caster.getX()
	iY = caster.getY()
	pPlayer = gc.getPlayer(caster.getOwner())
	iTeam = pPlayer.getTeam()
	eTeam = gc.getTeam(iTeam)
	iAnimal = gc.getPlayer(gc.getANIMAL_PLAYER())
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE1:
		pPlot = getPlot(iX+iiX,iY+iiY)
		for i in xrange(pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(i)
			if pUnit.getUnitCombatType() == gc.getInfoTypeForString('UNITCOMBAT_ANIMAL'):
				if pUnit.getTeam() == iAnimal.getTeam():
					return True
				if eTeam.isAtWar(pUnit.getTeam()):
					return True
			if pPlayer.getCivilizationType() == gc.getInfoTypeForString('CIVILIZATION_DOVIELLO'):
				if pUnit.getUnitCombatType() == gc.getInfoTypeForString('UNITCOMBAT_BEAST'):
					if pUnit.getTeam() == iAnimal.getTeam():
						return True
					if eTeam.isAtWar(pUnit.getTeam()):
						return True
	return False

def spellMezmerizeAnimal(caster):
	iX = caster.getX()
	iY = caster.getY()
	pPlayer = gc.getPlayer(caster.getOwner())
	iTeam = pPlayer.getTeam()
	eTeam = gc.getTeam(iTeam)
	iAnimal = gc.getPlayer(gc.getANIMAL_PLAYER())
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE1:
		pPlot = getPlot(iX+iiX,iY+iiY)
		for i in range(pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(i)
			if pUnit.getUnitCombatType() == gc.getInfoTypeForString('UNITCOMBAT_ANIMAL'):
				if eTeam.isAtWar(pUnit.getTeam()):
					if pUnit.isDelayedDeath() == False:
						if pUnit.isResisted(caster, gc.getInfoTypeForString('SPELL_MEZMERIZE_ANIMAL')) == False:
							newUnit = pPlayer.initUnit(pUnit.getUnitType(), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
							newUnit.convert(pUnit)
				if pUnit.getTeam() == iAnimal.getTeam():
					if pUnit.isDelayedDeath() == False:
						if pUnit.isResisted(caster, gc.getInfoTypeForString('SPELL_MEZMERIZE_ANIMAL')) == False:
							newUnit = pPlayer.initUnit(pUnit.getUnitType(), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
							newUnit.convert(pUnit)
			if pPlayer.getCivilizationType() == gc.getInfoTypeForString('CIVILIZATION_DOVIELLO'):
				if pUnit.getUnitCombatType() == gc.getInfoTypeForString('UNITCOMBAT_BEAST'):
					if eTeam.isAtWar(pUnit.getTeam()):
						if pUnit.isDelayedDeath() == False:
							if pUnit.isResisted(caster, gc.getInfoTypeForString('SPELL_MEZMERIZE_ANIMAL')) == False:
								newUnit = pPlayer.initUnit(pUnit.getUnitType(), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
								newUnit.convert(pUnit)
					if pUnit.getTeam() == iAnimal.getTeam():
						if pUnit.isDelayedDeath() == False:
							if pUnit.isResisted(caster, gc.getInfoTypeForString('SPELL_MEZMERIZE_ANIMAL')) == False:
								newUnit = pPlayer.initUnit(pUnit.getUnitType(), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
								newUnit.convert(pUnit)					

def reqMirror(caster):
	iPlayer = caster.getOwner()
	pPlot = caster.plot()
	if caster.isImmuneToMagic():
		return False
	if pPlot.isVisibleEnemyUnit(iPlayer):
		return False
	return True

def spellMirror(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	newUnit = pPlayer.initUnit(caster.getUnitType(), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
	for i in range(gc.getNumPromotionInfos()):
		newUnit.setHasPromotion(i, caster.isHasPromotion(i))
		if gc.getPromotionInfo(i).isEquipment():
			newUnit.setHasPromotion(i, False)
	newUnit.setHasPromotion(gc.getInfoTypeForString('PROMOTION_ILLUSION'), True)
	newUnit.setHasPromotion(gc.getInfoTypeForString('PROMOTION_IMMORTAL'), False)
	if newUnit.isImmortal():
		newUnit.changeImmortal(-1)
	newUnit.setDamage(caster.getDamage(), caster.getOwner())
	newUnit.setLevel(caster.getLevel())
	newUnit.setExperienceTimes100(caster.getExperienceTimes100(), -1)
	if not caster.getUnitType() == gc.getInfoTypeForString('UNIT_ALAZKAN'):
		newUnit.setUnitArtStyleType(caster.getUnitArtStyleType())
	newUnit.setHasCasted(True)
	newUnit.setDuration(1)

def reqPeace(caster):
	if gc.getGame().isOption(GameOptionTypes.GAMEOPTION_NO_CHANGING_WAR_PEACE):
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	iTeam = pPlayer.getTeam()
	eTeam = gc.getTeam(iTeam)
	if eTeam.getAtWarCount(True) == 0:
		return False
	return True

def spellPeace(caster):
	eTeam = gc.getTeam(gc.getPlayer(caster.getOwner()).getTeam())
	for iPlayer in range(gc.getMAX_PLAYERS()):
		pPlayer = gc.getPlayer(iPlayer)
		if (pPlayer.isAlive() and iPlayer != caster.getOwner() and not gc.getPlayer(iPlayer).isBarbarian()):
			i2Team = gc.getPlayer(iPlayer).getTeam()
			if eTeam.isAtWar(i2Team):
				eTeam.makePeace(i2Team)
	CyGame().changeGlobalCounter(-1 * (CyGame().getTrueGlobalCounter() / 2))

def reqPeaceSevenPines(caster):
	pPlot = caster.plot()
	if not pPlot.isPythonActive():
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	iTeam = pPlayer.getTeam()
	eTeam = gc.getTeam(iTeam)
	if eTeam.getAtWarCount(True) == 0:
		return False
	return True

def spellPeaceSevenPines(caster):
	eTeam = gc.getTeam(gc.getPlayer(caster.getOwner()).getTeam())
	for iPlayer in range(gc.getMAX_PLAYERS()):
		pPlayer = gc.getPlayer(iPlayer)
		if (pPlayer.isAlive() and iPlayer != caster.getOwner() and not gc.getPlayer(iPlayer).isBarbarian()):
			i2Team = gc.getPlayer(iPlayer).getTeam()
			if eTeam.isAtWar(i2Team):
				eTeam.makePeace(i2Team)
	CyGame().changeGlobalCounter(-1 * (CyGame().getTrueGlobalCounter() / 2))
	pPlot = caster.plot()
	pPlot.setPythonActive(False)

def reqPillarofFire(caster):
	iX = caster.getX()
	iY = caster.getY()
	pPlayer = gc.getPlayer(caster.getOwner())
	iTeam = pPlayer.getTeam()
	eTeam = gc.getTeam(iTeam)
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE2:
		pPlot = getPlot(iX+iiX,iY+iiY)
		bEnemy = False
		bNeutral = False
		for i in xrange(pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(i)
			if eTeam.isAtWar(pUnit.getTeam()):
				bEnemy = True
			else:
				bNeutral = True
		if (bEnemy and bNeutral == False):
			return True
	return False

def spellPillarofFire(caster):
	iX = caster.getX()
	iY = caster.getY()
	pPlayer = gc.getPlayer(caster.getOwner())
	iTeam = pPlayer.getTeam()
	eTeam = gc.getTeam(iTeam)
	iBestValue = 0
	pBestPlot = -1
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE2:
		pPlot = getPlot(iX+iiX,iY+iiY)
		bNeutral = False
		iValue = 0
		for i in xrange(pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(i)
			if eTeam.isAtWar(pUnit.getTeam()):
				iValue += 5 * pUnit.baseCombatStr()
			else:
				bNeutral = True
		if (iValue > iBestValue and bNeutral == False):
			iBestValue = iValue
			pBestPlot = pPlot
	if pBestPlot != -1:
		for i in xrange(pBestPlot.getNumUnits()):
			pUnit = pBestPlot.getUnit(i)
			pUnit.doDamage(50, 75, caster, gc.getInfoTypeForString('DAMAGE_FIRE'), True)
		if (pPlot.getFeatureType() == gc.getInfoTypeForString('FEATURE_FOREST') or pPlot.getFeatureType() == gc.getInfoTypeForString('FEATURE_JUNGLE')):
			bValid = True
			iImprovement = pPlot.getImprovementType()
			if iImprovement != -1 :
				if gc.getImprovementInfo(iImprovement).isPermanent():
					bValid = False
			if bValid:
				if CyGame().getSorenRandNum(100, "Flames Spread") <= gc.getDefineINT('FLAMES_SPREAD_CHANCE'):
					pPlot.setImprovementType(gc.getInfoTypeForString('IMPROVEMENT_SMOKE'))
		CyEngine().triggerEffect(gc.getInfoTypeForString('EFFECT_PILLAR_OF_FIRE'),pBestPlot.getPoint())

def reqGreatWorks(caster):
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	if pPlayer.isFoundedFirstCity == False :
		return False
	if pPlayer.isHuman() == False:
		prodNeededTotal = 0
		for iCity in xrange(pPlayer.getNumCities()):
			pCity = pPlayer.getCity(iCity)
			prodNeededTotal += pCity.getProductionNeeded()
		if prodNeededTotal > 1000 :
			return True
		else:
			return False
	return True
		

def spellGreatWorks(caster):
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	for iCity in xrange(pPlayer.getNumCities()):
		pCity = pPlayer.getCity(iCity)
		iProdNeeded = pCity.getProductionNeeded()
		if iProdNeeded > 100 :
			pCity.changeProduction(100)
		else :	
			pCity.changeProduction(iProdNeeded)

def reqMarchOfTheTrees(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		iTeam = gc.getPlayer(caster.getOwner()).getTeam()
		eTeam = gc.getTeam(iTeam)
		if eTeam.getAtWarCount(True) < 2:
			return False
	return True

def spellMarchOfTheTrees(caster):
	iAncientForest = gc.getInfoTypeForString('FEATURE_FOREST_ANCIENT')
	iForest = gc.getInfoTypeForString('FEATURE_FOREST')
	iNewForest = gc.getInfoTypeForString('FEATURE_FOREST_NEW')
	iTreant = gc.getInfoTypeForString('UNIT_TREANT')
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	map	= CyMap()
	plotByIndex	= map.plotByIndex
	for i in xrange(map.numPlots()):
		pPlot = plotByIndex(i)
		if pPlot.isOwned():
			if pPlot.getOwner() == iPlayer:
				if (pPlot.getFeatureType() == iForest or pPlot.getFeatureType() == iAncientForest):
					newUnit = pPlayer.initUnit(iTreant, pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
					newUnit.setDuration(5)
					pPlot.setFeatureType(iNewForest,0)

def reqCorruption(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	return True

def reqEnlightenment(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	return True

def spellCorruption(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	if caster.getOwner() == CyGame().getActivePlayer():
		addPopup(CyTranslator().getText("TXT_KEY_POPUP_KAHDI_CORRUPTION",()),'art/interface/popups/Corruption.dds')
	return True

def spellEnlightenment(caster):
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	
	if iPlayer == CyGame().getActivePlayer():
		addPopup(CyTranslator().getText("TXT_KEY_POPUP_KAHDI_ENLIGHTENMENT",()),'art/interface/popups/Enlightenment.dds')
	pPlayer.setHasTrait(gc.getInfoTypeForString('TRAIT_AMBITIOUS'),False)
	pPlayer.setHasTrait(gc.getInfoTypeForString('TRAIT_SPIRITUAL'),True)
	return True


def reqMotherLode(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		if pPlayer.getImprovementCount(gc.getInfoTypeForString('IMPROVEMENT_MINE')) < 10:
			return False
	return True

def spellMotherLode(caster):
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	pPlayer.changeGold(pPlayer.getImprovementCount(gc.getInfoTypeForString('IMPROVEMENT_MINE')) * 25)
	pPlayer.changeGold(pPlayer.getImprovementCount(gc.getInfoTypeForString('IMPROVEMENT_DWARVEN_MINE')) * 50)
	pPlayer.changeGold(pPlayer.getImprovementCount(gc.getInfoTypeForString('IMPROVEMENT_DWARVEN_SETTLEMENT')) * 75)
	pPlayer.changeGold(pPlayer.getImprovementCount(gc.getInfoTypeForString('IMPROVEMENT_DWARVEN_HALL')) * 100)
	pPlayer.changeGold(pPlayer.getImprovementCount(gc.getInfoTypeForString('IMPROVEMENT_DWARVEN_FORTRESS')) * 200)
	map	= CyMap()
	plotByIndex	= map.plotByIndex
	for i in xrange(map.numPlots()):
		pPlot = plotByIndex(i)
		if pPlot.isOwned():
			if pPlot.getOwner() == iPlayer:
				if pPlot.isWater() == False:
					if pPlot.isPeak() == False:
						if pPlot.isHills() == False:
							if CyGame().getSorenRandNum(100, "Mother Lode") < 10:
								pPlot.setPlotType(PlotTypes.PLOT_HILLS, True, True)

def spellSlaveDrive(caster):
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	iSlaveBuilding = gc.getInfoTypeForString('BUILDING_SLAVE_PIT')
	
	for iCity in range(pPlayer.getNumCities()):
		pCity = pPlayer.getCity(iCity)
		pCity.setNumRealBuilding(iSlaveBuilding, 1)

def reqFoundWyvern(caster):
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	iWyvernGuard = gc.getInfoTypeForString('UNITCLASS_DRAGON_GUARDIAN')
	if pPlayer.getUnitClassCount(iWyvernGuard) >= 12:
		return True
	return False
		

def reqWakeMother(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	
	if pPlayer.getUnitClassCount(gc.getInfoTypeForString('UNITCLASS_MOTHER_SPIDER')) > 0:
		return False
	
	pNest = pPlayer.getCapitalCity()
	iNestPop = pNest.getPopulation()
	if iNestPop >= 16:
		return True
	return False

def spellWakeMother(caster):
	iPlayer = caster.getOwner()
	iMother = gc.getInfoTypeForString('UNIT_MOTHER_SPIDER')
	pPlayer = gc.getPlayer(iPlayer)
	pCity = pPlayer.getCapitalCity()
	motherUnit = pPlayer.initUnit(iMother, pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)

def reqOpenChest(caster):
	if not caster.isGroupHead():
		return False
	return True

def spellOpenChest(caster):
	pPlot = caster.plot()
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	bValid = True
	if CyGame().getWBMapScript():
		bValid = sf.openChest(caster, pPlot)
	if bValid:
		if CyGame().getSorenRandNum(100, "Open Chest") < 25:
			lTrapList = ['POISON', 'FIRE', 'SPORES']
			sTrap = lTrapList[CyGame().getSorenRandNum(len(lTrapList), "Pick Trap")-1]
			point = pPlot.getPoint()
			if sTrap == 'POISON':
				caster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_POISONED'), True)
				caster.doDamageNoCaster(25, 90, gc.getInfoTypeForString('DAMAGE_POISON'), False)
				CyInterface().addMessage(iPlayer,True,25,CyTranslator().getText("TXT_KEY_MESSAGE_TRAP_POISON", ()),'AS2D_POSITIVE_DINK',1,'Art/Interface/Buttons/Promotions/Poisoned.dds',ColorTypes(8),pPlot.getX(),pPlot.getY(),True,True)
			if sTrap == 'FIRE':
				caster.doDamageNoCaster(50, 90, gc.getInfoTypeForString('DAMAGE_FIRE'), False)
				CyInterface().addMessage(iPlayer,True,25,CyTranslator().getText("TXT_KEY_MESSAGE_TRAP_FIRE", ()),'AS2D_POSITIVE_DINK',1,'Art/Interface/Buttons/Spells/Ring of Flames.dds',ColorTypes(8),pPlot.getX(),pPlot.getY(),True,True)
				CyEngine().triggerEffect(gc.getInfoTypeForString('EFFECT_RING_OF_FLAMES'),point)
				CyAudioGame().Play3DSound("AS3D_SPELL_FIREBALL",point.x,point.y,point.z)
			if sTrap == 'SPORES':
				caster.changeImmobileTimer(3)
				CyInterface().addMessage(iPlayer,True,25,CyTranslator().getText("TXT_KEY_MESSAGE_TRAP_SPORES", ()),'AS2D_POSITIVE_DINK',1,'Art/Interface/Buttons/Spells/Spores.dds',ColorTypes(8),pPlot.getX(),pPlot.getY(),True,True)
				CyEngine().triggerEffect(gc.getInfoTypeForString('EFFECT_SPORES'),point)
				CyAudioGame().Play3DSound("AS3D_SPELL_CONTAGION",point.x,point.y,point.z)

		lList = ['EMPTY', 'HIGH_GOLD', 'TECH']
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_EXPLORE_LAIR_ITEM_HEALING_SALVE'), caster):
			lList += ['ITEM_HEALING_SALVE']
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_EXPLORE_LAIR_ITEM_JADE_TORC'), caster):
			lList += ['ITEM_JADE_TORC']
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_EXPLORE_LAIR_ITEM_POTION_OF_INVISIBILITY'), caster):
			lList += ['ITEM_POTION_OF_INVISIBILITY']
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_EXPLORE_LAIR_ITEM_POTION_OF_RESTORATION'), caster):
			lList += ['ITEM_POTION_OF_RESTORATION']
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_EXPLORE_LAIR_ITEM_ROD_OF_WINDS'), caster):
			lList += ['ITEM_ROD_OF_WINDS']
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_EXPLORE_LAIR_ITEM_TIMOR_MASK'), caster):
			lList += ['ITEM_TIMOR_MASK']
		sGoody = lList[CyGame().getSorenRandNum(len(lList), "Pick Goody")-1]
		if sGoody == 'EMPTY':
			CyInterface().addMessage(iPlayer,True,25,CyTranslator().getText("TXT_KEY_MESSAGE_EXPLORE_LAIR_TREASURE_EMPTY",()),'AS2D_POSITIVE_DINK',1,'Art/Interface/Buttons/Equipment/Treasure.dds',ColorTypes(8),pPlot.getX(),pPlot.getY(),True,True)
		if sGoody == 'HIGH_GOLD':
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_EXPLORE_LAIR_HIGH_GOLD'), caster)
		if sGoody == 'ITEM_HEALING_SALVE':
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_EXPLORE_LAIR_ITEM_HEALING_SALVE'), caster)
		if sGoody == 'ITEM_JADE_TORC':
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_EXPLORE_LAIR_ITEM_JADE_TORC'), caster)
		if sGoody == 'ITEM_POTION_OF_INVISIBILITY':
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_EXPLORE_LAIR_ITEM_POTION_OF_INVISIBILITY'), caster)
		if sGoody == 'ITEM_POTION_OF_RESTORATION':
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_EXPLORE_LAIR_ITEM_POTION_OF_RESTORATION'), caster)
		if sGoody == 'ITEM_ROD_OF_WINDS':
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_EXPLORE_LAIR_ITEM_ROD_OF_WINDS'), caster)
		if sGoody == 'ITEM_TIMOR_MASK':
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_EXPLORE_LAIR_ITEM_TIMOR_MASK'), caster)
		if sGoody == 'TECH':
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_GRAVE_TECH'), caster)
		pTreasure = -1
		iTreasure = gc.getInfoTypeForString('EQUIPMENT_TREASURE')
		for i in range(pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(i)
			if pUnit.getUnitType() == iTreasure:
				pTreasure = pUnit
		pTreasure.kill(True, 0)

def reqPromoteSettlement(caster):
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	if not pCity.isSettlement():
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.getNumCities() - pPlayer.getNumSettlements() >= pPlayer.getMaxCities():
		return False
	if not pPlayer.isHuman():
		pNearestCity = gc.getMap().findCity(pCity.getX(), pCity.getY(), -1, pCity.getTeam(), False, False, -1, -1, pCity, True)
		if not pNearestCity.isNone():
			if (plotDistance(pCity.getX(), pCity.getY(), pNearestCity.getX(), pNearestCity.getY()) < 6):
				return False
	return True

def spellPromoteSettlement(caster):
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	pCity.setSettlement(False)

def reqRagingSeas(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		eTeam = gc.getTeam(pPlayer.getTeam())
		iArcane = gc.getInfoTypeForString('UNITCLASS_ARCANE_BARGE')
		iCaravel = gc.getInfoTypeForString('UNITCLASS_CARAVEL')
		iGalley = gc.getInfoTypeForString('UNITCLASS_GALLEY')
		iFrigate = gc.getInfoTypeForString('UNITCLASS_FRIGATE')
		iGalleon = gc.getInfoTypeForString('UNITCLASS_GALLEON')
		iManOWar = gc.getInfoTypeForString('UNITCLASS_MAN_O_WAR')
		iPrivateer = gc.getInfoTypeForString('UNITCLASS_PRIVATEER')
		iQueenOfTheLine = gc.getInfoTypeForString('UNITCLASS_QUEEN_OF_THE_LINE')
		iTrireme = gc.getInfoTypeForString('UNITCLASS_TRIREME')
		for iPlayer2 in range(gc.getMAX_PLAYERS()):
			pPlayer2 = gc.getPlayer(iPlayer2)
			if pPlayer2.isAlive():
				iTeam2 = gc.getPlayer(iPlayer2).getTeam()
				if eTeam.isAtWar(iTeam2):
					iCount = pPlayer2.getUnitClassCount(iArcane)
					iCount += pPlayer2.getUnitClassCount(iCaravel)
					iCount += pPlayer2.getUnitClassCount(iGalley)
					iCount += pPlayer2.getUnitClassCount(iFrigate) * 2
					iCount += pPlayer2.getUnitClassCount(iGalleon) * 2
					iCount += pPlayer2.getUnitClassCount(iManOWar) * 3
					iCount += pPlayer2.getUnitClassCount(iPrivateer)
					iCount += pPlayer2.getUnitClassCount(iQueenOfTheLine) * 3
					iCount += pPlayer2.getUnitClassCount(iTrireme)
					if iCount > 10:
						return True
		return False
	return True

def spellRagingSeas(caster):
	iCold = gc.getInfoTypeForString('DAMAGE_COLD')
	iFlames = gc.getInfoTypeForString('FEATURE_FLAMES')
	iLanun = gc.getInfoTypeForString('CIVILIZATION_LANUN')
	iSmoke = gc.getInfoTypeForString('IMPROVEMENT_SMOKE')
	iSpring = gc.getInfoTypeForString('EFFECT_SPRING')
	for i in range (CyMap().numPlots()):
		pPlot = CyMap().plotByIndex(i)
		if pPlot.isAdjacentToWater():
			for i in range(pPlot.getNumUnits()):
				pUnit = pPlot.getUnit(i)
				if pUnit.getCivilizationType() != iLanun:
					pUnit.doDamageNoCaster(75, 100, iCold, False)
			if pPlot.getImprovementType() != -1:
				if pPlot.getFeatureType() == iFlames:
					pPlot.setFeatureType(-1, 0)
				if pPlot.getImprovementType() == iSmoke:
					pPlot.setImprovementType(-1)
				else:
					if pPlot.isOwned():
						if gc.getImprovementInfo(pPlot.getImprovementType()).isPermanent() == False:
							if gc.getPlayer(pPlot.getOwner()).getCivilizationType() != iLanun:
								if CyGame().getSorenRandNum(100, "Raging Seas") <= 25:
									pPlot.setImprovementType(-1)
			if pPlot.isVisibleToWatchingHuman():
				CyEngine().triggerEffect(iSpring,pPlot.getPoint())

def spellRaiseSkeleton(caster):
	pPlot = caster.plot()
	if pPlot.getImprovementType() == gc.getInfoTypeForString('IMPROVEMENT_GRAVEYARD'):
		pPlot.setImprovementType(-1)
		caster.cast(gc.getInfoTypeForString('SPELL_RAISE_SKELETON'))
		caster.cast(gc.getInfoTypeForString('SPELL_RAISE_SKELETON'))

def reqRally(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.getCivics(gc.getInfoTypeForString('CIVICOPTION_MEMBERSHIP')) != gc.getInfoTypeForString('CIVIC_CRUSADE'):
		return False
	if pPlayer.isHuman() == False:
		if pPlayer.getNumCities() < 5:
			return False
	return True

def spellRally(caster):
	iOwner = caster.getOwner()
	pPlayer = gc.getPlayer(iOwner)
	iDemagog = gc.getInfoTypeForString('UNIT_DEMAGOG')
	iTown = gc.getInfoTypeForString('IMPROVEMENT_TOWN')
	iVillage = gc.getInfoTypeForString('IMPROVEMENT_VILLAGE')
	iCount = 0
	for i in range (CyMap().numPlots()):
		pPlot = CyMap().plotByIndex(i)
		if pPlot.getOwner() == iOwner:
			if pPlot.isCity():
				newUnit = pPlayer.initUnit(iDemagog, pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
			if pPlot.getImprovementType() == iTown:
				pPlot.setImprovementType(iVillage)
				newUnit = pPlayer.initUnit(iDemagog, pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)

def spellReadTheGrimoire(caster):
	iRnd = CyGame().getSorenRandNum(100, "Read the Grimoire")
	if iRnd < 20:
		caster.cast(gc.getInfoTypeForString('SPELL_SUMMON_SPECTRE'))
	if iRnd >= 20 and iRnd < 40:
		caster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_UNHOLY_TAINT'), True)
	if iRnd >= 40 and iRnd < 60:
		caster.cast(gc.getInfoTypeForString('SPELL_WITHER'))
	if iRnd >= 60 and iRnd < 70:
		caster.cast(gc.getInfoTypeForString('SPELL_SUMMON_PIT_BEAST'))
	if iRnd >= 70 and iRnd < 80:
		caster.cast(gc.getInfoTypeForString('SPELL_BURNING_BLOOD'))
	if iRnd >= 80 and iRnd < 90:
		caster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_DEMON'), True)
	if iRnd >= 90:
		caster.kill(True, PlayerTypes.NO_PLAYER)

def reqRebuildBarnaxus(caster):
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	pCityPlayer = gc.getPlayer(pCity.getOwner())
	if caster.getUnitType() == gc.getInfoTypeForString('UNIT_BARNAXUS'):
		return False
	if pCityPlayer.getCivilizationType() != gc.getInfoTypeForString('CIVILIZATION_LUCHUIRP'):
		return False
	return True

def spellRebuildBarnaxus(caster):
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	pCityPlayer = gc.getPlayer(pCity.getOwner())
	newUnit = pCityPlayer.initUnit(gc.getInfoTypeForString('UNIT_BARNAXUS'), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_NORTH)
	newUnit.setDamage(75, caster.getOwner())
	newUnit.finishMoves()
	pCity.applyBuildEffects(newUnit)
	if pPlayer.getCivilizationType() != gc.getInfoTypeForString('CIVILIZATION_LUCHUIRP'):
		pCityPlayer.AI_changeAttitudeExtra(iPlayer,2)

def spellRecruit(caster):
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	pPlayer = gc.getPlayer(caster.getOwner())
	eTeam = gc.getTeam(pPlayer.getTeam())
	iLoop = (pCity.getPopulation() / 3) + 1
	if pPlayer.getStateReligion() == gc.getInfoTypeForString('RELIGION_THE_ORDER'):
		iLoop = iLoop * 2
	for i in range(iLoop):
		iRnd = CyGame().getSorenRandNum(60, "Bob")
		iUnit = -1
		if iRnd <= 10:
			iUnit = gc.getInfoTypeForString('UNITCLASS_SCOUT')
			if eTeam.isHasTech(gc.getInfoTypeForString('TECH_HUNTING')):
				iUnit = gc.getInfoTypeForString('UNITCLASS_HUNTER')
			if eTeam.isHasTech(gc.getInfoTypeForString('TECH_ANIMAL_HANDLING')):
				iUnit = gc.getInfoTypeForString('UNITCLASS_RANGER')
		elif iRnd <= 20:
			iUnit = gc.getInfoTypeForString('UNITCLASS_SCOUT')
			if eTeam.isHasTech(gc.getInfoTypeForString('TECH_HUNTING')):
				iUnit = gc.getInfoTypeForString('UNITCLASS_HUNTER')
			if eTeam.isHasTech(gc.getInfoTypeForString('TECH_POISONS')):
				iUnit = gc.getInfoTypeForString('UNITCLASS_ASSASSIN')
		elif iRnd <= 30:
			iUnit = gc.getInfoTypeForString('UNITCLASS_SCOUT')
			if eTeam.isHasTech(gc.getInfoTypeForString('TECH_HORSEBACK_RIDING')):
				iUnit = gc.getInfoTypeForString('UNITCLASS_HORSEMAN')
			if eTeam.isHasTech(gc.getInfoTypeForString('TECH_STIRRUPS')):
				iUnit = gc.getInfoTypeForString('UNITCLASS_HORSE_ARCHER')
		elif iRnd <= 40:
			iUnit = gc.getInfoTypeForString('UNITCLASS_SCOUT')
			if eTeam.isHasTech(gc.getInfoTypeForString('TECH_HORSEBACK_RIDING')):
				iUnit = gc.getInfoTypeForString('UNITCLASS_HORSEMAN')
			if eTeam.isHasTech(gc.getInfoTypeForString('TECH_TRADE')):
				iUnit = gc.getInfoTypeForString('UNITCLASS_CHARIOT')
		elif iRnd <= 50:
			iUnit = gc.getInfoTypeForString('UNITCLASS_WARRIOR')
			if eTeam.isHasTech(gc.getInfoTypeForString('TECH_BRONZE_WORKING')):
				iUnit = gc.getInfoTypeForString('UNITCLASS_AXEMAN')
			if eTeam.isHasTech(gc.getInfoTypeForString('TECH_IRON_WORKING')):
				iUnit = gc.getInfoTypeForString('UNITCLASS_CHAMPION')
		elif iRnd <= 60:
			iUnit = gc.getInfoTypeForString('UNITCLASS_WARRIOR')
			if eTeam.isHasTech(gc.getInfoTypeForString('TECH_ARCHERY')):
				iUnit = gc.getInfoTypeForString('UNITCLASS_ARCHER')
			if eTeam.isHasTech(gc.getInfoTypeForString('TECH_BOWYERS')):
				iUnit = gc.getInfoTypeForString('UNITCLASS_LONGBOWMAN')
		if iUnit != -1:
			infoCiv = gc.getCivilizationInfo(pPlayer.getCivilizationType())
			iUnit = infoCiv.getCivilizationUnits(iUnit)
			if iUnit != -1:
				newUnit = pPlayer.initUnit(iUnit, caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_NORTH)
	
	iPopLoss = -(iLoop / 5)
	pCity.changePopulation(iPopLoss)
	caster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_RECRUITER'), False)
#	if caster.getUnitType() != gc.getInfoTypeForString('UNIT_DONAL'):
#		caster.kill(True, PlayerTypes.NO_PLAYER)


def reqWarpath(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		if pPlayer.getBuildingClassCount(gc.getInfoTypeForString('BUILDINGCLASS_CIV_BUILDING2')) < 2:
			return False
	else: 
		if pPlayer.getBuildingClassCount(gc.getInfoTypeForString('BUILDINGCLASS_CIV_BUILDING2')) < 1:
			return False
	return True

def spellWarpath(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	eTeam = gc.getTeam(pPlayer.getTeam())

	for iCity in range(pPlayer.getNumCities()):
		pCity = pPlayer.getCity(iCity)	
		if pCity.getNumBuilding(gc.getInfoTypeForString('BUILDING_COUNCIL_OF_THE_WARCHIEF')) == 1:
			iLoop = (pCity.getPopulation() / 3) + 3
			for i in range(iLoop):
				iRnd = CyGame().getSorenRandNum(60, "Bob")
				iUnit = -1
				if iRnd <= 10:
					iUnit = gc.getInfoTypeForString('UNITCLASS_SCOUT')
					if eTeam.isHasTech(gc.getInfoTypeForString('TECH_HUNTING')):
						iUnit = gc.getInfoTypeForString('UNITCLASS_HUNTER')
					if eTeam.isHasTech(gc.getInfoTypeForString('TECH_ANIMAL_HANDLING')):
						iUnit = gc.getInfoTypeForString('UNITCLASS_RANGER')
				elif iRnd <= 20:
					iUnit = gc.getInfoTypeForString('UNITCLASS_SCOUT')
					if eTeam.isHasTech(gc.getInfoTypeForString('TECH_HUNTING')):
						iUnit = gc.getInfoTypeForString('UNITCLASS_HUNTER')
					if eTeam.isHasTech(gc.getInfoTypeForString('TECH_POISONS')):
						iUnit = gc.getInfoTypeForString('UNITCLASS_ASSASSIN')
				elif iRnd <= 30:
					iUnit = gc.getInfoTypeForString('UNITCLASS_SCOUT')
					if eTeam.isHasTech(gc.getInfoTypeForString('TECH_HORSEBACK_RIDING')):
						iUnit = gc.getInfoTypeForString('UNITCLASS_HORSEMAN')
					if eTeam.isHasTech(gc.getInfoTypeForString('TECH_STIRRUPS')):
						iUnit = gc.getInfoTypeForString('UNITCLASS_HORSE_ARCHER')
				elif iRnd <= 40:
					iUnit = gc.getInfoTypeForString('UNITCLASS_SCOUT')
					if eTeam.isHasTech(gc.getInfoTypeForString('TECH_HORSEBACK_RIDING')):
						iUnit = gc.getInfoTypeForString('UNITCLASS_HORSEMAN')
					if eTeam.isHasTech(gc.getInfoTypeForString('TECH_TRADE')):
						iUnit = gc.getInfoTypeForString('UNITCLASS_CHARIOT')
				elif iRnd <= 50:
					iUnit = gc.getInfoTypeForString('UNITCLASS_WARRIOR')
					if eTeam.isHasTech(gc.getInfoTypeForString('TECH_BRONZE_WORKING')):
						iUnit = gc.getInfoTypeForString('UNITCLASS_AXEMAN')
					if eTeam.isHasTech(gc.getInfoTypeForString('TECH_IRON_WORKING')):
						iUnit = gc.getInfoTypeForString('UNITCLASS_CHAMPION')
				elif iRnd <= 60:
					iUnit = gc.getInfoTypeForString('UNITCLASS_WARRIOR')
					if eTeam.isHasTech(gc.getInfoTypeForString('TECH_ARCHERY')):
						iUnit = gc.getInfoTypeForString('UNITCLASS_ARCHER')
					if eTeam.isHasTech(gc.getInfoTypeForString('TECH_BOWYERS')):
						iUnit = gc.getInfoTypeForString('UNITCLASS_LONGBOWMAN')
				if iUnit != -1:
					infoCiv = gc.getCivilizationInfo(pPlayer.getCivilizationType())
					iUnit = infoCiv.getCivilizationUnits(iUnit)
					if iUnit != -1:
						newUnit = pPlayer.initUnit(iUnit, pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_NORTH)


def reqRecruitMercenary(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		pPlot = caster.plot()
		if pPlayer.getCivilizationType() == gc.getInfoTypeForString('CIVILIZATION_KHAZAD'):
			return False
		iX = caster.getX()
		iY = caster.getY()
		eTeam = gc.getTeam(pPlayer.getTeam())
		getPlot	= CyMap().plot
		for iiX,iiY in RANGE2:
			pPlot = getPlot(iX+iiX,iY+iiY)
			for i in xrange(pPlot.getNumUnits()):
				pUnit = pPlot.getUnit(i)
				p2Player = gc.getPlayer(pUnit.getOwner())
				e2Team = p2Player.getTeam()
				if eTeam.isAtWar(e2Team) == True:
					return True
		return False
	return True

def spellRecruitMercenary(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	iUnit = gc.getInfoTypeForString('UNITCLASS_MERCENARY')
	infoCiv = gc.getCivilizationInfo(pPlayer.getCivilizationType())
	iUnit = infoCiv.getCivilizationUnits(iUnit)
	newUnit = pPlayer.initUnit(iUnit, caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_NORTH)
	newUnit.finishMoves()
	newUnit.setHasCasted(True)
	newUnit.setHasPromotion(gc.getInfoTypeForString('PROMOTION_UNDEAD'), False)
	if caster.getUnitType() == gc.getInfoTypeForString('UNIT_MAGNADINE'):
		newUnit.setHasPromotion(gc.getInfoTypeForString('PROMOTION_LOYALTY'), True)

def spellReleaseFromCage(caster):
	pPlot = caster.plot()
	pPlot.setImprovementType(-1)

def reqReligiousFervor(caster):
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	iReligion = pPlayer.getStateReligion()
	if iReligion == -1:
		return False
	if pPlayer.isHuman() == False:
		iCount = 0
		for pyCity in PyPlayer(iPlayer).getCityList() :
			pCity = pyCity.GetCy()
			if pCity.isHasReligion(iReligion):
				iCount += 1
		if iCount < 5:
			return False
	return True

def spellReligiousFervor(caster):
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	iReligion = pPlayer.getStateReligion()
	if iReligion == gc.getInfoTypeForString('RELIGION_FELLOWSHIP_OF_LEAVES'):
		iUnit = gc.getInfoTypeForString('UNIT_PRIEST_OF_LEAVES')
	if iReligion == gc.getInfoTypeForString('RELIGION_RUNES_OF_KILMORPH'):
		iUnit = gc.getInfoTypeForString('UNIT_PRIEST_OF_KILMORPH')
	if iReligion == gc.getInfoTypeForString('RELIGION_THE_EMPYREAN'):
		iUnit = gc.getInfoTypeForString('UNIT_PRIEST_OF_THE_EMPYREAN')
	if iReligion == gc.getInfoTypeForString('RELIGION_THE_ORDER'):
		iUnit = gc.getInfoTypeForString('UNIT_PRIEST_OF_THE_ORDER')
	if iReligion == gc.getInfoTypeForString('RELIGION_OCTOPUS_OVERLORDS'):
		iUnit = gc.getInfoTypeForString('UNIT_PRIEST_OF_THE_OVERLORDS')
	if iReligion == gc.getInfoTypeForString('RELIGION_THE_ASHEN_VEIL'):
		iUnit = gc.getInfoTypeForString('UNIT_PRIEST_OF_THE_VEIL')
	if iReligion == gc.getInfoTypeForString('RELIGION_COUNCIL_OF_ESUS'):
		iUnit = gc.getInfoTypeForString('UNIT_ASSASSIN')
	iCount = 0
	for pyCity in PyPlayer(iPlayer).getCityList() :
		pCity = pyCity.GetCy()
		if pCity.isHasReligion(iReligion):
			iCount += 1
	for pyCity in PyPlayer(iPlayer).getCityList() :
		pCity = pyCity.GetCy()
		newUnit = pPlayer.initUnit(iUnit, pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		newUnit.changeExperience(iCount, -1, False, False, False)
		newUnit.setReligion(iReligion)

def reqRepair(caster):
	pPlot = caster.plot()
	iGolem = gc.getInfoTypeForString('PROMOTION_GOLEM')
	iNaval = gc.getInfoTypeForString('UNITCOMBAT_NAVAL')
	iSiege = gc.getInfoTypeForString('UNITCOMBAT_SIEGE')
	iHiddenNationality = gc.getInfoTypeForString('PROMOTION_HIDDEN_NATIONALITY')
	
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.getUnitCombatType() == iSiege or pUnit.getUnitCombatType() == iNaval or pUnit.isHasPromotion(iGolem)):
			if pUnit.getDamage() > 0 and not pUnit.isHasPromotion(iHiddenNationality) :
				return True
	return False

def spellRepair(caster,amount):
	pPlot = caster.plot()
	iGolem = gc.getInfoTypeForString('PROMOTION_GOLEM')
	iNaval = gc.getInfoTypeForString('UNITCOMBAT_NAVAL')
	iSiege = gc.getInfoTypeForString('UNITCOMBAT_SIEGE')
	iHiddenNationality = gc.getInfoTypeForString('PROMOTION_HIDDEN_NATIONALITY')
	
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.getUnitCombatType() == iSiege or pUnit.getUnitCombatType() == iNaval or pUnit.isHasPromotion(iGolem)):
			if not pUnit.isHasPromotion(iHiddenNationality):
				pUnit.changeDamage(-amount,0)

def reqAccelerate(caster):
	pPlot = caster.plot()
	iGolem = gc.getInfoTypeForString('PROMOTION_GOLEM')
	iSiege = gc.getInfoTypeForString('UNITCOMBAT_SIEGE')
	iAccelerated = gc.getInfoTypeForString('PROMOTION_ACCELERATED')
	
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.getUnitCombatType() == iSiege or pUnit.isHasPromotion(iGolem)):
			if not pUnit.isHasPromotion(iAccelerated):
				return True
	return False

def spellAccelerate(caster):
	pPlot = caster.plot()
	iGolem = gc.getInfoTypeForString('PROMOTION_GOLEM')
	iSiege = gc.getInfoTypeForString('UNITCOMBAT_SIEGE')
	iAccelerated = gc.getInfoTypeForString('PROMOTION_ACCELERATED')
	
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.getUnitCombatType() == iSiege or pUnit.isHasPromotion(iGolem)):
			pUnit.setHasPromotion(iAccelerated, True)


def reqRessurection(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	iHero = cf.getHero(pPlayer)
	if iHero == -1:
		return False
	if not CyGame().isUnitClassMaxedOut(iHero, 0):
		return False
	for iPlayer in range(gc.getMAX_PLAYERS()):
		pPlayer = gc.getPlayer(iPlayer)
		if pPlayer.getUnitClassCount(iHero) > 0:
			return False
	py = PyPlayer(caster.getOwner())
	iSpell = gc.getInfoTypeForString('SPELL_RESSURECTION')
	for pUnit in py.getUnitList():
		if pUnit.getDelayedSpell() == iSpell:
			return False
# Scions start - Hopefully prevents innapropriate Alexi ressurections.
	if pPlayer.getUnitClassCount(gc.getInfoTypeForString('UNITCLASS_KORRINA_BLACK_LADY')) > 0:
		return False
	if pPlayer.getUnitClassCount(gc.getInfoTypeForString('UNITCLASS_KORRINA_RED_LADY')) > 0:
		return False
	if pPlayer.getUnitClassCount(gc.getInfoTypeForString('UNITCLASS_KORRINA')) > 0:
		return False
# Scions end	
	return True

def spellRessurection(caster):
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	iHero = cf.getHero(pPlayer)
	infoCiv = gc.getCivilizationInfo(pPlayer.getCivilizationType())
	iUnit = infoCiv.getCivilizationUnits(iHero)
	iBarn = gc.getInfoTypeForString('EQUIPMENT_PIECES_OF_BARNAXUS')
	iBarnProm = gc.getInfoTypeForString('PROMOTION_PIECES_OF_BARNAXUS')
	if iUnit == gc.getInfoTypeForString('UNIT_BARNAXUS'):
		for iPlayer2 in range(gc.getMAX_PLAYERS()):
			pPlayer2 = gc.getPlayer(iPlayer2)
			if pPlayer2.isAlive():
				py = PyPlayer(iPlayer2)
				for pUnit in py.getUnitList():
					if pUnit.isHasPromotion(iBarnProm):
						pUnit.setHasPromotion(iBarnProm, False)
						CyInterface().addMessage(iPlayer2,True,25,CyTranslator().getText("TXT_KEY_MESSAGE_PIECES_LOST", ()),'AS2D_CHARM_PERSON',1,'Art/Interface/Buttons/Units/Barnaxus.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
					if pUnit.getUnitType() == iBarn:
						CyInterface().addMessage(iPlayer2,True,25,CyTranslator().getText("TXT_KEY_MESSAGE_PIECES_LOST", ()),'AS2D_CHARM_PERSON',1,'Art/Interface/Buttons/Units/Barnaxus.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
						pUnit.kill(True, PlayerTypes.NO_PLAYER)
	iCreated = gc.getGame().getUnitClassCreatedCount(iHero)
	for iClear in range(iCreated):
		gc.getGame().decrementUnitClassCreatedCount(iHero)
	newUnit = pPlayer.initUnit(iUnit, pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_NORTH)
	for iProm in range(gc.getNumPromotionInfos()):
		if newUnit.isHasPromotion(iProm):
			if gc.getPromotionInfo(iProm).isEquipment():
				newUnit.setHasPromotion(iProm, False)

def spellRessurectionGraveyard(caster):
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	infoCiv = gc.getCivilizationInfo(pPlayer.getCivilizationType())
	iUnit = infoCiv.getCivilizationUnits(gc.getInfoTypeForString('UNITCLASS_CHAMPION'))
	if iUnit == -1:
		iUnit = gc.getInfoTypeForString('UNIT_CHAMPION')
	newUnit = pPlayer.initUnit(iUnit, pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
	newUnit.changeExperience(CyGame().getSorenRandNum(30, "Ressurection Graveyard"), -1, False, False, False)
	pPlot.setImprovementType(-1)

def reqRevelry(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isGoldenAge():
		return False
	if pPlayer.isHuman() == False:
		if pPlayer.getTotalPopulation() < 25:
			return False
	return True

def spellRevelry(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	pPlayer.changeGoldenAgeTurns(CyGame().goldenAgeLength() * 2)

def reqRevelation(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	iTeam = pPlayer.getTeam()
	iX = caster.getX()
	iY = caster.getY()
	iHidden = gc.getInfoTypeForString('PROMOTION_HIDDEN')
	iHiddenNationality = gc.getInfoTypeForString('PROMOTION_HIDDEN_NATIONALITY')
	iIllusion = gc.getInfoTypeForString('PROMOTION_ILLUSION')
	iInvisible = gc.getInfoTypeForString('PROMOTION_INVISIBLE')
	for iiX in range(iX-3, iX+4, 1):
		for iiY in range(iY-3, iY+4, 1):
			pPlot = CyMap().plot(iiX,iiY)
			for iUnit in range(pPlot.getNumUnits()):
				pUnit = pPlot.getUnit(iUnit)
				if pUnit.getTeam() != iTeam:
					if pUnit.isHasPromotion(iHidden):
						return True
					if pUnit.isHasPromotion(iHiddenNationality):
						return True
					if pUnit.isHasPromotion(iInvisible):
						return True
					if pUnit.isHasPromotion(iIllusion):
						return True
	return False

def spellRevelation(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	iTeam = pPlayer.getTeam()
	iX = caster.getX()
	iY = caster.getY()
	iHidden = gc.getInfoTypeForString('PROMOTION_HIDDEN')
	iHiddenNationality = gc.getInfoTypeForString('PROMOTION_HIDDEN_NATIONALITY')
	iIllusion = gc.getInfoTypeForString('PROMOTION_ILLUSION')
	iInvisible = gc.getInfoTypeForString('PROMOTION_INVISIBLE')
	getPlot	= CyMap().plot
	for iiX in xrange(iX-3, iX+4, 1):
		for iiY in xrange(iY-3, iY+4, 1):
			pPlot = getPlot(iiX,iiY)
			for iUnit in xrange(pPlot.getNumUnits()):
				pUnit = pPlot.getUnit(iUnit)
				if pUnit.getTeam() != iTeam:
					if pUnit.isHasPromotion(iHidden):
						pUnit.setHasPromotion(iHidden, False)
					if pUnit.isHasPromotion(iHiddenNationality):
						pUnit.setHasPromotion(iHiddenNationality, False)
					if pUnit.isHasPromotion(iInvisible):
						pUnit.setHasPromotion(iInvisible, False)
					if pUnit.isHasPromotion(iIllusion):
						pUnit.kill(True, caster.getOwner())

def spellRingofFlames(caster):
	iX = caster.getX()
	iY = caster.getY()
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE1:
		pPlot = getPlot(iX+iiX,iY+iiY)
		bValid = True
		if pPlot.getImprovementType() != -1:
			if gc.getImprovementInfo(pPlot.getImprovementType()).isPermanent():
				bValid = False
		if bValid:
			if (pPlot.getFeatureType() == gc.getInfoTypeForString('FEATURE_FOREST') or pPlot.getFeatureType() == gc.getInfoTypeForString('FEATURE_JUNGLE') or pPlot.getFeatureType() == gc.getInfoTypeForString('FEATURE_FOREST_NEW')):
				if CyGame().getSorenRandNum(100, "Flames Spread") <= gc.getDefineINT('FLAMES_SPREAD_CHANCE'):
					pPlot.setImprovementType(gc.getInfoTypeForString('IMPROVEMENT_SMOKE'))

def reqRiverOfBlood(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.getNumCities() == 0:
		return False
	if not pPlayer.isHuman():
		if pPlayer.getNumCities() < 5:
			return False
	return True

def spellRiverOfBlood(caster):
	iCalabim = gc.getInfoTypeForString('CIVILIZATION_CALABIM')
# Scions Start - Reduces pop loss from River of Blood for Scion
	iScions = gc.getInfoTypeForString('CIVILIZATION_SCIONS')
	iDtesh = gc.getInfoTypeForString('CIVILIZATION_DTESH')
# Scions End
	for iPlayer in range(gc.getMAX_PLAYERS()):
		pPlayer = gc.getPlayer(iPlayer)
		if pPlayer.isAlive():
# Scions Start # 2 of 3

			if pPlayer.getCivilizationType() == iScions:	
				for iCity in range(pPlayer.getNumCities()):
					pCity = pPlayer.getCity(iCity)
					if pCity.getPopulation() > 3:
						pCity.changePopulation(1)
			if pPlayer.getCivilizationType() == iScions:		
				for iCity in range(pPlayer.getNumCities()):
					pCity = pPlayer.getCity(iCity)
					if pCity.getPopulation() == 3:
						pCity.changePopulation(2)			
# Scions End 
# Dtesh Start
			if pPlayer.getCivilizationType() == iDtesh:		
				for iCity in range(pPlayer.getNumCities()):
					pCity = pPlayer.getCity(iCity)
					pCity.changePopulation(2)	
# Dtesh End

			if pPlayer.getCivilizationType() != iCalabim:
				for pyCity in PyPlayer(iPlayer).getCityList() :
					pCity = pyCity.GetCy()
					if pCity.getPopulation() > 2:
						pCity.changePopulation(-2)
						CyInterface().addMessage(pCity.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_RIVER_OF_BLOOD", ()),'',1,'Art/Interface/Buttons/Spells/River of Blood.dds',ColorTypes(7),pCity.getX(),pCity.getY(),True,True)
			if pPlayer.getCivilizationType() == iCalabim:
				for pyCity in PyPlayer(iPlayer).getCityList() :
					pCity = pyCity.GetCy()
					pCity.changePopulation(2)

def reqRoar(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	eTeam = gc.getTeam(pPlayer.getTeam())
	iX = caster.getX()
	iY = caster.getY()
	iTarget = -1
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE1:
		pPlot = getPlot(iX+iiX,iY+iiY)
		for i in range(pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(i)
			if not pUnit.isImmuneToFear():
				p2Player = gc.getPlayer(pUnit.getOwner())
				e2Team = p2Player.getTeam()
				if eTeam.isAtWar(e2Team) == True:
					return True
	return False

def spellRoar(caster):
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	eTeam = gc.getTeam(pPlayer.getTeam())
	pPlot = caster.plot()
	iX = caster.getX()
	iY = caster.getY()
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE1:
		pLoopPlot = getPlot(iX+iiX,iY+iiY)
		if not pLoopPlot.isNone():
			for i in range(pLoopPlot.getNumUnits() -1, -1, -1):
				pUnit = pLoopPlot.getUnit(i)
				p2Player = gc.getPlayer(pUnit.getOwner())
				i2Team = p2Player.getTeam()
				if eTeam.isAtWar(i2Team):
					if doFear(pUnit, pPlot, caster, True):
						CyInterface().addMessage(pUnit.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_FEAR", (gc.getUnitInfo(pUnit.getUnitType()).getDescription(), )),'',1,'Art/Interface/Buttons/Spells/Roar.dds',ColorTypes(7),pUnit.getX(),pUnit.getY(),True,True)
						CyInterface().addMessage(iPlayer,True,25,CyTranslator().getText("TXT_KEY_MESSAGE_FEAR_ENEMY", (gc.getUnitInfo(pUnit.getUnitType()).getDescription(), )),'',1,'Art/Interface/Buttons/Spells/Roar.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)

def reqRobGrave(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	if not pPlayer.isHuman():
		if pPlayer.getAlignment() == gc.getInfoTypeForString('ALIGNMENT_GOOD') or pPlayer.isBarbarian():
			return False
	return True

def spellRobGrave(caster):
	CyGame().changeGlobalCounter(1)
	pPlot = caster.plot()
	pPlot.setImprovementType(-1)
	pPlayer = gc.getPlayer(caster.getOwner())
	lList = ['LOW_GOLD', 'HIGH_GOLD']
	if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_GRAVE_SPECTRE'), caster):
		lList += ['SPAWN_SPECTRE']
	if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_GRAVE_SKELETONS'), caster):
		lList += ['SPAWN_SKELETONS']
	if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_GRAVE_TECH'), caster):
		lList = lList + ['TECH']
	sGoody = lList[CyGame().getSorenRandNum(len(lList), "Pick Goody")-1]
	if sGoody == 'LOW_GOLD':
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_GRAVE_LOW_GOLD'), caster)
	if sGoody == 'HIGH_GOLD':
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_GRAVE_HIGH_GOLD'), caster)
	if sGoody == 'TECH':
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_GRAVE_TECH'), caster)
	if sGoody == 'SPAWN_SKELETONS':
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_GRAVE_SKELETONS'), caster)
	if sGoody == 'SPAWN_SPECTRE':
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_GRAVE_SPECTRE'), caster)

def spellSacrificeAltar(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	pPlot = caster.plot()
	eTeam = gc.getTeam(pPlayer.getTeam())
	iTech = pPlayer.getCurrentResearch()
	iNum = 10 + (caster.getLevel() * caster.getLevel())
	eTeam.changeResearchProgress(iTech, iNum, caster.getOwner())

def spellSacrificePyre(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	caster.cast(gc.getInfoTypeForString('SPELL_RING_OF_FLAMES'))
	iCount = 1
	if caster.isImmortal():
		caster.changeImmortal(-10)
	if isWorldUnitClass(caster.getUnitClassType()):
		iCount = 7
	for i in range(iCount):
		newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_FIRE_ELEMENTAL'), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		#Should we make this assign the units to the same Master as the original unit had?
		newUnit.setDuration(caster.getDuration())


def spellSacrifice(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	pPlot = caster.plot()
	eTeam = gc.getTeam(pPlayer.getTeam())
	iNum = 10 + (caster.getLevel() * caster.getLevel())

	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		iPriest = gc.getInfoTypeForString('UNIT_LIZARD_PRIEST_OF_AGRUONN')
		iShadowPriest = gc.getInfoTypeForString('UNIT_SHADOW_PRIEST_OF_AGRUONN')
		iHeroPriest = gc.getInfoTypeForString('UNIT_MIQUIZTLI')

		if pUnit.getUnitType() == iPriest or pUnit.getUnitType() == iShadowPriest or pUnit.getUnitType() == iHeroPriest:
			iEmpower1 = gc.getInfoTypeForString('PROMOTION_EMPOWER1')
			iEmpower2 = gc.getInfoTypeForString('PROMOTION_EMPOWER2')
			iEmpower3 = gc.getInfoTypeForString('PROMOTION_EMPOWER3')
			iEmpower4 = gc.getInfoTypeForString('PROMOTION_EMPOWER4')
			iEmpower5 = gc.getInfoTypeForString('PROMOTION_EMPOWER5')

			py = PyPlayer(caster.getOwner())
			
			for pUnit in py.getUnitList():
				if pUnit.getUnitType() == iPriest or pUnit.getUnitType() == iShadowPriest or pUnit.getUnitType() == iHeroPriest:
					if (iNum > 25):
						pUnit.setHasPromotion(iEmpower5, True)
						pUnit.setHasPromotion(iEmpower4, True)
					if (iNum > 13):
						pUnit.setHasPromotion(iEmpower3, True)
						pUnit.setHasPromotion(iEmpower2, True)
					else:
						pUnit.setHasPromotion(iEmpower1, True)
						
			return
					


def reqPurify(caster):
	pPlot = caster.plot()
	if reqSanctify(caster):
		return True
		
				
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.isHasPromotion(gc.getInfoTypeForString('PROMOTION_DISEASED')):	
			return True
				
	return False
			

def reqSanctify(caster):
	pPlot = caster.plot()
	bValid = False
	if pPlot.getImprovementType() == gc.getInfoTypeForString('IMPROVEMENT_CITY_RUINS'):
		return True
	if pPlot.getImprovementType() == gc.getInfoTypeForString('IMPROVEMENT_GRAVEYARD'):
		return True
	iX = pPlot.getX()
	iY = pPlot.getY()
	getPlot	= CyMap().plot
	if gc.getGame().isOption(GameOptionTypes.GAMEOPTION_NO_PLOT_COUNTER):
		iBrokenLands = gc.getInfoTypeForString('TERRAIN_BROKEN_LANDS')
		iBurningSands = gc.getInfoTypeForString('TERRAIN_BURNING_SANDS')
		iFieldsOfPerdition = gc.getInfoTypeForString('TERRAIN_FIELDS_OF_PERDITION')
		iShallows = gc.getInfoTypeForString('TERRAIN_SHALLOWS')
		for iiX,iiY in RANGE1:
			pPlot = getPlot(iX+iiX,iY+iiY)
			if not pPlot.isNone():
				iTerrain = pPlot.getTerrainType()
				if (iTerrain == iBrokenLands or iTerrain == iBurningSands or iTerrain == iFieldsOfPerdition or iTerrain == iShallows):
					bValid = True
	else:
		for iiX,iiY in RANGE1:
			pPlot = getPlot(iX+iiX,iY+iiY)
			if not pPlot.isNone():
				if pPlot.getPlotCounter() > 0:
					bValid = True
	if bValid == False:
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if not pPlayer.isHuman():
		if caster.getOwner() != pPlot.getOwner():
			return False
		if pPlayer.getCivilizationType() == gc.getInfoTypeForString('CIVILIZATION_INFERNAL'):
			return False
	return True

def spellSanctify(caster):
	pPlot = caster.plot()
	iX = pPlot.getX()
	iY = pPlot.getY()
	getPlot	= CyMap().plot
	if pPlot.getImprovementType() == gc.getInfoTypeForString('IMPROVEMENT_CITY_RUINS'):
		pPlot.setImprovementType(-1)
		CyGame().changeGlobalCounter(-1)
	if pPlot.getImprovementType() == gc.getInfoTypeForString('IMPROVEMENT_GRAVEYARD'):
		pPlot.setImprovementType(-1)
		CyGame().changeGlobalCounter(-1)
		pPlayer = gc.getPlayer(caster.getOwner())
		newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_EINHERJAR'), pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
	if gc.getGame().isOption(GameOptionTypes.GAMEOPTION_NO_PLOT_COUNTER):
		iBrokenLands = gc.getInfoTypeForString('TERRAIN_BROKEN_LANDS')
		iBurningSands = gc.getInfoTypeForString('TERRAIN_BURNING_SANDS')
		iDesert = gc.getInfoTypeForString('TERRAIN_DESERT')
		iFieldsOfPerdition = gc.getInfoTypeForString('TERRAIN_FIELDS_OF_PERDITION')
		iGrass = gc.getInfoTypeForString('TERRAIN_GRASS')
		iMarsh = gc.getInfoTypeForString('TERRAIN_MARSH')
		iPlains = gc.getInfoTypeForString('TERRAIN_PLAINS')
		iShallows = gc.getInfoTypeForString('TERRAIN_SHALLOWS')
		for iiX,iiY in RANGE1:
			pPlot = getPlot(iX+iiX,iY+iiY)
			if not pPlot.isNone():
				iTerrain = pPlot.getTerrainType()
				if iTerrain == iBrokenLands:
					pPlot.setTerrainType(iGrass, False, False)
				if iTerrain == iBurningSands:
					pPlot.setTerrainType(iDesert, False, False)
				if iTerrain == iFieldsOfPerdition:
					pPlot.setTerrainType(iPlains, False, False)
				if iTerrain == iShallows:
					pPlot.setTerrainType(iMarsh, False, False)
	else:
		for iiX,iiY in RANGE1:
			pPlot = getPlot(iX+iiX,iY+iiY)
			if pPlot.getPlotCounter() > 0:
				pPlot.changePlotCounter(pPlot.getPlotCounter() * -1)
# FF: Added by Jean Elcard 14/01/2009 (speed tweak)
		rebuildGraphics()
# FF: End Add

def reqSanctuary(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.getNumCities() == 0:
		return False
	if not pPlayer.isHuman():
		iTeam = gc.getPlayer(caster.getOwner()).getTeam()
		eTeam = gc.getTeam(iTeam)
		if eTeam.getAtWarCount(True) < 2:
			return False
	return True

def spellSanctuary(caster):
	iPlayer = caster.getOwner()
	iTeam = caster.getTeam()
	pPlayer = gc.getPlayer(iPlayer)
	pPlayer.changeSanctuaryTimer(30)
	map	= CyMap()
	plotByIndex = map.plotByIndex
	for i in xrange(map.numPlots()):
		pPlot = plotByIndex(i)
		if pPlot.isOwned():
			if pPlot.getOwner() == iPlayer:
				for i in xrange(pPlot.getNumUnits(), -1, -1):
					pUnit = pPlot.getUnit(i)
					if pUnit.getTeam() != iTeam:
						pUnit.jumpToNearestValidPlot()

def reqSandLion(caster):
	pPlot = caster.plot()
	if (pPlot.getTerrainType() != gc.getInfoTypeForString('TERRAIN_DESERT') and pPlot.getTerrainType() != gc.getInfoTypeForString('TERRAIN_BURNING_SANDS')):
		return False
	return True

def reqScorch(caster):
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	sValidTerrains = ['SNOW', 'TUNDRA', 'MARSH', 'GRASS', 'PLAINS', 'FIELDS_OF_PERDITION']
	iValidTerrains = [gc.getInfoTypeForString('TERRAIN_' + sTerrain) for sTerrain in sValidTerrains]
	iDtesh = gc.getInfoTypeForString('CIVILIZATION_DTESH')
	iCiv = pPlayer.getCivilizationType()
	if (pPlot.getTerrainType() in iValidTerrains):
		if not pPlayer.isHuman():
			iLizCiv1 = gc.getInfoTypeForString('CIVILIZATION_MAZATL')
			iLizCiv2 = gc.getInfoTypeForString('CIVILIZATION_CUALLI')
			iCiv = pPlayer.getCivilizationType ()
			if pPlot.getTerrainType() == gc.getInfoTypeForString('TERRAIN_MARSH') and (iCiv != iLizCiv1 or iCiv != iLizCiv2):
				return True
			if gc.getInfoTypeForString('TERRAIN_SNOW'):
				if pPlayer.getCivilizationType() == gc.getInfoTypeForString('CIVILIZATION_ILLIANS'):
					return False
				elif caster.getOwner() != pPlot.getOwner():
					return False
			if gc.getInfoTypeForString('TERRAIN_TUNDRA'):
				if pPlayer.getCivilizationType() == gc.getInfoTypeForString('CIVILIZATION_DOVIELLO'):
					return False
				elif caster.getOwner() != pPlot.getOwner():
					return False
			elif caster.getOwner() == pPlot.getOwner():
				return False
		return True
	if pPlot.getTerrainType() == gc.getInfoTypeForString('TERRAIN_DESERT'):
		if iCiv == iDtesh:
			return True
	if pPlot.getTerrainType() == gc.getInfoTypeForString('TERRAIN_BURNING_SANDS'):
		if iCiv == iDtesh:
			return True
	if pPlot.getTerrainType() == gc.getInfoTypeForString('TERRAIN_BROKEN_LANDS'):
		if iCiv == iDtesh:
			return True
	if pPlot.getTerrainType() == gc.getInfoTypeForString('TERRAIN_SHALLOWS'):
		if iCiv == iDtesh:
			return True
	return False

def spellScorch(caster):
	gc			= CyGlobalContext()
	getInfoType	= gc.getInfoTypeForString
	pPlot = caster.plot()
	iTerrain = pPlot.getTerrainType()
	iFeature = pPlot.getFeatureType()
	iImprovement = pPlot.getImprovementType()
	sJungleFeatures = ['FEATURE_JUNGLE']
	iJungleFeatures = [getInfoType(sFeature) for sFeature in sJungleFeatures]
	sForestFeatures = ['FEATURE_FOREST', 'FEATURE_FOREST_NEW']
	iForestFeatures = [getInfoType(sFeature) for sFeature in sForestFeatures]
	pPlayer = gc.getPlayer(caster.getOwner())
	iCiv = pPlayer.getCivilizationType()
	iDtesh = getInfoType('CIVILIZATION_DTESH')
	# spawn a defender in scorched terrain
	if iFeature == getInfoType('FEATURE_FOREST_ANCIENT'):
		pSpawnPlot = findClearPlot(UnitTypes.NO_UNIT, pPlot)
		if pSpawnPlot != -1:
			iTreant = getInfoType('UNIT_TREANT')
			eDirection = directionXYFromPlot(pSpawnPlot, pPlot)
			pDemonPlayer = gc.getPlayer(gc.getDEMON_PLAYER())
			pTreant = pDemonPlayer.initUnit(iTreant, pSpawnPlot.getX(), pSpawnPlot.getY(), UnitAITypes.NO_UNITAI, eDirection)
			pTreant.setDuration(5)
	if iFeature == getInfoType('FEATURE_FOREST_BURNT'):
		if CyGame().getSorenRandNum(100, "Mistform Spawn") < 25:
			pSpawnPlot = findClearPlot(UnitTypes.NO_UNIT, pPlot)
			if pSpawnPlot != -1:
				iMistform = getInfoType('UNIT_MISTFORM')
				eDirection = directionXYFromPlot(pSpawnPlot, pPlot)
				pDemonPlayer = gc.getPlayer(gc.getDEMON_PLAYER())
				pMistform = pDemonPlayer.initUnit(iMistform, pSpawnPlot.getX(), pSpawnPlot.getY(), UnitAITypes.NO_UNITAI, eDirection)
				pMistform.setDuration(5)
	if iFeature in iJungleFeatures:
		if CyGame().getSorenRandNum(100, "Jungle Defender Spawn") < 5:	
			pSpawnPlot = findClearPlot(UnitTypes.NO_UNIT, pPlot)
			if pSpawnPlot != -1:
				lJList = ['UNIT_GOBLIN', 'UNIT_GOBLIN', 'UNIT_GOBLIN', 'UNIT_WOLF_RIDER', 'UNIT_LIZARDMAN', 'UNIT_LIZARDMAN', 'UNIT_LIZARDMAN', 'UNIT_LIZARDMAN', 'UNIT_LIZARDMAN_RANGER', 'UNIT_LIZARDMAN_ASSASSIN']
				sJungleDefender = lJList[CyGame().getSorenRandNum(len(lJList), "Pick Jungle Defender")]
				iJungleDefender = getInfoType(sJungleDefender)
				eDirection = directionXYFromPlot(pSpawnPlot, pPlot)
				pOrcPlayer = gc.getPlayer(gc.getORC_PLAYER())
				pJungleDefender = pOrcPlayer.initUnit(iJungleDefender, pSpawnPlot.getX(), pSpawnPlot.getY(), UnitAITypes.NO_UNITAI, eDirection)
	if iFeature in iForestFeatures:
		if CyGame().getSorenRandNum(100, "Forest Defender Spawn") < 5:	
			pSpawnPlot = findClearPlot(UnitTypes.NO_UNIT, pPlot)
			if pSpawnPlot != -1:
				lFList = ['UNIT_WOLF', 'UNIT_WOLF', 'UNIT_WOLF', 'UNIT_WOLF', 'UNIT_WOLF', 'UNIT_WOLF_PACK', 'UNIT_WOLF_PACK', 'UNIT_WOLF_PACK', 'UNIT_BABY_SPIDER', 'UNIT_BABY_SPIDER', 'UNIT_BABY_SPIDER', 'UNIT_BABY_SPIDER', 'UNIT_BABY_SPIDER', 'UNIT_WEREWOLF', 'UNIT_GRIFFON', 'UNIT_BEAR','UNIT_BEAR', 'UNIT_FAWN', 'UNIT_FAWN', 'UNIT_FAWN', 'UNIT_FAWN', 'UNIT_FAWN', 'UNIT_SATYR']
				sForestDefender = lFList[CyGame().getSorenRandNum(len(lFList), "Pick Forest Defender")]
				iForestDefender = getInfoType(sForestDefender)
				eDirection = directionXYFromPlot(pSpawnPlot, pPlot)
				pAnimalPlayer = gc.getPlayer(gc.getANIMAL_PLAYER())
				pForestDefender = pAnimalPlayer.initUnit(iForestDefender, pSpawnPlot.getX(), pSpawnPlot.getY(), UnitAITypes.NO_UNITAI, eDirection)
	# terraform the terrain
	
	if iImprovement == getInfoType('IMPROVEMENT_SWAMP'):
		pPlot.setImprovementType(-1)
	
	if iTerrain == getInfoType('TERRAIN_SNOW'):
		pPlot.setTerrainType(getInfoType('TERRAIN_TUNDRA'), True, True)
	elif iTerrain == getInfoType('TERRAIN_TUNDRA'):
		pPlot.setTerrainType(getInfoType('TERRAIN_PLAINS'), True, True)
	elif iTerrain == getInfoType('TERRAIN_MARSH'):
		pPlot.setTerrainType(getInfoType('TERRAIN_GRASS'), True, True)
	elif iTerrain == getInfoType('TERRAIN_GRASS'):
		pPlot.setTerrainType(getInfoType('TERRAIN_PLAINS'), True, True)
	elif iTerrain == getInfoType('TERRAIN_PLAINS'):
		pPlayer = gc.getPlayer(caster.getOwner())
		iDtesh = getInfoType('CIVILIZATION_DTESH')
		iCiv = pPlayer.getCivilizationType()
		if iCiv != iDtesh:
			pPlot.setTerrainType(getInfoType('TERRAIN_DESERT'), True, True)
			if iFeature in iForestFeatures: 
				pPlot.setFeatureType(FeatureTypes.NO_FEATURE, -1)
				if CyGame().getSorenRandNum(100, "Scorch Forest Scrub") < 33:
					pPlot.setFeatureType(getInfoType('FEATURE_SCRUB'), -1)
			if iFeature in iJungleFeatures: 
				pPlot.setFeatureType(FeatureTypes.NO_FEATURE, -1)
				if CyGame().getSorenRandNum(100, "Scorch Jungle Scrub") < 25:
					pPlot.setFeatureType(getInfoType('FEATURE_SCRUB'), -1)
			if iFeature == getInfoType('FEATURE_FOREST_ANCIENT'): 
				pPlot.setFeatureType(FeatureTypes.NO_FEATURE, -1)
				if CyGame().getSorenRandNum(100, "Scorch Ancient Forest Scrub") < 20:
					pPlot.setFeatureType(getInfoType('FEATURE_SCRUB'), -1)
			if iFeature == getInfoType('FEATURE_FOREST_BURNT'): 
				pPlot.setFeatureType(FeatureTypes.NO_FEATURE, -1)
			# add flood plains to new desert along rivers (delayed)
			if pPlot.canHaveFeature(getInfoType('FEATURE_FLOOD_PLAINS')):
				pPlot.setFeatureType(getInfoType('FEATURE_FLOOD_PLAINS'), -1)
				pPlot.setTempFeatureType(FeatureTypes.NO_FEATURE, -1, scale(5))
			# adds an oasis to some of the new deserts
			iOasis = getInfoType('FEATURE_OASIS')
			if pPlot.canHaveFeature(iOasis):
				if CyGame().getSorenRandNum(10000, "Scorch Oasis") < gc.getFeatureInfo(iOasis).getAppearanceProbability():
					pPlot.setFeatureType(iOasis, -1)
		elif iCiv == iDtesh:
			pPlot.setTerrainType(getInfoType('TERRAIN_WASTELAND'), True, True)
			if iFeature in iForestFeatures: 
				pPlot.setFeatureType(FeatureTypes.NO_FEATURE, -1)
			if iFeature in iJungleFeatures: 
				pPlot.setFeatureType(FeatureTypes.NO_FEATURE, -1)
			if iFeature == getInfoType('FEATURE_FOREST_ANCIENT'): 
				pPlot.setFeatureType(FeatureTypes.NO_FEATURE, -1)
			if iFeature == getInfoType('FEATURE_FOREST_BURNT'): 
				pPlot.setFeatureType(FeatureTypes.NO_FEATURE, -1)
	elif iTerrain == getInfoType('TERRAIN_FIELDS_OF_PERDITION'):
		if iCiv != iDtesh:
			pPlot.setTerrainType(getInfoType('TERRAIN_BURNING_SANDS'), True, True)
		if iCiv == iDtesh:
			pPlot.setTerrainType(getInfoType('TERRAIN_WASTELAND'), True, True)
			pPlot.changePlotCounter(0)
	elif iTerrain == getInfoType('TERRAIN_DESERT'):
		if iCiv == iDtesh:
			pPlot.setTerrainType(getInfoType('TERRAIN_WASTELAND'), True, True)
	elif iTerrain == getInfoType('TERRAIN_BURNING_SANDS'):
		if iCiv == iDtesh:
			pPlot.setTerrainType(getInfoType('TERRAIN_WASTELAND'), True, True)
			pPlot.changePlotCounter(0)
	elif iTerrain == getInfoType('TERRAIN_BROKEN_LANDS'):
		if iCiv == iDtesh:
			pPlot.setTerrainType(getInfoType('TERRAIN_WASTELAND'), True, True)
			pPlot.changePlotCounter(0)
	elif iTerrain == getInfoType('TERRAIN_SHALLOWS'):
		if iCiv == iDtesh:
			pPlot.setTerrainType(getInfoType('TERRAIN_WASTELAND'), True, True)
			pPlot.changePlotCounter(0)
	elif iImprovement == getInfoType('IMPROVEMENT_SWAMP'):
		pPlot.setImprovementType(-1)
		
	# declare war at plot owner
	if pPlot.isOwned():
		startWar(caster.getOwner(), pPlot.getOwner(), WarPlanTypes.WARPLAN_TOTAL)
#Added in Frozen/Blizzards: TC01
	getPlot	= CyMap().plot
	iIce	= getInfoType('FEATURE_ICE')
	for iiX in xrange(pPlot.getX()-1, pPlot.getX()+2):
		for iiY in xrange(pPlot.getY()-1, pPlot.getY()+2):
			pIce = getPlot(iiX, iiY)
			if pIce.getFeatureType() == iIce:
				pIce.setFeatureType(-1, -1)
#End of Frozen/Blizzards

def spellSing(caster):
	pPlot = caster.plot()
	point = pPlot.getPoint()
	iRnd = CyGame().getSorenRandNum(100, "Sing")
	szText = "AS3D_SING1"
	if iRnd > 25:
		szText = "AS3D_SING2"
	if iRnd > 50:
		szText = "AS3D_SING3"
	if iRnd > 75:
		szText = "AS3D_SING4"
	CyAudioGame().Play3DSound(szText,point.x,point.y,point.z)

def reqSironasTouch(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isFeatAccomplished(FeatTypes.FEAT_HEAL_UNIT_PER_TURN) == False:
		return False
	if caster.getDamage() == 0:
		return False
	if pPlayer.isHuman() == False:
		if caster.getDamage() < 15:
			return False
	return True

def spellSironasTouch(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	pPlayer.setFeatAccomplished(FeatTypes.FEAT_HEAL_UNIT_PER_TURN, False)
	caster.changeDamage(-15,0)

def reqSlaveTradeBuy(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	iDtesh = gc.getInfoTypeForString('CIVILIZATION_DTESH')
	iCiv = pPlayer.getCivilizationType()
	if iCiv == iDtesh:
		return False
	return True
	
def spellSlaveTradeBuy(caster):
	pCity = caster.plot().getPlotCity()
	pPlayer = gc.getPlayer(caster.getOwner())
	pPlot = caster.plot()
	newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_SLAVE'), pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
	iPromotion = -1
	iRnd = CyGame().getSorenRandNum(100, "Slave Trade Buy")
	if (iRnd >= 60 and iRnd < 70):
		iPromotion = gc.getInfoTypeForString('PROMOTION_DWARF')
	if (iRnd >= 70 and iRnd < 80):
		iPromotion = gc.getInfoTypeForString('PROMOTION_ELF')
	if (iRnd >= 80):
		iPromotion = gc.getInfoTypeForString('PROMOTION_ORC')
	if iPromotion != -1:
		newUnit.setHasPromotion(iPromotion, True)

def spellSnowfall(caster):
	iX = caster.getX()
	iY = caster.getY()
	iFlames = gc.getInfoTypeForString('FEATURE_FLAMES')
	iSmoke = gc.getInfoTypeForString('IMPROVEMENT_SMOKE')
	iSnow = gc.getInfoTypeForString('TERRAIN_SNOW')
	randNum = CyGame().getSorenRandNum
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE1:
		pPlot = getPlot(iX+iiX,iY+iiY)
		if not pPlot.isNone():
			if not pPlot.isWater():
				if pPlot.getTerrainType() != iSnow:
					iRnd = randNum(6, "Snowfall") + 3
					pPlot.setTempTerrainType(iSnow, iRnd)
					if pPlot.getFeatureType() == iFlames:
						pPlot.setFeatureType(-1, -1)
					if pPlot.getImprovementType() == iSmoke:
						pPlot.setImprovementType(-1)

def spellSnowfallGreator(caster):
	iX = caster.getX()
	iY = caster.getY()
	iFlames = gc.getInfoTypeForString('FEATURE_FLAMES')
	iSmoke = gc.getInfoTypeForString('IMPROVEMENT_SMOKE')
	iSnow = gc.getInfoTypeForString('TERRAIN_SNOW')
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE2:
		pPlot = getPlot(iX+iiX,iY+iiY)
		if not pPlot.isNone():
			if not pPlot.isWater():
				if pPlot.getTerrainType() != iSnow:
					iRnd = CyGame().getSorenRandNum(12, "Snowfall") + 6
					pPlot.setTempTerrainType(iSnow, iRnd)
					if pPlot.getFeatureType() == iFlames:
						pPlot.setFeatureType(-1, -1)
					if pPlot.getImprovementType() == iSmoke:
						pPlot.setImprovementType(-1)

def reqSpreadTheCouncilOfEsus(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	pCity = caster.plot().getPlotCity()
	if pCity.isHasReligion(gc.getInfoTypeForString('RELIGION_COUNCIL_OF_ESUS')):
		return False
	if pPlayer.isHuman() == False:
		if pPlayer.getStateReligion() != gc.getInfoTypeForString('RELIGION_COUNCIL_OF_ESUS'):
			return False
	return True

def reqSpring(caster):
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	bFlames = False
	iSciCiv = gc.getInfoTypeForString('CIVILIZATION_SCIONS')
	iCiv = pPlayer.getCivilizationType()
	iX = pPlot.getX()
	iY = pPlot.getY()
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE1:
		pPlot2 = getPlot(iX+iiX,iY+iiY)
		if pPlot2.getFeatureType() == gc.getInfoTypeForString('FEATURE_FLAMES') or pPlot2.getImprovementType() == gc.getInfoTypeForString('IMPROVEMENT_SMOKE'):
			bFlames = True
	if pPlayer.getCivilizationType() == gc.getInfoTypeForString('CIVILIZATION_MALAKIM'):
		return False
	pPlot = caster.plot()
	if bFlames == False:
		if pPlot.getImprovementType() == gc.getInfoTypeForString('IMPROVEMENT_SWAMP'):
			return False
				
		if pPlayer.isHuman() == False:
			if caster.getOwner() != pPlot.getOwner():
				return False
	if pPlayer.isHuman() == False:
		if pPlayer.getCivilizationType() == gc.getInfoTypeForString('CIVILIZATION_INFERNAL'):
			return False
	if pPlot.getImprovementType() != -1 and (gc.getImprovementInfo(pPlot.getImprovementType()).isUnique() == True) :
		return False
	if (pPlot.isCity  () == True) and (pPlot.getTerrainType() == gc.getInfoTypeForString('TERRAIN_MARSH')):
		return False
	return True

def spellSpring(caster):
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	iCiv = pPlayer.getCivilizationType ()
	iLizCiv1 = gc.getInfoTypeForString('CIVILIZATION_MAZATL')
	iLizCiv2 = gc.getInfoTypeForString('CIVILIZATION_CUALLI')
	
	iTerrain = pPlot.getTerrainType()
	if iTerrain == gc.getInfoTypeForString('TERRAIN_DESERT'):
		pPlot.setTerrainType(gc.getInfoTypeForString('TERRAIN_PLAINS'),True,True)
		if pPlot.getFeatureType() == gc.getInfoTypeForString('FEATURE_FLOOD_PLAINS'):
			pPlot.setFeatureType(-1, -1)
	elif iTerrain == gc.getInfoTypeForString('TERRAIN_PLAINS'):
		pPlot.setTerrainType(gc.getInfoTypeForString('TERRAIN_GRASS'),True,True)
	elif iTerrain == gc.getInfoTypeForString('TERRAIN_GRASS'):
		pPlot.setTerrainType(gc.getInfoTypeForString('TERRAIN_MARSH'),True,True)
	elif iTerrain == gc.getInfoTypeForString('TERRAIN_FIELDS_OF_PERDITION'):
		pPlot.setTerrainType(gc.getInfoTypeForString('TERRAIN_SHALLOWS'),True,True)
	elif iTerrain == gc.getInfoTypeForString('TERRAIN_TUNDRA'):
		pPlot.setTerrainType(gc.getInfoTypeForString('TERRAIN_MARSH'),True,True)
	elif iTerrain == gc.getInfoTypeForString('TERRAIN_MARSH') and (iCiv == iLizCiv1 or iCiv == iLizCiv2) :
		pPlot.setImprovementType(gc.getInfoTypeForString('IMPROVEMENT_SWAMP'))
	iX = pPlot.getX()
	iY = pPlot.getY()
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE1:
		pPlot2 = getPlot(iX+iiX,iY+iiY)
		if pPlot2.getFeatureType() == gc.getInfoTypeForString('FEATURE_FLAMES'):
			pPlot2.setFeatureType(-1, -1)
		if pPlot2.getImprovementType() == gc.getInfoTypeForString('IMPROVEMENT_SMOKE'):
			pPlot2.setImprovementType(-1)

def reqSprint(caster):
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_FATIGUED')):
		return False
	return True

def reqStasis(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		if pPlayer.getNumCities() < 5:
			return False
	return True

def spellStasis(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	iDelay = 20
	iTeam = pPlayer.getTeam()
	if CyGame().getGameSpeedType() == gc.getInfoTypeForString('GAMESPEED_QUICK'):
		iDelay = 14
	if CyGame().getGameSpeedType() == gc.getInfoTypeForString('GAMESPEED_EPIC'):
		iDelay = 30
	if CyGame().getGameSpeedType() == gc.getInfoTypeForString('GAMESPEED_MARATHON'):
		iDelay = 60
	for iPlayer2 in range(gc.getMAX_PLAYERS()):
		pPlayer2 = gc.getPlayer(iPlayer2)
		if pPlayer2.isAlive():
			if pPlayer2.getTeam() != iTeam:
				pPlayer2.changeDisableProduction(iDelay)
				pPlayer2.changeDisableResearch(iDelay)

def reqSteal(caster):
	iTeam = caster.getTeam()
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.getTeam() != iTeam and not pUnit.isCommunalProperty():
			for iProm in range(gc.getNumPromotionInfos()):
				if pUnit.isHasPromotion(iProm):
					if gc.getPromotionInfo(iProm).isEquipment():
						return True
	if pPlot.isCity():
		pCity = pPlot.getPlotCity()
		if pCity.getTeam() != iTeam:
			for iBuild in range(gc.getNumBuildingInfos()):
				if pCity.getNumRealBuilding(iBuild) > 0:
					if gc.getBuildingInfo(iBuild).getEquipmentPromotion() != -1:
						return True
	return False

def spellSteal(caster):
	iTeam = caster.getTeam()
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.getTeam() != iTeam:
			for iProm in range(gc.getNumPromotionInfos()):
				if pUnit.isHasPromotion(iProm) and not pUnit.isCommunalProperty():
					if gc.getPromotionInfo(iProm).isEquipment():
 						if CyGame().getSorenRandNum(100, "Steal") <= 20:
							startWar(caster.getOwner(), pUnit.getOwner(), WarPlanTypes.WARPLAN_TOTAL)
						else:
							caster.setHasPromotion(iProm, True)
							pUnit.setHasPromotion(iProm, False)
	if pPlot.isCity():
		pCity = pPlot.getPlotCity()
		if pCity.getTeam() != iTeam:
			for iBuild in range(gc.getNumBuildingInfos()):
				if pCity.getNumRealBuilding(iBuild) > 0:
					if gc.getBuildingInfo(iBuild).getEquipmentPromotion() != -1:
 						if CyGame().getSorenRandNum(100, "Steal") <= 20:
							startWar(caster.getOwner(), pUnit.getOwner(), WarPlanTypes.WARPLAN_TOTAL)
						else:
							pCity.setNumRealBuilding(iBuild, 0)
							caster.setHasPromotion(gc.getBuildingInfo(iBuild).getEquipmentPromotion(), True)

def reqTakeEquipmentBuilding(caster,building):
	if caster.getUnitCombatType() == gc.getInfoTypeForString('UNITCOMBAT_NAVAL'):
		return False
	if caster.getUnitCombatType() == gc.getInfoTypeForString('UNITCOMBAT_SIEGE'):
		return False
	if caster.getSpecialUnitType() == gc.getInfoTypeForString('SPECIALUNIT_SPELL'):
		return False
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_ILLUSION')):
		return False
	iBuilding = gc.getInfoTypeForString(building)
	iProm = gc.getBuildingInfo(iBuilding).getEquipmentPromotion()
	if caster.isHasPromotion(iProm):
		return False
	return True

def spellTakeEquipmentBuilding(caster,building):
	iBuilding = gc.getInfoTypeForString(building)
	pPlot = caster.plot()
	pPlot.getPlotCity().setNumRealBuilding(iBuilding, 0)

def reqTakeEquipmentPromotion(caster,promotion):
	if caster.getUnitCombatType() == gc.getInfoTypeForString('UNITCOMBAT_NAVAL'):
		return False
	if caster.getUnitCombatType() == gc.getInfoTypeForString('UNITCOMBAT_SIEGE'):
		return False
	if caster.getSpecialUnitType() == gc.getInfoTypeForString('SPECIALUNIT_SPELL'):
		return False
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_ILLUSION')):
		return False
	iProm = gc.getInfoTypeForString(promotion)
	if caster.isHasPromotion(iProm):
		return False
	iPlayer = caster.getOwner()
	pPlot = caster.plot()
	pHolder = -1
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if ((pUnit.getOwner() == iPlayer or pUnit.isCommunalProperty()) and pUnit.isHasPromotion(iProm)):
			pHolder = pUnit
	if pHolder == -1:
		return False
	if pHolder.isHasCasted():
		return False
	if pHolder.getUnitType() == gc.getInfoTypeForString('UNIT_BARNAXUS'):
		if iProm == gc.getInfoTypeForString('PROMOTION_PIECES_OF_BARNAXUS'):
			return False
	pPlayer = gc.getPlayer(iPlayer)
	if pPlayer.isHuman() == False and pHolder.getUnitType() != gc.getInfoTypeForString('EQUIPMENT_CONTAINER'):
		if caster.baseCombatStr() - 2 <= pHolder.baseCombatStr():
			return False
		if gc.getUnitInfo(pHolder.getUnitType()).getFreePromotions(iProm):
			return False
	return True

def spellTakeEquipmentPromotion(caster,promotion):
	iProm = gc.getInfoTypeForString(promotion)
	iPlayer = caster.getOwner()
	pPlot = caster.plot()
	pHolder = -1
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if ((pUnit.getOwner() == iPlayer or pUnit.isCommunalProperty()) and pUnit.isHasPromotion(iProm) and pUnit != caster):
			pHolder = pUnit
	if pHolder != -1:
		pHolder.setHasPromotion(iProm, False)
		caster.setHasPromotion(iProm, True)

def reqTakeEquipmentUnit(caster,unit):
	if caster.getUnitCombatType() == gc.getInfoTypeForString('UNITCOMBAT_NAVAL'):
		return False
	if caster.getUnitCombatType() == gc.getInfoTypeForString('UNITCOMBAT_SIEGE'):
		return False
	if caster.getSpecialUnitType() == gc.getInfoTypeForString('SPECIALUNIT_SPELL'):
		return False
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_ILLUSION')):
		return False
	iUnit = gc.getInfoTypeForString(unit)
	iProm = gc.getUnitInfo(iUnit).getEquipmentPromotion()
	if caster.isHasPromotion(iProm):
		return False
	iPlayer = caster.getOwner()
	pPlot = caster.plot()
	pHolder = -1
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if ((pUnit.getOwner() == iPlayer or pUnit.isCommunalProperty()) and pUnit.getUnitType() == iUnit):
			if pUnit.isDelayedDeath() == False:
				pHolder = pUnit
	if pHolder == -1:
		return False
	return True

def spellTakeEquipmentUnit(caster,unit):
	iUnit = gc.getInfoTypeForString(unit)
	iProm = gc.getUnitInfo(iUnit).getEquipmentPromotion()
	iPlayer = caster.getOwner()
	pPlot = caster.plot()
	pHolder = -1
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if ((pUnit.getOwner() == iPlayer or pUnit.isCommunalProperty()) and pUnit.getUnitType() == iUnit):
			if pUnit.isDelayedDeath() == False:
				pHolder = pUnit
	if pHolder != -1:
		pHolder.kill(True, PlayerTypes.NO_PLAYER)

def reqTaunt(caster):
	iX = caster.getX()
	iY = caster.getY()
	pPlayer = gc.getPlayer(caster.getOwner())
	iTeam = pPlayer.getTeam()
	eTeam = gc.getTeam(iTeam)
	bValid = False
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE1:
		pLoopPlot = getPlot(iX+iiX,iY+iiY)
		for i in range(pLoopPlot.getNumUnits()):
			pUnit = pLoopPlot.getUnit(i)
			if eTeam.isAtWar(pUnit.getTeam()):
				if pUnit.isAlive():
					if not pUnit.isOnlyDefensive():
						if pUnit.getImmobileTimer() == 0:
							bValid = True
	return bValid

def spellTaunt(caster):
	iEnraged = gc.getInfoTypeForString('PROMOTION_ENRAGED')
	iSpell = gc.getInfoTypeForString('SPELL_TAUNT')
	iX = caster.getX()
	iY = caster.getY()
	pPlayer = gc.getPlayer(caster.getOwner())
	pPlot = caster.plot()
	iTeam = pPlayer.getTeam()
	eTeam = gc.getTeam(iTeam)
	bValid = False
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE1:
		pLoopPlot = getPlot(iX+iiX,iY+iiY)
		for i in xrange(pLoopPlot.getNumUnits()):
			pUnit = pLoopPlot.getUnit(i)
			if eTeam.isAtWar(pUnit.getTeam()):
				if pUnit.isAlive():
					if not pUnit.isOnlyDefensive():
						if not pUnit.isResisted(caster, iSpell):
							pUnit.setHasPromotion(iEnraged, True)
							pUnit.attack(pPlot, False)
							pUnit.setHasPromotion(iEnraged, False)

def spellTeleport(caster,loc):
	player = caster.getOwner()
	pPlayer = gc.getPlayer(player)
	pCity = pPlayer.getCapitalCity()
	if pCity.isNone():
		pPlot = caster.getSpawnPlot()
		if caster.canMoveInto(pPlot, False, False, True):
			caster.setXY(pPlot.getX(), pPlot.getY(), False, True, True)
	caster.setXY(pCity.getX(), pCity.getY(), False, True, True)

def reqTeachSpellcasting(caster):
	iAnimal = gc.getInfoTypeForString('UNITCOMBAT_ANIMAL')
	iBird = gc.getInfoTypeForString('SPECIALUNIT_BIRD')
	lList = []
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_AIR1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_AIR1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_BODY1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_BODY1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_CHAOS1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_CHAOS1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_CREATION1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_CREATION1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_DEATH1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_DEATH1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_DIMENSIONAL1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_DIMENSIONAL1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_EARTH1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_EARTH1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_ENCHANTMENT1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_ENCHANTMENT1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_ENTROPY1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_ENTROPY1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_FIRE1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_FIRE1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_FORCE1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_FORCE1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_ICE1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_ICE1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_LAW1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_LAW1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_LIFE1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_LIFE1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_METAMAGIC1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_METAMAGIC1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_MIND1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_MIND1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_NATURE1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_NATURE1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_SHADOW1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_SHADOW1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_SPIRIT1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_SPIRIT1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_SUN1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_SUN1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_WATER1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_WATER1')]
	if len(lList) > 0:
		pPlot = caster.plot()
		iPlayer = caster.getOwner()
		for i in xrange(pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(i)
			if pUnit.getOwner() == iPlayer:
				if pUnit.isAlive():
					if pUnit.getUnitCombatType() != iAnimal:
						if pUnit.getSpecialUnitType() != iBird:
							for iProm in range(len(lList)):
								if not pUnit.isHasPromotion(lList[iProm]):
									return True
	return False

def spellTeachSpellcasting(caster):
	iAnimal = gc.getInfoTypeForString('UNITCOMBAT_ANIMAL')
	iBird = gc.getInfoTypeForString('SPECIALUNIT_BIRD')
	lList = []
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_AIR1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_AIR1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_BODY1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_BODY1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_CHAOS1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_CHAOS1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_CREATION1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_CREATION1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_DEATH1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_DEATH1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_DIMENSIONAL1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_DIMENSIONAL1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_EARTH1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_EARTH1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_ENCHANTMENT1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_ENCHANTMENT1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_ENTROPY1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_ENTROPY1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_FIRE1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_FIRE1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_FORCE1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_FORCE1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_ICE1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_ICE1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_LAW1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_LAW1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_LIFE1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_LIFE1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_METAMAGIC1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_METAMAGIC1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_MIND1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_MIND1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_NATURE1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_NATURE1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_SHADOW1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_SHADOW1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_SPIRIT1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_SPIRIT1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_SUN1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_SUN1')]
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_WATER1')):
		lList = lList + [gc.getInfoTypeForString('PROMOTION_WATER1')]
	pPlot = caster.plot()
	iPlayer = caster.getOwner()
	for i in xrange(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.getOwner() == iPlayer:
			if pUnit.isAlive():
				if pUnit.getUnitCombatType() != iAnimal:
					if pUnit.getSpecialUnitType() != iBird:
						for iProm in range(len(lList)):
							if not pUnit.isHasPromotion(lList[iProm]):
								pUnit.setHasPromotion(lList[iProm], True)

def reqTransmutation(caster):
	iCopper = gc.getInfoTypeForString('BONUS_COPPER')
	iGold = gc.getInfoTypeForString('BONUS_GOLD')
	pPlot = caster.plot()
	if pPlot.getOwner() != caster.getOwner():
		return False
	if (pPlot.getBonusType(-1) != iCopper and pPlot.getBonusType(-1) != iGold):
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		if (pPlot.getBonusType(-1) == iCopper and pPlayer.countOwnedBonuses(iCopper) >= 2 and pPlayer.countOwnedBonuses(iGold) == 0):
			return True
		if (pPlot.getBonusType(-1) == iGold and pPlayer.countOwnedBonuses(iGold) >= 2 and pPlayer.countOwnedBonuses(iCopper) == 0):
			return True
		return False
	return True

def spellTransmutation(caster):
	pPlot = caster.plot()
	iBonus = -1
	iCopper = gc.getInfoTypeForString('BONUS_COPPER')
	iGold = gc.getInfoTypeForString('BONUS_GOLD')
	if pPlot.getBonusType(-1) == iCopper:
		iBonus = iGold
	if pPlot.getBonusType(-1) == iGold:
		iBonus = iCopper
	if iBonus != -1:
		pPlot.setBonusType(iBonus)
		
def reqMinorBrood(caster):
	iCow = gc.getInfoTypeForString('BONUS_COW')
	iPig = gc.getInfoTypeForString('BONUS_PIG')
	iSheep = gc.getInfoTypeForString('BONUS_SHEEP')
	iDeer = gc.getInfoTypeForString('BONUS_DEER')
	iArcticDeer = gc.getInfoTypeForString('BONUS_DEER_ARCTIC')
	iHorse = gc.getInfoTypeForString('BONUS_HORSE')
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	eTeam = gc.getTeam(pPlayer.getTeam())
	if pPlot.getOwner() != caster.getOwner():
		return False
	if (pPlot.getBonusType(-1) != iCow and pPlot.getBonusType(-1) != iHorse and pPlot.getBonusType(-1) != iArcticDeer and pPlot.getBonusType(-1) != iDeer and pPlot.getBonusType(-1) != iSheep and pPlot.getBonusType(-1) != iPig):
		return False

	if pPlot.getBonusType(-1) == iHorse:
		if eTeam.isHasTech(gc.getInfoTypeForString('TECH_ANIMAL_HUSBANDRY')) == False:
			return False

	if pPlayer.isHuman() == False:
		if (pPlot.getBonusType(-1) == iCow and pPlayer.countOwnedBonuses(iCow) < 3):
			return False
		if (pPlot.getBonusType(-1) == iPig and pPlayer.countOwnedBonuses(iPig) < 3):
			return False
		if (pPlot.getBonusType(-1) == iSheep and pPlayer.countOwnedBonuses(iSheep) < 3):
			return False
		if (pPlot.getBonusType(-1) == iDeer and pPlayer.countOwnedBonuses(iDeer) < 3):
			return False
		if (pPlot.getBonusType(-1) == iArcticDeer and pPlayer.countOwnedBonuses(iArcticDeer) < 3):
			return False
		if (pPlot.getBonusType(-1) == iHorse and pPlayer.countOwnedBonuses(iHorse) < 3):
			return False
		if pPlot.isCityRadius() :
			return False
		return True
		

	return True

def spellMinorBrood(caster):
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	iBabySpider = gc.getInfoTypeForString('UNIT_BABY_SPIDER')
	
	pPlot.setBonusType(-1)
		
	iCasterLevel = caster.getLevel()
	iEmpower1 = gc.getInfoTypeForString('PROMOTION_EMPOWER1')
	iEmpower2 = gc.getInfoTypeForString('PROMOTION_EMPOWER2')
	iEmpower3 = gc.getInfoTypeForString('PROMOTION_EMPOWER3')
	iEmpower4 = gc.getInfoTypeForString('PROMOTION_EMPOWER4')
	iEmpower5 = gc.getInfoTypeForString('PROMOTION_EMPOWER5')
	
		
	iCount1 = CyGame().getSorenRandNum(2, "Minor Brood count 1") + 1
	iCount2 = CyGame().getSorenRandNum(2, "Minor Brood count 2") + 1
	iCountTotal = iCount1 + iCount2

	for i in xrange(iCountTotal):
		newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_BABY_SPIDER'), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		if iCasterLevel >= 3:
			newUnit.setHasPromotion(iEmpower1, True)
		if iCasterLevel >= 4:
			newUnit.setHasPromotion(iEmpower2, True)
		if iCasterLevel >= 5:
			newUnit.setHasPromotion(iEmpower3, True)
		if iCasterLevel >= 6:
			newUnit.setHasPromotion(iEmpower4, True)
		if iCasterLevel >= 7:
			newUnit.setHasPromotion(iEmpower5, True)
			
	

def spellTreetopDefence(caster):
	pPlot = caster.plot()
	for i in xrange(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.getTeam() == caster.getTeam():
			pUnit.setFortifyTurns(5)

def reqTrust(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isFeatAccomplished(FeatTypes.FEAT_TRUST):
		return False
	if pPlayer.isBarbarian():
		return False
	return True

def spellTrust(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	pCity = pPlayer.getCapitalCity()
	pPlayer.setFeatAccomplished(FeatTypes.FEAT_TRUST, True)


def reqTsunamiKraken(caster):
	gc			= CyGlobalContext()
	pPlayer 	= gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman(): return True
	eTeam 		= gc.getTeam(pPlayer.getTeam())
	iX = caster.getX(); iY = caster.getY()
	pCasterPlot	= caster.plot()
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE2:
		iNewX = iX+iiX; iNewY = iY+iiY
		pPlot = getPlot(iNewX,iNewY)
		if pPlot.isAdjacentToWater():
			if not (iX == iNewX and iY == iNewY):
				for i in xrange(pPlot.getNumUnits()):
					pUnit = pPlot.getUnit(i)
					if eTeam.isAtWar(pUnit.getTeam()):
						return True
	return False
	
def spellTsunami(caster):
	gc			= CyGlobalContext()
	getInfoType = gc.getInfoTypeForString
	eCold		= getInfoType('DAMAGE_COLD')
	effect		= CyEngine().triggerEffect
	pCasterPlot	= caster.plot()
	randNum		= CyGame().getSorenRandNum
	iX = caster.getX()
	iY = caster.getY()
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE2:
		iNewX = iX+iiX; iNewY = iY+iiY
		pPlot = getPlot(iNewX,iNewY)
		if pPlot.isAdjacentToWater():
			if not (iX == iNewX and iY == iNewY):
				for i in xrange(pPlot.getNumUnits()):
					pUnit = pPlot.getUnit(i)
					pUnit.doDamage(30, 75, caster, eCold, True)
				if pPlot.getImprovementType() != -1:
					if gc.getImprovementInfo(pPlot.getImprovementType()).isPermanent() == False:
						if randNum(100, "Tsunami") <= 25:
							pPlot.setImprovementType(-1)
				effect(gc.getInfoTypeForString('EFFECT_SPRING'),pPlot.getPoint())

def spellUnyieldingOrder(caster):
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	pCity.setOccupationTimer(0)
	pCity.changeHurryAngerTimer(-9)

def spellArchon(caster):
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	pCity.changeHurryAngerTimer(-20)

def reqUpgradeDovielloWarrior(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	if not pPlayer.isHuman():
		iTeam = gc.getPlayer(caster.getOwner()).getTeam()
		eTeam = gc.getTeam(iTeam)
		if eTeam.getAtWarCount(True) == 0:
			return False
		if eTeam.getAtWarCount(True) == 1:
			if pPlayer.getNumCities() > 1:
				return False
	return True

def spellUseSupplies(caster):
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	iEvent = CvUtil.findInfoTypeNum(gc.getEventTriggerInfo, gc.getNumEventTriggerInfos(),'EVENTTRIGGER_USE_SUPPLIES')
	triggerData = pPlayer.initTriggeredData(iEvent, True, -1, pCity.getX(), pCity.getY(), iPlayer, pCity.getID(), -1, -1, -1, -1)

def reqVeilOfNight(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		if pPlayer.getNumUnits() < 25:
			return False
		iTeam = gc.getPlayer(caster.getOwner()).getTeam()
		eTeam = gc.getTeam(iTeam)
		if eTeam.getAtWarCount(True) > 0:
			return False
	return True

def spellVeilOfNight(caster):
	iHiddenNationality = gc.getInfoTypeForString('PROMOTION_HIDDEN_NATIONALITY')
	py = PyPlayer(caster.getOwner())
	for pUnit in py.getUnitList():
		if pUnit.baseCombatStr() > 0:
			pUnit.setHasPromotion(iHiddenNationality, True)

def reqWane(caster):
	if caster.getUnitCombatType() == gc.getInfoTypeForString('UNITCOMBAT_ANIMAL'):
		return False
	if caster.getUnitCombatType() == gc.getInfoTypeForString('UNITCOMBAT_BEAST'):
		return False
	if caster.isImmortal():
		return False
	if caster.getUnitCombatType() == gc.getInfoTypeForString('UNITCOMBAT_WORKER'):
		return False
	if caster.getUnitClassType() == gc.getInfoTypeForString('UNITCLASS_FORT_COMMANDER'):
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.getUnitClassCount(gc.getInfoTypeForString('UNITCLASS_SHADE')) >= 4:
		return False
	return True

def reqWarcry(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		if pPlayer.getNumUnits() < 25:
			return False
		iTeam = gc.getPlayer(caster.getOwner()).getTeam()
		eTeam = gc.getTeam(iTeam)
		if eTeam.getAtWarCount(True) == 0:
			return False
	return True

def spellWarcry(caster):
	iWarcry = gc.getInfoTypeForString('PROMOTION_WARCRY')
	py = PyPlayer(caster.getOwner())
	for pUnit in py.getUnitList():
		if pUnit.getUnitCombatType() != -1:
			pUnit.setHasPromotion(iWarcry, True)

def reqWhiteout(caster):
	pPlot = caster.plot()
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_HIDDEN')):
		return False
	if pPlot.getTerrainType() != gc.getInfoTypeForString('TERRAIN_SNOW'):
		return False
	return True

def reqWildHunt(caster):
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	if pPlayer.isHuman() == False:
		iTeam = gc.getPlayer(iPlayer).getTeam()
		eTeam = gc.getTeam(iTeam)
		if eTeam.getAtWarCount(True) == 0:
			return False
		if pPlayer.getNumUnits() < 20:
			return False
	return True

def spellWildHunt(caster):	
	gc			= CyGlobalContext()
	getInfoType	= gc.getInfoTypeForString
	iPlayer 	= caster.getOwner()
	pPlayer 	= gc.getPlayer(iPlayer)
	pDen 		= pPlayer.getCapitalCity()
	pPlot 		= pDen.plot()
	iNumAnimals = pPlayer.getNumUnits()
	Manager		= CvEventInterface.getEventManager()
	iAnimalChance = 0
	if pDen != None:
		iAnimalChance = pDen.getCityCounter()
	iAnimalChance += scaleInverse(2500)
	iReligion 	= pPlayer.getStateReligion()
	randNum		= CyGame().getSorenRandNum
	
	lList = Manager.cf.doAnimalListDoviello(iPlayer)
	
	for i in xrange(iNumAnimals):
		if randNum(10000, "Animal Spawn") < iAnimalChance:
			sAnimal = lList[randNum(len(lList), "Pick Animal")-1]
			iUnit = getInfoType(sAnimal)
			newUnit = pPlayer.initUnit(iUnit, pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_NORTH)
			newUnit.setHasPromotion(getInfoType('PROMOTION_LOYALTY3'), True)
			if iReligion != -1:
				newUnit.setReligion(iReligion)
			if pPlayer.getCivics(getInfoType('CIVICOPTION_MEMBERSHIP')) == getInfoType('CIVIC_WILDCOUNCIL'):
				newUnit.setHasPromotion(getInfoType('PROMOTION_HEROIC_STRENGTH'), True)
		
def spellWonder(caster):
	iCount = CyGame().getSorenRandNum(3, "Wonder") + 3
	pPlayer = gc.getPlayer(caster.getOwner())
	pPlot = caster.plot()
	bCity = False
	point = pPlot.getPoint()
	iStartingCasts = caster.getCastingLimit()
	bStartingCast = caster.isHasCasted()
	if pPlot.isCity():
		bCity = True
	for i in xrange(iCount):
		iRnd = CyGame().getSorenRandNum(67, "Wonder")
		iUnit = -1
		if iRnd == 0:
			caster.cast(gc.getInfoTypeForString('SPELL_BLAZE'))
		elif iRnd == 1:
			caster.cast(gc.getInfoTypeForString('SPELL_BLESS'))
		elif iRnd == 2:
			caster.cast(gc.getInfoTypeForString('SPELL_BLINDING_LIGHT'))
		elif iRnd == 3:
			caster.cast(gc.getInfoTypeForString('SPELL_BLOOM'))
		elif iRnd == 4:
			caster.cast(gc.getInfoTypeForString('SPELL_BLUR'))
		elif iRnd == 5:
			caster.cast(gc.getInfoTypeForString('SPELL_CHARM_PERSON'))
		elif iRnd == 6:
			caster.cast(gc.getInfoTypeForString('SPELL_CONTAGION'))
		elif iRnd == 7:
			caster.cast(gc.getInfoTypeForString('SPELL_COURAGE'))
		elif iRnd == 8:
			caster.cast(gc.getInfoTypeForString('SPELL_CRUSH'))
		elif iRnd == 9:
			caster.cast(gc.getInfoTypeForString('SPELL_DESTROY_UNDEAD'))
		elif iRnd == 10:
			caster.cast(gc.getInfoTypeForString('SPELL_DISPEL_MAGIC'))
		elif iRnd == 11:
			caster.cast(gc.getInfoTypeForString('SPELL_EARTHQUAKE'))
		elif iRnd == 12:
			caster.cast(gc.getInfoTypeForString('SPELL_ENCHANTED_BLADE'))
		elif iRnd == 13:
			CyEngine().triggerEffect(gc.getInfoTypeForString('EFFECT_SPELL1'),point)
			CyAudioGame().Play3DSound("AS3D_SPELL_DEFILE",point.x,point.y,point.z)
			for iX in range(pPlot.getX()-1, pPlot.getX()+2, 1):
				for iY in range(pPlot.getY()-1, pPlot.getY()+2, 1):
					pLoopPlot = CyMap().plot(iX,iY)
					if pLoopPlot.isNone() == False:
						pLoopPlot.changePlotCounter(100)
		elif iRnd == 14:
			caster.cast(gc.getInfoTypeForString('SPELL_ENTANGLE'))
		elif iRnd == 15:
			caster.cast(gc.getInfoTypeForString('SPELL_ESCAPE'))
		elif iRnd == 16:
			caster.cast(gc.getInfoTypeForString('SPELL_FIREBALL'))
		elif iRnd == 17:
			caster.cast(gc.getInfoTypeForString('SPELL_FLAMING_ARROWS'))
		elif iRnd == 18:
			caster.cast(gc.getInfoTypeForString('SPELL_FLOATING_EYE'))
		elif iRnd == 19:
			caster.cast(gc.getInfoTypeForString('SPELL_HASTE'))
		elif iRnd == 20:
			caster.cast(gc.getInfoTypeForString('SPELL_HASTURS_RAZOR'))
		elif iRnd == 21:
			caster.cast(gc.getInfoTypeForString('SPELL_HEAL'))
		elif iRnd == 22:
			caster.cast(gc.getInfoTypeForString('SPELL_HIDE'))
		elif iRnd == 23:
			caster.cast(gc.getInfoTypeForString('SPELL_LOYALTY'))
		elif iRnd == 24:
			caster.cast(gc.getInfoTypeForString('SPELL_MAELSTROM'))
		elif iRnd == 25:
			caster.cast(gc.getInfoTypeForString('SPELL_MORALE'))
		elif iRnd == 26:
			caster.cast(gc.getInfoTypeForString('SPELL_MUTATION'))
		elif iRnd == 27:
			caster.cast(gc.getInfoTypeForString('SPELL_PILLAR_OF_FIRE'))
		elif iRnd == 28:
			caster.cast(gc.getInfoTypeForString('SPELL_POISONED_BLADE'))
		elif iRnd == 29:
			caster.cast(gc.getInfoTypeForString('SPELL_REVELATION'))
		elif iRnd == 30:
			caster.cast(gc.getInfoTypeForString('SPELL_RING_OF_FLAMES'))
		elif iRnd == 31:
			caster.cast(gc.getInfoTypeForString('SPELL_RUST'))
		elif iRnd == 32:
			caster.cast(gc.getInfoTypeForString('SPELL_SANCTIFY'))
		elif iRnd == 33:
			caster.cast(gc.getInfoTypeForString('SPELL_SCORCH'))
		elif iRnd == 34:
			caster.cast(gc.getInfoTypeForString('SPELL_SHADOWWALK'))
		elif iRnd == 35:
			caster.cast(gc.getInfoTypeForString('SPELL_SPORES'))
		elif iRnd == 36:
			caster.cast(gc.getInfoTypeForString('SPELL_SPRING'))
		elif iRnd == 37:
			caster.cast(gc.getInfoTypeForString('SPELL_STONESKIN'))
		elif iRnd == 38:
			caster.cast(gc.getInfoTypeForString('SPELL_SUMMON_AIR_ELEMENTAL'))
		elif iRnd == 39:
			caster.cast(gc.getInfoTypeForString('SPELL_SUMMON_AUREALIS'))
		elif iRnd == 40:
			caster.cast(gc.getInfoTypeForString('SPELL_SUMMON_BALOR'))
		elif iRnd == 41:
			caster.cast(gc.getInfoTypeForString('SPELL_SUMMON_DJINN'))
		elif iRnd == 42:
			caster.cast(gc.getInfoTypeForString('SPELL_SUMMON_EARTH_ELEMENTAL'))
		elif iRnd == 43:
			caster.cast(gc.getInfoTypeForString('SPELL_SUMMON_EINHERJAR'))
		elif iRnd == 44:
			caster.cast(gc.getInfoTypeForString('SPELL_SUMMON_FIRE_ELEMENTAL'))
		elif iRnd == 45:
			iUnit = gc.getInfoTypeForString('UNIT_KRAKEN')
		elif iRnd == 46:
			caster.cast(gc.getInfoTypeForString('SPELL_SUMMON_MISTFORM'))
		elif iRnd == 47:
			caster.cast(gc.getInfoTypeForString('SPELL_SUMMON_PIT_BEAST'))
		elif iRnd == 48:
			caster.cast(gc.getInfoTypeForString('SPELL_SUMMON_SAND_LION'))
		elif iRnd == 49:
			caster.cast(gc.getInfoTypeForString('SPELL_SUMMON_SPECTRE'))
		elif iRnd == 50:
			iUnit = gc.getInfoTypeForString('UNIT_TIGER')
		elif iRnd == 51:
			iUnit = gc.getInfoTypeForString('UNIT_TREANT')
		elif iRnd == 52:
			caster.cast(gc.getInfoTypeForString('SPELL_SUMMON_WATER_ELEMENTAL'))
		elif iRnd == 53:
			caster.cast(gc.getInfoTypeForString('SPELL_SUMMON_WRAITH'))
		elif iRnd == 54:
			caster.cast(gc.getInfoTypeForString('SPELL_TSUNAMI'))
		elif iRnd == 55:
			caster.cast(gc.getInfoTypeForString('SPELL_VALOR'))
		elif iRnd == 56:
			caster.cast(gc.getInfoTypeForString('SPELL_VITALIZE'))
		elif iRnd == 57:
			caster.cast(gc.getInfoTypeForString('SPELL_WITHER'))
		elif iRnd == 58:
			if bCity == False:
				iImprovement = pPlot.getImprovementType()
				bValid = True
				if iImprovement != -1 :
					if gc.getImprovementInfo(iImprovement).isPermanent() :
						bValid = False
				if bValid :
					pPlot.setImprovementType(gc.getInfoTypeForString('IMPROVEMENT_PENGUINS'))
					CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_WONDER_PENGUINS", ()),'',1,'Art/Interface/Buttons/Improvements/Penguins.dds',ColorTypes(8),pPlot.getX(),pPlot.getY(),True,True)
		elif iRnd == 59:
			if bCity == False:
				iImprovement = pPlot.getImprovementType()
				bValid = True
				if iImprovement != -1 :
					if gc.getImprovementInfo(iImprovement).isPermanent() :
						bValid = False
				if bValid :
					pPlot.setImprovementType(gc.getInfoTypeForString('IMPROVEMENT_MUSHROOMS'))
					CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_WONDER_MUSHROOMS", ()),'',1,'Art/Interface/Buttons/Improvements/Mushrooms.dds',ColorTypes(8),pPlot.getX(),pPlot.getY(),True,True)
		elif iRnd == 60:
			for iProm in range(gc.getNumPromotionInfos()):
				if caster.isHasPromotion(iProm):
					if gc.getPromotionInfo(iProm).isRace():
						caster.setHasPromotion(iProm, False)
			caster.setUnitArtStyleType(gc.getInfoTypeForString('UNIT_ARTSTYLE_BABOON'))
			CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_WONDER_BABOON", ()),'',1,'Art/Interface/Buttons/Units/Margalard.dds',ColorTypes(8),pPlot.getX(),pPlot.getY(),True,True)
			if pPlayer.isHuman():
				t = "TROPHY_FEAT_BABOON"
				if not CyGame().isHasTrophy(t):
					CyGame().changeTrophyValue(t, 1)
		elif iRnd == 61:
			CyEngine().triggerEffect(gc.getInfoTypeForString('EFFECT_SPELL1'),point)
			CyAudioGame().Play3DSound("AS3D_SPELL_SANCTIFY",point.x,point.y,point.z)
			for iX in range(pPlot.getX()-2, pPlot.getX()+3, 1):
				for iY in range(pPlot.getY()-2, pPlot.getY()+3, 1):
					pLoopPlot = CyMap().plot(iX,iY)
					if pLoopPlot.isNone() == False:
						pLoopPlot.changePlotCounter(-100)
		elif iRnd == 62:
			caster.cast(gc.getInfoTypeForString('SPELL_SEVER_SOUL'))

		elif iRnd == 63:
			caster.cast(gc.getInfoTypeForString('SPELL_SLOW'))
		elif iRnd == 64:
			caster.cast(gc.getInfoTypeForString('SPELL_SUMMON_ICE_ELEMENTAL'))
		elif iRnd == 65:
			caster.cast(gc.getInfoTypeForString('SPELL_SNOWFALL'))
		elif iRnd == 66:
			boo = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_DIRE_HAMSTER'), pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
			boo.setDuration(10)
			boo.setName("Boo")
			CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_WONDER_HAMSTER", ()),'',1,'Art/Interface/Buttons/Units/Spiderkin.dds',ColorTypes(8),pPlot.getX(),pPlot.getY(),True,True)



		if iUnit != -1:
			newUnit = pPlayer.initUnit(iUnit, pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
			if pPlayer.hasTrait(gc.getInfoTypeForString('TRAIT_SUMMONER')):
				newUnit.setDuration(3)
			else:
				newUnit.setDuration(1)

# FF: Added by Jean Elcard 14/01/2009 (speed tweak)
	rebuildGraphics()
# FF: End Add

	caster.setCastingLimit(iStartingCasts)
	caster.setHasCasted(bStartingCast)


def reqWorldbreak(caster):
	if CyGame().getGlobalCounter() == 0:
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		if CyGame().getGlobalCounter() < 50:
			return False
	return True

def spellWorldbreak(caster):
	iCounter = CyGame().getGlobalCounter()
	iFire = gc.getInfoTypeForString('DAMAGE_FIRE')
	iForest = gc.getInfoTypeForString('FEATURE_FOREST')
	iJungle = gc.getInfoTypeForString('FEATURE_JUNGLE')
	iPillar = gc.getInfoTypeForString('EFFECT_PILLAR_OF_FIRE')
	iSmoke 	= gc.getInfoTypeForString('IMPROVEMENT_SMOKE')
	Manager	= CvEventInterface.getEventManager()
	randNum	= CyGame().getSorenRandNum
	getPlot	= CyMap().plotByIndex
	for i in xrange(CyMap().numPlots()):
		pPlot = getPlot(i)
		bValid = True
		if pPlot.isOwned():
			if pPlot.getOwner() == caster.getOwner():
				bValid = False
		if bValid:
			if pPlot.isCity():
				if randNum(100, "Worldbreak") <= (iCounter / 4):
					Manager.cf.doCityFire(pPlot.getPlotCity())
				for i in xrange(pPlot.getNumUnits()):
					pUnit = pPlot.getUnit(i)
					pUnit.doDamage(iCounter, 100, caster, iFire, False)
				CyEngine().triggerEffect(iPillar,pPlot.getPoint())
			if (pPlot.getFeatureType() == iForest or pPlot.getFeatureType() == iJungle):
				if pPlot.getImprovementType() == -1:
					if randNum(100, "Flames Spread") <= (iCounter / 4):
						pPlot.setImprovementType(iSmoke)

def atRangeGuardian(pCaster, pPlot):
	iX = pPlot.getX()
	iY = pPlot.getY()
	if pPlot.getNumUnits() == 0:
		if CyGame().getGameTurn() > 20: #fixes a problem if units spawn next to the gargoyle
			iPlayer = pCaster.getOwner()
			if not gc.getPlayer(pCaster.getOwner()).isBarbarian():
				bPlayer = gc.getPlayer(gc.getDEMON_PLAYER())
				iUnit = gc.getInfoTypeForString('UNIT_GARGOYLE')
				newUnit1 = bPlayer.initUnit(iUnit, pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
				newUnit1.changeStrBoost(3-CyGame().getSorenRandNum(10, "Gargoyle Weakening"))
				newUnit1.setHasPromotion(gc.getInfoTypeForString('PROMOTION_SHARD_COURAGE'), True)
				newUnit1.setHasPromotion(gc.getInfoTypeForString('PROMOTION_PRISTIN_LEASH'), True)
				newUnit2 = bPlayer.initUnit(iUnit, pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
				newUnit2.changeStrBoost(3-CyGame().getSorenRandNum(10, "Gargoyle Weakening"))
				newUnit2.setHasPromotion(gc.getInfoTypeForString('PROMOTION_SHARD_STRENGTH'), True)
				newUnit2.setHasPromotion(gc.getInfoTypeForString('PROMOTION_PRISTIN_LEASH'), True)
				newUnit3 = bPlayer.initUnit(iUnit, pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
				newUnit3.changeStrBoost(3-CyGame().getSorenRandNum(10, "Gargoyle Weakening"))
				newUnit3.setHasPromotion(gc.getInfoTypeForString('PROMOTION_SHARD_WISDOM'), True)
				newUnit3.setHasPromotion(gc.getInfoTypeForString('PROMOTION_PRISTIN_LEASH'), True)
				CyInterface().addMessage(pCaster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_GUARDIAN", ()),'',1,gc.getUnitInfo(iUnit).getButton(),ColorTypes(8),pPlot.getX(),pPlot.getY(),True,True)
				pPlot.setPythonActive(False)
				
def atRangeCitadel(pCaster, pPlot):
	iPlayer = pPlot.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	eTeam = gc.getTeam(pPlayer.getTeam())
	p2Plot = pCaster.plot()
	if eTeam.isAtWar(pCaster.getTeam()):
		if pPlayer.isHuman() == True:
			if pPlot.getNumUnits() != 0:
				pCaster.doDamageNoCaster(10, 40, gc.getInfoTypeForString('DAMAGE_FIRE'), False)
				CyEngine().triggerEffect(gc.getInfoTypeForString('EFFECT_PILLAR_OF_FIRE'),p2Plot.getPoint())
		if pPlayer.isHuman() == False:
			pCaster.doDamageNoCaster(10, 40, gc.getInfoTypeForString('DAMAGE_FIRE'), False)
			CyEngine().triggerEffect(gc.getInfoTypeForString('EFFECT_PILLAR_OF_FIRE'),p2Plot.getPoint())			
		
def atRangeJungleAltar(pCaster, pPlot):
	if CyGame().getWBMapScript():
		sf.atRangeJungleAltar(pCaster, pPlot)

def atRangeNecrototem(pCaster, pPlot):
	if doFear(pCaster, pPlot, -1, False):
		CyInterface().addMessage(pCaster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_FEAR", (gc.getUnitInfo(pCaster.getUnitType()).getDescription(), )),'',1,'Art/Interface/Buttons/Improvements/Necrototem.dds',ColorTypes(7),pCaster.getX(),pCaster.getY(),True,True)

def onMoveAncientForest(pCaster, pPlot):
	if pPlot.isOwned():
		if pPlot.getNumUnits() == 1:
			if pCaster.isFlying() == False:
				iChance = gc.getDefineINT('TREANT_SPAWN_CHANCE')
				if pPlot.isBeingWorked():
					pCity = pPlot.getWorkingCity()
					if pCity.getNumBuilding(gc.getInfoTypeForString('BUILDING_TEMPLE_OF_LEAVES')) > 0:
						iChance = iChance * 3
				if CyGame().getSorenRandNum(100, "Treant Spawn Chance") <= iChance:
					pPlayer = gc.getPlayer(pCaster.getOwner())
					p2Player = gc.getPlayer(pPlot.getOwner())
					eTeam = gc.getTeam(pPlayer.getTeam())
					i2Team = p2Player.getTeam()
					if (eTeam.isAtWar(i2Team) and p2Player.getStateReligion() == gc.getInfoTypeForString('RELIGION_FELLOWSHIP_OF_LEAVES')):
						for i in range(pPlot.getNumUnits()):
							p2Unit = pPlot.getUnit(i)
							p2Plot = findClearPlot(p2Unit, -1)
							if p2Plot != -1:
								p2Unit.setXY(p2Plot.getX(),p2Plot.getY(), False, True, True)
								p2Unit.finishMoves()
						if pPlot.getNumUnits() == 0:
							newUnit = p2Player.initUnit(gc.getInfoTypeForString('UNIT_TREANT'), pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
							newUnit.setDuration(3)
							CyInterface().addMessage(pCaster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_TREANT_ENEMY",()),'AS2D_FEATUREGROWTH',1,'Art/Interface/Buttons/Units/Treant.dds',ColorTypes(7),newUnit.getX(),newUnit.getY(),True,True)
							CyInterface().addMessage(pPlot.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_TREANT",()),'AS2D_FEATUREGROWTH',1,'Art/Interface/Buttons/Units/Treant.dds',ColorTypes(8),newUnit.getX(),newUnit.getY(),True,True)

#	Changed in Frozen: TC01
#	Frozen units should not be damaged by Blizzards. If the module is loaded, they will not be, otherwise, I use the original code. The line I changed is marked.
def onMoveBlizzard(pCaster, pPlot):
	iFrozen = gc.getInfoTypeForString('CIVILIZATION_FROZEN')
	if pCaster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_WINTERBORN')) == False:
		if gc.getPlayer(pCaster.getOwner()).getCivilizationType() != gc.getInfoTypeForString('CIVILIZATION_FROZEN'):		#Added in Frozen: TC01
			pCaster.doDamage(10, 50, pCaster, gc.getInfoTypeForString('DAMAGE_COLD'), False)
#End of Frozen

def onMoveLetumFrigus(pCaster, pPlot):
	pPlayer = gc.getPlayer(pCaster.getOwner())
	if pPlayer.isHuman():
		iEvent = CvUtil.findInfoTypeNum(gc.getEventTriggerInfo, gc.getNumEventTriggerInfos(),'EVENTTRIGGER_LETUM_FRIGUS')
		triggerData = pPlayer.initTriggeredData(iEvent, True, -1, pCaster.getX(), pCaster.getY(), pCaster.getOwner(), -1, -1, -1, -1, -1)
		CyInterface().addMessage(pCaster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_LETUM_FRIGUS", ()),'',1,'Art/Interface/Buttons/Improvements/Letum Frigus.dds',ColorTypes(8),pPlot.getX(),pPlot.getY(),True,True)
		pPlot.setPythonActive(False)

def onMoveMaelstrom(pCaster, pPlot):
	if CyGame().getSorenRandNum(100, "Maelstrom") <= 25:
		CyInterface().addMessage(pCaster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_MAELSTROM_KILL",()),'AS2D_FEATUREGROWTH',1,'Art/Interface/Buttons/Improvements/Maelstrom.dds',ColorTypes(7),pPlot.getX(),pPlot.getY(),True,True)
		pCaster.kill(True, PlayerTypes.NO_PLAYER)
	else:
		iOcean = gc.getInfoTypeForString('TERRAIN_OCEAN')
		iBestValue = 0
		pBestPlot = -1
		for i in range (CyMap().numPlots()):
			iValue = 0
			pTargetPlot = CyMap().plotByIndex(i)
			if pTargetPlot.getTerrainType() == iOcean:
				iValue = CyGame().getSorenRandNum(1000, "Maelstrom")
				if pTargetPlot.isOwned() == False:
					iValue += 1000
				if iValue > iBestValue:
					iBestValue = iValue
					pBestPlot = pTargetPlot
		if pBestPlot != -1:
			pCaster.setXY(pBestPlot.getX(), pBestPlot.getY(), False, True, True)
			pCaster.setDamage(25, PlayerTypes.NO_PLAYER)
			CyInterface().addMessage(pCaster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_MAELSTROM_MOVE",()),'AS2D_FEATUREGROWTH',1,'Art/Interface/Buttons/Improvements/Maelstrom.dds',ColorTypes(7),pCaster.getX(),pCaster.getY(),True,True)

def onMovePoolOfTears(pCaster, pPlot):
	if pCaster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_DISEASED')):
		pCaster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_DISEASED'), False)
		CyInterface().addMessage(pCaster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_POOL_OF_TEARS_DISEASED",()),'AS2D_FEATUREGROWTH',1,'Art/Interface/Buttons/Improvements/Pool of Tears.dds',ColorTypes(8),pCaster.getX(),pCaster.getY(),True,True)
	if pCaster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_PLAGUED')):
		pCaster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_PLAGUED'), False)
		CyInterface().addMessage(pCaster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_POOL_OF_TEARS_PLAGUED",()),'AS2D_FEATUREGROWTH',1,'Art/Interface/Buttons/Improvements/Pool of Tears.dds',ColorTypes(8),pCaster.getX(),pCaster.getY(),True,True)
	if pCaster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_POISONED')):
		pCaster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_POISONED'), False)
		CyInterface().addMessage(pCaster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_POOL_OF_TEARS_POISONED",()),'AS2D_FEATUREGROWTH',1,'Art/Interface/Buttons/Improvements/Pool of Tears.dds',ColorTypes(8),pCaster.getX(),pCaster.getY(),True,True)
	if pCaster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_WITHERED')):
		pCaster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_WITHERED'), False)
		CyInterface().addMessage(pCaster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_POOL_OF_TEARS_WITHERED",()),'AS2D_FEATUREGROWTH',1,'Art/Interface/Buttons/Improvements/Pool of Tears.dds',ColorTypes(8),pCaster.getX(),pCaster.getY(),True,True)

	pPlayer = gc.getPlayer(pCaster.getOwner())

	if pPlayer.isFeatAccomplished(FeatTypes.FEAT_VISIT_POOL_OF_TEARS) == False:
		if pPlayer.getCivilizationType() == gc.getInfoTypeForString("CIVILIZATION_ELOHIM"):
			iEvent = CvUtil.findInfoTypeNum(gc.getEventTriggerInfo, gc.getNumEventTriggerInfos(),'EVENTTRIGGER_POOL_OF_TEARS_ELOHIM')
			triggerData = pPlayer.initTriggeredData(iEvent, True, -1, pCaster.getX(), pCaster.getY(), -1, -1, -1, -1, -1, -1)
			pPlayer.setFeatAccomplished(FeatTypes.FEAT_VISIT_POOL_OF_TEARS, True)
	


def onMoveJungleAltar(pCaster, pPlot):
	if CyGame().getWBMapScript():
		sf.onMoveJungleAltar(pCaster, pPlot)

def onMovePortal(pCaster, pPlot):
	if CyGame().getWBMapScript():
		sf.onMovePortal(pCaster, pPlot)

def onMoveWarningPost(pCaster, pPlot):
	if CyGame().getWBMapScript():
		sf.onMoveWarningPost(pCaster, pPlot)

def onMoveCarcer(pCaster, pPlot):
	if (pCaster.getLevel() > 14):
		pPlot.setImprovementType(-1)
		pPlayer = gc.getPlayer(pCaster.getOwner())
		if CyGame().getUnitClassCreatedCount(gc.getInfoTypeForString('UNIT_BRIGIT')) == 0:
			if pPlot.isVisibleToWatchingHuman():
				CyEngine().triggerEffect(gc.getInfoTypeForString('EFFECT_ICE_SUMMON'),pPlot.getPoint())
				CyAudioGame().Play3DSound("AS3D_ICEBREAK",pPlot.getPoint().x,pPlot.getPoint().y,pPlot.getPoint().z)
			newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_BRIGIT'), pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
			if pPlayer.isHuman():
				t = "TROPHY_FEAT_RESCUE_BRIGIT"
				if not CyGame().isHasTrophy(t):
					CyGame().changeTrophyValue(t, 1)

def onMoveSironasBeacon(pCaster, pPlot):
	pPlayer = gc.getPlayer(pCaster.getOwner())
	if pPlayer.isFeatAccomplished(FeatTypes.FEAT_VISIT_SIRONAS_BEACON) == False:
		
		if pPlayer.getCivilizationType() == gc.getInfoTypeForString("CIVILIZATION_ELOHIM"):
			iEvent = CvUtil.findInfoTypeNum(gc.getEventTriggerInfo, gc.getNumEventTriggerInfos(),'EVENTTRIGGER_SIRONAS_BEACON_ELOHIM')
			triggerData = pPlayer.initTriggeredData(iEvent, True, -1, pCaster.getX(), pCaster.getY(), -1, -1, -1, -1, -1, -1)
			pPlayer.setFeatAccomplished(FeatTypes.FEAT_VISIT_SIRONAS_BEACON, True)

def onMoveMirrorOfHeaven(pCaster, pPlot):
	if CyGame().getWBMapScript():
		sf.onMoveMirrorOfHeaven(pCaster, pPlot)
		return
	pPlayer = gc.getPlayer(pCaster.getOwner())
	if pPlayer.isFeatAccomplished(FeatTypes.FEAT_VISIT_MIRROR_OF_HEAVEN) == False:
		
		if pPlayer.getCivilizationType() == gc.getInfoTypeForString("CIVILIZATION_ELOHIM"):
			iEvent = CvUtil.findInfoTypeNum(gc.getEventTriggerInfo, gc.getNumEventTriggerInfos(),'EVENTTRIGGER_MIRROR_OF_HEAVEN_ELOHIM')
			triggerData = pPlayer.initTriggeredData(iEvent, True, -1, pCaster.getX(), pCaster.getY(), -1, -1, -1, -1, -1, -1)
			pPlayer.setFeatAccomplished(FeatTypes.FEAT_VISIT_MIRROR_OF_HEAVEN, True)
			
		if pPlayer.getCivilizationType() == gc.getInfoTypeForString("CIVILIZATION_MALAKIM"):
			iEvent = CvUtil.findInfoTypeNum(gc.getEventTriggerInfo, gc.getNumEventTriggerInfos(),'EVENTTRIGGER_MALAKIM_MIRROR')
			triggerData = pPlayer.initTriggeredData(iEvent, True, -1, pCaster.getX(), pCaster.getY(), -1, -1, -1, -1, -1, -1)

def onMoveRemnantsOfPatria(pCaster, pPlot):
	pPlayer = gc.getPlayer(pCaster.getOwner())
	if pPlayer.isFeatAccomplished(FeatTypes.FEAT_VISIT_REMNANTS_OF_PATRIA) == False:
		
		if pPlayer.getCivilizationType() == gc.getInfoTypeForString("CIVILIZATION_ELOHIM"):
			iEvent = CvUtil.findInfoTypeNum(gc.getEventTriggerInfo, gc.getNumEventTriggerInfos(),'EVENTTRIGGER_REMNANTS_OF_PATRIA_ELOHIM')
			triggerData = pPlayer.initTriggeredData(iEvent, True, -1, pCaster.getX(), pCaster.getY(), -1, -1, -1, -1, -1, -1)
			pPlayer.setFeatAccomplished(FeatTypes.FEAT_VISIT_REMNANTS_OF_PATRIA, True)
			
		if pPlayer.getCivilizationType() == gc.getInfoTypeForString("CIVILIZATION_SCIONS"):
			iEvent = CvUtil.findInfoTypeNum(gc.getEventTriggerInfo, gc.getNumEventTriggerInfos(),'EVENTTRIGGER_REMNANTS_OF_PATRIA_SCIONS')
			triggerData = pPlayer.initTriggeredData(iEvent, True, -1, pCaster.getX(), pCaster.getY(), -1, -1, -1, -1, -1, -1)
			pPlayer.setFeatAccomplished(FeatTypes.FEAT_VISIT_REMNANTS_OF_PATRIA, True)	

def onMoveOdiosPrison(pCaster, pPlot):
	pPlayer = gc.getPlayer(pCaster.getOwner())
	if pPlayer.isFeatAccomplished(FeatTypes.FEAT_VISIT_ODIOS_PRISON) == False:
		
		if pPlayer.getCivilizationType() == gc.getInfoTypeForString("CIVILIZATION_ELOHIM"):
			iEvent = CvUtil.findInfoTypeNum(gc.getEventTriggerInfo, gc.getNumEventTriggerInfos(),'EVENTTRIGGER_ODIOS_PRISON_ELOHIM')
			triggerData = pPlayer.initTriggeredData(iEvent, True, -1, pCaster.getX(), pCaster.getY(), -1, -1, -1, -1, -1, -1)

def onMoveBradelinesWell(pCaster, pPlot):
	pPlayer = gc.getPlayer(pCaster.getOwner())
	if pPlayer.isFeatAccomplished(FeatTypes.FEAT_VISIT_BRADELINES_WELL) == False:
		if pPlayer.getCivilizationType() == gc.getInfoTypeForString("CIVILIZATION_ELOHIM"):
			iEvent = CvUtil.findInfoTypeNum(gc.getEventTriggerInfo, gc.getNumEventTriggerInfos(),'EVENTTRIGGER_BRADELINES_WELL_ELOHIM')
			triggerData = pPlayer.initTriggeredData(iEvent, True, -1, pCaster.getX(), pCaster.getY(), -1, -1, -1, -1, -1, -1)
			pPlayer.setFeatAccomplished(FeatTypes.FEAT_VISIT_BRADELINES_WELL, True)
			pPlot.setImprovementType(gc.getInfoTypeForString("IMPROVEMENT_BRADELINES_WELL_PURIFIED"))
			
def onMoveFoxford(pCaster, pPlot):
	pPlayer = gc.getPlayer(pCaster.getOwner())
	iEvent = CvUtil.findInfoTypeNum(gc.getEventTriggerInfo, gc.getNumEventTriggerInfos(),'EVENTTRIGGER_FOXFORD')
	triggerData = pPlayer.initTriggeredData(iEvent, True, -1, pCaster.getX(), pCaster.getY(), -1, -1, -1, -1, -1, -1)

				
def voteFundDissidents():
	iOvercouncil = gc.getInfoTypeForString('DIPLOVOTE_OVERCOUNCIL')
	for iPlayer in range(gc.getMAX_PLAYERS()):
		pPlayer = gc.getPlayer(iPlayer)
		if pPlayer.isAlive():
			if pPlayer.isFullMember(iOvercouncil):
				for pyCity in PyPlayer(iPlayer).getCityList() :
					if CyGame().getSorenRandNum(100, "Fund Dissidents") < 50:
						pCity = pyCity.GetCy()
						pCity.changeHurryAngerTimer(1 + CyGame().getSorenRandNum(3, "Fund Dissidents"))

##### MARNOK LAIRS

### Replaces the original spell req (was heavy python)
def reqExploreLair(caster):
	gc 			= CyGlobalContext()
	getInfoType = gc.getInfoTypeForString
	if caster.isOnlyDefensive(): return False
	if caster.getUnitCombatType() == getInfoType('UNITCOMBAT_SIEGE'): return False
	if caster.isBarbarian(): return False
	if not caster.getMasterUnit().isNone(): return False
	if caster.getSpecialUnitType() == getInfoType('SPECIALUNIT_SPELL'): return False
	if caster.getSpecialUnitType() == getInfoType('SPECIALUNIT_BIRD'): return False
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	if not pPlayer.isHuman():
		eBarbCiv = gc.getImprovementInfo(pPlot.getImprovementType()).getSpawnUnitCiv()
		eBarbTeam = -1
		if (eBarbCiv == getInfoType('CIVILIZATION_DEMON') and not CyGame().isOption(GameOptionTypes.GAMEOPTION_NO_DEMONS)):
			eBarbTeam = gc.getDEMON_TEAM()
		elif (eBarbCiv == getInfoType('CIVILIZATION_ANIMAL') and not CyGame().isOption(GameOptionTypes.GAMEOPTION_NO_ANIMALS)):
			eBarbTeam = gc.getANIMAL_TEAM()
		elif (eBarbCiv == getInfoType('CIVILIZATION_ORC') and not CyGame().isOption(GameOptionTypes.GAMEOPTION_NO_BARBARIANS)):
			eBarbTeam = gc.getORC_TEAM()
		if not pPlot.isWater():
			pCapital = pPlayer.getCapitalCity()
			if pCapital.isNone():
				return False
			elif (plotDistance(caster.getX(), caster.getY(), pCapital.getX(), pCapital.getY()) < 20):
				if (pCapital.plot().getNumDefenders(caster.getOwner()) < 6):
					return False
			else:
				pNearestCity = CyMap().findCity(caster.getX(), caster.getY(), -1, caster.getTeam(), False, False, -1, -1, pCapital, False)
				if not pNearestCity.isNone():
					if (plotDistance(caster.getX(), caster.getY(), pNearestCity.getX(), pNearestCity.getY()) < 20):
						if (pNearestCity.plot().getNumDefenders(caster.getOwner()) < 4):
							return False
		if not (eBarbTeam == -1):
			if not gc.getTeam(pPlayer.getTeam()).isAtWar(eBarbTeam):
				return False
	return True

### Still used by Shipwrecks
def spellExploreLair(caster):
	pPlot = caster.plot()
	iRnd = CyGame().getSorenRandNum(100, "Explore Lair") + caster.getLevel()
	iRnd += caster.getNoBadExplore()/2
	iDestroyLair = 0
	Manager	= CvEventInterface.getEventManager()
	if iRnd < 14:
		iDestroyLair = Manager.cf.exploreLairBigBad(caster)
	if iRnd >= 14 and iRnd < 44:
		iDestroyLair = Manager.cf.exploreLairBad(caster)
	if iRnd >= 44 and iRnd < 74:
		iDestroyLair = Manager.cf.exploreLairNeutral(caster)
	if iRnd >= 74 and iRnd < 94:
		iDestroyLair = Manager.cf.exploreLairGood(caster)
	if iRnd >= 94:
		iDestroyLair = Manager.cf.exploreLairBigGood(caster)
	if iDestroyLair > CyGame().getSorenRandNum(100, "Explore Lair"):
		CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_LAIR_DESTROYED", ()),'AS2D_POSITIVE_DINK',1,'Art/Interface/Buttons/Spells/Explore Lair.dds',ColorTypes(8),pPlot.getX(),pPlot.getY(),True,True)
		pPlot.setImprovementType(-1)
	caster.finishMoves()
	caster.changeExperience(1, -1, False, False, False)

### Still used by Epic Lairs
def spellExploreLairEpic(caster):
	pPlot = caster.plot()
	iRnd = CyGame().getSorenRandNum(100, "Explore Lair") + caster.getLevel()
	iRnd += caster.getNoBadExplore()/2
	iDestroyLair = 0
	if iRnd < 50:
		iDestroyLair = CvEventInterface.getEventManager().cf.exploreLairBigBad(caster)
	if iRnd >= 50:
		iDestroyLair = CvEventInterface.getEventManager().cf.exploreLairBigGood(caster)
	if iDestroyLair > CyGame().getSorenRandNum(100, "Explore Lair"):
		CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_LAIR_DESTROYED", ()),'AS2D_POSITIVE_DINK',1,'Art/Interface/Buttons/Spells/Explore Lair.dds',ColorTypes(8),pPlot.getX(),pPlot.getY(),True,True)
		removeEpicLair(pPlot)
	caster.finishMoves()
	caster.changeExperience(3, -1, False, False, False)

def removeEpicLair(pPlot):
	iLair 		= pPlot.getImprovementType()
	iReplace 	= -1
	Manager		= CvEventInterface.getEventManager()
	Improv		= Manager.UniqueImprovements
	
	if   iLair == Improv["Aifon Isle"]:				iReplace = Improv["Aifon Isle (Explored)"]
	elif iLair == Improv["Bradeline's Well"]:		iReplace = Improv["Bradeline's Well (Explored)"]
	elif iLair == Improv["Broken Sepulcher"]:		iReplace = Improv["Broken Sepulcher (Explored)"]
	elif iLair == Improv["Pyre of the Seraphic"]:	iReplace = Improv["Pyre of the Seraphic (Explored)"]
	elif iLair == Improv["Dragon Bones"]:			iReplace = Improv["Dragon Bones Explored"]
	
	if iReplace != -1:
		pPlot.setImprovementType(iReplace)

def spellMarnokDungeoneer(caster):
	iPlayer = caster.getOwner()
	pPlot 	= caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	iLair 	= pPlot.getImprovementType()
	
	Manager	= CvEventInterface.getEventManager()
	Lair	= Manager.Lairs
	
	randNum	= CyGame().getSorenRandNum
	iRnd 	= randNum(100, "Primary Dungeon Result List")
	iRnd += caster.getNoBadExplore()/2
	iDestroyLair=75
	
	if iRnd < 11:
		iDestroyLair = MarnokDungeoneerBigBad(caster)
	elif iRnd >= 11 and iRnd < 21:
		iDestroyLair = MarnokDungeoneerMonster(caster)
	elif iRnd >= 21 and iRnd < 35:
		iDestroyLair = MarnokDungeoneerBadRandom(caster)
	elif iRnd >= 35 and iRnd < 65:
		iDestroyLair = MarnokDungeoneerRandomStuff(caster)
	elif iRnd >= 65 and iRnd < 70:
		iDestroyLair = MarnokDungeoneerAlignSpecific(caster)
	elif iRnd >= 70 and iRnd < 75:
		iDestroyLair = MarnokDungeoneerCivSpecific(caster)
	elif iRnd >= 75 and iRnd < 90:
		iDestroyLair = MarnokDungeoneerGood(caster)
	elif iRnd >= 90:
		iDestroyLair = MarnokDungeoneerBigGood(caster)
	caster.finishMoves()
	caster.changeExperience(1, -1, False, False, False)
	# Destroy the Lair, or not:
	iRnd = randNum(100, "Lair Destuction")
	if iRnd <= iDestroyLair:
		if iLair == Lair["Goblin Fort"]:
			pPlot.setImprovementType(Lair["Goblin Fort (Cleared Out)"])
			CyInterface().addMessage(iPlayer,True,25,CyTranslator().getText("TXT_KEY_MESSAGE_LAIR_DESTROYED", ()),'AS2D_POSITIVE_DINK',1,'Art/Interface/Buttons/Spells/Rob Grave.dds',ColorTypes(8),pPlot.getX(),pPlot.getY(),True,True)
			return True
		else:
			pPlot.setImprovementType(-1)
			CyInterface().addMessage(iPlayer,True,25,CyTranslator().getText("TXT_KEY_MESSAGE_LAIR_DESTROYED", ()),'AS2D_POSITIVE_DINK',1,'Art/Interface/Buttons/Spells/Rob Grave.dds',ColorTypes(8),pPlot.getX(),pPlot.getY(),True,True)
			return True
	else:
		CyInterface().addMessage(iPlayer,True,25,CyTranslator().getText("TXT_KEY_MESSAGE_LAIR_NOT_DESTROYED", ()),'AS2D_DEAL_CANCELLED',1,'Art/Interface/Buttons/Spells/Rob Grave.dds',ColorTypes(7),pPlot.getX(),pPlot.getY(),True,True)
		return False
		
def MarnokDungeoneerBigBad(caster):
	iPlayer = caster.getOwner()
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	
	Manager		= CvEventInterface.getEventManager()
	Lair		= Manager.Lairs
	Improvement	= Manager.Improvements
	Goody		= Manager.Goodies
	
	iRnd = CyGame().getSorenRandNum(100, "Lair BigBad Result List")
	if iRnd <= 60:
		return Manager.cf.exploreLairBigBad(caster)
	if iRnd > 60:
		eImprovement	= pPlot.getImprovementType()
		#Lair-Type Specific	
		if   eImprovement == Lair["Steading"]:
			if pPlayer.canReceiveGoody(pPlot, Goody["Hill Giant"], caster):
				pPlayer.receiveGoody(pPlot,   Goody["Hill Giant"], caster)
				return 80
		elif eImprovement == Lair["Barrow"]:
			if pPlayer.canReceiveGoody(pPlot, Goody["Lich"], caster):
				pPlayer.receiveGoody(pPlot,   Goody["Lich"], caster)
				return 80
		elif eImprovement == Lair["Ruins"]:
			if pPlayer.canReceiveGoody(pPlot, Goody["Cyklop"], caster):
				pPlayer.receiveGoody(pPlot,   Goody["Cyklop"], caster)
				return 80
		elif eImprovement == Lair["Dungeon"]:
			if pPlayer.canReceiveGoody(pPlot, Goody["Minotaur"], caster):
				pPlayer.receiveGoody(pPlot,   Goody["Minotaur"], caster)
				return 80
		elif eImprovement == Lair["Goblin Fort"]:
			if pPlayer.canReceiveGoody(pPlot, Goody["Troll"], caster):
				pPlayer.receiveGoody(pPlot,   Goody["Troll"], caster)
				return 80

	# list of individual entries not linked to terrain or lair type
	# (none at present)
	#default entry
	if pPlayer.canReceiveGoody(pPlot, Goody["Ogre"], caster):
		pPlayer.receiveGoody(pPlot,   Goody["Ogre"], caster)
		return 100
	if pPlayer.canReceiveGoody(pPlot, Goody["Zombie"], caster):
		pPlayer.receiveGoody(pPlot,   Goody["Zombie"], caster)
		return 100
	if pPlayer.canReceiveGoody(pPlot, Goody["Treant"], caster):
		pPlayer.receiveGoody(pPlot,   Goody["Treant"], caster)
		return 100
	return MarnokDungeoneerBadRandom(caster)
	
def MarnokDungeoneerBadRandom(caster):
	# what's the worst that could happen?
	iPlayer = caster.getOwner()
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	iRnd = CyGame().getSorenRandNum(100, "Lair BadRandom Result List")
	iRnd += caster.getNoBadExplore()
	
	if iRnd <= 11:
		#DEATH!
		caster.kill(True,0)
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_MYSTERYDEATH'), caster)
		return 0
	if iRnd <= 21:
		return CvEventInterface.getEventManager().cf.exploreLairBigBad(caster)
	if iRnd <= 31:
		return CvEventInterface.getEventManager().cf.exploreLairBad(caster)
	if iRnd <= 36:
		caster.doDamageNoCaster(25, 100, gc.getInfoTypeForString('DAMAGE_PHYSICAL'), False)
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_DUNGEONCOLLAPSE'), caster)
		return 100
	if iRnd <= 41:
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_POSSESSED'), caster):
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_POSSESSED'), caster)
			return 80
	if iRnd <= 46:
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_WITHERED'), caster):
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_WITHERED'), caster)
			return 80
	if iRnd <= 51:
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_CRAZED'), caster):
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_CRAZED'), caster)
			return 80
	if iRnd <= 56:
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_ENERVATED'), caster):
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_ENERVATED'), caster)
			return 80
	if iRnd <= 61:
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_DISEASED'), caster):
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_DISEASED'), caster)
			return 80
	if iRnd <= 66:
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_PLAGUED'), caster):
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_PLAGUED'), caster)
			return 80
	if iRnd <= 71:
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_POISONED'), caster):
			caster.doDamageNoCaster(25, 50, gc.getInfoTypeForString('DAMAGE_POISON'), False)
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_POISONED'), caster)
			return 80
	return MarnokDungeoneerRandomStuff(caster)

def MarnokDungeoneerMonster(caster):
	iPlayer = caster.getOwner()
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	iRnd = CyGame().getSorenRandNum(100, "Lair Monster Result List")
	if iRnd <= 40:
		return CvEventInterface.getEventManager().cf.exploreLairBigBad(caster)
	if iRnd <= 80:
		#Lair-Type Specific	
		if pPlot.getImprovementType() == gc.getInfoTypeForString('IMPROVEMENT_MARNOK_HILLGIANT_STEADING'):
			if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_HILLGIANT'), caster):
				pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_HILLGIANT'), caster)
				return 80
		if pPlot.getImprovementType() == gc.getInfoTypeForString('IMPROVEMENT_BARROW'):
			if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_LICH'), caster):
				pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_LICH'), caster)
				return 80
		if pPlot.getImprovementType() == gc.getInfoTypeForString('IMPROVEMENT_RUINS'):
			if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_CYKLOP'), caster):
				pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_CYKLOP'), caster)
				return 80
		if pPlot.getImprovementType() == gc.getInfoTypeForString('IMPROVEMENT_DUNGEON'):
			if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MINOTAUR'), caster):
				pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MINOTAUR'), caster)
				return 80
		if pPlot.getImprovementType() == gc.getInfoTypeForString('IMPROVEMENT_GOBLIN_FORT'):
			if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_TROLL'), caster):
				pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_TROLL'), caster)
				return 80
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_OGRE'), caster):
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_OGRE'), caster)
			return 100
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_ZOMBIE'), caster):
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_ZOMBIE'), caster)
			return 100
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_TREANT'), caster):
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_TREANT'), caster)
			return 100
	if iRnd <= 90:
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_PITBEAST'), caster):
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_PITBEAST'), caster)
			return 50
	if iRnd <= 100:
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_SPIDER'), caster):
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_SPIDER'), caster)
			return 50
	return MarnokDungeoneerRandomStuff(caster)
	

def MarnokDungeoneerRandomStuff(caster):
	iPlayer = caster.getOwner()
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	iRnd = CyGame().getSorenRandNum(100, "Lair RandomStuff Result List")
	if iRnd <= 21:
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_MUTATED'), caster):
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_MUTATED'), caster)
			return 50
	if iRnd <= 71:
		return CvEventInterface.getEventManager().cf.exploreLairNeutral(caster)
	if iRnd <= 91:
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_ADVENTURER'), caster):
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_ADVENTURER'), caster)
			return 100
	return MarnokDungeoneerGood(caster)

def MarnokDungeoneerCivSpecific(caster):
	iPlayer = caster.getOwner()
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	iRnd = CyGame().getSorenRandNum(100, "Lair CivSpecific Result List")
	
	if pPlayer.getCivilizationType() == gc.getInfoTypeForString('CIVILIZATION_ELOHIM'):
		if iRnd <= 50:
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_VEHEM_PROPER_BURIAL_ELOHIM'), caster)
			CyGame().changeGlobalCounter(-1)
			return 100
	return MarnokDungeoneerGood(caster)
	
def MarnokDungeoneerAlignSpecific(caster):
	iPlayer = caster.getOwner()
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	
	if pPlayer.getAlignment() == gc.getInfoTypeForString('ALIGNMENT_EVIL'):
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_VEHEM_RIVAL_PARTY_EVIL'), caster)
		return 100
	if pPlayer.getAlignment() == gc.getInfoTypeForString('ALIGNMENT_NEUTRAL'):
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_VEHEM_RIVAL_PARTY_NEUTRAL'), caster)
		return 100
	if pPlayer.getAlignment() == gc.getInfoTypeForString('ALIGNMENT_GOOD'):
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_VEHEM_RIVAL_PARTY_GOOD'), caster)
		return 100
	return MarnokDungeoneerGood(caster)
		
def MarnokDungeoneerReligionSpecific(caster):
	iPlayer = caster.getOwner()
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	# NOTE : could use religion of unit and state religion as seperate sub-categories!	
	#default entry, where state religion is not represented here or some factor means other entries not used
	if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_BARBARIANS_WEAK'), caster):
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_BARBARIANS_WEAK'), caster)
		return 80
	if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_BEAR'), caster):
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_BEAR'), caster)
		return 80
	if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_SKELETONS'), caster):
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_SKELETONS'), caster)
		return 80
	return MarnokDungeoneerGood(caster)
		
def MarnokDungeoneerGood(caster):
	iPlayer = caster.getOwner()
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	iRnd = CyGame().getSorenRandNum(100, "Lair Good Result List")
	
	if iRnd <= 11:
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_MAP'), caster)
		return 80
	if iRnd <= 21:
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_HIGH_GOLD'), caster)
		return 90
	if iRnd <= 26:
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_ADVENTURER'), caster):
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_ADVENTURER'), caster)
			return 80
	if iRnd <= 31:
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_SPIRIT_GUIDE'), caster):
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_SPIRIT_GUIDE'), caster)
			return 80
	if iRnd <= 36:
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_ENCHANTED_BLADE'), caster):
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_ENCHANTED_BLADE'), caster)
			return 100
	if iRnd <= 86:
		return CvEventInterface.getEventManager().cf.exploreLairGood(caster)
	if iRnd <= 96:
		return CvEventInterface.getEventManager().cf.exploreLairGoodEquipment(caster)

	return MarnokDungeoneerBigGood(caster)
	
def MarnokDungeoneerBigGood(caster):
	iPlayer = caster.getOwner()
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	iRnd = CyGame().getSorenRandNum(100, "Lair BigGood Result List")
	iRnd += caster.getNoBadExplore()/2

	### Comment by Vehem: Made Immortal a very rare option for non-adventurers and moved it to the top of the list.
	
	if iRnd <= 11:
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_FAMOUS_ADVENTURE'), caster):
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_FAMOUS_ADVENTURE') , caster)
			return 100
	if iRnd <= 21:
		MarnokDungeoneerMinerals(caster)
		return 100
	if iRnd <= 31:
		MarnokDungeoneerMana(caster)
		return 100
	#rescue a prisoner series (free great person)
	if iRnd <= 36:
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_RELEASE_PRISONER_ARTIST') , caster)
		return 100
	if iRnd <= 41:
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_RELEASE_PRISONER_SCIENTIST') , caster)
		return 100
	if iRnd <= 46:
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_RELEASE_PRISONER_ENGINEER') , caster)
		return 100
	if iRnd <= 51:
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_RELEASE_PRISONER_COMMANDER') , caster)
		return 100
	if iRnd <= 56:
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_RELEASE_PRISONER_MERCHANT') , caster)
		return 100
	if iRnd <= 61:
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_RELEASE_PRISONER_PROPHET') , caster)
		return 100
	if iRnd <= 81:
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_TECH'), caster)
		return 100
	if iRnd <= 101:
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_MAGIC_ITEM') , caster)
		iItem = receiveDungeonMagicItem(caster)
		return 100
	if iRnd > 101:
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_IMMORTAL'), caster):
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_IMMORTAL') , caster)
			return 100

	return MarnokDungeoneerBigGood(caster)
		
def MarnokDungeoneerMinerals(caster):
	# reveals a new mineral resource.
	iPlayer = caster.getOwner()
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	iRnd = CyGame().getSorenRandNum(50, "Lair Mineral List Result")
	iRnd += caster.getNoBadExplore()/2

	### Comment by Vehem: Shuffled things around, made it so that only adventurers can find the really rare ones. Also - made this one a "Rnd(50)".
	
	if iRnd <= 20:
		pPlot.setBonusType(gc.getInfoTypeForString('BONUS_COPPER'))
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_BONUS_COPPER') , caster)
		return 100
	if iRnd <= 30:
		pPlot.setBonusType(gc.getInfoTypeForString('BONUS_IRON'))
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_BONUS_IRON') , caster)
		return 100
	if iRnd <= 40:
		pPlot.setBonusType(gc.getInfoTypeForString('BONUS_GOLD'))
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_BONUS_GOLD') , caster)
		return 100
	if iRnd <= 50:
		pPlot.setBonusType(gc.getInfoTypeForString('BONUS_GEMS'))
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_BONUS_GEMS') , caster)
		return 100
	if iRnd <= 55:
		pPlot.setBonusType(gc.getInfoTypeForString('BONUS_MITHRIL'))
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_BONUS_MITHRIL') , caster)
		return 100
	if iRnd > 55:
		pPlot.setBonusType(gc.getInfoTypeForString('BONUS_REAGENTS'))
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_BONUS_REAGENTS') , caster)
		return 100
	#default
	# other ideas : 
	#+hammers, like the "tin mine" event
	#+gold, perhaps a silver mine?
	# maybe even +food for an underground mushroom forest. 
	### Comment by Vehem: I looked into this one, but can't see a way to add yields to a plot using Python alone.
	
def MarnokDungeoneerMana(caster):
	# reveals a new Mana node. This is a pretty big deal and ought to come with some cost, I think.
	# associaed goodie event ought to spawn bad monsters - elementals of course, shadows, etc
	# and/or add an effect to represent explosive release of mystical forces
	iPlayer = caster.getOwner()
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	iRnd = CyGame().getSorenRandNum(100, "Lair Mana Result List")
	if iRnd < 4:
		pPlot.setBonusType(-1)
		pPlot.setBonusType(gc.getInfoTypeForString('BONUS_MANA_DEATH'))
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_DEATHMANA') , caster)
		return 100
	if iRnd < 7:
		pPlot.setBonusType(-1)
		pPlot.setBonusType(gc.getInfoTypeForString('BONUS_MANA_FIRE'))
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_FIREMANA') , caster)
		return 100
	if iRnd < 10:
		pPlot.setBonusType(-1)
		pPlot.setBonusType(gc.getInfoTypeForString('BONUS_MANA_AIR'))
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_AIRMANA') , caster)
		return 100
	if iRnd < 13:
		pPlot.setBonusType(-1)
		pPlot.setBonusType(gc.getInfoTypeForString('BONUS_MANA_BODY'))
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_BODYMANA') , caster)
		return 100
	if iRnd < 16:
		pPlot.setBonusType(-1)
		pPlot.setBonusType(gc.getInfoTypeForString('BONUS_MANA_CHAOS'))
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_CHAOSMANA') , caster)
		return 100
	if iRnd < 19:
		pPlot.setBonusType(-1)
		pPlot.setBonusType(gc.getInfoTypeForString('BONUS_MANA_EARTH'))
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_EARTHMANA') , caster)
		return 100
	if iRnd < 22:
		pPlot.setBonusType(-1)
		pPlot.setBonusType(gc.getInfoTypeForString('BONUS_MANA_ENCHANTMENT'))
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_ENCHANTMENTMANA') , caster)
		return 100
	if iRnd < 25:
		pPlot.setBonusType(-1)
		pPlot.setBonusType(gc.getInfoTypeForString('BONUS_MANA_ENTROPY'))
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_ENTROPYMANA') , caster)
		return 100
	if iRnd < 28:
		pPlot.setBonusType(-1)
		pPlot.setBonusType(gc.getInfoTypeForString('BONUS_MANA_FIRE'))
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_FIREMANA') , caster)
		return 100
	if iRnd < 31:
		pPlot.setBonusType(-1)
		pPlot.setBonusType(gc.getInfoTypeForString('BONUS_MANA_LAW'))
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_LAWMANA') , caster)
		return 100
	if iRnd < 34:
		pPlot.setBonusType(-1)
		pPlot.setBonusType(gc.getInfoTypeForString('BONUS_MANA_LIFE'))
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_LIFEMANA') , caster)
		return 100
	if iRnd < 37:
		pPlot.setBonusType(-1)
		pPlot.setBonusType(gc.getInfoTypeForString('BONUS_MANA_METAMAGIC'))
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_METAMAGICMANA') , caster)
		return 100
	if iRnd < 40:
		pPlot.setBonusType(-1)
		pPlot.setBonusType(gc.getInfoTypeForString('BONUS_MANA_MIND'))
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_MINDMANA') , caster)
		return 100
	if iRnd < 43:
		pPlot.setBonusType(-1)
		pPlot.setBonusType(gc.getInfoTypeForString('BONUS_MANA_NATURE'))
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_NATUREMANA') , caster)
		return 100
	if iRnd < 46:
		pPlot.setBonusType(-1)
		pPlot.setBonusType(gc.getInfoTypeForString('BONUS_MANA_SPIRIT'))
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_SPIRITMANA') , caster)
		return 100
	if iRnd < 49:
		pPlot.setBonusType(-1)
		pPlot.setBonusType(gc.getInfoTypeForString('BONUS_MANA_WATER'))
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_WATERMANA') , caster)
		return 100
	if iRnd < 54:
		pPlot.setBonusType(-1)
		pPlot.setBonusType(gc.getInfoTypeForString('BONUS_MANA_SUN'))
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_SUNMANA') , caster)
		return 100
	if iRnd < 57:
		pPlot.setBonusType(-1)
		pPlot.setBonusType(gc.getInfoTypeForString('BONUS_MANA_SHADOW'))
		pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_SHADOWMANA') , caster)
		return 100
	#default
	# basic raw mana
	pPlot.setBonusType(-1)
	pPlot.setBonusType(gc.getInfoTypeForString('BONUS_MANA'))
	pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_BASICMANA') , caster)
	return 100

def receiveDungeonMagicItem(caster):
	iPlayer = caster.getOwner()
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	iRnd = CyGame().getSorenRandNum(100, "Lair Result Magic Item List")
	iRnd += caster.getNoBadExplore()/2


	### Comment by Vehem: Added the new items in...
	iEquipment = -1
			
	if iRnd <= 20:
		iEquipment = gc.getInfoTypeForString('PROMOTION_HEALING_SALVE')
	if iRnd > 20 and iRnd <= 30:
		iEquipment = gc.getInfoTypeForString('PROMOTION_HEALING_POTION')
	if iRnd > 30 and iRnd <= 35:
		iEquipment = gc.getInfoTypeForString('PROMOTION_NEWTS_DRAUGHT')
	if iRnd > 35 and iRnd <= 45:
		iEquipment = gc.getInfoTypeForString('PROMOTION_HEART_AMULET')
	if iRnd > 45 and iRnd <= 50:
		iEquipment = gc.getInfoTypeForString('PROMOTION_SWIFT_BOOTS')
	if iRnd > 50 and iRnd <= 60:
		iEquipment = gc.getInfoTypeForString('PROMOTION_TRAVELLERS_CLOAK')
	if iRnd > 60 and iRnd <= 70:
		iEquipment = gc.getInfoTypeForString('PROMOTION_RING_OF_PERCEPTION')
	if iRnd > 70 and iRnd <= 75:
		iEquipment = gc.getInfoTypeForString('PROMOTION_RING_OF_STRIKING')
	if iRnd > 75 and iRnd <= 80:
		iEquipment = gc.getInfoTypeForString('PROMOTION_COMPELLING_JEWEL')
	if iRnd > 80 and iRnd <= 85:
		iEquipment = gc.getInfoTypeForString('PROMOTION_CURSED_TOKEN_OF_RAGNAROK')
	if iRnd > 85 and iRnd <= 90:
		iEquipment = gc.getInfoTypeForString('PROMOTION_ROD_OF_WINDS')
	if iRnd > 90 and iRnd <= 95:
		iEquipment = gc.getInfoTypeForString('PROMOTION_JADE_TORC')
	if iRnd > 95 and iRnd <= 99:
		iEquipment = gc.getInfoTypeForString('PROMOTION_MENACING_HELM')
	if iRnd > 99 and iRnd <= 105:
		iEquipment = gc.getInfoTypeForString('PROMOTION_HAUBERK_OF_ABJURATION')
	if iRnd > 105:
		#Double prize!
		receiveDungeonMagicItem(caster)
		receiveDungeonMagicItem(caster)
		return 100
	
	
	### Comment by Vehem: This way the item should drop on the floor if the unit already has one of them (so that he doesn't lose out of multiple common items).
		
	if not caster.isHasPromotion(iEquipment):
		caster.setHasPromotion(iEquipment, True)
	else:
		containerUnit = -1
		pPlot = caster.plot()
		for i in range(pPlot.getNumUnits()):
			if pPlot.getUnit(i).getUnitType() == gc.getInfoTypeForString('EQUIPMENT_CONTAINER'):
				containerUnit = pPlot.getUnit(i)
		if containerUnit == -1:
			containerUnit = gc.getPlayer(gc.getORC_PLAYER()).initUnit(gc.getInfoTypeForString('EQUIPMENT_CONTAINER'), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		containerUnit.setHasPromotion(iEquipment, True)
		
	return 100
	
	
		
def reqMarnokHillGiantLairMaking(caster):
	pPlot = caster.plot()
	if pPlot.getImprovementType() != gc.getInfoTypeForString('IMPROVEMENT_TOWER') and pPlot.getImprovementType() != gc.getInfoTypeForString('IMPROVEMENT_BARROW') and pPlot.getImprovementType() != gc.getInfoTypeForString('IMPROVEMENT_RUINS'):
		return False
	if pPlot.getTerrainType() != gc.getInfoTypeForString('TERRAIN_HILL'):
		return False
	if caster.getUnitType() == gc.getInfoTypeForString('UNIT_HILL_GIANT'):
		return True
	return False
	
def spellMarnokHillGiantLairMaking(caster):
	pPlot = caster.plot()
	pPlot.setImprovementType(-1)
	pPlot.setImprovementType(gc.getInfoTypeForString('IMPROVEMENT_MARNOK_HILLGIANT_STEADING'))
	
def reqMarnokHillGiantLairEvent(caster):
	pPlot = caster.plot()
	if pPlot.getImprovementType() != gc.getInfoTypeForString('IMPROVEMENT_MARNOK_HILLGIANT_STEADING'):
		return False
	iRnd = CyGame().getSorenRandNum(100, "Hillgiant Steading Allow")
	if iRnd > 10:
		return False
	if pPlayer.isBarbarian():
		return True
		
def spellMarnokHillGiantLairEvent(caster):
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	iRnd = CyGame().getSorenRandNum(100, "HillGiant Steading Result")
	if iRnd < 20:
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_ADVENTURER'), caster):
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_ADVENTURER'), caster)
	if iRnd >= 20 and iRnd < 35:
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_OGRE'), caster):
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_OGRE'), caster)
			return
	if iRnd >= 35 and iRnd < 60:
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_BARBARIANS_WEAK'), caster):
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_BARBARIANS_WEAK'), caster)
			return
	if iRnd >= 60 and iRnd < 80:
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_BARBARIANS_STRONG'), caster):
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_BARBARIANS_STRONG'), caster)
			return
	if iRnd >= 80 and iRnd < 85:
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_OGRE_STONESKIN'), caster):
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_OGRE_STONESKIN'), caster)
			return
	if iRnd >= 85 and iRnd < 90:
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_OGRE_CHIEF'), caster):
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_OGRE_CHIEF'), caster)
			return
	if iRnd >= 90: 
		if pPlayer.canReceiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_HILLGIANT'), caster):
			pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_MARNOK_HILLGIANT'), caster)
			return
	pPlayer.receiveGoody(pPlot, gc.getInfoTypeForString('GOODY_LOW_GOLD'), caster)

def MarnokSpawnMonster(caster, monster, iSpawnPlayer):
	iPlayer = caster.getOwner()
	pPlot = caster.plot()
	pPlot.setImprovementType(-1)
	pPlayer = gc.getPlayer(caster.getOwner())
	pNewPlot = findClearPlot(-1, pPlot)
	pOwner = gc.getPlayer(iSpawnPlayer)
	if pNewPlot != -1:
		unitMonster = pOwner.initUnit(monster, pNewPlot.getX(), pNewPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		return unitMonster
	return -1
	
def reqSummonPegasus(caster):
	pPlayer = PyPlayer(caster.getOwner())
	iCount = 0
	iMax = 0
	iPegasusRiderPromotion = gc.getInfoTypeForString('PROMOTION_PEGASUS_RIDER')
	iPegasusUnitType = gc.getInfoTypeForString('UNIT_PEGASUS')
	iSummonLimitPromotion = gc.getInfoTypeForString('PROMOTION_AIR3')
	
	for pUnit in pPlayer.getUnitList():
		if pUnit.isHasPromotion(iPegasusRiderPromotion) or pUnit.getUnitType() == iPegasusUnitType:
			iCount += 1
			
		if pUnit.isHasPromotion(iSummonLimitPromotion):
			iMax += 1
	
	if iCount < iMax:
		return True
	
def spellMountPegasus(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	pPlot = caster.plot()
	iPegasus = gc.getInfoTypeForString('UNIT_PEGASUS')
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (caster.getOwner() == pUnit.getOwner() and pUnit.getUnitType() == iPegasus):
			pUnit.setHasPromotion(gc.getInfoTypeForString('PROMOTION_GOLEM'), True)
			pUnit.kill(False,0)
			return True
	
	return False

def reqTempest(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		iTeam = gc.getPlayer(caster.getOwner()).getTeam()
		eTeam = gc.getTeam(iTeam)
		if eTeam.getAtWarCount(True) < 2:
			return False
	return True
	
def spellTempest(caster):
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	iAirElementalChance = 9
	iAirElly = gc.getInfoTypeForString('UNIT_AIR_ELEMENTAL')
	iTeam = pPlayer.getTeam()	

	
	for i in range (CyMap().numPlots()):
		pPlot = CyMap().plotByIndex(i)
		iOwner = pPlot.getOwner()
		
		if iOwner == iPlayer:
			if pPlot.getNumUnits() == 0:
				if CyGame().getSorenRandNum(100, "AirEllySpawn") < iAirElementalChance:
					newUnit = pPlayer.initUnit(iAirElly, pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_NORTH)
					newUnit.setDuration(CyGame().getSorenRandNum(5, "AirEllySpawn") + 1) 
			else:
				for i in range(pPlot.getNumUnits()):
					pUnit = pPlot.getUnit(i)
					iTeam2 = gc.getTeam(gc.getPlayer(pUnit.getOwner()).getTeam())
					if iTeam2.isAtWar(iTeam):
						pUnit.setImmobileTimer(CyGame().getSorenRandNum(5, "AirEllySpawn") + 1)


def reqFertility(caster):
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	pPlot = caster.plot()

	pBonus = pPlot.getBonusType(-1)
	if pBonus == -1:
		return False
		
	iWheat = gc.getInfoTypeForString('BONUS_WHEAT')
	iRice = gc.getInfoTypeForString('BONUS_RICE')
	iCorn = gc.getInfoTypeForString('BONUS_CORN')
	
	iCow = gc.getInfoTypeForString('BONUS_COW')
	iSheep = gc.getInfoTypeForString('BONUS_SHEEP')
 	iPig = gc.getInfoTypeForString('BONUS_PIG')

	if pBonus == iWheat or pBonus == iRice or pBonus == iCorn or pBonus == iCow or pBonus == iSheep or pBonus == iPig:
		return True
	
	return False
	
def spellFertility(caster):
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	pPlot = caster.plot()
	
	pBonus = pPlot.getBonusType(-1)
		
	iWheat = gc.getInfoTypeForString('BONUS_WHEAT')
	iRice = gc.getInfoTypeForString('BONUS_RICE')
	iCorn = gc.getInfoTypeForString('BONUS_CORN')
	
	iCow = gc.getInfoTypeForString('BONUS_COW')
	iSheep = gc.getInfoTypeForString('BONUS_SHEEP')
 	iPig = gc.getInfoTypeForString('BONUS_PIG')	
 	
 	if pBonus == iWheat:
 		pPlot.setBonusType(iRice)
 		return
 	if pBonus == iRice:
 		pPlot.setBonusType(iCorn)
 		return
  	if pBonus == iCorn:
  		pPlot.setBonusType(iWheat)
 		return
 		
  	if pBonus == iCow:
 		pPlot.setBonusType(iSheep)
 		return
 	if pBonus == iSheep:
 		pPlot.setBonusType(iPig)
 		return
 	if pBonus == iPig:
 		pPlot.setBonusType(iCow)
 		return 		
 		
def reqBirth(caster):
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()

	if pPlayer.hasTrait(gc.getInfoTypeForString('TRAIT_FALLOW')):
		return False
	if pCity.getPopulation() > 7:
		return False
	
	return True 	
	
def reqFrozenLands(caster):
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	pPlot = caster.plot()


	if not pPlayer.isHuman():
		iTeam = gc.getPlayer(caster.getOwner()).getTeam()
		eTeam = gc.getTeam(iTeam)
		iPlotOwner = pPlot.getOwner()
		if iPlotOwner != -1:
			iTeamPlotOwner = gc.getPlayer(iPlotOwner).getTeam()
			if eTeam.isAtWar(iTeamPlotOwner) == False:
				return False
	
	return True
	
def spellFrozenLands(caster):
	pPlot 		= caster.plot()
	iPlayer 	= caster.getOwner()
	gc			= CyGlobalContext()
	getInfoType	= gc.getInfoTypeForString
	iDesert 	= getInfoType('TERRAIN_DESERT')
	iGrass 		= getInfoType('TERRAIN_GRASS')
	iWetland 	= getInfoType('TERRAIN_MARSH')
	iPlains 	= getInfoType('TERRAIN_PLAINS')
	iSnow 		= getInfoType('TERRAIN_SNOW')
	iTundra 	= getInfoType('TERRAIN_TUNDRA')
	getPlayer	= gc.getPlayer
	iTeam 		= getPlayer(caster.getOwner()).getTeam()
	eTeam 		= gc.getTeam(iTeam)	
	
	iX = caster.getX()
	iY = caster.getY()
	getPlot	= CyMap().plot
	randNum	= CyGame().getSorenRandNum
	for iiX,iiY in RANGE2:
		pPlot = getPlot(iX+iiX,iY+iiY)
		iPlotOwner = pPlot.getOwner()
		if not pPlot.isOwned() or iPlotOwner == iPlayer or eTeam.isAtWar(getPlayer(iPlotOwner).getTeam()):
			if randNum(100, "Plot affected chance") < 40:
				if not pPlot.isWater():
					iTerrain = pPlot.getTerrainType()
					if iTerrain == iTundra:
						pPlot.setTempTerrainType(iSnow, randNum(10, "Bob") + 10)
					if iTerrain == iGrass or iTerrain == iWetland or iTerrain == iPlains:
						pPlot.setTempTerrainType(iTundra, randNum(10, "Bob") + 10)
					if iTerrain == iDesert:
						pPlot.setTempTerrainType(iPlains, randNum(10, "Bob") + 10)			

def spellFrozenLandsMaster(caster):
	pPlot 		= caster.plot()
	iPlayer 	= caster.getOwner()
	gc			= CyGlobalContext()
	getInfoType	= gc.getInfoTypeForString
	iDesert 	= getInfoType('TERRAIN_DESERT')
	iGrass 		= getInfoType('TERRAIN_GRASS')
	iWetland 	= getInfoType('TERRAIN_MARSH')
	iPlains 	= getInfoType('TERRAIN_PLAINS')
	iSnow 		= getInfoType('TERRAIN_SNOW')
	iTundra 	= getInfoType('TERRAIN_TUNDRA')
	getPlayer	= gc.getPlayer
	iTeam 		= getPlayer(caster.getOwner()).getTeam()
	eTeam 		= gc.getTeam(iTeam)	
	
	iX = caster.getX()
	iY = caster.getY()
	randNum	= CyGame().getSorenRandNum
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE2:
		pPlot = getPlot(iX+iiX,iY+iiY)
		iPlotOwner = pPlot.getOwner()
		if not pPlot.isOwned() or iPlotOwner == iPlayer or eTeam.isAtWar(getPlayer(iPlotOwner).getTeam()):
			if randNum(100, "Plot affected chance") < 40:
				if not pPlot.isWater():
					iTerrain = pPlot.getTerrainType()
					if iTerrain == iTundra:
						pPlot.setTerrainType(iSnow, True, True)
					if iTerrain == iGrass or iTerrain == iWetland or iTerrain == iPlains:
						pPlot.setTerrainType(iTundra, True, True)
					if iTerrain == iDesert:
						pPlot.setTerrainType(iPlains, True, True)								
							
def spellWallOfForce(caster):
	pPlot = caster.plot()
	pPlot.setMinLevel(4)

# Scions start
def spellArawnsCall(caster):
	iSpell = gc.getInfoTypeForString('SPELL_ARAWN_BECKONS')
	iUndead = gc.getInfoTypeForString('PROMOTION_UNDEAD')
	iCalled = gc.getInfoTypeForString('PROMOTION_CALLED')
	iX = caster.getX()
	iY = caster.getY()
	pPlayer = gc.getPlayer(caster.getOwner())
	randNum	= CyGame().getSorenRandNum
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE1:
		pPlot = getPlot(iX+iiX,iY+iiY)
		for i in xrange(pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(i)
			if pUnit.isHasPromotion(iUndead):
				iResist = pUnit.getResistChance(caster, iSpell)
				if randNum(100, "Arawan Beckons resist roll") > iResist:
					pUnit.setHasPromotion(iCalled, True)
						
def reqArawnsCall(caster):
	iUndead = gc.getInfoTypeForString('PROMOTION_UNDEAD')
	iScion = gc.getInfoTypeForString('CIVILIZATION_SCIONS')
	iX = caster.getX()
	iY = caster.getY()
	pPlayer = gc.getPlayer(caster.getOwner())
	eTeam = pPlayer.getTeam()
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE1:
		pPlot = getPlot(iX+iiX,iY+iiY)
		for i in xrange(pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(i)
			if pUnit.isHasPromotion(iUndead):	
				if pUnit.getCivilizationType() != iScion:
					if pPlayer.isHuman():
						return True
					p2Player = gc.getPlayer(pUnit.getOwner())
					e2Team = gc.getTeam(p2Player.getTeam())
					if e2Team.isAtWar(eTeam):
						return True
	return False
					
# Spell for Awakened and Reborn 
def reqAddPop(caster):
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	if (pCity.happyLevel() - pCity.unhappyLevel(0)) < 1:
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if not pPlayer.isHuman():
		if pCity.getOwner() != caster.getOwner():
			return False
	return True

# Used when some Pelemoc spells start a war.	
def spellCB(caster):
	pPlot = caster.plot()
	startWar(caster.getOwner(), pPlot.getOwner(), WarPlanTypes.WARPLAN_LIMITED)

# Many of Pelemoc's spells require that he be in another civ's city.	
def reqStrife(caster):
	pCity = caster.plot().getPlotCity()
	pPlayer = gc.getPlayer(caster.getOwner())
	if pCity.getOwner() == caster.getOwner():
		return False
	return True
	
# req for Succor
def reqSuccor(caster):
	iUH = 0
	pCity = caster.plot().getPlotCity()
	pPlayer = gc.getPlayer(caster.getOwner())
	iUH = pCity.goodHealth() - pCity.badHealth(False)
	if pCity.getOwner() == caster.getOwner():
		return False
	if iUH > -2:
		return False
	return True

# Pelemoc's Subversion spell.	
def spellSubversion(caster,loc):
	pPlot = caster.plot()
	if CyGame().getSorenRandNum(4, "subversion war odds") < 1:
		startWar(caster.getOwner(), pPlot.getOwner(), WarPlanTypes.WARPLAN_LIMITED)
	
	player = caster.getOwner()
	pPlayer = gc.getPlayer(player)
	pCity = pPlayer.getCapitalCity()
	
	iReborn = gc.getInfoTypeForString('UNIT_REBORN')
	spawnUnit = pPlayer.initUnit(iReborn, pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
	
# Pelemoc's Bring Out Your I'm Not Dead Yet spell.	
def spellSuccor(caster,loc):
	pPlot = caster.plot()
	
	player = caster.getOwner()
	pPlayer = gc.getPlayer(player)
	pCity = pPlayer.getCapitalCity()

	iReborn = gc.getInfoTypeForString('UNIT_REBORN')
	spawnUnit = pPlayer.initUnit(iReborn, pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)

# Many spells also require that a particular building not already be present.  This one's for Emperor's Claim.
def reqEclaim(caster):
	pCity = caster.plot().getPlotCity()
	pPlayer = gc.getPlayer(caster.getOwner())
	if pCity.getOwner() == caster.getOwner():
		return False
	if pCity.getNumRealBuilding(gc.getInfoTypeForString('BUILDING_EMPERORS_CLAIM')) > 0:
		return False
	return True

# Req. for Rousing Oration.
def reqOrat(caster):
	pCity = caster.plot().getPlotCity()
	pPlayer = gc.getPlayer(caster.getOwner())
	if pCity.getOwner() == caster.getOwner():
		return False
	if pCity.getNumRealBuilding(gc.getInfoTypeForString('BUILDING_ROUSING_ORATION')) > 0:
		return False
	return True

# Req for Poison Words	
def reqPwords(caster):
	pCity = caster.plot().getPlotCity()
	pPlayer = gc.getPlayer(caster.getOwner())
	if pCity.getOwner() == caster.getOwner():
		return False
	if pCity.getNumRealBuilding(gc.getInfoTypeForString('BUILDING_POISON_WORDS')) > 0:
		return False
	return True

# Req for Corrupt Guild	
def reqPac(caster):
	pCity = caster.plot().getPlotCity()
	pPlayer = gc.getPlayer(caster.getOwner())
	if pCity.getOwner() == caster.getOwner():
		return False
	if pCity.getNumRealBuilding(gc.getInfoTypeForString('BUILDING_CORRUPT_GUILD')) > 0:
		return False
	return True

# Req for Melante's Estate.	
def reqMelante(caster):
	pCity = caster.plot().getPlotCity()
	if pCity.getNumRealBuilding(gc.getInfoTypeForString('BUILDING_PALACE_SCIONS')) > 0:
		return False
	if pCity.getNumRealBuilding(gc.getInfoTypeForString('BUILDING_MELANTE')) > 0:
		return False
	return True

# Req for Thaumaturge's Keep	
def reqAA(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	pCity = caster.plot().getPlotCity()
	if (CyGame().isOption(GameOptionTypes.GAMEOPTION_ONE_CITY_CHALLENGE) and pPlayer.isFeatAccomplished(FeatTypes.FEAT_BUILT_KEEP) == False):
		return True
	if pCity.getNumRealBuilding(gc.getInfoTypeForString('BUILDING_PALACE_SCIONS')) > 0:
		return False
	if pPlayer.isFeatAccomplished(FeatTypes.FEAT_BUILT_KEEP) == True:
		return False
	return True

# Sets up the Thaumaturge's Keep campus.	
def spellAA(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	pPlayer.setFeatAccomplished(FeatTypes.FEAT_BUILT_KEEP, True)
	pCity = caster.plot().getPlotCity()
	caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_MAIN'))
# The line above creates the base Keep building.  The randomly-slected-from lists below add the  buildings - 1 or 2 mana and 1 to 3 other buildings.
	iChance = CyGame().getSorenRandNum(11, "Keep building roll")
	if iChance <= 0:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_FORCE'))
	if iChance == 1:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_ENTROPY'))
	if iChance == 2:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_EARTH'))
	if iChance == 3:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_AIR'))
	if iChance == 4:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_FIRE'))
	if iChance == 5:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_WATER'))
	if iChance == 6:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_SHADOW'))
	if iChance == 7:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_CHAOS'))
	if iChance == 8:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_BODY'))
	if iChance == 9:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_MIND'))	
	if iChance == 10:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_ENCHANTMENT'))
	if iChance == 11:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_METAMAGIC'))
		
	iChance2 = CyGame().getSorenRandNum(13, "Keep building roll 2")
	if iChance2 == iChance:
		iChance2 = 14
	if iChance2 <= 0:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_FORCE'))
	if iChance2 == 1:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_ENTROPY'))
	if iChance2 == 2:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_EARTH'))
	if iChance2 == 3:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_AIR'))
	if iChance2 == 4:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_FIRE'))
	if iChance2 == 5:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_WATER'))
	if iChance2 == 6:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_SHADOW'))
	if iChance2 == 7:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_CHAOS'))
	if iChance2 == 8:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_BODY'))
	if iChance2 == 9:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_MIND'))	
	if iChance2 == 10:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_ENCHANTMENT'))
	if iChance2 == 11:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_METAMAGIC'))
	if iChance2 == 12:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_SCHOLA_FURO'))			
	if iChance2 == 13:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_ALCINUS_TROVE'))
	if iChance2 == 14:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_DEATH'))

	iChance3 = CyGame().getSorenRandNum(3, "Keep building roll 3")
	if iChance3 <= 0:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_MILITARY_ABATTOIR'))
	if iChance3 == 1:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_ALCHEMIST'))

	iChance4 = CyGame().getSorenRandNum(3, "Keep building roll 4")
	if iChance4 <= 0:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_NOXIOUS_SMELL'))
	if iChance4 == 1:
		caster.cast(gc.getInfoTypeForString('SPELL_BUILD_KEEP_CORROSIVE_SPILL'))		


# req for Emperor's Mark.			
def reqEmark(caster):
	pCity = caster.plot().getPlotCity()
	if pCity.getNumRealBuilding(gc.getInfoTypeForString('BUILDING_EMPERORS_MARK')) > 0:
		return False
	return True

# Redactor's Haunted Land creating spell.   - Doesn't change mountains, floodplinas.  Doesn't always work on forests, jungles.
def spellHL(caster):
	pPlot = caster.plot()
	if pPlot.isOwned():
		startWar(caster.getOwner(), pPlot.getOwner(), WarPlanTypes.WARPLAN_LIMITED)
		
	iX = caster.getX()
	iY = caster.getY()
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE1:
		pPlot = getPlot(iX+iiX,iY+iiY)
		if pPlot.isWater() == False:
			if pPlot.isCity() == False:
				if pPlot.isPeak() == False:
					if (pPlot.getFeatureType() == gc.getInfoTypeForString('FEATURE_VOLCANO')) == False:
						if (pPlot.getFeatureType() == gc.getInfoTypeForString('FEATURE_FLOOD_PLAINS')) == False:
							if (pPlot.getFeatureType() == gc.getInfoTypeForString('FEATURE_FOREST_ANCIENT') and (CyGame().getSorenRandNum(3, "HL destroy A_Forest Chance") > 0)) == False:
								if (pPlot.getFeatureType() == gc.getInfoTypeForString('FEATURE_FOREST') and (CyGame().getSorenRandNum(3, "HL destroy Forest Chance") == 0)) == False:
									if (pPlot.getFeatureType() == gc.getInfoTypeForString('FEATURE_JUNGLE') and (CyGame().getSorenRandNum(3, "HL destroy jungle Chance") == 0)) == False:
										pPlot.setFeatureType(gc.getInfoTypeForString('FEATURE_HAUNTED_LANDS'),0)
# Creeper's HL spell.
def spellHL3(caster):
	pPlot = caster.plot()
	pPlot.setFeatureType(gc.getInfoTypeForString('FEATURE_HAUNTED_LANDS'),0)

# Ghostwalker's HL spell.  Also creates Creepers.		
def spellHL2(caster):
	iCreeper = gc.getInfoTypeForString('UNIT_CREEPER')
	pPlot = caster.plot()
	pPlot.setFeatureType(gc.getInfoTypeForString('FEATURE_HAUNTED_LANDS'),0)
	pPlayer = gc.getPlayer(caster.getOwner())
	iChance = CyGame().getSorenRandNum(3, "Create Creeper from HL spell Chance")
	if iChance == 0:
		newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_CREEPER'), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)		
		
	if pPlot.isOwned():
		startWar(caster.getOwner(), pPlot.getOwner(), WarPlanTypes.WARPLAN_LIMITED)

# Creates Creepers when Ghostwalker killed.		
def spelldeadG(caster):
#	iChance = CyGame().getSorenRandNum(3, "Chance")
#	if iChance == 1:
#	caster.cast(gc.getInfoTypeForString('SPELL_CREEPER'))
#	caster.cast(gc.getInfoTypeForString('SPELL_CREEPER'))
	pPlayer = gc.getPlayer(caster.getOwner())
	newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_CREEPER'), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)

# Keeps HL spell from being cast on water or in a HL tile.
def reqHL(caster):
	iHaunted= gc.getInfoTypeForString('FEATURE_HAUNTED_LANDS')
	pPlayer = gc.getPlayer(caster.getOwner())
	pPlot = caster.plot()
	if (pPlot.getFeatureType() == iHaunted):
		return False
	if pPlot.isWater():
		return False
#	iNewForest= gc.getInfoTypeForString('FEATURE_FOREST_NEW')
#	iForest= gc.getInfoTypeForString('FEATURE_FOREST')
#	iAncientForest= gc.getInfoTypeForString('FEATURE_FOREST_ANCIENT')
#	iJungle= gc.getInfoTypeForString('FEATURE_JUNGLE')	
#	if pPlot.getTerrainType() != gc.getInfoTypeForString('TERRAIN_GRASS') and pPlot.getTerrainType() != gc.getInfoTypeForString('TERRAIN_PLAINS') and pPlot.getTerrainType() != gc.getInfoTypeForString('TERRAIN_TUNDRA'):
#		return False
#	if (pPlot.getFeatureType() == iNewForest or pPlot.getFeatureType() == iForest or pPlot.getFeatureType() == iAncientForest or pPlot.getFeatureType() == iJungle):
#		return False
#	if (pPlayer.getCivilizationType() != gc.getInfoTypeForString('CIVILIZATION_SVARTALFAR') and pPlayer.getCivilizationType() != gc.getInfoTypeForString('CIVILIZATION_LJOSALFAR')):
#		if pPlot.isCity():
#			return False
		if pPlot.getImprovementType() != -1:
			return False
	if pPlot.isCity():
		return False
	return True

# Req for Give Gift spell.	
def reqGiveGift(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	pPlot = caster.plot()
	iUndead = gc.getInfoTypeForString('PROMOTION_UNDEAD')
	iGhastlyDragoon = gc.getInfoTypeForString('PROMOTION_GHASTLY_DRAGOON')
	iNaval = gc.getInfoTypeForString('UNITCOMBAT_NAVAL')
	iMounted = gc.getInfoTypeForString('UNITCOMBAT_MOUNTED')
	iSiege = gc.getInfoTypeForString('UNITCOMBAT_SIEGE')
	iGolem = gc.getInfoTypeForString('PROMOTION_GOLEM')
	iScion = gc.getInfoTypeForString('CIVILIZATION_SCIONS')
	iRedLady = gc.getInfoTypeForString('UNIT_KORRINA_RED_LADY')
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isAlive() or pUnit.getUnitCombatType() == iSiege or pUnit.getRace() == iGolem or pUnit.getUnitCombatType() == iNaval):
			if pUnit.isHasPromotion(iUndead) == False:		
				if pUnit.getCivilizationType() == iScion:
					if pUnit.getUnitType() != iRedLady:	 
						return True
		if pUnit.getCivilizationType() == iScion:
			if pUnit.getUnitCombatType() == iMounted:
				if pUnit.isHasPromotion(iGhastlyDragoon) == False:
					return True
	return False

# Redactor spell that makes some non-undead units Undead.
def spellGiveGift(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	pPlot = caster.plot()
	iUndead = gc.getInfoTypeForString('PROMOTION_UNDEAD')
	iGhastlyDragoon = gc.getInfoTypeForString('PROMOTION_GHASTLY_DRAGOON')
	iNaval = gc.getInfoTypeForString('UNITCOMBAT_NAVAL')
	iMounted = gc.getInfoTypeForString('UNITCOMBAT_MOUNTED')
	iSiege = gc.getInfoTypeForString('UNITCOMBAT_SIEGE')
	iGolem = gc.getInfoTypeForString('PROMOTION_GOLEM')
	iScion = gc.getInfoTypeForString('CIVILIZATION_SCIONS')
	iRedLady = gc.getInfoTypeForString('UNIT_KORRINA_RED_LADY')
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)

		if (pUnit.isAlive() or pUnit.getUnitCombatType() == iSiege or pUnit.getRace() == iGolem or pUnit.getUnitCombatType() == iNaval):
				if pUnit.getCivilizationType() == iScion:
					if pUnit.getUnitType() != iRedLady:	 
						pUnit.setHasPromotion(iUndead, True)
		if pUnit.getCivilizationType() == iScion:
			if pUnit.getUnitCombatType() == iMounted:
				pUnit.setHasPromotion(iGhastlyDragoon, True)

# Wraithlord's body 3 spell works via a pyperturn promo.
def effectUPush(caster):
	caster.cast(gc.getInfoTypeForString('SPELL_GRAND_WARD'))

def reqUPush(caster):		
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_GRAND_WARD')):
		return False
	return True

# Used to keep Scions from using normal Body spells.  (Not needed anymore, I believe.)
def reqnotScions(caster):
	if caster.getCivilizationType() == gc.getInfoTypeForString('CIVILIZATION_SCIONS'):
		return False
	return True

# Ghostwalkers can only become Haunts on a HL tile.
def reqHaunt(caster):
	pPlot = caster.plot()
	if pPlot.getFeatureType() != gc.getInfoTypeForString('FEATURE_HAUNTED_LANDS'):
		return False
	return True

# Changes Ghostwalker to a Haunt.
def spellHaunt(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_HAUNT'), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
	for i in range(gc.getNumPromotionInfos()):
		if gc.getPromotionInfo(i).isEquipment() == False:
			newUnit.setHasPromotion(i, caster.isHasPromotion(i))
	newUnit.setDamage(caster.getDamage(), caster.getOwner())
	newUnit.setHasPromotion(gc.getInfoTypeForString('PROMOTION_HAUNT'), True)
	newUnit.setHasPromotion(gc.getInfoTypeForString('PROMOTION_SUBDUE_ANIMAL'), False)
	newUnit.setLevel(caster.getLevel())
	newUnit.setExperienceTimes100(caster.getExperienceTimes100(), -1)# Changes Ghostwalker to a Haunt.
	
def reqHauntKorrina(caster):
	if caster.isMadeAttack():
		return False
	return True
		
def spellHauntKorrina(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_HAUNT_KORRINA'), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
	for i in range(gc.getNumPromotionInfos()):
		if gc.getPromotionInfo(i).isEquipment() == False:
			newUnit.setHasPromotion(i, caster.isHasPromotion(i))
	newUnit.setDamage(caster.getDamage(), caster.getOwner())
	newUnit.setHasPromotion(gc.getInfoTypeForString('PROMOTION_HAUNT_KORRINA'), True)
	newUnit.setHasPromotion(gc.getInfoTypeForString('PROMOTION_INVISIBLE'), True)
	newUnit.setHasPromotion(gc.getInfoTypeForString('PROMOTION_STEALTH'), False)
	newUnit.setLevel(caster.getLevel())
	newUnit.setExperienceTimes100(caster.getExperienceTimes100(), -1)
	newUnit.setHasCasted(True)

def spellKorrinaHaunt(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_KORRINA_BLACK_LADY'), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
	for i in range(gc.getNumPromotionInfos()):
		if gc.getPromotionInfo(i).isEquipment() == False:
			newUnit.setHasPromotion(i, caster.isHasPromotion(i))
	newUnit.setDamage(caster.getDamage(), caster.getOwner())
	newUnit.setHasPromotion(gc.getInfoTypeForString('PROMOTION_HAUNT_KORRINA'), False)
	newUnit.setHasPromotion(gc.getInfoTypeForString('PROMOTION_INVISIBLE'), False)
	newUnit.setHasPromotion(gc.getInfoTypeForString('PROMOTION_STEALTH'), True)
	newUnit.setLevel(caster.getLevel())
	newUnit.setExperienceTimes100(caster.getExperienceTimes100(), -1)
	newUnit.setHasCasted(True)
	newUnit.setMadeAttack(True)

# For the Chan 1 version of Alcinus.
def resMit(caster):
	if CyGame().GetWorldBuilderMode():
		return 0
	bContinue = True
	gc.getGame().decrementUnitClassCreatedCount(caster.getUnitClassType())
	gc.getGame().decrementUnitClassCreatedCount(caster.getUnitClassType())
	if CyGame().getSorenRandNum(100, "Alcinus death defection Check") <= 25 or (caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_ALCINUS_HOSTILE')) == True):
		for iPlayer in range(gc.getMAX_CIV_PLAYERS()):
			pPlayer = gc.getPlayer(iPlayer)
			if (pPlayer.isAlive()):
				if pPlayer.getCivilizationType() == gc.getInfoTypeForString('CIVILIZATION_SCIONS'):
					pCity = pPlayer.getCapitalCity()
					newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_ALCINUS'), pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
					caster.setDamage(95, -1)
					newUnit.convert(caster)
					bContinue = False
	if bContinue:
		listPlayers = []
		for iPlayer in range(gc.getMAX_CIV_PLAYERS()):
			pPlayer = gc.getPlayer(iPlayer)
			if (pPlayer.isAlive()):
				listPlayers.append(pPlayer)
		iGift = CyGame().getSorenRandNum(len(listPlayers), "Who gets Alcinus Gift")
		pCity = listPlayers[iGift].getCapitalCity()
		pPlayer = listPlayers[iGift]
		newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_ALCINUS'), pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		caster.setDamage(95, -1)
		newUnit.convert(caster)
	return 1

# For the Mage version of Alcinus.
def MIT2(caster):
	if CyGame().GetWorldBuilderMode():
		return 0
	bContinue = True
	gc.getGame().decrementUnitClassCreatedCount(caster.getUnitClassType())
	gc.getGame().decrementUnitClassCreatedCount(caster.getUnitClassType())
	if CyGame().getSorenRandNum(100, "Alcinus death defection Check") <= 25 or (caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_ALCINUS_HOSTILE')) == True):
		for iPlayer in range(gc.getMAX_CIV_PLAYERS()):
			pPlayer = gc.getPlayer(iPlayer)
			if (pPlayer.isAlive()):
				if pPlayer.getCivilizationType() == gc.getInfoTypeForString('CIVILIZATION_SCIONS'):
					pCity = pPlayer.getCapitalCity()
					newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_ALCINUS_UPGRADED'), pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
					caster.setDamage(95, -1)
					newUnit.convert(caster)
					bContinue = False
	if bContinue:
		listPlayers = []
		for iPlayer in range(gc.getMAX_CIV_PLAYERS()):
			pPlayer = gc.getPlayer(iPlayer)
			if (pPlayer.isAlive()):
				listPlayers.append(pPlayer)
		iGift = CyGame().getSorenRandNum(len(listPlayers) * 1, "Alcinus death Gift")
		pCity = listPlayers[iGift].getCapitalCity()
		pPlayer = listPlayers[iGift]
		newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_ALCINUS_UPGRADED'), pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		caster.setDamage(95, -1)
		newUnit.convert(caster)
		return 1

# For the Archmage version of Alcinus.
def MIT3(caster):
	if CyGame().GetWorldBuilderMode():
		return 0
	bContinue = True
	gc.getGame().decrementUnitClassCreatedCount(caster.getUnitClassType())
	gc.getGame().decrementUnitClassCreatedCount(caster.getUnitClassType())
	if CyGame().getSorenRandNum(100, "Alcinus death defection Check") <= 25 or (caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_ALCINUS_HOSTILE')) == True):
		for iPlayer in range(gc.getMAX_CIV_PLAYERS()):
			pPlayer = gc.getPlayer(iPlayer)
			if (pPlayer.isAlive()):
				if pPlayer.getCivilizationType() == gc.getInfoTypeForString('CIVILIZATION_SCIONS'):
					pCity = pPlayer.getCapitalCity()
					newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_ALCINUS_ARCHMAGE'), pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
					caster.setDamage(95, -1)
					newUnit.convert(caster)
					bContinue = False
	if bContinue:
		listPlayers = []
		for iPlayer in range(gc.getMAX_CIV_PLAYERS()):
			pPlayer = gc.getPlayer(iPlayer)
			if (pPlayer.isAlive()):
				listPlayers.append(pPlayer)
		iGift = CyGame().getSorenRandNum(len(listPlayers) * 1, "Alcinus death Gift")
		pCity = listPlayers[iGift].getCapitalCity()
		pPlayer = listPlayers[iGift]
		newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_ALCINUS_ARCHMAGE'), pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		caster.setDamage(95, -1)
		newUnit.convert(caster)
		return 1

# Per-turn check to return non-barbarian Haunts to Ghostwalker.
def checkHaunt(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isBarbarian():
		return
	if CyGame().getSorenRandNum(4, "Haunt to Ghostwalker Check") >= 1:
		return
	newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_GHOSTWALKER'), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
	for i in range(gc.getNumPromotionInfos()):
		if gc.getPromotionInfo(i).isEquipment() == False:
			newUnit.setHasPromotion(i, caster.isHasPromotion(i))
	newUnit.setDamage(caster.getDamage(), caster.getOwner())
	newUnit.setHasPromotion(gc.getInfoTypeForString('PROMOTION_SUBDUE_ANIMAL'), True)
	newUnit.setHasPromotion(gc.getInfoTypeForString('PROMOTION_HAUNT'), False)
	newUnit.setLevel(caster.getLevel())
	newUnit.setExperienceTimes100(caster.getExperienceTimes100(), -1)
	caster.kill(True, 0)

# MoP don't always use suicide attacks, and never aginast workers and hawks.
def mopsuicide(pCaster, pOpponent):
	if (pOpponent.getUnitClassType() == gc.getInfoTypeForString('UNITCLASS_HAWK')):
		return
	if (pOpponent.getUnitCombatType() == gc.getInfoTypeForString('UNITCOMBAT_WORKER')):
		return
	if CyGame().getSorenRandNum(3, "MoP suicide attack Check") > 1:
		pCaster.kill(True, 0)

# Req for Feeding Creepers.
def reqPlant(caster):
	pPlot = caster.plot()
	iCreeper = gc.getInfoTypeForString('UNIT_CREEPER')
	iPPromo = gc.getInfoTypeForString('PROMOTION_FED_CREEPER')
	iPSent = gc.getInfoTypeForString('PROMOTION_SENTRY2')
	if caster.getExperience() < 4:
			return False
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.getUnitType() == iCreeper:
			if pUnit.isHasPromotion(iPSent):
				return True
	return False

# Req for Dark Council spell.  Makes sure the whole Council is assembled in 1 square. 
## VEHEM: Rewritten to use named booleans to keep track of each member - easier to read.

def reqDarkC(caster):
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	iPelemoc = gc.getInfoTypeForString('UNIT_PELEMOC')
	iThemoch = gc.getInfoTypeForString('UNIT_THEMOCH')
	iAlcinus = gc.getInfoTypeForString('UNIT_ALCINUS')
	iAlcinus2 = gc.getInfoTypeForString('UNIT_ALCINUS_UPGRADED')
	iAlcinus3 = gc.getInfoTypeForString('UNIT_ALCINUS_ARCHMAGE')
	
	if pPlayer.isHuman() == False:
		return True
	
	bPelemocPresent = False
	bThemochPresent = False
	bAlcinusPresent = False

	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)

		if pUnit.getUnitType() == iPelemoc:
			bPelemocPresent = True	

		if pUnit.getUnitType() == iThemoch:
			bThemochPresent = True

		if pUnit.getUnitType() == iAlcinus or pUnit.getUnitType() == iAlcinus2 or pUnit.getUnitType() == iAlcinus3:
			bAlcinusPresent = True
			
	if bPelemocPresent and bThemochPresent and bAlcinusPresent:
		return True
	
	return False
	
def reqSpiralGate(caster):
	pPlayer = gc.getPlayer(caster.getOwner())		
	eTeam = gc.getTeam(pPlayer.getTeam())	
	
	if pPlayer.isHuman() == False:
		iCastingChance = -1
		if eTeam.isHasTech(gc.getInfoTypeForString('TECH_ARCANE_LORE')) == True:
			iCastingChance += 1
		if eTeam.isHasTech(gc.getInfoTypeForString('TECH_RELIGIOUS_LAW')) == True:
			iCastingChance += 2
		if eTeam.isHasTech(gc.getInfoTypeForString('TECH_MITHRIL_WORKING')) == True:
			iCastingChance += 2
		if eTeam.isHasTech(gc.getInfoTypeForString('TECH_GUILDS')) == True:
			iCastingChance += 2
		if eTeam.isHasTech(gc.getInfoTypeForString('TECH_ENGINEERING')) == True:
			iCastingChance += 2
		if CyGame().getSorenRandNum(199, "AI chance for Spiral Gate") < iCastingChance:
			return True
			
	return True
	
def spellSpiralGate(argslist):
	if isinstance( argslist, tuple ):
		makeHelpText = True
		eSpell, caster = argslist
	else:
		caster = argslist
		makeHelpText=False
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	eTeam = gc.getTeam(pPlayer.getTeam())
	
	bonusCategory = dict()
	bonusCategory['false laroth'] = dict()
	bonusCategory['archer'] = dict()
	bonusCategory['adept'] = dict()
	bonusCategory['melee'] = dict()
	bonusCategory['recon'] = dict()
	bonusCategory['mounted'] = dict()
	bonusCategory['supplies'] = dict()
	bonusCategory['population'] = dict()
	bonusCategory['creeper'] = dict()
	unitUpgrades = dict()
	
	# A list of units to be given
	# Each unit is described with a tuple
	# ( unitString, bonusCategoryName, promotionList, name)
	giveUnits = []
	giveUnits.append( ( 'UNIT_NECROMANCER', 'false laroth', ['PROMOTION_DEATH1', 'PROMOTION_DEATH2', 'PROMOTION_SPIRIT1', 'PROMOTION_SPIRIT2', 'PROMOTION_SHADOW1', 'PROMOTION_SHADOW2', 'PROMOTION_COMBAT1', 'PROMOTION_COMBAT2', 'PROMOTION_HIDDEN', 'PROMOTION_ADVENTURER', ], CyTranslator().getText('TXT_KEY_UNIT_FALSE_LAROTH',() ) ) )
	bonusCategory['false laroth']['xp'] = 10
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_ARCHERY') ):
		giveUnits.append( ( 'UNIT_ARCHER', 'archer', ['PROMOTION_ADVENTURER', ],  'Anyon' ) )
		giveUnits.append( ( 'UNIT_ARCHER', 'archer', ['PROMOTION_ADVENTURER', ],  'Lann' ) )
		giveUnits.append( ( 'UNIT_CREEPER', 'creeper', ['PROMOTION_CREEPER_ROOTED'],  '' ) )
		giveUnits.append( ( 'UNIT_CREEPER', 'creeper', ['PROMOTION_CREEPER_YOUNG'],  '' ) )
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_BRONZE_WORKING') ):
		giveUnits.append( ( 'UNIT_HONORED_BAND', 'melee', ['PROMOTION_ADVENTURER', ],  'Medb' ) )
		giveUnits.append( ( 'UNIT_HONORED_BAND', 'melee', ['PROMOTION_ADVENTURER', ],  'Aife' ) )
		bonusCategory['melee']['weapons'] = 'PROMOTION_BRONZE_WEAPONS'
		bonusCategory['false laroth']['weapons'] = 'PROMOTION_BRONZE_WEAPONS'
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_IRON_WORKING') ):
		giveUnits.append( ( 'UNIT_PRINCIPES', 'melee', ['PROMOTION_ADVENTURER', ],  'Scathach' ) )
		giveUnits.append( ( 'UNIT_PRINCIPES', 'melee', ['PROMOTION_ADVENTURER', ],  'Voadica' ) )
		giveUnits.append( ( 'UNIT_HONORED_BAND', 'melee', [],  '' ) )
		bonusCategory['melee']['weapons'] = 'PROMOTION_IRON_WEAPONS'
		bonusCategory['false laroth']['weapons'] = 'PROMOTION_IRON_WEAPONS'
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_TRADE')):
		giveUnits.append( ( 'UNIT_SPIRAL_SUPPLIES', 'supplies', [],  '' ) )
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_STIRRUPS')):
		giveUnits.append( ( 'UNIT_HORSE_ARCHER', 'mounted', [],  '' ) )
		giveUnits.append( ( 'UNIT_HORSE_ARCHER', 'mounted', [],  '' ) )
		giveUnits.append( ( 'UNIT_CREEPER', 'creeper', ['PROMOTION_CREEPER_BLOOMING'],  '' ) )
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_WARHORSES')):
		giveUnits.append( ( 'UNIT_HORSE_ARCHER', 'mounted', [],  '' ) )
		giveUnits.append( ( 'UNIT_HORSE_ARCHER', 'mounted', [],  '' ) )
		giveUnits.append( ( 'UNIT_HORSE_ARCHER', 'mounted', [],  '' ) )
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_ARMORED_CAVALRY')):
		giveUnits.append( ( 'UNIT_HORSE_ARCHER', 'mounted', ['PROMOTION_COMBAT1', ],  '' ) )
		giveUnits.append( ( 'UNIT_HORSE_ARCHER', 'mounted', ['PROMOTION_COMBAT1', ],  '' ) )
		giveUnits.append( ( 'UNIT_SPIRAL_SUPPLIES', 'supplies', [],  '' ) )
		giveUnits.append( ( 'UNIT_SPIRAL_SUPPLIES', 'supplies', [],  '' ) )
		bonusCategory['mounted']['xp'] = 10
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_ANIMAL_HANDLING')):
		giveUnits.append( ( 'UNIT_CETRATUS', 'recon', [],  '' ) )
		giveUnits.append( ( 'UNIT_CETRATUS', 'recon', [],  '' ) )
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_FERAL_BOND')):
		giveUnits.append( ( 'UNIT_GHOSTWALKER', 'recon', [],  '' ) )
		giveUnits.append( ( 'UNIT_GHOSTWALKER', 'recon', [],  '' ) )
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_ANIMAL_MASTERY')):
		giveUnits.append( ( 'UNIT_GHOSTWALKER', 'recon', ['PROMOTION_ADVENTURER', ],  'Gurith' ) )
		giveUnits.append( ( 'UNIT_GHOSTWALKER', 'recon', ['PROMOTION_ADVENTURER', 'PROMOTION_COMBAT1', 'PROMOTION_COMBAT2', ],  'Fathen' ) )
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		giveUnits.append( ( 'UNIT_CREEPER', 'creeper', ['PROMOTION_CREEPER_BLOOMING'],  '' ) )
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_SMELTING')):
		giveUnits.append( ( 'UNIT_HONORED_BAND', 'melee', [],  '' ) )
		giveUnits.append( ( 'UNIT_SPIRAL_SUPPLIES', 'supplies', [],  '' ) )
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		giveUnits.append( ( 'UNIT_CREEPER', 'creeper', ['PROMOTION_CREEPER_MATURE'],  '' ) )
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_SANITATION')):
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_MEDICINE')):
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		giveUnits.append( ( 'UNIT_CREEPER', 'creeper', [],  '' ) )
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_MITHRIL_WORKING')):
		giveUnits.append( ( 'UNIT_SPIRAL_SUPPLIES', 'supplies', [],  '' ) )
		giveUnits.append( ( 'UNIT_PHALANX', 'melee', [ ],  '' ) )
		giveUnits.append( ( 'UNIT_PHALANX', 'melee', [],  '' ) )
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		bonusCategory['melee'].setdefault( 'promotions', [] ).append( 'PROMOTION_ENCHANTED_BLADE' )
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_ASTRONOMY')):
		giveUnits.append( ( 'UNIT_SPIRAL_SUPPLIES', 'supplies', [],  '' ) )
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_BOWYERS')):
		giveUnits.append( ( 'UNIT_LONGBOWMAN', 'archer', [],  '' ) )
		giveUnits.append( ( 'UNIT_LONGBOWMAN', 'archer', [],  '' ) )
		giveUnits.append( ( 'UNIT_LONGBOWMAN', 'archer', [],  '' ) )
		giveUnits.append( ( 'UNIT_CREEPER', 'creeper', [],  '' ) )
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_PRECISION')):
		giveUnits.append( ( 'UNIT_LONGBOWMAN', 'archer', [],  '' ) )
		giveUnits.append( ( 'UNIT_LONGBOWMAN', 'archer', [],  '' ) )
		giveUnits.append( ( 'UNIT_MARKSMAN', 'archer', ['PROMOTION_ADVENTURER', ],  'Tadc' ) )
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_TAXATION')):
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		giveUnits.append( ( 'UNIT_CREEPER', 'creeper', ['PROMOTION_CREEPER_BLOOMING'],  '' ) )
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_GUILDS')):
		giveUnits.append( ( 'UNIT_SPIRAL_SUPPLIES', 'supplies', [],  '' ) )
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_MERCANTILISM')):
		giveUnits.append( ( 'UNIT_SPIRAL_SUPPLIES', 'supplies', [],  '' ) )
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_MILITARY_STRATEGY')):
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		bonusCategory['melee']['xp'] = 6
		bonusCategory['archer']['xp'] = 6
		bonusCategory['recon']['xp'] = 6
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_ENGINEERING')):
		giveUnits.append( ( 'UNIT_SPIRAL_SUPPLIES', 'supplies', [],  '' ) )
		giveUnits.append( ( 'UNIT_CATAPULT', 'supplies', ['PROMOTION_ASSAULT1', ],  '' ) )
		giveUnits.append( ( 'UNIT_CATAPULT', 'supplies', ['PROMOTION_BARRAGE1', ],  '' ) )
		giveUnits.append( ( 'UNIT_CREEPER', 'creeper', ['PROMOTION_CREEPER_BLOOMING'],  '' ) )
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_BLASTING_POWDER')):
		giveUnits.append( ( 'UNIT_BONE_HORDE', 'archer', [],  '' ) )
		giveUnits.append( ( 'UNIT_BONE_HORDE', 'archer', [],  '' ) )
		giveUnits.append( ( 'UNIT_BONE_HORDE', 'archer', [],  '' ) )
		giveUnits.append( ( 'UNIT_BONE_HORDE', 'archer', [],  '' ) )
		giveUnits.append( ( 'UNIT_CREEPER', 'creeper', ['PROMOTION_CREEPER_MATURE'],  '' ) )
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_SORCERY')):
		unitUpgrades['UNIT_ADEPT'] = 'UNIT_NECROMANCER'
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_ARCANE_LORE')):
		giveUnits.append( ( 'UNIT_NECROMANCER', 'adept', ['PROMOTION_DEATH1', 'PROMOTION_DEATH2', ], '' ) )
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_STRENGTH_OF_WILL')):
		giveUnits.append( ( 'UNIT_NECROMANCER', 'adept', ['PROMOTION_DEATH1', 'PROMOTION_DEATH2', 'PROMOTION_COMBAT1', ], '' ) )
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_PASS_THROUGH_THE_ETHER')):
		giveUnits.append( ( 'UNIT_NECROMANCER', 'adept', ['PROMOTION_DEATH1', 'PROMOTION_COMBAT2', 'PROMOTION_COMBAT1', ], '' ) )
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		giveUnits.append( ( 'UNIT_SPIRAL_SUPPLIES', 'supplies', [],  '' ) )
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_MACHINERY')):
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		giveUnits.append( ( 'UNIT_CATAPULT', 'supplies', [],  '' ) )
		giveUnits.append( ( 'UNIT_CATAPULT', 'supplies', [],  '' ) )
		giveUnits.append( ( 'UNIT_SPIRAL_SUPPLIES', 'supplies', [],  '' ) )
		giveUnits.append( ( 'UNIT_CREEPER', 'creeper', ['PROMOTION_CREEPER_YOUNG'],  '' ) )
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_OMNISCIENCE')):
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		giveUnits.append( ( 'UNIT_NECROMANCER', 'adept', ['PROMOTION_DEATH1', 'PROMOTION_DEATH2', 'PROMOTION_COMBAT1', 'PROMOTION_COMBAT2', 'PROMOTION_COMBAT3', ], '' ) )
		giveUnits.append( ( 'UNIT_NECROMANCER', 'adept', ['PROMOTION_DEATH1', 'PROMOTION_DEATH2', 'PROMOTION_COMBAT1', 'PROMOTION_FIRE1', 'PROMOTION_FIRE2', 'PROMOTION_ADVENTURER', ], 'Tetricues' ) )
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_DIVINATION')):
		bonusCategory['adept']['xp'] = bonusCategory['adept'].get('xp', 0 ) +2		
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_ALTERATION')):
		giveUnits.append( ( 'UNIT_GHOSTWALKER', 'recon', ['PROMOTION_ILLUSION', 'PROMOTION_ADVENTURER', ],  'Otal the Faded' ) )
		bonusCategory['adept']['xp'] = bonusCategory['adept'].get('xp', 0 ) +2		
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_NECROMANCY')):
		bonusCategory['adept']['xp'] = bonusCategory['adept'].get('xp', 0 ) +2
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_ELEMENTALISM')):
		bonusCategory['archer'].setdefault( 'promotions', [] ).append( 'PROMOTION_FLAMING_ARROWS' )
		bonusCategory['adept']['xp'] = bonusCategory['adept'].get('xp', 0 ) +2		
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_RELIGIOUS_LAW')):
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		giveUnits.append( ( 'UNIT_CREEPER', 'creeper', ['PROMOTION_CREEPER_YOUNG'],  '' ) )
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_THEOLOGY')):
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_COMMUNE_WITH_NATURE')):
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_FANATICISM')):
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		giveUnits.append( ( 'UNIT_REVENANT', 'melee', ['PROMOTION_ADVENTURER', ],  'Rasaec the Hollow' ) ) # Revenants are disciples, but very melee like disciples
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_MALEVOLENT_DESIGNS')):
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_RIGHTEOUSNESS')):
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		giveUnits.append( ( 'UNIT_CREEPER', 'creeper', ['PROMOTION_CREEPER_BLOOMING'],  '' ) )
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_DIVINE_ESSENCE')):
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		giveUnits.append( ( 'UNIT_AWAKENED', 'population', [],  '' ) )
		giveUnits.append( ( 'UNIT_ABOMINATION', 'melee', [],  '' ) )

	if not makeHelpText:
		pCapital = pPlayer.getCapitalCity()
		capitalX = pCapital.getX()
		capitalY = pCapital.getY()
		bestPlotGoodness = -1
		iBestPlot = None
		for i in xrange (CyMap().numPlots()):
			pPlot = CyMap().plotByIndex(i)
			plotGoodness = -1
			if ( pPlot.getOwner() != iPlayer 
				and not pPlot.isWater() 
				and pPlot.getNumUnits() == 0 
				and not pPlot.isCity()
				and not pPlot.isImpassable() ):
					plotGoodness = CyGame().getSorenRandNum(500, "Place Spiral Gate")
					# I'm placing a limit on the added goodness.
					# This makes final goodness a bit less map dependant and less predictable.
					# The limits will need finetuning.
					# With a limit of 250, all continents with at least 175 tiles are equally good.
					plotGoodness += min( pPlot.area().getNumTiles() * 2, 100 )
					# With a limit of 500, all continents with at least 100 unclaimed tiles are equally good.
					plotGoodness += min( pPlot.area().getNumUnownedTiles() * 5, 400 )
					# Distance to capital is squared, since area is squared
					# With a limit of 450, all tiles further away than 450**.5 or 21 squares are equally good
					plotGoodness += min( ( (pPlot.getX()-capitalX)**2 + (pPlot.getY()-capitalY)**2 ), 750)
					if not pPlot.isOwned():
						plotGoodness += 300
			if plotGoodness > bestPlotGoodness:
				bestPlotGoodness = plotGoodness
				pBestPlot = pPlot
		if pBestPlot is None: 
			# It's a world spell, it shouldn't fail just because. Probably won't anyway
			# but just to be sure.
			pBestPlot = pCapital.plot()
		
		pBestPlot.setFeatureType(gc.getInfoTypeForString('FEATURE_HAUNTED_LANDS'),0)
		
		commonInitUnitArgs = ( pBestPlot.getX(), pBestPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_NORTH )
		for unitString, bonusCategoryName, promotionList, name in giveUnits:
			while unitString in unitUpgrades:
				unitString = unitUpgrades[unitString]
			newUnit = pPlayer.initUnit( gc.getInfoTypeForString(unitString), *commonInitUnitArgs )
			for promotionString in promotionList:
				newUnit.setHasPromotion( gc.getInfoTypeForString( promotionString ), True)
			if 'promotions' in bonusCategory[bonusCategoryName]:
				for promotionString in bonusCategory[bonusCategoryName]['promotions']:
					newUnit.setHasPromotion( gc.getInfoTypeForString( promotionString ), True)
			if 'weapons' in bonusCategory[bonusCategoryName]:
				newUnit.setHasPromotion( gc.getInfoTypeForString( bonusCategory[bonusCategoryName]['weapons'] ), True)
			if 'xp' in bonusCategory[bonusCategoryName]:
				newUnit.setExperienceTimes100(bonusCategory[bonusCategoryName]['xp']*100, -1)
			if name:
				newUnit.setName(name)
				
	else:
		counts = dict( (key,0) for key in [ 'False laroth', 'archer', 'adept', 'melee', 'recon', 'mounted', 'supplies', 'creeper', 'population' ])
		for unitString, bonusCategoryName, promotionList, name in giveUnits:
			counts[unitString] = counts.get( unitString, 0) +1
			counts[bonusCategoryName] += 1
		counts['military'] = sum( c for key, c in counts.iteritems() if key in set( [ 'False laroth', 'archer', 'adept', 'melee', 'recon', 'mounted', ] ) )
		templateHelpString = 'Treachery in the Land of the Dead.  A False Laroth steals away additional subjects for the Scions.  Currently casting this spell will give %(military)i military units, %(supplies)i supplies, %(population)i Awakened, and %(creeper)i Creepers.  The units will appear in a random, probably distant, location.'
		return templateHelpString % counts
		
# "Feed" spell - Ghostwalkers spend xps to allow Creepers to create HL - The Creeper spell requires the Sentry2 promo.
def spellPlant(caster):
	pPlot = caster.plot()
	caster.changeExperience(-3, -1, False, False, False)
	iCreeper = gc.getInfoTypeForString('UNIT_CREEPER')
	iPPromo = gc.getInfoTypeForString('PROMOTION_FED_CREEPER')
	iPSent = gc.getInfoTypeForString('PROMOTION_SENTRY2')
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.getUnitType() == iCreeper:
			if pUnit.isHasPromotion(iPSent):
				pUnit.setHasPromotion(iPPromo, True)
				pUnit.setHasPromotion(iPSent, False)
				return

# Req for Corrupt Quartermaster
def reqOTT(caster):
	pPlot = caster.plot()
	iPPromo = gc.getInfoTypeForString('PROMOTION_CORRUPT_QUARTERMASTER')
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (caster.getOwner() != pUnit.getOwner()):
			if pUnit.isHasPromotion(gc.getInfoTypeForString('PROMOTION_CORRUPT_QUARTERMASTER')) == False:
				return True
	return False

# Corrupt Quartermaster	
def spellOTT(caster):
	pPlot = caster.plot()
	iPPromo = gc.getInfoTypeForString('PROMOTION_CORRUPT_QUARTERMASTER')
	iAnimal = gc.getInfoTypeForString('UNITCOMBAT_ANIMAL')
	iBeast = gc.getInfoTypeForString('UNITCOMBAT_BEAST')
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.getUnitCombatType() != iAnimal:
			if pUnit.getUnitCombatType() != iBeast:
				if (caster.getOwner() != pUnit.getOwner()):
#			if pUnit.isHasPromotion(iPPromo):
					if pUnit.isHasPromotion(gc.getInfoTypeForString('PROMOTION_CORRUPT_QUARTERMASTER')) == False:
						pUnit.setHasPromotion(iPPromo, True)
						return

# Pelemoc's Horsemen.  Gives Pelemoc and effect promo and carries slight chance for war.
def effectSuperSchemer(caster):
	pCity = caster.plot().getPlotCity()
	iUH = CyGame().getSorenRandNum(15, "Pelemocs Horsemen anger amount")
#	if CyGame().getSorenRandNum(10, "AirEllySpawn") < 5:
#		pCity.changeHappinessTimer(-3)
#		pCity.changeExtraHappiness(-1)
	pCity.changeHurryAngerTimer(iUH)
	
	caster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_SUPER_SCHEMER'), True)
	
#	if CyGame().getSorenRandNum(150, "Pelemocs Horesman war odds") == 1:
#		startWar(caster.getOwner(), pPlot.getOwner(), WarPlanTypes.WARPLAN_LIMITED)

# Req for Pelemoc's Horsemen
def reqSuperSchemer(caster):
	pCity = caster.plot().getPlotCity()
	pPlayer = gc.getPlayer(caster.getOwner())
	if pCity.getOwner() == caster.getOwner():
		return False
	return True

# Req for Arawn's Dust	
def reqSpoil(caster):
	pPlot = caster.plot()
#	pUnit = pPlot.getUnit(i)
	iFarm = gc.getInfoTypeForString('IMPROVEMENT_FARM')
	iPasture = gc.getInfoTypeForString('IMPROVEMENT_PASTURE')
	iPlantation = gc.getInfoTypeForString('IMPROVEMENT_PLANTATION')
	iCamp = gc.getInfoTypeForString('IMPROVEMENT_CAMP')
#	iPPromo = gc.getInfoTypeForString('PROMOTION_PLANT')
	if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_FED_CREEPER')):
		return False
	if pPlot.getImprovementType() == iFarm:
		return True
	if pPlot.getImprovementType() == iCamp:
		return True
	if pPlot.getImprovementType() == iPasture:
		return True
	if pPlot.getImprovementType() == iPlantation:
		return True
	return False

# Arawn's Dust	
def spellSpoil(caster):
	pPlot = caster.plot()
	pPlot.setImprovementType(-1)
	caster.kill(True, 0)
	
def spellSeekAlcinus(caster):
		
	iAlcinus1 = gc.getInfoTypeForString('UNIT_ALCINUS')
	iAlcinus2 = gc.getInfoTypeForString('UNIT_ALCINUS_UPGRADED')
	iAlcinus3 = gc.getInfoTypeForString('UNIT_ALCINUS_ARCHMAGE')
	
	for iPlayer in range(gc.getMAX_PLAYERS()):
		pPlayer = gc.getPlayer(iPlayer)
		py = PyPlayer(iPlayer)
		if (pPlayer.isAlive()):
			for pUnit in py.getUnitList():	
				if pUnit.getUnitType() == iAlcinus1 or pUnit.getUnitType() == iAlcinus2 or pUnit.getUnitType() == iAlcinus3:
					pPlot = pUnit.plot()
					pPlayer = gc.getPlayer(caster.getOwner())
					iTeam = pPlayer.getTeam()
					pPlot.setRevealed(iTeam, True, False, TeamTypes.NO_TEAM)
					CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("We have found the traitor!", ()),'',1,'Art/Interface/Buttons/Units/Scions/MIT.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
					
def effectDyingCreeper(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	
	iChance = CyGame().getSorenRandNum(3, "Dying Creeper death chance")
	if iChance == 0:
		newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_CREEPER'), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)		
	caster.kill(True,0)
	
def reqManifestHornedDread(caster):

	iGhostwalker = gc.getInfoTypeForString('UNIT_GHOSTWALKER')
	iHornedDreadPromo = gc.getInfoTypeForString('PROMOTION_HORNED_DREAD')

	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isFeatAccomplished(FeatTypes.FEAT_MANIFEST_HORNED_DREAD) == False:
		return False
	if pPlayer.isFeatAccomplished(FeatTypes.FEAT_MANIFEST_FIRST_HORNED_DREAD) == False:
		return False

	if caster.isHasPromotion(iHornedDreadPromo):
		return False

	return True

def spellManifestHornedDread(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	py = PyPlayer(caster.getOwner())
	pPlayer.setFeatAccomplished(FeatTypes.FEAT_MANIFEST_HORNED_DREAD, False)
	
	iGhostwalker = gc.getInfoTypeForString('UNIT_GHOSTWALKER')
	iHornedDreadPromo = gc.getInfoTypeForString('PROMOTION_HORNED_DREAD')

	for pUnit in py.getUnitList():
		if pUnit.getUnitType() == iGhostwalker:
			if pUnit.isHasPromotion(iHornedDreadPromo):
				pUnit.setHasPromotion(iHornedDreadPromo, False)
				
	caster.setHasPromotion(iHornedDreadPromo, True)
	
def reqManifestFirstHornedDread(caster):
	pPlayer = gc.getPlayer(caster.getOwner())

	if pPlayer.isFeatAccomplished(FeatTypes.FEAT_MANIFEST_FIRST_HORNED_DREAD) == True:
		return False

	return True

def spellManifestFirstHornedDread(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	pPlayer.setFeatAccomplished(FeatTypes.FEAT_MANIFEST_FIRST_HORNED_DREAD, True)
	
	iGhostwalker = gc.getInfoTypeForString('UNIT_GHOSTWALKER')
	iHornedDreadPromo = gc.getInfoTypeForString('PROMOTION_HORNED_DREAD')

	caster.setHasPromotion(iHornedDreadPromo, True)
	
# Scions end
def reqLoyalty(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	pPlot = caster.plot()
	iLoyalty = gc.getInfoTypeForString('PROMOTION_LOYALTY')
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (caster.getTeam() == pUnit.getTeam() and not pUnit.isHasPromotion(iLoyalty)):
			return True
	return False

def spellLoyalty(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	pPlot = caster.plot()
	iEnraged = gc.getInfoTypeForString('PROMOTION_ENRAGED')
	iFreelancer = gc.getInfoTypeForString('PROMOTION_FREELANCER_EFFECT')
	iSuppressedRage = gc.getInfoTypeForString('PROMOTION_SUPPRESSED_RAGE')
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (caster.getTeam() == pUnit.getTeam() and (pUnit.isHasPromotion(iEnraged) or pUnit.isHasPromotion(iFreelancer))):
			pUnit.setHasPromotion(iEnraged, False)
			pUnit.setHasPromotion(iFreelancer, False)
			pUnit.setHasPromotion(iSuppressedRage, True)
			
def reqMotherDevour(caster):
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	
	iBroodStrength = 4

	if pCity.getPopulation() < 4:
		return False

	if pCity.getNumBuilding(gc.getInfoTypeForString('BUILDING_ARCHOS_NEST_ADDON1')) > 0:
		iBroodStrength = 5
		if pCity.getPopulation() < 8:
			return False		
	elif pCity.getNumBuilding(gc.getInfoTypeForString('BUILDING_ARCHOS_NEST_ADDON2')) > 0:
		iBroodStrength = 6
		if pCity.getPopulation() < 12:
			return False
	elif pCity.getNumBuilding(gc.getInfoTypeForString('BUILDING_ARCHOS_NEST_ADDON3')) > 0:
		iBroodStrength = 7
		if pCity.getPopulation() < 15:
			return False
	elif pCity.getNumBuilding(gc.getInfoTypeForString('BUILDING_ARCHOS_NEST_ADDON4')) > 0:
		return False

	if caster.getLevel() >= iBroodStrength:
		return True
	
	return False
	
def spellMotherDevour(caster):
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	iAddon1 = gc.getInfoTypeForString('BUILDING_ARCHOS_NEST_ADDON1') 
	iAddon2 = gc.getInfoTypeForString('BUILDING_ARCHOS_NEST_ADDON2')
	iAddon3 = gc.getInfoTypeForString('BUILDING_ARCHOS_NEST_ADDON3')
	iAddon4 = gc.getInfoTypeForString('BUILDING_ARCHOS_NEST_ADDON4')

	if pCity.getNumBuilding(iAddon3) > 0:
		pCity.setNumRealBuilding(iAddon3, 0)
		pCity.setNumRealBuilding(iAddon4, 1)

	elif pCity.getNumBuilding(iAddon2) > 0:
		pCity.setNumRealBuilding(iAddon2, 0)
		pCity.setNumRealBuilding(iAddon3, 1)

	elif pCity.getNumBuilding(iAddon1) > 0:
		pCity.setNumRealBuilding(iAddon1, 0)
		pCity.setNumRealBuilding(iAddon2, 1)

	else: 
		pCity.setNumRealBuilding(iAddon1, 1)

def reqOasis(caster):
	pPlot = caster.plot()
	if pPlot.getTerrainType() != gc.getInfoTypeForString('TERRAIN_DESERT'):
		return False
	if pPlot.isCity():
		return False
	if pPlot.getImprovementType() != -1:
		return False
	if pPlot.getFeatureType() == gc.getInfoTypeForString('FEATURE_FLOOD_PLAINS'):
		return False
	iOasis = gc.getInfoTypeForString('FEATURE_OASIS')
	iDesert = gc.getInfoTypeForString('TERRAIN_DESERT')
	iX = caster.getX()
	iY = caster.getY()
	getPlot	= CyMap().plot
	for iiX in range(iX-4, iX+5, 1):
		for iiY in range(iY-4, iY+5, 1):
			pPlot = getPlot(iiX,iiY)
			if not pPlot.isNone():
				iFeature = pPlot.getFeatureType()
				if iFeature == iOasis:
					return False
	for iiX,iiY in RANGE1:
		pPlot = getPlot(iX+iiX,iY+iiY)
		if not pPlot.isNone():
			sValidTerrains = ['DESERT', 'COAST', 'OCEAN']
			iValidTerrains = [gc.getInfoTypeForString('TERRAIN_' + sTerrain) for sTerrain in sValidTerrains]
			if not (pPlot.getTerrainType() in iValidTerrains):
				return False
	return True

def spellOasis(caster):
	pPlot = caster.plot()
	pPlot.setFeatureType(gc.getInfoTypeForString('FEATURE_OASIS'),0)
	
def reqDesertStealth(caster):
	pPlot = caster.plot()
	if pPlot.getTerrainType() == gc.getInfoTypeForString('TERRAIN_DESERT'):
		if caster.isHasPromotion(gc.getInfoTypeForString('PROMOTION_DESERT_STEALTH')):
			return False
		return True

def effectAutoSanctify(caster):
	if caster.isHasCasted():
		return
	spellSanctify(caster)
	caster.setHasCasted(True)
	
	# Chose not to use caster.cast here as sound effects from many adepts at the start of turn would be annoying

def reqAutoSanctify(caster):
	if caster.isHasPromotion(gc.getInfoTypeForString("PROMOTION_WARDEN")):
		return False
	return True
	
def reqSpreadJotKilmorph(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	pCity = caster.plot().getPlotCity()
	
	if pPlayer.getStateReligion() != gc.getInfoTypeForString('RELIGION_RUNES_OF_KILMORPH'):
		return False
		
	eTeam = gc.getTeam(pPlayer.getTeam())
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_WAY_OF_THE_EARTHMOTHER')) == False:
		return False
		
	if pCity.isHasReligion(gc.getInfoTypeForString('RELIGION_RUNES_OF_KILMORPH')):
		return False	
		
	return True
	
def reqSpreadJotEsus(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	pCity = caster.plot().getPlotCity()
	
	if pPlayer.getStateReligion() != gc.getInfoTypeForString('RELIGION_COUNCIL_OF_ESUS'):
		return False
		
	eTeam = gc.getTeam(pPlayer.getTeam())
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_DECEPTION')) == False:
		return False
		
	if pCity.isHasReligion(gc.getInfoTypeForString('RELIGION_COUNCIL_OF_ESUS')):
		return False	
		
	return True
	
def reqSpreadJotEmpyrean(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	pCity = caster.plot().getPlotCity()
	
	if pPlayer.getStateReligion() != gc.getInfoTypeForString('RELIGION_THE_EMPYREAN'):
		return False
		
	eTeam = gc.getTeam(pPlayer.getTeam())
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_HONOR')) == False:
		return False
		
	if pCity.isHasReligion(gc.getInfoTypeForString('RELIGION_THE_EMPYREAN')):
		return False	
		
	return True
	
def reqSpreadJotLeaves(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	pCity = caster.plot().getPlotCity()
	
	if pPlayer.getStateReligion() != gc.getInfoTypeForString('RELIGION_FELLOWSHIP_OF_LEAVES'):
		return False
		
	eTeam = gc.getTeam(pPlayer.getTeam())
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_WAY_OF_THE_FORESTS')) == False:
		return False
		
	if pCity.isHasReligion(gc.getInfoTypeForString('RELIGION_FELLOWSHIP_OF_LEAVES')):
		return False	
		
	return True
	
def reqSpreadJotAV(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	pCity = caster.plot().getPlotCity()
	
	if pPlayer.getStateReligion() != gc.getInfoTypeForString('RELIGION_THE_ASHEN_VEIL'):
		return False
		
	eTeam = gc.getTeam(pPlayer.getTeam())
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_CORRUPTION_OF_SPIRIT')) == False:
		return False
		
	if pCity.isHasReligion(gc.getInfoTypeForString('RELIGION_THE_ASHEN_VEIL')):
		return False	
		
	return True

def reqSpreadJotOO(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	pCity = caster.plot().getPlotCity()
	
	if pPlayer.getStateReligion() != gc.getInfoTypeForString('RELIGION_OCTOPUS_OVERLORDS'):
		return False
		
	eTeam = gc.getTeam(pPlayer.getTeam())
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_MESSAGE_FROM_THE_DEEP')) == False:
		return False
		
	if pCity.isHasReligion(gc.getInfoTypeForString('RELIGION_OCTOPUS_OVERLORDS')):
		return False	
		
	return True
	
def reqSpreadJotOrder(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	pCity = caster.plot().getPlotCity()
	
	if pPlayer.getStateReligion() != gc.getInfoTypeForString('RELIGION_THE_ORDER'):
		return False
		
	eTeam = gc.getTeam(pPlayer.getTeam())
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_ORDERS_FROM_HEAVEN')) == False:
		return False
		
	if pCity.isHasReligion(gc.getInfoTypeForString('RELIGION_THE_ORDER')):
		return False	
		
	return True

def reqAustrinRemoteFound(caster):
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	
	if not pPlayer.isFeatAccomplished(FeatTypes.FEAT_EXPEDITION_READY):
		return False
		
	if pPlot.isOwned() and pPlot.getOwner() != caster.getOwner():
		return False
		
	if pPlot.isCityRadius():
		return False
		
	if pPlot.isWater():
		return False

	if not pPlayer.isHuman():
		if pPlot.getFoundValue() < (pPlot.area().getBestFoundValue() * 2) / 3:
			return False

	return True

def spellAustrinRemoteFound(caster):
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())

	pCity = pPlayer.initCity(pPlot.getX(),pPlot.getY())
	CvEventInterface.getEventManager().onCityBuilt([pCity])
	pPlayer.setFeatAccomplished(FeatTypes.FEAT_EXPEDITION_READY, False)

def onDeathForestCreeper(pCaster):
	iForest = gc.getInfoTypeForString('FEATURE_FOREST')
	iNewForest = gc.getInfoTypeForString('FEATURE_FOREST_NEW')
	iJungle = gc.getInfoTypeForString('FEATURE_JUNGLE')
	pPlot = pCaster.plot()
	if not pPlot.isOwned():
		if pPlot.getFeatureType() == iNewForest:
			if CyGame().getSorenRandNum(3, "Chance to Spawn Extra Forest Creeper from New Forest") == 1:
				pPlayer = gc.getPlayer(pCaster.getOwner())
				newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_FOREST_CREEPER'), pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
				return
			if CyGame().getSorenRandNum(3, "Chance to Change New Forest to Forest") == 1:
				pPlot.setFeatureType(-1, -1)
				pPlot.setFeatureType(iForest, 0)
				return
		if (pPlot.getFeatureType() != iForest or pPlot.getFeatureType() != iNewForest or pPlot.getFeatureType() != iJungle):
			if pPlot.canHaveFeature(iNewForest):
				if pPlot.getFeatureType() == -1:
					pPlot.setFeatureType(-1, -1)
					pPlot.setFeatureType(iNewForest, 0)
					return
		if (pPlot.getFeatureType() == iForest or pPlot.getFeatureType() == iJungle):
			iX = pCaster.getX()
			iY = pCaster.getY()
			iFallenForest = gc.getInfoTypeForString('IMPROVEMENT_BLIGHTED_FOREST')
			iImprovementCount = 0
			getPlot	= CyMap().plot
			for iiX,iiY in RANGE2:
				pPlot = getPlot(iX+iiX,iY+iiY)
				if pPlot.isNone() == False:
					if pPlot.getImprovementType() == iFallenForest:
						iImprovementCount += 1
			if iImprovementCount == 0:
				pPlot = pCaster.plot()
				pPlayer = gc.getPlayer(pCaster.getOwner())
				pPlot.setImprovementType(iFallenForest)
				newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_FOREST_CREEPER'), pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
				if CyGame().getSorenRandNum(5, "Chance to Spawn Malignant Flora from Fallen Forest Creation") < 3:
					newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_MALIGNANT_FLORA'), pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
					return
			if iImprovementCount > 0:
				if CyGame().getSorenRandNum(3, "Chance to Spawn Extra Forest Creeper from Forest when Lair fails") == 1:
					pPlayer = gc.getPlayer(pCaster.getOwner())
					newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_FOREST_CREEPER'), pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)

def onDeathDragon(pCaster):
	pPlayer = gc.getPlayer(pCaster.getOwner())
	pAnimalPlayer = gc.getPlayer(gc.getANIMAL_PLAYER())
	iBones = gc.getInfoTypeForString('IMPROVEMENT_DRAGON_BONES_EXPLORED')
	pPlot = pCaster.plot()
	if pPlayer == pAnimalPlayer:
		pPlot.setImprovementType(iBones)
				
def effectMalignantFlora(caster):
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlot.isCity():
		caster.kill(True, 0)
	if CyGame().getSorenRandNum(4, "Chance to Spawn Forest Creeper from Malignant Flora") == 1:
		newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_FOREST_CREEPER'), pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		if pPlot.getFeatureType() == gc.getInfoTypeForString('FEATURE_FOREST'):
			if CyGame().getSorenRandNum(20, "Chance to Animal from Malignant Flora Forest") == 1:
				if CyGame().getSorenRandNum(10, "Chance to Wolf or Bear from Malignant Flora") >= 3:
					newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_WOLF'), pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
				else:
					newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_BEAR'), pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		if pPlot.getFeatureType() == gc.getInfoTypeForString('FEATURE_JUNGLE'):
			if CyGame().getSorenRandNum(20, "Chance to Animal from Malignant Flora Jungle") == 1:
				if CyGame().getSorenRandNum(10, "Chance to Panther or Gorilla from Malignant Flora") >= 5:
					newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_TIGER'), pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
				else:
					newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_GORILLA'), pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)		
		if (pPlot.getFeatureType() != gc.getInfoTypeForString('FEATURE_FOREST') or pPlot.getFeatureType() != gc.getInfoTypeForString('FEATURE_JUNGLE')):
			pPlot.setFeatureType(gc.getInfoTypeForString('FEATURE_FOREST'), 0)
					
def atRangeBlightedForest(pCaster, pPlot):
	if CvEventInterface.getEventManager().cf.doForestPush(pCaster, pPlot, -1, False):
		CyInterface().addMessage(pCaster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_BLIGHTED_FOREST", (gc.getUnitInfo(pCaster.getUnitType()).getDescription(), )),'',1,'Art/Interface/Buttons/Improvements/Blighted Forest.dds',ColorTypes(7),pCaster.getX(),pCaster.getY(),True,True)
		
def spellExploreBlightedForest(caster):
	iPlayer = caster.getOwner()
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	eTeam = gc.getTeam(pPlayer.getTeam())
	iRnd = CyGame().getSorenRandNum(100, "Explore Blighted Forest")
	iRnd += caster.getNoBadExplore()/2
	iDestroyLair = 0
	
	if eTeam.isHasTech(gc.getInfoTypeForString('TECH_IRON_WORKING')):
		iRnd += 20
		
	if iRnd < 30:
		pPlayer = gc.getPlayer(gc.getANIMAL_PLAYER())
		newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_MALIGNANT_FLORA'), pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
	elif iRnd >= 30 and iRnd < 40:
		pPlayer = gc.getPlayer(gc.getANIMAL_PLAYER())
		newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_BEAR'), pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		newUnit.setDamage(25, -1)
		newUnit.setHasPromotion(gc.getInfoTypeForString('PROMOTION_DISEASED'), True)
		iDestroyLair = 50
	elif iRnd >= 40 and iRnd < 50:
		pPlayer = gc.getPlayer(gc.getANIMAL_PLAYER())
		newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_WOLF'), pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		newUnit.setDamage(25, -1)
		newUnit.setHasPromotion(gc.getInfoTypeForString('PROMOTION_DISEASED'), True)
		iDestroyLair = 50
	elif iRnd >= 50:
		iDestroyLair = 100
	# Destroy the Lair, or not:
	iRnd = CyGame().getSorenRandNum(100, "Blighted Forest Destuction")
	if iRnd <= iDestroyLair:
		pPlot.setImprovementType(-1)
		CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_LAIR_DESTROYED", ()),'AS2D_POSITIVE_DINK',1,'Art/Interface/Buttons/Spells/Rob Grave.dds',ColorTypes(8),pPlot.getX(),pPlot.getY(),True,True)
		return True
	else:
		CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_LAIR_NOT_DESTROYED", ()),'AS2D_DEAL_CANCELLED',1,'Art/Interface/Buttons/Spells/Rob Grave.dds',ColorTypes(7),pPlot.getX(),pPlot.getY(),True,True)
		return False
	caster.finishMoves()
	caster.changeExperience(1, -1, False, False, False)

def effectWanderingCurse(caster):
	pPlot = caster.plot()
	pPlot2 = findClearPlot(-1, caster.plot())
	if pPlot2 != -1:
		caster.setXY(pPlot2.getX(), pPlot2.getY(), False, True, True)
		CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_UNIT_WANDERING", ()),'AS2D_FEATUREGROWTH',1,'Art/Interface/Buttons/Promotions/Lost.dds',ColorTypes(7),pPlot.getX(),pPlot.getY(),True,True)

def postCombatWinWerewolf(pCaster, pOpponent):
	if pOpponent.isAlive() and pOpponent.canDefend(pOpponent.plot()):	#Can only convert Living Combat Units
		if pCaster.baseCombatStr() < gc.getUnitInfo(pCaster.getUnitType()).getCombat() * 3 / 2:
			iGrowChance = pOpponent.baseCombatStr() * 5
			if pCaster.isAIControl():
				iGrowChance = iGrowChance * 2
			if CyGame().getSorenRandNum(100, "Werewolf Growth") < iGrowChance:	#Low rigid chance for now, will set something up for variability some other time
				pCaster.changeStrBoost(1)
				if not pCaster.baseCombatStr() < gc.getUnitInfo(pCaster.getUnitType()).getCombat() * 3 / 2:
					oldName = pCaster.getName()
					pCaster.setName(CyTranslator().getText('TXT_KEY_UNIT_GREATER_WEREWOLF',()))
					CyInterface().addMessage(pCaster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_WEREWOLF_SATIATED", (oldName, pCaster.getName())),'',1,'Art/Interface/Buttons/Promotions/Werewolf.dds',ColorTypes(8),pCaster.getX(),pCaster.getY(),True,True)
					pCaster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_CRAZED'), False)
				elif pCaster.baseCombatStr() == gc.getUnitInfo(pCaster.getUnitType()).getCombat():
					oldName = pCaster.getName()
					pCaster.setName(CyTranslator().getText('TXT_KEY_UNIT_BLOODED_WEREWOLF',()))
					CyInterface().addMessage(pCaster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_WEREWOLF_CALMED", (oldName, pCaster.getName())),'',1,'Art/Interface/Buttons/Promotions/Werewolf.dds',ColorTypes(8),pCaster.getX(),pCaster.getY(),True,True)
					pCaster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_CRAZED'), False)
#			elif pCaster.baseCombatStr() < gc.getUnitInfo(pCaster.getUnitType()).getCombat():	#We should MAYBE include a chance for going enraged if you don't gain strength, could be somewhat annoying to always gain strength or enrage, it essentially means you NEVER control a Ravenous Werewolf directly without Loyalty applied
#				pCaster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_ENRAGED'), True)
#				CyInterface().addMessage(pCaster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_WEREWOLF_ENRAGING", (pCaster.getName(), )),'',1,'Art/Interface/Buttons/Promotions/Werewolf.dds',ColorTypes(8),pCaster.getX(),pCaster.getY(),True,True)

		if not pOpponent.isImmuneToCapture():	#Let Loyalty grant Immunity
			if not pOpponent.isImmortal():
				if (pOpponent.getCaptureUnitType(pOpponent.getCivilizationType()) == -1 and gc.getUnitInfo(pCaster.getUnitType()).getUnitCreateFromCombat() == -1):	#Prevents gaining 2 units from a single combat, could still get a Wolf and a Slave right now however, but don't want to have Werewolves disabled completely by following Slavery Civic
					iConvertChance = 30
					if isWorldUnitClass(pCaster.getUnitClassType()):	#Baron is better at this, and any Hero units he may recruit in the future
						iConvertChance = 50
					if CyGame().getSorenRandNum(100, "Werewolf Curse") < iConvertChance:	#Low rigid chance for now, will set something up for variability some other time
						pPlayer = gc.getPlayer(pCaster.getOwner())
						newUnit = pPlayer.initUnit(pOpponent.getUnitType(), pCaster.getX(), pCaster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
						for i in range(gc.getNumPromotionInfos()):
							newUnit.setHasPromotion(i, pOpponent.isHasPromotion(i))
							if gc.getPromotionInfo(i).isEquipment():
								newUnit.setHasPromotion(i, False)
						newUnit.setLevel(pOpponent.getLevel())
						newUnit.setExperienceTimes100(pOpponent.getExperienceTimes100(), -1)
						newUnit.setHasCasted(True)
						newUnit.finishMoves()
						if newUnit.baseCombatStr() > 1:
							newUnit.changeStrBoost(-newUnit.baseCombatStr()/4)
						oldName = pOpponent.getName()
						newUnit.setHasPromotion(gc.getInfoTypeForString('PROMOTION_WEREWOLF'), True)
						if newUnit.baseCombatStr() == gc.getUnitInfo(newUnit.getUnitType()).getCombat():
							newUnit.setName(CyTranslator().getText('TXT_KEY_UNIT_BLOODED_WEREWOLF',()))
						else:
							newUnit.setName(CyTranslator().getText('TXT_KEY_UNIT_RAVENOUS_WEREWOLF',()))
							newUnit.setHasPromotion(gc.getInfoTypeForString('PROMOTION_CRAZED'), True)
						CyInterface().addMessage(newUnit.getOwner(),True,25,CyTranslator().getText("TXT_KEY_WEREWOLF_INFECTED", (oldName, newUnit.getName())),'',1,'Art/Interface/Buttons/Promotions/Werewolf.dds',ColorTypes(8),pCaster.getX(),pCaster.getY(),True,True)

def postCombatLossWerewolf(pCaster, pOpponent):
	if pOpponent.isAlive():
		if pOpponent.getDamage() > 0:	#Must be hurt to be infected, better if we force it to require that the wolf itself hurt you, but this still works nicely.
			iInfectChance = 10
			if CyGame().getSorenRandNum(100, "Werewolf Infection") < iInfectChance:	#Low rigid chance for now, will set something up for variability some other time
				pOpponent.setHasPromotion(gc.getInfoTypeForString('PROMOTION_WEREWOLF'), True)

def findCommander(caster):
	py = PyPlayer(caster.getOwner())
	pPlot = caster.plot()
	pBestUnit = -1
	iBestRank = 7
	iBestLevel = 9999
	bSameGroup = False
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.getOwner() == caster.getOwner():
			if not pUnit.getID() == caster.getID():
				if (bSameGroup and pUnit.getGroupID() == caster.getGroupID()) or (not bSameGroup):
					if caster.getDomainType() == pUnit.getDomainType():
						if not pUnit.getID() == caster.getCommanderUnit().getID() and not pUnit.getCommanderUnit().getID() == caster.getID():		#Neither of us is leading the other one
							if pUnit.getNumMinions() < pUnit.getCommandLimit():
								iCorporal = gc.getInfoTypeForString('PROMOTION_CORPORAL')
								if(iCorporal == -1):									#If we don't have the Bannor Chain of Command Module Loaded
									if(pUnit.getGroupID() == caster.getGroupID()):
										if not (bSameGroup):
											pBestUnit = pUnit
											iBestLevel = pUnit.getLevel()
											bSameGroup = True
										elif pUnit.getLevel() <iBestLevel:
											pBestUnit = pUnit
											iBestLevel = pUnit.getLevel()
									else:
										if pUnit.getLevel() <iBestLevel:
											pBestUnit = pUnit
											iBestLevel = pUnit.getLevel()
								else:
									iSarge = gc.getInfoTypeForString('PROMOTION_SEARGENT')
									iMasterSarge = gc.getInfoTypeForString('PROMOTION_MASTER_SEARGENT')
									iCaptain = gc.getInfoTypeForString('PROMOTION_CAPTAIN')
									iGeneral = gc.getInfoTypeForString('PROMOTION_GENERAL')
									iMinionRank = 0
									if caster.isHasPromotion(iGeneral):
										iMinionRank = 5
									elif caster.isHasPromotion(iCaptain):
										iMinionRank = 4
									elif caster.isHasPromotion(iMasterSarge):
										iMinionRank = 3
									elif caster.isHasPromotion(iSarge):
										iMinionRank = 2
									elif caster.isHasPromotion(iCorporal):
										iMinionRank = 1
									elif caster.getCommandLimit() > 0:
										iMinionRank = 6

									iCommanderRank = 6
									if pUnit.isHasPromotion(iGeneral):
										iCommanderRank = 5
									elif pUnit.isHasPromotion(iCaptain):
										iCommanderRank = 4
									elif pUnit.isHasPromotion(iMasterSarge):
										iCommanderRank = 3
									elif pUnit.isHasPromotion(iSarge):
										iCommanderRank = 2
									elif pUnit.isHasPromotion(iCorporal):
										iCommanderRank = 1
									
									if iCommanderRank > iMinionRank:	#If you have a rank, you cannot lead someone who outranks you
										if(pUnit.getGroupID() == caster.getGroupID()):
											if not (bSameGroup):
												pBestUnit = pUnit
												iBestRank = iCommanderRank
												iBestLevel = pUnit.getLevel()
												bSameGroup = True
											elif iCommanderRank < iBestRank:	#Prefer to follow the lowest Commander available
												pBestUnit = pUnit
												iBestRank = iCommanderRank
												iBestLevel = pUnit.getLevel()
											elif (iCommanderRank == iBestRank):
												if (pUnit.getLevel() < iBestLevel):
													pBestUnit = pUnit
													iBestLevel = pUnit.getLevel()
										else:
											if iCommanderRank < iBestRank:	#Prefer to follow the lowest Commander available
												pBestUnit = pUnit
												iBestRank = iCommanderRank
												iBestLevel = pUnit.getLevel()
											elif (iCommanderRank == iBestRank):
												if (pUnit.getLevel() < iBestLevel):
													pBestUnit = pUnit
													iBestLevel = pUnit.getLevel()
	return pBestUnit

def reqAttachMinion(caster):
	if not caster.getMasterUnit().isNone():
		return False
	pCommander = findCommander(caster)
	if pCommander != -1:
		return True
	return False

def attachMinion(caster):
	pCommander = findCommander(caster)
	if pCommander != -1:
		pCommander.addMinion(caster)

def removeMinion(caster):
	pUnit = caster.getCommanderUnit()
	pUnit.removeMinion(caster)

def getHelpAttachMinion(argsList):
	eSpell, pCaster = argsList
	if pCaster == -1 or pCaster.isNone():
		szHelp = ""
	else:
		pCommander = findCommander(pCaster)
		if not (pCommander == -1):
			szHelp = localText.getText("TXT_KEY_SPELL_JOIN_COMMANDER", (pCommander.getName(),pCaster.getName()))
	return szHelp

def reqAdvancement(caster):
	if caster.getUnitCombatType() == gc.getInfoTypeForString('UNITCOMBAT_ANIMAL'):
		return False
	if caster.getUnitCombatType() == gc.getInfoTypeForString('UNITCOMBAT_BEAST'):
		return False
	if caster.isImmortal():
		return False
	if caster.getUnitCombatType() == gc.getInfoTypeForString('UNITCOMBAT_WORKER'):
		return False
	if caster.getCommandLimit() > 0:
		return False
	return True

def doAdvancement(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	pPlot = caster.plot()
	newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_COMMANDER_BANNOR_CAPTAIN'), pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)

def displayAllUnits(pCaster):
	for iPlayer in xrange(0,int(gc.getMAX_PLAYERS())):
		if ((gc.getPlayer(iPlayer).isAlive()) and (gc.getPlayer(iPlayer).isBarbarian()!=True) ):
			for j in xrange( CyGlobalContext().getNumUnitClassInfos() ):
				eLoopUnit = CyGlobalContext().getCivilizationInfo(gc.getPlayer(iPlayer).getCivilizationType()).getCivilizationUnits(j)
				if (eLoopUnit != -1):
					x = j%10 + 1 + iPlayer*12
					y = (j/10) + 5
					gc.getPlayer(iPlayer).initUnit( eLoopUnit, x, y, UnitAITypes.UNITAI_UNKNOWN, DirectionTypes.NO_DIRECTION )

def increaseAC(caster):
	CyGame().changeGlobalCounter(10)

def decreaseAC(caster):
	CyGame().changeGlobalCounter(-10)
	
def zeroAC(caster):
	CyGame().changeGlobalCounter(-1 * (CyGame().getTrueGlobalCounter()))
	
def maxAC(caster):
	CyGame().changeGlobalCounter(9999)
	
def WorstUnit(player, location):
	py = player
	pPlot = location
	pWorstUnit = -1
	fWorstValue = 9999999999999999999999999999 #Nothing returned could be higher than this value, so the first unit will always be the worst to begin with.
	for i in range(pPlot.getNumUnits()):
		fValue = 999999999999999999
		pUnit = pPlot.getUnit(i)
		if pUnit.getOwner() == player:
			iLevel = pUnit.getLevel()
			iStrength = pUnit.baseCombatStr()
			fStrength = iStrength * (1.0 - (pUnit.GetDamage() / 100))#Find the unit's actual strength by factoring in it's damage
			fModifier = iLevel / 2
			if pUnit.isHasPromotion(gc.getInfoTypeForString('PROMOTION_HERO')) or pUnit.isHasPromotion(gc.getInfoTypeForString('PROMOTION_ADVENTURER')):
				fModifier += 999999999999 #Heroes should never be chosen
			if pUnit.isHasPromotion(gc.getInfoTypeForString('PROMOTION_WEAK')):
				fModifier -= 1.0
			if pUnit.isHasPromotion(gc.getInfoTypeForString('PROMOTION_STRONG')):
				fModifier += 2.0
			if pUnit.isHasPromotion(gc.getInfoTypeForString('PROMOTION_CRAZED')):
				fModifier -= 1.0
			if pUnit.isHasPromotion(gc.getInfoTypeForString('PROMOTION_DISEASED')):
				fModifier -= 1.0
			if pUnit.isHasPromotion(gc.getInfoTypeForString('PROMOTION_ENRAGED')):
				fModifier -= 1.0
			if pUnit.isHasPromotion(gc.getInfoTypeForString('PROMOTION_UNDISCIPLINED')):
				fModifier -= 1.0
			if pUnit.isHasPromotion(gc.getInfoTypeForString('PROMOTION_PLAGUED')):
				fModifier -= 1.0
				
			fValue = fStrength * fModifier
			if fValue < fWorstValue:
				fWorstValue = fValue
				pWorstUnit = pUnit
	
	return pWorstUnit
	
def spellDovielloChallenge(caster):
	caster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_CHALLENGER'), True)

def reqDovielloChallenge(caster):
	pPlot = caster.plot()
	iChallenger = gc.getInfoTypeForString('PROMOTION_CHALLENGER')
	iStack = 0
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.getID() != caster.getID() and pUnit.getOwner() == caster.getOwner() and pUnit.getUnitCombatType() != gc.getInfoTypeForString('UNITCOMBAT_ANIMAL'):
			if pUnit.getUnitCombatType() != gc.getInfoTypeForString('UNITCOMBAT_NAVAL'):
				if pUnit.getUnitClassType() != gc.getInfoTypeForString('UNITCLASS_SETTLER'):
					if pUnit.getUnitClassType() != gc.getInfoTypeForString('UNITCLASS_WORKER'):
						iStack += 1
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if caster.getUnitCombatType() == gc.getInfoTypeForString('UNITCOMBAT_ANIMAL') or caster.getUnitCombatType() == gc.getInfoTypeForString('UNITCOMBAT_NAVAL'):
			return False
		if caster.getUnitClassType() == gc.getInfoTypeForString('UNITCLASS_SETTLER'):
			return False
		if caster.getUnitClassType() == gc.getInfoTypeForString('UNITCLASS_WORKER'):
			return False
		if pUnit.isHasPromotion(iChallenger):					
			return False
		if iStack < 1:
			return False
	return True	

def reqDovielloDuel(caster):
	pPlot = caster.plot()
	if caster.getUnitCombatType() == gc.getInfoTypeForString('UNITCOMBAT_ANIMAL') or caster.getUnitCombatType() == gc.getInfoTypeForString('UNITCOMBAT_NAVAL'):
		return False
	if caster.getUnitClassType() == gc.getInfoTypeForString('UNITCLASS_WORKER'):
		return False
	if caster.getUnitClassType() == gc.getInfoTypeForString('UNITCLASS_SETTLER'):
		return False
	return True	
	
def spellDovielloDuel(caster):
	pPlot = caster.plot()
	iChallengerProm = gc.getInfoTypeForString('PROMOTION_CHALLENGER')
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		iRnd = CyGame().getSorenRandNum(100, "Doviello Duel")
		if pUnit.isHasPromotion(iChallengerProm) == True:	
			iChallengerOdds = getCombatOdds(pUnit, caster)
			iChallengerRnd = (iRnd + (iChallengerOdds * 2)) / 3
			iDefenderOdds = getCombatOdds(caster, pUnit)
			iDefenderRnd = (iRnd + (iDefenderOdds * 2)) / 3
			if iDefenderOdds > iChallengerOdds:
				iDefenseRnd = CyGame().getSorenRandNum(100, "Doviello Duel Defender")
				iDefenseTieRnd = CyGame().getSorenRandNum(100, "Doviello Duel Defender Tie")
				if iDefenseTieRnd < 10:
					caster.changeExperience(pUnit.getExperienceTimes100() / 1000, -1, False, False, False)
					caster.setDamage(75, caster.getOwner())
					pUnit.changeExperience(caster.getExperienceTimes100() / 1000, -1, False, False, False)
					pUnit.setDamage(75, pUnit.getOwner())
					pUnit.setHasPromotion(gc.getInfoTypeForString('PROMOTION_CHALLENGER'), False)
					CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_DOVIELLO_DUEL_DRAW", ()),'',1,'Art/Interface/Buttons/Buildings/Arena.dds',ColorTypes(8),caster.getX(),caster.getY(),True,True)
				elif (iDefenseTieRnd <= 12 and iDefenseTieRnd >= 10):
					iVictorRnd = CyGame().getSorenRandNum(100, "Doviello Duel")
					if iVictorRnd < 50:
						CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_ARENA_DEATH_DEFENDER", ()),'',1,'Art/Interface/Buttons/Buildings/Arena.dds',ColorTypes(7),caster.getX(),caster.getY(),True,True)
						caster.kill(True, PlayerTypes.NO_PLAYER)
						pUnit.kill(True, PlayerTypes.NO_PLAYER)
					else:
						CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_ARENA_DEATH_CHALLENGER", ()),'',1,'Art/Interface/Buttons/Buildings/Arena.dds',ColorTypes(7),caster.getX(),caster.getY(),True,True)
						caster.kill(True, PlayerTypes.NO_PLAYER)
						pUnit.kill(True, PlayerTypes.NO_PLAYER)
				elif iDefenseTieRnd > 12:
					if iDefenseRnd > iDefenderOdds:
						pUnit.changeExperience((caster.getExperienceTimes100() / 200) + 2, -1, False, False, False)
						pUnit.setDamage(25, pUnit.getOwner())
						pUnit.setHasPromotion(gc.getInfoTypeForString('PROMOTION_CHALLENGER'), False)
						CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_DOVIELLO_DUEL_LOSS", ()),'',1,'Art/Interface/Buttons/Buildings/Arena.dds',ColorTypes(8),caster.getX(),caster.getY(),True,True)
						caster.kill(True, PlayerTypes.NO_PLAYER)
					if iDefenseRnd < iDefenderOdds:
						caster.changeExperience((pUnit.getExperienceTimes100() / 200) + 2, -1, False, False, False)
						caster.setDamage(25, caster.getOwner())
						CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_DOVIELLO_DUEL_WIN", ()),'',1,'Art/Interface/Buttons/Buildings/Arena.dds',ColorTypes(8),caster.getX(),caster.getY(),True,True)
						pUnit.kill(True, PlayerTypes.NO_PLAYER)
			if iChallengerOdds > iDefenderOdds:
				iChallengeRnd = CyGame().getSorenRandNum(100, "Doviello Duel Challenger")
				iChallengerTieRnd = CyGame().getSorenRandNum(100, "Doviello Duel Challenger Tie")
				if iChallengerTieRnd < 10:
					caster.changeExperience(pUnit.getExperienceTimes100() / 1000, -1, False, False, False)
					caster.setDamage(75, caster.getOwner())
					pUnit.changeExperience(caster.getExperienceTimes100() / 1000, -1, False, False, False)
					pUnit.setDamage(75, pUnit.getOwner())
					pUnit.setHasPromotion(gc.getInfoTypeForString('PROMOTION_CHALLENGER'), False)
					CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_DOVIELLO_DUEL_DRAW", ()),'',1,'Art/Interface/Buttons/Buildings/Arena.dds',ColorTypes(8),caster.getX(),caster.getY(),True,True)
				elif (iChallengerTieRnd <= 12 and iChallengerTieRnd >= 10):
					iVictorRnd = CyGame().getSorenRandNum(100, "Doviello Duel")
					if iVictorRnd < 50:
						CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_ARENA_DEATH_DEFENDER", ()),'',1,'Art/Interface/Buttons/Buildings/Arena.dds',ColorTypes(7),caster.getX(),caster.getY(),True,True)
						caster.kill(True, PlayerTypes.NO_PLAYER)
						pUnit.kill(True, PlayerTypes.NO_PLAYER)
					else:
						CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_ARENA_DEATH_CHALLENGER", ()),'',1,'Art/Interface/Buttons/Buildings/Arena.dds',ColorTypes(7),caster.getX(),caster.getY(),True,True)
						caster.kill(True, PlayerTypes.NO_PLAYER)
						pUnit.kill(True, PlayerTypes.NO_PLAYER)
				elif iChallengerTieRnd > 12:
					if iChallengeRnd < iChallengerOdds:
						pUnit.changeExperience((caster.getExperienceTimes100() / 200) + 2, -1, False, False, False)
						pUnit.setDamage(25, pUnit.getOwner())
						pUnit.setHasPromotion(gc.getInfoTypeForString('PROMOTION_CHALLENGER'), False)
						CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_DOVIELLO_DUEL_LOSS", ()),'',1,'Art/Interface/Buttons/Buildings/Arena.dds',ColorTypes(8),caster.getX(),caster.getY(),True,True)
						caster.kill(True, PlayerTypes.NO_PLAYER)
					if iChallengeRnd > iChallengerOdds:
						caster.changeExperience((pUnit.getExperienceTimes100() / 200) + 2, -1, False, False, False)
						caster.setDamage(25, caster.getOwner())
						CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_DOVIELLO_DUEL_WIN", ()),'',1,'Art/Interface/Buttons/Buildings/Arena.dds',ColorTypes(8),caster.getX(),caster.getY(),True,True)
						pUnit.kill(True, PlayerTypes.NO_PLAYER)
			if iChallengerOdds == iDefenderOdds:
				iEqualRnd = CyGame().getSorenRandNum(100, "Doviello Duel Equals")
				iEqualTieRnd = CyGame().getSorenRandNum(100, "Doviello Duel Equals Tie")
				if iEqualTieRnd < 10:
					caster.changeExperience(pUnit.getExperienceTimes100() / 1000, -1, False, False, False)
					caster.setDamage(75, caster.getOwner())
					pUnit.changeExperience(caster.getExperienceTimes100() / 1000, -1, False, False, False)
					pUnit.setDamage(75, pUnit.getOwner())
					pUnit.setHasPromotion(gc.getInfoTypeForString('PROMOTION_CHALLENGER'), False)
					CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_DOVIELLO_DUEL_DRAW", ()),'',1,'Art/Interface/Buttons/Buildings/Arena.dds',ColorTypes(8),caster.getX(),caster.getY(),True,True)
				elif (iEqualTieRnd <= 12 and iEqualTieRnd >= 10):
					iVictorRnd = CyGame().getSorenRandNum(100, "Doviello Duel")
					if iVictorRnd < 50:
						CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_ARENA_DEATH_DEFENDER", ()),'',1,'Art/Interface/Buttons/Buildings/Arena.dds',ColorTypes(7),caster.getX(),caster.getY(),True,True)
						caster.kill(True, PlayerTypes.NO_PLAYER)
						pUnit.kill(True, PlayerTypes.NO_PLAYER)
					else:
						CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_ARENA_DEATH_CHALLENGER", ()),'',1,'Art/Interface/Buttons/Buildings/Arena.dds',ColorTypes(7),caster.getX(),caster.getY(),True,True)
						caster.kill(True, PlayerTypes.NO_PLAYER)
						pUnit.kill(True, PlayerTypes.NO_PLAYER)
				elif iEqualTieRnd > 12:
					if iEqualRnd < 50:
						pUnit.changeExperience((caster.getExperienceTimes100() / 200) + 2, -1, False, False, False)
						pUnit.setDamage(25, pUnit.getOwner())
						pUnit.setHasPromotion(gc.getInfoTypeForString('PROMOTION_CHALLENGER'), False)
						CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_DOVIELLO_DUEL_LOSS", ()),'',1,'Art/Interface/Buttons/Buildings/Arena.dds',ColorTypes(8),caster.getX(),caster.getY(),True,True)
						caster.kill(True, PlayerTypes.NO_PLAYER)
					if iEqualRnd >= 50:
						caster.changeExperience((pUnit.getExperienceTimes100() / 200) + 2, -1, False, False, False)
						caster.setDamage(25, caster.getOwner())
						CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_DOVIELLO_DUEL_WIN", ()),'',1,'Art/Interface/Buttons/Buildings/Arena.dds',ColorTypes(8),caster.getX(),caster.getY(),True,True)
						pUnit.kill(True, PlayerTypes.NO_PLAYER)
			break

def postCombatScavenger(pCaster, pOpponent):
	if pOpponent.isAlive():
		pCaster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_SCAVENGER'), False)
		pCaster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_SCAVENGER'), True)
	if pOpponent.isHasPromotion(gc.getInfoTypeForString('PROMOTION_BRONZE_WEAPONS')):
		pCaster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_BRONZE_WEAPONS'), True)
	if pOpponent.isHasPromotion(gc.getInfoTypeForString('PROMOTION_IRON_WEAPONS')):
		pCaster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_IRON_WEAPONS'), True)
	if pOpponent.isHasPromotion(gc.getInfoTypeForString('PROMOTION_MITHRIL_WEAPONS')):
		pCaster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_MITHRIL_WEAPONS'), True)
	if pOpponent.isHasPromotion(gc.getInfoTypeForString('PROMOTION_ENCHANTED_BLADE')):
		pCaster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_ENCHANTED_BLADE'), True)
	
def spellVarulv(Caster):
	Caster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_VARULV_SPELL'), False)
	Caster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_VARULV_SPELL_BLOCK'), True)
	
def reqInciteFervor(caster):
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	pPlayer = gc.getPlayer(caster.getOwner())
	StateBelief = gc.getPlayer(pCity.getOwner()).getStateReligion()
	
	if (StateBelief == gc.getPlayer(pCity.getOwner()).getStateReligion()):
		if pCity.getOwner() == caster.getOwner():
			return True
		
	if pPlayer.getCivilizationType() == gc.getInfoTypeForString('CIVILIZATION_SCIONS'):
		if pPlayer.getLeaderType() == gc.getInfoTypeForString('LEADER_RISEN_EMPEROR'):
			if pCity.getOwner() == caster.getOwner():
				return True

	return False
			
	
def spellInciteFervor(caster):
	iOwner = caster.getOwner()
	pPlayer = gc.getPlayer(iOwner)
	pCiv = pPlayer.getCivilizationType()
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	iScions = gc.getInfoTypeForString('CIVILIZATION_SCIONS')
	iMachinarumP = gc.getInfoTypeForString('UNIT_ADEPTUS')
	iOrderP = gc.getInfoTypeForString('UNIT_DISCIPLE_THE_ORDER')
	iVeilP = gc.getInfoTypeForString('UNIT_DISCIPLE_THE_ASHEN_VEIL')
	iLeavesP = gc.getInfoTypeForString('UNIT_DISCIPLE_FELLOWSHIP_OF_LEAVES')
	iOOP = gc.getInfoTypeForString('UNIT_DISCIPLE_OCTOPUS_OVERLORDS')
	iRoKP = gc.getInfoTypeForString('UNIT_DISCIPLE_RUNES_OF_KILMORPH')
	iEmpyP = gc.getInfoTypeForString('UNIT_DISCIPLE_EMPYREAN')
	iLegate = gc.getInfoTypeForString('UNIT_LEGATE')
	iLeaves = gc.getInfoTypeForString('RELIGION_FELLOWSHIP_OF_LEAVES')
	iRoK = gc.getInfoTypeForString('RELIGION_RUNES_OF_KILMORPH')
	iEmpy = gc.getInfoTypeForString('RELIGION_THE_EMPYREAN')
	iOrder = gc.getInfoTypeForString('RELIGION_THE_ORDER')
	iOO = gc.getInfoTypeForString('RELIGION_OCTOPUS_OVERLORDS')
	iVeil = gc.getInfoTypeForString('RELIGION_THE_ASHEN_VEIL')
	iMachinarum = gc.getInfoTypeForString('RELIGION_MACHINARUM')
	StateBelief = pPlayer.getStateReligion()
	
	if StateBelief == iLeaves:
		newUnit = pPlayer.initUnit(iLeavesP, pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		newUnit = pPlayer.initUnit(iLeavesP, pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		newUnit = pPlayer.initUnit(iLeavesP, pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		pCity.changeHurryAngerTimer(3)
		pCity.changePopulation(-3)
	if StateBelief == iRoK:
		newUnit = pPlayer.initUnit(iRoKP, pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		newUnit = pPlayer.initUnit(iRoKP, pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		newUnit = pPlayer.initUnit(iRoKP, pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		pCity.changeHurryAngerTimer(3)
		pCity.changePopulation(-3)
	if StateBelief == iEmpy:
		newUnit = pPlayer.initUnit(iEmpyP, pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		newUnit = pPlayer.initUnit(iEmpyP, pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		newUnit = pPlayer.initUnit(iEmpyP, pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		pCity.changeHurryAngerTimer(3)
		pCity.changePopulation(-3)
	if StateBelief == iOrder:
		newUnit = pPlayer.initUnit(iOrderP, pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		newUnit = pPlayer.initUnit(iOrderP, pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		newUnit = pPlayer.initUnit(iOrderP, pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		pCity.changeHurryAngerTimer(3)
		pCity.changePopulation(-3)
	if StateBelief == iOO:
		newUnit = pPlayer.initUnit(iOOP, pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		newUnit = pPlayer.initUnit(iOOP, pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		newUnit = pPlayer.initUnit(iOOP, pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		pCity.changeHurryAngerTimer(3)
		pCity.changePopulation(-3)
	if StateBelief == iVeil:
		newUnit = pPlayer.initUnit(iVeilP, pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		newUnit = pPlayer.initUnit(iVeilP, pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		newUnit = pPlayer.initUnit(iVeilP, pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		pCity.changeHurryAngerTimer(3)
		pCity.changePopulation(-3)
	if StateBelief == iMachinarum:
		newUnit = pPlayer.initUnit(iMachinarumP, pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		newUnit = pPlayer.initUnit(iMachinarumP, pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		newUnit = pPlayer.initUnit(iMachinarumP, pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		pCity.changeHurryAngerTimer(3)
		pCity.changePopulation(-3)
	if pCiv == iScions:
		newUnit = pPlayer.initUnit(iLegate, pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		newUnit = pPlayer.initUnit(iLegate, pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		newUnit = pPlayer.initUnit(iLegate, pCity.getX(), pCity.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
		pCity.changeHurryAngerTimer(3)
		pCity.changePopulation(-3)
		
def reqDeathsDominion(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		if pPlayer.getNumUnits() < 25:
			return False
		iTeam = gc.getPlayer(caster.getOwner()).getTeam()
		eTeam = gc.getTeam(iTeam)
		if eTeam.getAtWarCount(True) == 0:
			return False
	return True

def spellDeathsDominion(caster):
	iDominion = gc.getInfoTypeForString('PROMOTION_UNDEATHS_DOMINION')
	py = PyPlayer(caster.getOwner())
	for pUnit in py.getUnitList():
		if pUnit.getUnitCombatType() != -1:
			pUnit.setHasPromotion(iDominion, True)
			
def reqClaimFort(caster):
	iUnitFortCommander = CvUtil.findInfoTypeNum(gc.getUnitClassInfo,gc.getNumUnitClassInfos(),'UNITCLASS_FORT_COMMANDER')
	pPlot = caster.plot()
	for iUnitLoop in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(iUnitLoop)			
			# Can't cast if another commander is there
		if pUnit.getUnitClassType() == iUnitFortCommander:
			return False
	if pPlot.isOwned():
		if pPlot.getOwner() != caster.getOwner():
			pPlayer = gc.getPlayer(caster.getOwner())
			eTeam = gc.getTeam(pPlayer.getTeam())
			p2Player = gc.getPlayer(pPlot.getOwner())
			e2Team = p2Player.getTeam()
			if eTeam.isAtWar(e2Team) == False:
				return False
	return True

def spellClaimFort(pCaster):
	pPlot = pCaster.plot()
	iPlayer = pCaster.getOwner()
	iPlayer2 = pPlot.getOwner()
	iImprovement = pPlot.getImprovementType()
	pPlayer = gc.getPlayer(pCaster.getOwner())
	iUnit = gc.getInfoTypeForString('UNITCLASS_FORT_COMMANDER')
	infoCiv = gc.getCivilizationInfo(pPlayer.getCivilizationType())
	iUnit = infoCiv.getCivilizationUnits(iUnit)
	if iUnit == -1:
		iUnit = gc.getInfoTypeForString('UNIT_FORT_COMMANDER')
	iRace = infoCiv.getDefaultRace()
	newUnit = pPlayer.initUnit(iUnit, pCaster.getX(), pCaster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_NORTH)	
	if iRace != -1:
		newUnit.setHasPromotion(iRace, True)
	pPlot.clearCultureControl(iPlayer2, iImprovement, 1)
	pPlot.setImprovementOwner(iPlayer)
	pPlot.addCultureControl(iPlayer, iImprovement, 1)	

def checkFort(pCaster):
	pPlot = pCaster.plot()
	iPlayer = pPlot.getOwner()
	iImprovement = pPlot.getImprovementType()
	if iPlayer == -1:
		pCaster.kill(True, PlayerTypes.NO_PLAYER)
	if iPlayer != -1:
		if iImprovement != -1:
			if not gc.getImprovementInfo(iImprovement).isFort():
				pCaster.kill(True, PlayerTypes.NO_PLAYER)

def reqPioneer(caster):
	pPlot = caster.plot()
	if pPlot.isOwned():
		return False
	elif pPlot.getImprovementType() != -1:
		return False
	iX = caster.getX()
	iY = caster.getY()
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE1:
		pPlot = getPlot(iX+iiX,iY+iiY)
		if not pPlot.isNone():
			iImprovement = pPlot.getImprovementType()
			if iImprovement != -1:
				if gc.getImprovementInfo(iImprovement).isFort():
					return False
	return True	

def reqFieldFortification(caster):
	pPlot = caster.plot()
	if pPlot.getImprovementType() != -1:
		return False
	elif pPlot.isCity():
		return False
	iX = caster.getX()
	iY = caster.getY()
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE1:
		pPlot = getPlot(iX+iiX,iY+iiY)
		if not pPlot.isNone():
			iImprovement = pPlot.getImprovementType()
			if iImprovement != -1:
				if gc.getImprovementInfo(iImprovement).isFort():
					return False
	return True		
	
def spellPioneer(caster):
	pPlot = caster.plot()
	iFeature = pPlot.getFeatureType()
	iCivType = gc.getPlayer(caster.getOwner()).getCivilizationType()
	if iFeature in ( gc.getInfoTypeForString(forest) for forest in ('FEATURE_FOREST', 'FEATURE_FOREST_BURNT', 'FEATURE_FOREST_NEW', 'FEATURE_FOREST_ANCIENT', ) ):
		if iCivType not in ( gc.getInfoTypeForString(elf) for elf in ('CIVILIZATION_LJOSALFAR', 'CIVILIZATION_SVARTALFAR', ) ):
			pPlot.setFeatureType(FeatureTypes.NO_FEATURE, -1)
	if iFeature in ( gc.getInfoTypeForString(jungle) for jungle in ('FEATURE_JUNGLE', ) ):
		if iCivType not in ( gc.getInfoTypeForString(lizard) for lizard in ('CIVILIZATION_CUALLI', 'CIVILIZATION_MAZATL', 'CIVILIZATION_CLAN_OF_EMBERS', ) ):
			pPlot.setFeatureType(FeatureTypes.NO_FEATURE, -1)
	if reqClaimFort(caster):
		spellClaimFort(caster)
		
def reqBoosom(caster):
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	sValidTerrains = ['SNOW', 'TUNDRA', 'MARSH', 'GRASS', 'PLAINS', 'FIELDS_OF_PERDITION', 'DESERT']
	iValidTerrains = [gc.getInfoTypeForString('TERRAIN_' + sTerrain) for sTerrain in sValidTerrains]
	if (pPlot.getTerrainType() in iValidTerrains):
		return True
	return False

def spellBoosom(caster):
	pPlot = caster.plot()
	iTerrain = pPlot.getTerrainType()
	if iTerrain == gc.getInfoTypeForString('TERRAIN_SNOW'):
		pPlot.setPlotType(PlotTypes.PLOT_HILLS, True, True)
	elif iTerrain == gc.getInfoTypeForString('TERRAIN_TUNDRA'):
		pPlot.setPlotType(PlotTypes.PLOT_HILLS, True, True)
	elif iTerrain == gc.getInfoTypeForString('TERRAIN_MARSH'):
		pPlot.setPlotType(PlotTypes.PLOT_HILLS, True, True)
	elif iTerrain == gc.getInfoTypeForString('TERRAIN_GRASS'):
		pPlot.setPlotType(PlotTypes.PLOT_HILLS, True, True)
	elif iTerrain == gc.getInfoTypeForString('TERRAIN_PLAINS'):
		pPlot.setPlotType(PlotTypes.PLOT_HILLS, True, True)
	elif iTerrain == gc.getInfoTypeForString('TERRAIN_FIELDS_OF_PERDITION'):
		pPlot.setPlotType(PlotTypes.PLOT_HILLS, True, True)
	elif iTerrain == gc.getInfoTypeForString('TERRAIN_DESERT'):
		pPlot.setPlotType(PlotTypes.PLOT_HILLS, True, True)
		
	# declare war at plot owner
	if pPlot.isOwned():
		startWar(caster.getOwner(), pPlot.getOwner(), WarPlanTypes.WARPLAN_TOTAL)
		
def reqFreeze(caster):
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	sValidTerrains = ['TUNDRA', 'MARSH', 'GRASS', 'PLAINS', 'FIELDS_OF_PERDITION', 'DESERT']
	iValidTerrains = [gc.getInfoTypeForString('TERRAIN_' + sTerrain) for sTerrain in sValidTerrains]
	if (pPlot.getTerrainType() in iValidTerrains):
		return True
	return False

def spellFreeze(caster):
	pPlot = caster.plot()
	iTerrain = pPlot.getTerrainType()
	if iTerrain == gc.getInfoTypeForString('TERRAIN_SNOW'):
		pPlot.setTerrainType(gc.getInfoTypeForString('TERRAIN_SNOW'),True,True)
	elif iTerrain == gc.getInfoTypeForString('TERRAIN_GRASS'):
		pPlot.setTerrainType(gc.getInfoTypeForString('TERRAIN_TUNDRA'),True,True)
	elif iTerrain == gc.getInfoTypeForString('TERRAIN_PLAINS'):
		pPlot.setTerrainType(gc.getInfoTypeForString('TERRAIN_TUNDRA'),True,True)
	elif iTerrain == gc.getInfoTypeForString('TERRAIN_FIELDS_OF_PERDITION'):
		pPlot.setTerrainType(gc.getInfoTypeForString('TERRAIN_TUNDRA'),True,True)
	elif iTerrain == gc.getInfoTypeForString('TERRAIN_DESERT'):
		pPlot.setTerrainType(gc.getInfoTypeForString('TERRAIN_TUNDRA'),True,True)
	elif iTerrain == gc.getInfoTypeForString('TERRAIN_MARSH'):
		pPlot.setTerrainType(gc.getInfoTypeForString('TERRAIN_TUNDRA'),True,True)
		
	# declare war at plot owner
	if pPlot.isOwned():
		startWar(caster.getOwner(), pPlot.getOwner(), WarPlanTypes.WARPLAN_TOTAL)

def reqJotBloom(caster):
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	sValidTerrains = ['MARSH', 'GRASS', 'PLAINS', 'TUNDRA', 'SNOW']
	iValidTerrains = [gc.getInfoTypeForString('TERRAIN_' + sTerrain) for sTerrain in sValidTerrains]
	if (pPlot.getTerrainType() in iValidTerrains):
		return True
	return False

def spellJotBloom(caster):
	pPlot = caster.plot()
	iTerrain = pPlot.getTerrainType()
	if iTerrain == gc.getInfoTypeForString('TERRAIN_SNOW'):
		pPlot.setFeatureType(gc.getInfoTypeForString('FEATURE_FOREST_NEW'), -1)
	elif iTerrain == gc.getInfoTypeForString('TERRAIN_GRASS'):
		pPlot.setFeatureType(gc.getInfoTypeForString('FEATURE_FOREST_NEW'), -1)
	elif iTerrain == gc.getInfoTypeForString('TERRAIN_PLAINS'):
		pPlot.setFeatureType(gc.getInfoTypeForString('FEATURE_FOREST_NEW'), -1)
	elif iTerrain == gc.getInfoTypeForString('TERRAIN_TUNDRA'):
		pPlot.setFeatureType(gc.getInfoTypeForString('FEATURE_FOREST_NEW'), -1)
	elif iTerrain == gc.getInfoTypeForString('TERRAIN_MARSH'):
		pPlot.setFeatureType(gc.getInfoTypeForString('FEATURE_FOREST_NEW'), -1)

def reqJotFeed(caster):
	if caster.getDamage() == 0:
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		if caster.getDamage() < 20:
			return False
	return True

def spellJotFeed(caster):
	caster.setDamage(caster.getDamage() - 20, caster.getOwner())
	pVictim = -1
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.getOwner() == caster.getOwner():
			if pUnit.getUnitType() == gc.getInfoTypeForString('UNIT_THRALL_MILITIA'):
				if (pVictim == -1 or pVictim.getLevel() > pUnit.getLevel()):
					pVictim = pUnit
	if pVictim != -1:
		pVictim.kill(True, 0)

def spellWisdom(caster):
	py = PyPlayer(caster.getOwner())
	for pUnit in py.getUnitList():
		if pUnit.isHasPromotion(gc.getInfoTypeForString('PROMOTION_JOT_GIANTKIN')):
			pUnit.setExperienceTimes100((pUnit.getExperienceTimes100() * 2), -1)

def reqSteading(caster):
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
			
	if pPlot.isOwned() and pPlot.getOwner() != caster.getOwner():
		return False
		
	if pPlot.isCityRadius():
		return False

	if not pPlayer.isHuman():
		if pPlot.getFoundValue() < (pPlot.area().getBestFoundValue() * 2) / 3:
			return False

	return True

def spellSteading(caster):
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())

	pCity = pPlayer.initCity(pPlot.getX(),pPlot.getY())
	CvEventInterface.getEventManager().onCityBuilt([pCity])
	
# Vitalize	
	
def plotsInRange( centerX, centerY, maxRange, minRange=None ):
	maxRangeSquared = (maxRange+.5)**2
	if minRange is None:
		minRangeSquared = -1
	else:
		minRangeSquared = (minRange+.5)**2
	for offsetX in xrange( -maxRange, maxRange+1 ):
		for offsetY in xrange( -maxRange, maxRange+1 ):
			if minRangeSquared < offsetX**2 + offsetY**2 < maxRangeSquared:
				yield ( centerX + offsetX, centerY + offsetY )

def getSpellRange( caster ):
	spellRange = 0
	for promotion in ( 'PROMOTION_EXTENSION1', 'PROMOTION_EXTENSION2' ):
		if caster.isHasPromotion( gc.getInfoTypeForString( promotion ) ):
			spellRange += 1
	return spellRange

baseVitalizeUpgrades = dict( ( gc.getInfoTypeForString( start_terrain ), gc.getInfoTypeForString( end_terrain ) )
							for start_terrain, end_terrain in [
								('TERRAIN_SNOW', 'TERRAIN_TUNDRA'),
								('TERRAIN_TUNDRA', 'TERRAIN_PLAINS'),
								('TERRAIN_WASTELAND', 'TERRAIN_DESERT'),
								('TERRAIN_DESERT', 'TERRAIN_PLAINS'),
								('TERRAIN_PLAINS', 'TERRAIN_GRASS'),
								('TERRAIN_MARSH', 'TERRAIN_GRASS'),
								('TERRAIN_OCEAN', 'TERRAIN_COAST'),
								] )
civSpecificVitalize = dict()
civSpecificVitalize[gc.getInfoTypeForString('CIVILIZATION_ILLIANS')] = dict( ( gc.getInfoTypeForString( start_terrain ), gc.getInfoTypeForString( end_terrain ) )
							for start_terrain, end_terrain in [
								('TERRAIN_TUNDRA', 'TERRAIN_SNOW'),
								('TERRAIN_DESERT', 'TERRAIN_SNOW'),
								('TERRAIN_PLAINS', 'TERRAIN_SNOW'),
								('TERRAIN_WASTELAND', 'TERRAIN_SNOW'),
								('TERRAIN_GRASS', 'TERRAIN_SNOW'),
								('TERRAIN_MARSH', 'TERRAIN_SNOW'),
								('TERRAIN_BURNING_SANDS', 'TERRAIN_SNOW'),
								('TERRAIN_BROKEN_LANDS', 'TERRAIN_SNOW'),
								('TERRAIN_FIELDS_OF_PERDITION', 'TERRAIN_SNOW'),
								('TERRAIN_OCEAN', 'TERRAIN_COAST'),
								] )
civSpecificVitalize[gc.getInfoTypeForString('CIVILIZATION_MAZATL')] = dict( baseVitalizeUpgrades )
civSpecificVitalize[gc.getInfoTypeForString('CIVILIZATION_MAZATL')].update( dict( ( gc.getInfoTypeForString( start_terrain ), gc.getInfoTypeForString( end_terrain ) )
							for start_terrain, end_terrain in [
								('TERRAIN_GRASS', 'TERRAIN_MARSH'),
								('TERRAIN_MARSH', 'TERRAIN_MARSH'),
								] ) )
civSpecificVitalize[gc.getInfoTypeForString('CIVILIZATION_CUALLI')] = dict (civSpecificVitalize[gc.getInfoTypeForString('CIVILIZATION_MAZATL')])
civSpecificVitalize[gc.getInfoTypeForString('CIVILIZATION_MALAKIM')] = dict( baseVitalizeUpgrades )
civSpecificVitalize[gc.getInfoTypeForString('CIVILIZATION_MALAKIM')].update( dict( ( gc.getInfoTypeForString( start_terrain ), gc.getInfoTypeForString( end_terrain ) )
							for start_terrain, end_terrain in [
								('TERRAIN_DESERT', 'TERRAIN_DESERT'),
								] ) )

def reqVitalize(caster):
	pPlot = caster.plot()
	if pPlot.getOwner() != caster.getOwner():
		return False
	if pPlot.isWater():
		return False
	pPlayer = gc.getPlayer( caster.getOwner() )
	vitalizeUpgrades = civSpecificVitalize.get( pPlayer.getCivilizationType(), baseVitalizeUpgrades )
	if not pPlot.getTerrainType() in vitalizeUpgrades:
		return False
	return True

def spellVitalize(caster):
	map = CyMap()
	grass = gc.getInfoTypeForString( 'TERRAIN_GRASS' )
	plains = gc.getInfoTypeForString( 'TERRAIN_PLAINS' )
	desert = gc.getInfoTypeForString( 'TERRAIN_DESERT' )
	floodPlains = gc.getInfoTypeForString('FEATURE_FLOOD_PLAINS')
	pPlayer = gc.getPlayer( caster.getOwner() )
	vitalizeUpgrades = civSpecificVitalize.get( pPlayer.getCivilizationType(), baseVitalizeUpgrades )
	for x,y in plotsInRange( caster.getX(), caster.getY(), getSpellRange( caster )+1 ):
		pPlot = map.plot(x,y)
		if not pPlot.isNone() and pPlot.getOwner() == caster.getOwner():
			terrain = pPlot.getTerrainType()
			if terrain in vitalizeUpgrades:
				pPlot.setTerrainType( vitalizeUpgrades[terrain], True, True )
			# From here on terrain refers to what pPlot was before the upgrade
			if terrain == desert and pPlot.getFeatureType() == floodPlains and terrain != pPlot.getTerrainType():
				pPlot.setFeatureType(-1, -1)
			if pPlot.getTerrainType() == grass and pPlot.isHills() and pPlot.isCity():
				pPlot.setTerrainType( plains, True, True )

def reqVitalizeCompanion(caster):
	pPlot = caster.plot()
	if pPlot.getOwner() != caster.getOwner():
		return False
	elif pPlot.isWater():
		return False
	elif not pPlot.getTerrainType() in ( gc.getInfoTypeForString( terrain ) for terrain in ['TERRAIN_GRASS', 'TERRAIN_PLAINS']):
		return False
	return True

def spellVitalizeCompanion(caster):
	'''
	Transforms concentric circles of grassland to plains.
	'''
	map = CyMap()
	grass = gc.getInfoTypeForString( 'TERRAIN_GRASS' )
	plains = gc.getInfoTypeForString( 'TERRAIN_PLAINS' )
	player = caster.getOwner()
	for transformRange in xrange( getSpellRange( caster )+1+1 ): # +1 for basic range, +1 to include endpoint
		altered = False
		if transformRange:
			minRange = transformRange -1
		else:
			minRange = None
		for x,y in plotsInRange( caster.getX(), caster.getY(), transformRange, None ):
			pPlot = map.plot(x,y)
			if not pPlot.isNone() and pPlot.getOwner() == player:
				terrain = pPlot.getTerrainType()
				if terrain == grass:
					pPlot.setTerrainType( plains, True, True )
					altered = True
		if altered:
			return

# Vitalize end

def spellAbsorbEssence(caster):
	pPlot = caster.plot()
	iXP = (caster.getLevel() * 100)
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		iXP = pUnit.getExperienceTimes100() + iXP
		if pUnit.getUnitType() == gc.getInfoTypeForString('UNIT_DTESHI_COMMANDER'):
			pUnit.setExperienceTimes100(iXP, -1)
			break

#	Added in Frozen: TC01
#	Custom spell functions added in Frozen module. They do not need specific statements since they are only called from the XML. They are:
#		reqWintering checks if the Wintering worldspell can be casted
#		spellWintering does the effects of the Wintering worldspell
#		spellSnowfallPassive causes passive spread ice terrain as an Ascended moves about the map
#		reqFreezeForest checks if the Freeze Forest spell can be used
#		spellFreezeForest does the effects of the Freeze Forest spell
#		effectNested is the effect of Young being hatched from Nested units
#		effectYoung is the effect of a Young dying

def reqWintering(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	for i in range (CyMap().numPlots()):
		pPlot = CyMap().plotByIndex(i)
		if pPlayer.isHuman() == False:
			if caster.getOwner() == pPlot.getOwner():
				if pPlot.getTerrainTypeCount(gc.getInfoTypeForString('TERRAIN_SNOW')) < 20:
					return False
		return True

def spellWintering(caster):
	for i in range (CyMap().numPlots()):
		pPlot = CyMap().plotByIndex(i)
		if pPlot.getTerrainType() == gc.getInfoTypeForString('TERRAIN_SNOW'):
			if pPlot.getOwner() == caster.getOwner():
				pPlot.setFeatureType(gc.getInfoTypeForString('FEATURE_WINTER'), 0)
			if pPlot.getOwner() != caster.getOwner():
				pPlot.setFeatureType(gc.getInfoTypeForString('FEATURE_BLIZZARD'), 0)
		if pPlot.getTerrainType() == gc.getInfoTypeForString('TERRAIN_TUNDRA'):
			if pPlot.getOwner() == caster.getOwner():
				pPlot.setTerrainType(gc.getInfoTypeForString('TERRAIN_SNOW'),True,True)
				pPlot.setFeatureType(gc.getInfoTypeForString('FEATURE_WINTER'), 0)
			if pPlot.getOwner() != caster.getOwner:
				pPlot.setTerrainType(gc.getInfoTypeForString('TERRAIN_SNOW'),True,True)
		for e in range(pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(e)
			if not pUnit.isHasPromotion(gc.getInfoTypeForString('PROMOTION_WINTERBORN')):
				if not pUnit.getOwner() == gc.getInfoTypeForString('CIVILIZATION_FROZEN'):
					if not pUnit.getDomainType() == gc.getInfoTypeForString('DOMAIN_WATER'):
						pUnit.setHasPromotion(gc.getInfoTypeForString('PROMOTION_WINTERED'), True)

def spellSnowfallPassive(caster):
	gc			= CyGlobalContext()
	getInfoType	= gc.getInfoTypeForString
	randNum		= CyGame().getSorenRandNum
	iX = caster.getX()
	iY = caster.getY()
	getPlot		= CyMap().plot
	pPlot 		= getPlot(iX, iY)
	iFlames 	= getInfoType('FEATURE_FLAMES')
	iFloodPlains= getInfoType('FEATURE_FLOOD_PLAINS')
	iForest 	= getInfoType('FEATURE_FOREST')
	iJungle 	= getInfoType('FEATURE_JUNGLE')
	iScrub 		= getInfoType('FEATURE_SCRUB')
	iSmoke 		= getInfoType('IMPROVEMENT_SMOKE')
	iSnow 		= getInfoType('TERRAIN_SNOW')
	iIce 		= getInfoType('FEATURE_ICE')
	for iiX,iiY in RANGE2:
		pLoopPlot = getPlot(iX+iiX,iY+iiY)
		if not pPlot.isNone():
			iRnd = randNum(12, "Snowfall") + 6
			if not pLoopPlot.isWater():
				if pLoopPlot.getTerrainType() != iSnow:
					pLoopPlot.setTempTerrainType(iSnow, iRnd)
					if pLoopPlot.getImprovementType() == iSmoke:
						pLoopPlot.setImprovementType(-1)
					iFeature = pLoopPlot.getFeatureType()
					if iFeature == iForest:
						pLoopPlot.setFeatureType(iForest, 2)
					if iFeature == iJungle:
						pLoopPlot.setFeatureType(iForest, 2)
					if iFeature == iFlames:
						pLoopPlot.setFeatureType(-1, -1)
					if iFeature == iFloodPlains:
						pLoopPlot.setFeatureType(-1, -1)
					if iFeature == iScrub:
						pLoopPlot.setFeatureType(-1, -1)
			if pPlot.isWater():
				if pPlot.getFeatureType() != iIce:
					pPlot.setFeatureType(iIce, 0)

	return False

def reqFreezeForest(caster):
	pPlot = caster.plot()
	iSnow = gc.getInfoTypeForString('TERRAIN_SNOW')
	iForest = gc.getInfoTypeForString('FEATURE_FOREST')
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlot.getFeatureType() == -1:
		if pPlot.getTerrainType() == iSnow:
			return True
	if pPlot.getFeatureType() == iForest:
		if not pPlot.getFeatureType() == iSnow:
			return True
	if pPlayer.isHuman() == False:
		if caster.getOwner() == pPlot.getOwner():
			return True
	return False

def spellFreezeForest(caster):
	pPlot = caster.plot()
	iSnow = gc.getInfoTypeForString('TERRAIN_SNOW')
	iForest = gc.getInfoTypeForString('FEATURE_FOREST')
	if pPlot.getFeatureType() == -1:
		if pPlot.getTerrainType() == iSnow:
			pPlot.setFeatureType(iForest, 2)
	if pPlot.getFeatureType() == iForest:
		if not pPlot.getFeatureType() == iSnow:
			pPlot.setTerrainType(iSnow, True, True)
			pPlot.setFeatureType(iForest, 2)

def effectNested(caster):
	iX = caster.getX()
	iY = caster.getY()
	iFrozen = gc.getInfoTypeForString('CIVILIZATION_FROZEN')
	iYoung = gc.getInfoTypeForString('UNIT_YOUNG_KOCRACHON')
	for i in xrange(gc.getMAX_PLAYERS()):
		pPlayer = gc.getPlayer(i)
		if pPlayer.isAlive():
			if pPlayer.getCivilizationType() == iFrozen:
				pFrozen = pPlayer
				break
		else:
			pFrozen = gc.getPlayer(gc.getBARBARIAN_PLAYER())

	iRand = CyGame().getSorenRandNum(100, "Nested")
	iNumYoung = CyGame().getSorenRandNum(2, "Nested") + 1
	print ("Number of Young = %d" % (iNumYoung))
	if iRand <= 15:
		for i in xrange(iNumYoung - 1):
			pFrozen.initUnit(iYoung, iX, iY, UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)

		caster.kill(True, PlayerTypes.NO_PLAYER)

def effectYoung(caster):
	pPlot = caster.plot()
	bFrozen = False
	iYoung = gc.getInfoTypeForString('UNIT_YOUNG_KOCRACHON')
	if not caster.getUnitType() == iYoung:
		return

	iRand = CyGame().getSorenRandNum(100, "Young")
	if iRand <= 30:
		caster.kill(True, PlayerTypes.NO_PLAYER)

def spellSummonWinterCreatures(caster):
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	pPlayer.trigger(gc.getInfoTypeForString('EVENTTRIGGER_SUMMON_WINTER_CREATURES'))

def reqWinterCreatureSummoning(caster):
	return False
#End of Frozen

def effectWinter(pCaster):
	iSnow = gc.getInfoTypeForString('TERRAIN_SNOW')
	iFlames = gc.getInfoTypeForString('FEATURE_FLAMES')
	iFloodPlains = gc.getInfoTypeForString('FEATURE_FLOOD_PLAINS')
	iForest = gc.getInfoTypeForString('FEATURE_FOREST')
	iJungle = gc.getInfoTypeForString('FEATURE_JUNGLE')
	iScrub = gc.getInfoTypeForString('FEATURE_SCRUB')
	iSmoke = gc.getInfoTypeForString('IMPROVEMENT_SMOKE')
	iX = pCaster.getX()
	iY = pCaster.getY()
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE2:
		pLoopPlot = getPlot(iX+iiX,iY+iiY)
		if not pLoopPlot.isNone():
			if not pLoopPlot.isWater():
				pLoopPlot.setTerrainType(iSnow, True, True)
				if pLoopPlot.getImprovementType() == iSmoke:
					pLoopPlot.setImprovementType(-1)
				iFeature = pLoopPlot.getFeatureType()
				if iFeature == iForest:
					pLoopPlot.setFeatureType(iForest, 2)
				if iFeature == iJungle:
					pLoopPlot.setFeatureType(iForest, 2)
				if iFeature == iFlames:
					pLoopPlot.setFeatureType(-1, -1)
				if iFeature == iFloodPlains:
					pLoopPlot.setFeatureType(-1, -1)
				if iFeature == iScrub:
					pLoopPlot.setFeatureType(-1, -1)
						
def effectMechanosAffinity(pCaster):
	iMechanosAffinity = gc.getInfoTypeForString('PROMOTION_MECHANOS_AFFINITY')
	pPlayer = gc.getPlayer(pCaster.getOwner())
	iRefinedNum = pPlayer.getNumAvailableBonuses(gc.getInfoTypeForString('BONUS_REFINED_MANA')) - 1

	for i in xrange(pCaster.countHasPromotion(iMechanosAffinity)):
		pCaster.setHasPromotion(iMechanosAffinity, False)
	
	for i in xrange(iRefinedNum):
		pCaster.setHasPromotion(iMechanosAffinity, True)
		
def postCombatLossDemolitions(pCaster, pOpponent):
	pPlot = pCaster.plot()
	pPlot.setImprovementType(-1)
	
def postCombatLossTriforce(pCaster, pOpponent):
	pOpponent.setHasPromotion(gc.getInfoTypeForString('PROMOTION_TRIFORCE'), True)
	
def spellTriforce(pCaster):
	pPlot = pCaster.plot()
	iPlayer = pCaster.getOwner()
	iPlayer2 = pPlot.getOwner()
	iImprovement = pPlot.getImprovementType()
	pPlayer = gc.getPlayer(pCaster.getOwner())
	iUnit = gc.getInfoTypeForString('UNITCLASS_FORT_COMMANDER')
	infoCiv = gc.getCivilizationInfo(pPlayer.getCivilizationType())
	iUnit = infoCiv.getCivilizationUnits(iUnit)
	if iUnit == -1:
		iUnit = gc.getInfoTypeForString('UNIT_FORT_COMMANDER')
	iRace = infoCiv.getDefaultRace()
	newUnit = pPlayer.initUnit(iUnit, pCaster.getX(), pCaster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_NORTH)	
	if iRace != -1:
		newUnit.setHasPromotion(iRace, True)
	pPlot.clearCultureControl(iPlayer2, iImprovement, 1)
	pPlot.setImprovementOwner(iPlayer)
	pPlot.addCultureControl(iPlayer, iImprovement, 1)	
	newUnit.convert(pCaster)
	
def spellMobileFortCreate(pCaster):
	pPlot = pCaster.plot()
	iPlayer = pCaster.getOwner()
	iImprovement = pPlot.getImprovementType()
	pPlayer = gc.getPlayer(pCaster.getOwner())
	iUnit = gc.getInfoTypeForString('UNIT_MOBILE_FORTRESS')
	if iImprovement != -1:
		pPlot.setImprovementType(-1)
	newUnit = pPlayer.initUnit(iUnit, pCaster.getX(), pCaster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_NORTH)	
	newUnit.convert(pCaster)

def spellMobileFortSettleCastle(pCaster):
	pPlot = pCaster.plot()
	iPlayer = pCaster.getOwner()
	iPlayer2 = pPlot.getOwner()
	iImprovement = pPlot.getImprovementType()
	pPlayer = gc.getPlayer(pCaster.getOwner())
	iUnit = gc.getInfoTypeForString('UNIT_FORT_COMMANDER')
	if iImprovement == -1:
		pPlot.setImprovementType(gc.getInfoTypeForString('IMPROVEMENT_CASTLE'))
		iImprovement = pPlot.getImprovementType()
	newUnit = pPlayer.initUnit(iUnit, pCaster.getX(), pCaster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_NORTH)	
	newUnit.convert(pCaster)
	pPlot.clearCultureControl(iPlayer2, iImprovement, 1)
	pPlot.setImprovementOwner(iPlayer)
	pPlot.addCultureControl(iPlayer, iImprovement, 1)	
	newUnit.convert(pCaster)
	
def spellMobileFortSettleCitadel(pCaster):
	pPlot = pCaster.plot()
	iPlayer = pCaster.getOwner()
	iPlayer2 = pPlot.getOwner()
	iImprovement = pPlot.getImprovementType()
	pPlayer = gc.getPlayer(pCaster.getOwner())
	iUnit = gc.getInfoTypeForString('UNIT_FORT_COMMANDER')
	if iImprovement == -1:
		pPlot.setImprovementType(gc.getInfoTypeForString('IMPROVEMENT_CITADEL'))
		iImprovement = pPlot.getImprovementType()
	newUnit = pPlayer.initUnit(iUnit, pCaster.getX(), pCaster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_NORTH)	
	newUnit.convert(pCaster)
	pPlot.clearCultureControl(iPlayer2, iImprovement, 1)
	pPlot.setImprovementOwner(iPlayer)
	pPlot.addCultureControl(iPlayer, iImprovement, 1)	
	newUnit.convert(pCaster)

def reqMobileFortSettle(pCaster):
	pPlot = pCaster.plot()
	if pPlot.getImprovementType() != -1:
		return False
	if pPlot.isCity():
		return False
	return True
	
def reqPegasus(pCaster):
	pPlayer 		= gc.getPlayer(pCaster.getOwner())
	pOrcPlayer 		= gc.getPlayer(gc.getORC_PLAYER())
	pAnimalPlayer 	= gc.getPlayer(gc.getANIMAL_PLAYER())
	pDemonPlayer 	= gc.getPlayer(gc.getDEMON_PLAYER())
	
	if pPlayer == pOrcPlayer:
		return False
	if pPlayer == pAnimalPlayer:
		return False
	if pPlayer == pDemonPlayer:
		return False
		
	return True
	
def spellPotionOfRestoration(caster):

	if (CyGame().getSorenRandNum(10, "Potion run out chance") < 3):
		caster.setHasPromotion(gc.getInfoTypeForString('PROMOTION_POTION_OF_RESTORATION'), False)

def spellMasterOfForce(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	iX = caster.getX()
	iY = caster.getY()
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE1:
		pPlot = getPlot(iX+iiX,iY+iiY)
		for i in xrange(pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(i)
			p2Player = gc.getPlayer(pUnit.getOwner())
			e2Team = p2Player.getTeam()
			if pUnit.getDuration() > 0:
				pUnit.kill(True, PlayerTypes.NO_PLAYER)
	return False

def reqCommandUndead(caster):
	iUndead = gc.getInfoTypeForString('PROMOTION_UNDEAD')
	iHero = gc.getInfoTypeForString('PROMOTION_HERO')
	iSpell = gc.getInfoTypeForString('SPELL_COMMAND_UNDEAD')
	iScions = gc.getInfoTypeForString('CIVILIZATION_SCIONS')
	iX = caster.getX()
	iY = caster.getY()
	pPlayer = gc.getPlayer(caster.getOwner())
	if caster.getNumForcedMinions() >= 8:
		return False
	iResistMax = 40
	if not pPlayer.isHuman():
		iResistMax = 20
	if pPlayer.getCivilizationType() == iScions:
		iResistMax = 65
	iTeam = pPlayer.getTeam()
	eTeam = gc.getTeam(iTeam)
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE2:
		pPlot = getPlot(iX+iiX,iY+iiY)
		for i in range(pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(i)
			if pUnit.isHasPromotion(iHero):
				iResistMax = iResistMax + 20
			if pUnit.isHasPromotion(iUndead):
				if eTeam.isAtWar(pUnit.getTeam()):
					iResist = pUnit.getResistChance(caster, iSpell)
					if iResist <= iResistMax:
						return True
	return False	

def spellCommandUndead(caster):
	iUndead = gc.getInfoTypeForString('PROMOTION_UNDEAD')
	iHero = gc.getInfoTypeForString('PROMOTION_HERO')
	iSpell = gc.getInfoTypeForString('SPELL_COMMAND_UNDEAD')
	iScions = gc.getInfoTypeForString('CIVILIZATION_SCIONS')
	iX = caster.getX()
	iY = caster.getY()
	pPlayer = gc.getPlayer(caster.getOwner())
	iResistMax = 40
	iBestValue = 0
	pBestUnit = -1
	if not pPlayer.isHuman():
		iResistMax = 20
	if pPlayer.getCivilizationType() == iScions:
		iResistMax = 65
	iTeam = pPlayer.getTeam()
	eTeam = gc.getTeam(iTeam)
	getPlot	= CyMap().plot
	for iiX,iiY in RANGE2:
		pPlot = getPlot(iX+iiX,iY+iiY)
		for i in xrange(pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(i)
			if pUnit.isHasPromotion(iHero):
				iResistMax = iResistMax + 20
			iValue = 0
			if pUnit.isHasPromotion(iUndead):
				if eTeam.isAtWar(pUnit.getTeam()):
					iResist = pUnit.getResistChance(caster, iSpell)
					if iResist <= iResistMax:
						iValue = pUnit.baseCombatStr() * 10
						iValue = iValue + (100 - iResist)
						if iValue > iBestValue:
							iBestValue = iValue
							pBestUnit = pUnit
	if pBestUnit != -1:
		pPlot = caster.plot()
		iPreviousOwner = pBestUnit.getOwner()
		if pBestUnit.isResisted(caster, iSpell) == False:
			CyInterface().addMessage(pBestUnit.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_COMMAND_UNDEAD", ()),'',1,'Art/Civs/Dtesh/OpalusMortis.dds',ColorTypes(7),pBestUnit.getX(),pBestUnit.getY(),True,True)
			CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_COMMAND_UNDEAD_ENEMY", ()),'',1,'Art/Civs/Dtesh/OpalusMortis.dds',ColorTypes(8),pPlot.getX(),pPlot.getY(),True,True)
			newUnit = pPlayer.initUnit(pBestUnit.getUnitType(), pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
			newUnit.convert(pBestUnit)
			newUnit.changeImmobileTimer(1)
			newUnit.setPreviousOwner(iPreviousOwner)
			caster.addMinion(newUnit)
		else:
			CyInterface().addMessage(caster.getOwner(),True,25,CyTranslator().getText("TXT_KEY_MESSAGE_DOMINATION_FAILED", ()),'',1,'Art/Interface/Buttons/Spells/Domination.dds',ColorTypes(7),pPlot.getX(),pPlot.getY(),True,True)

			
def spellClanBlaze(caster):
	pPlot = caster.plot()
	pPlot.setFeatureType(gc.getInfoTypeForString('FEATURE_FOREST_BURNT'),1)

def spellAnimosity(caster):
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(gc.getORC_PLAYER())

	if not pPlot.isCity():
		if not (pPlot.isOwned() and pPlot.getOwner() != caster.getOwner()):
			if not pPlot.isCityRadius():	
				pCity = pPlayer.initCity(pPlot.getX(),pPlot.getY())
				CvEventInterface.getEventManager().onCityBuilt([pCity])
				caster.kill(True,0)
		

def reqRantineDomination(caster):
	iOrc	= gc.getORC_PLAYER()
	iHero	= gc.getInfoTypeForString('PROMOTION_HERO')
	iSpell	= gc.getInfoTypeForString('SPELL_RANTINE_DOMINATION')
	iX		= caster.getX()
	iY		= caster.getY()
	pPlayer	= gc.getPlayer(caster.getOwner())
	if caster.getNumForcedMinions() >= 8:
		return False
	iResistMax = 40
	iTeam = pPlayer.getTeam()
	eTeam = gc.getTeam(iTeam)
	getPlot = CyMap().plot
	for iiX,iiY in RANGE2:
		pPlot = getPlot(iX+iiX,iY+iiY)
		for i in xrange(pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(i)
			if pUnit.isHasPromotion(iHero):
				iResistMax = iResistMax + 20
			if pUnit.getOwner == iOrc:
				iResist = pUnit.getResistChance(caster, iSpell)
				if iResist <= iResistMax:
					return True
	return False
	
def spellRantineDomination(caster):
	gc			= CyGlobalContext()
	getInfoType	= gc.getInfoTypeForString
	iOrc 		= gc.getORC_PLAYER()
	iHero 		= getInfoType('PROMOTION_HERO')
	iSpell 		= getInfoType('SPELL_RANTINE_DOMINATION')
	iX = caster.getX()
	iY = caster.getY()
	pPlayer = gc.getPlayer(caster.getOwner())
	iResistMax = 40
	iBestValue = 0
	pBestUnit = -1
	iTeam = pPlayer.getTeam()
	eTeam = gc.getTeam(iTeam)
	getPlot = CyMap().plot
	for iiX,iiY in RANGE2:
		pPlot = getPlot(iX+iiX,iY+iiY)
		for i in xrange(pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(i)
			if pUnit.isHasPromotion(iHero):
				iResistMax = iResistMax + 20
			iValue = 0
			if pUnit.getOwner == iOrc:
				iResist = pUnit.getResistChance(caster, iSpell)
				if iResist <= iResistMax:
					iValue = pUnit.baseCombatStr() * 10
					iValue = iValue + (100 - iResist)
					if iValue > iBestValue:
						iBestValue = iValue
						pBestUnit = pUnit
	if pBestUnit != -1:
		pPlot = caster.plot()
		iPreviousOwner = pBestUnit.getOwner()
		if pBestUnit.isResisted(caster, iSpell) == false:
			CyInterface().addMessage(pBestUnit.getOwner(),true,25,CyTranslator().getText("TXT_KEY_MESSAGE_COMMAND_UNDEAD", ()),'',1,'Art/Civs/Dtesh/OpalusMortis.dds',ColorTypes(7),pBestUnit.getX(),pBestUnit.getY(),True,True)
			CyInterface().addMessage(caster.getOwner(),true,25,CyTranslator().getText("TXT_KEY_MESSAGE_COMMAND_UNDEAD_ENEMY", ()),'',1,'Art/Civs/Dtesh/OpalusMortis.dds',ColorTypes(8),pPlot.getX(),pPlot.getY(),True,True)
			newUnit = pPlayer.initUnit(pBestUnit.getUnitType(), pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
			newUnit.convert(pBestUnit)
			newUnit.changeImmobileTimer(1)
			newUnit.setPreviousOwner(iPreviousOwner)
			caster.addMinion(newUnit)
		else:
			CyInterface().addMessage(caster.getOwner(),true,25,CyTranslator().getText("TXT_KEY_MESSAGE_DOMINATION_FAILED", ()),'',1,'Art/Interface/Buttons/Spells/Domination.dds',ColorTypes(7),pPlot.getX(),pPlot.getY(),True,True)	

def spellClearSwamp(caster):
	pPlot = caster.plot()
	iImprovement = pPlot.getImprovementType()
	if iImprovement == gc.getInfoTypeForString('IMPROVEMENT_SWAMP'):
		pPlot.setImprovementType(-1)

def reqCreateSwamp(caster):
	pPlot = caster.plot()
	iTerrain = pPlot.getTerrainType()
	if iTerrain != gc.getInfoTypeForString('TERRAIN_MARSH'):
		return False
		
def spellCreateSwamp(caster):
	pPlot = caster.plot()
	iTerrain = pPlot.getTerrainType()
	pPlot.setImprovementType(gc.getInfoTypeForString('IMPROVEMENT_SWAMP'))	
	
def reqShapeJungle(caster):
	pPlot = caster.plot()
	if (pPlot.getTerrainType() == gc.getInfoTypeForString("TERRAIN_GRASS") or pPlot.getTerrainType() == gc.getInfoTypeForString("TERRAIN_MARSH")):
		if (pPlot.getFeatureType() == -1):
			return True
	return False
	
def reqDeepenForest(caster):
	pPlot = caster.plot()
	if (pPlot.getTerrainType() == gc.getInfoTypeForString("TERRAIN_GRASS") or pPlot.getTerrainType() == gc.getInfoTypeForString("TERRAIN_MARSH")):
		return True
	return False	

def spellShapeJungle(caster):
	pPlot = caster.plot()
	pPlot.setTempFeatureType(FeatureTypes.NO_FEATURE, -1, 0)
	pPlot.setFeatureType(gc.getInfoTypeForString('FEATURE_JUNGLE'), 0)
	
def reqSpiderSwarmUpgrade(pCaster):	
	pPlayer = gc.getPlayer(pCaster.getOwner())
	if (pPlayer.getNumCities() > 0):
		pNest = pPlayer.getCapitalCity()
		iNestPop = pNest.getPopulation()
		if iNestPop >= 16:
			return True
	return False
	
def reqSpiderSwarmUpgrade(pCaster):	
	pPlayer = gc.getPlayer(pCaster.getOwner())
	if (pPlayer.getNumCities() > 0):
		pNest = pPlayer.getCapitalCity()
		iNestPop = pNest.getPopulation()
		if iNestPop >= 24:
			return True
	return False	
	
def reqMotherEnraged(pCaster):
	pPlayer = gc.getPlayer(pCaster.getOwner())

	if (pPlayer.getNumCities() > 0):	
		pNest = pPlayer.getCapitalCity()
		iNestPop = pNest.getPopulation()
		if iNestPop >= 24:
			return True
	return False

def reqIgnitePyre(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		pPlot = caster.plot()
		iX = caster.getX()
		iY = caster.getY()
		eTeam = gc.getTeam(pPlayer.getTeam())
		getPlot	= CyMap().plot
		for iiX,iiY in RANGE1:
			pPlot = getPlot(iX+iiX,iY+iiY)
			for i in range(pPlot.getNumUnits()):
				pUnit = pPlot.getUnit(i)
				p2Player = gc.getPlayer(pUnit.getOwner())
				e2Team = p2Player.getTeam()
				if eTeam.isAtWar(e2Team) == True:
					return True
		return False
	return True

def spellIgnitePyre(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	iUnit = gc.getInfoTypeForString('UNIT_PYRE_ZOMBIE')
	newUnit = pPlayer.initUnit(iUnit, caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_NORTH)
	newUnit.finishMoves()
	newUnit.setHasCasted(True)
		

def reqAllowCheats(caster):
	return CvEventInterface.getEventManager().bAllowCheats
	
def spellSelfDestruct(caster):
	gc 	= CyGlobalContext()
	git	= gc.getInfoTypeForString
	getPlot	= CyMap().plot
	iX = caster.getX()
	iY = caster.getY()
	for iiX,iiY in BFC:
		pPlot = getPlot(iX+iiX,iY+iiY)
		for i in xrange(pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(i)
			pUnit.kill(True, PlayerTypes.NO_PLAYER)
		if not pPlot.isWater():
			pPlot.setFeatureType(-1, -1)
			pPlot.setFeatureType(git('FEATURE_FALLOUT'), 0)
	caster.kill()

def reqAddToCityDtesh(caster):
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	if (pCity.getPopulation() >= pCity.getCityPopulationCap()):
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if not pPlayer.isHuman():
		if pCity.getOwner() != caster.getOwner():
			return False
	return True	
		